EnableExplicit

XIncludeFile "..\functions.pbi"
XIncludeFile "..\profiles.pbi"

XIncludeFile "ProfileManager_frmMain.pbf"
XIncludeFile "ProfileManager_frmAddEditProfile.pbf"

#APPNAME = "ProfileManager"
#Version = "2016-08-11"

#Action_Add  = 1
#Action_Edit = 2

Enumeration
	#frmAddEditProfile_Shortcut_Escape
	#frmAddEditProfile_Shortcut_Return
EndEnumeration

Global Action_AddEdit

Global IniPath.s = GetAppDataPath("tuebbentools", "PB2Web") + "PB2Web.ini"

If  FileSize(GetExePath() + "PB2Web.ini")
	RenameFile(GetExePath() + "PB2Web.ini", IniPath)
EndIf

Global NewProfileName.s = ProgramParameter()

Procedure CheckButtons()
	
	Protected Flag
	
	If GetGadgetState(#frmMain_lstProfiles) = -1
		Flag = #True
	Else
		Flag = #False
	EndIf
	
	DisableGadget(#frmMain_cmdEdit, Flag)
	DisableGadget(#frmMain_cmdDelete, Flag)
	DisableGadget(#frmMain_cmdDuplicate, Flag)
	
EndProcedure

Procedure FillList()
	ClearGadgetItems(#frmMain_lstProfiles)
  SortStructuredList(Profile(), #PB_Sort_Ascending, OffsetOf(sProfile\Name), TypeOf(sProfile\Name))
	ForEach Profile()
		AddGadgetItem(#frmMain_lstProfiles, -1, Profile()\Name)
	Next
	CheckButtons()
	SetGadgetText(#frmMain_txtSetProfile, "")
EndProcedure

Procedure GetThemes()
	
	ClearGadgetItems(#frmAddEditProfile_cboTheme)
	
	Protected ThemeDir.s = GetExePath() + "system/libraries/jquery.ui/themes/"
	
	If FileSize(ThemeDir) <> -2
		ThemeDir = GetExePath() + "../system/libraries/jquery.ui/themes/"
	EndIf

	If FileSize(ThemeDir) <> -2
		MessageRequester(#APPNAME, "No themes found!")
		ProcedureReturn
	EndIf
	
	If ExamineDirectory(0, ThemeDir, "*.*")
		While NextDirectoryEntry(0)
			If DirectoryEntryType(0) = #PB_DirectoryEntry_Directory And
			   DirectoryEntryName(0) <> "." And 
			   DirectoryEntryName(0) <> ".."
				AddGadgetItem(#frmAddEditProfile_cboTheme, -1, DirectoryEntryName(0))
			EndIf
		Wend
		FinishDirectory(0)
	EndIf
		
EndProcedure

Procedure frmAddEditProfile_cmdServerPath_Event()
	Protected Foldername.s
	Foldername = GetGadgetText(#frmAddEditProfile_txtServerPath)
	Foldername = PathRequester("Select...", Foldername)
	If Foldername <> ""
		SetGadgetText(#frmAddEditProfile_txtServerPath, Foldername)
	EndIf
EndProcedure

Procedure frmAddEditProfile_cmdCgiFilename_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtCgiFilename)
	Filename = OpenFileRequester("Select...", Filename, "Executable (*.exe)|*.exe", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtCgiFilename, Filename)
	EndIf
EndProcedure
Procedure frmAddEditProfile_cmdPhpFilename_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtPhpFilename)
	Filename = OpenFileRequester("Select...", Filename, "PHP file (*.php)|*.php", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtPhpFilename, Filename)
	EndIf
EndProcedure
Procedure frmAddEditProfile_cmdAspFilename_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtAspFilename)
	Filename = OpenFileRequester("Select...", Filename, "Asp file (*.Asp)|*.Asp", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtAspFilename, Filename)
	EndIf
EndProcedure
Procedure frmAddEditProfile_cmdAspxFilename_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtAspxFilename)
	Filename = OpenFileRequester("Select...", Filename, "Aspx file (*.Aspx)|*.Aspx", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtAspxFilename, Filename)
	EndIf
EndProcedure
Procedure frmAddEditProfile_cmdPythonFilename_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtPythonFilename)
	Filename = OpenFileRequester("Select...", Filename, "Python file (*.py)|*.py", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtPythonFilename, Filename)
	EndIf
EndProcedure
Procedure frmAddEditProfile_cmdNodeJsFilename_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtNodeJsFilename)
	Filename = OpenFileRequester("Select...", Filename, "JavaScript file (*.js)|*.js", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtNodeJsFilename, Filename)
	EndIf
EndProcedure

Procedure frmAddEditProfile_cmdThemeRefresh_Event()
	
	Protected SelectedTheme.s = GetGadgetText(#frmAddEditProfile_cboTheme)
	
	GetThemes()
	
	SetGadgetText(#frmAddEditProfile_cboTheme, SelectedTheme)
	
EndProcedure

Procedure frmAddEditProfile_optBrowser_Event()
	
	If GetGadgetState(#frmAddEditProfile_optStartSpecificBrowser)	= 1
		DisableGadget(#frmAddEditProfile_txtSpecificBrowser, #False)
		DisableGadget(#frmAddEditProfile_cmdSpecificBrowser, #False)
	Else
		DisableGadget(#frmAddEditProfile_txtSpecificBrowser, #True)
		DisableGadget(#frmAddEditProfile_cmdSpecificBrowser, #True)
	EndIf
	
EndProcedure

Procedure frmAddEditProfile_cmdSpecificBrowser_Event()
	Protected Filename.s
	Filename = GetGadgetText(#frmAddEditProfile_txtSpecificBrowser)
	Filename = OpenFileRequester("Select...", Filename, "Executable (*.exe)|*.exe", 0)
	If Filename <> ""
		SetGadgetText(#frmAddEditProfile_txtSpecificBrowser, Filename)
	EndIf
EndProcedure

Procedure frmAddEditProfile_cmdOK_Event()
	
	Protected *Old_Element
	Protected Found
	
	If GetGadgetText(#frmAddEditProfile_txtProfileName) = ""
		MessageRequester(#APPNAME, "Please choose a profile name")
		SetActiveGadget(#frmAddEditProfile_txtProfileName)
		ProcedureReturn
	EndIf
	
	If Action_AddEdit = #Action_Add
		
		*Old_Element = @Profile() 
		
		ForEach Profile()
			If LCase(Profile()\Name) = LCase(GetGadgetText(#frmAddEditProfile_txtProfileName))
				Found = #True
				Break
			EndIf
		Next
		
		ChangeCurrentElement(Profile(), *Old_Element) 
		
		If Found 
			MessageRequester(#APPNAME, "Please choose another profile name")
			SetActiveGadget(#frmAddEditProfile_txtProfileName)
			ProcedureReturn
		EndIf
		
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtServerPath) = ""
		MessageRequester(#APPNAME, "Please choose a server path")
		SetActiveGadget(#frmAddEditProfile_txtServerPath)
		ProcedureReturn
	Else
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtServerPath))) <> -2
			MessageRequester(#APPNAME, "The server path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtServerPath)
			ProcedureReturn
		EndIf
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtServerAddress) = ""
		; 		MessageRequester(#APPNAME, "Please choose a server address")
		; 		SetActiveGadget(#frmAddEditProfile_txtServerAddress)
		; 		ProcedureReturn
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtAspFilename) <> ""
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtAspFilename))) <> -2
			MessageRequester(#APPNAME, "ASP-Filename: Path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtAspFilename)
			ProcedureReturn
		EndIf
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtAspxFilename) <> ""
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtAspxFilename))) <> -2
			MessageRequester(#APPNAME, "ASPX-Filename: Path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtAspxFilename)
			ProcedureReturn
		EndIf
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtCgiFilename) <> ""
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtCgiFilename))) <> -2
			MessageRequester(#APPNAME, "CGI-Filename: Path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtCgiFilename)
			ProcedureReturn
		EndIf
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtNodeJsFilename) <> ""
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtNodeJsFilename))) <> -2
			MessageRequester(#APPNAME, "NodeJs-Filename: Path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtNodeJsFilename)
			ProcedureReturn
		EndIf
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtPhpFilename) <> ""
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtPhpFilename))) <> -2
			MessageRequester(#APPNAME, "PHP-Filename: Path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtPhpFilename)
			ProcedureReturn
		EndIf
	EndIf
	
	If GetGadgetText(#frmAddEditProfile_txtPythonFilename) <> ""
		If FileSize(GetPathPart(GetGadgetText(#frmAddEditProfile_txtPythonFilename))) <> -2
			MessageRequester(#APPNAME, "Python-Filename: Path doesn't exists")
			SetActiveGadget(#frmAddEditProfile_txtPythonFilename)
			ProcedureReturn
		EndIf
	EndIf
	
	If Action_AddEdit = #Action_Add
		AddElement(Profile())
	EndIf
	
	Profile()\Name            = GetGadgetText(#frmAddEditProfile_txtProfileName)
	
	Profile()\IndexPage       = GetGadgetText(#frmAddEditProfile_txtIndexPage)
	Profile()\ServerPath      = GetGadgetText(#frmAddEditProfile_txtServerPath)
	Profile()\ServerAddress   = GetGadgetText(#frmAddEditProfile_txtServerAddress)
	
	Profile()\AspFilename     = GetGadgetText(#frmAddEditProfile_txtAspFilename)
	Profile()\AspAddress      = GetGadgetText(#frmAddEditProfile_txtAspAddress)
	
	Profile()\AspxFilename    = GetGadgetText(#frmAddEditProfile_txtAspxFilename)
	Profile()\AspxAddress     = GetGadgetText(#frmAddEditProfile_txtAspxAddress)
	
	Profile()\CgiFilename     = GetGadgetText(#frmAddEditProfile_txtCgiFilename)
	Profile()\CgiAddress      = GetGadgetText(#frmAddEditProfile_txtCgiAddress)
	
	Profile()\PhpFilename     = GetGadgetText(#frmAddEditProfile_txtPhpFilename)
	Profile()\PhpAddress      = GetGadgetText(#frmAddEditProfile_txtPhpAddress)
	
	Profile()\PythonFilename  = GetGadgetText(#frmAddEditProfile_txtPythonFilename)
	Profile()\PythonAddress   = GetGadgetText(#frmAddEditProfile_txtPythonAddress)
	
	Profile()\NodeJsFilename  = GetGadgetText(#frmAddEditProfile_txtNodeJsFilename)
	Profile()\NodeJsAddress   = GetGadgetText(#frmAddEditProfile_txtNodeJsAddress)
	
	Profile()\ApplicationName = GetGadgetText(#frmAddEditProfile_txtApplicationName)
	Profile()\Theme           = GetGadgetText(#frmAddEditProfile_cboTheme)
	Profile()\Encoding        = GetGadgetText(#frmAddEditProfile_cboEncoding)
	
	Profile()\AdditionalScriptsAndStylesheets = GetGadgetText(#frmAddEditProfile_txtAdditionalScriptsAndStyleSheets)
	
	Profile()\AfterConvertingDoNothing            = GetGadgetState(#frmAddEditProfile_optDoNothing)
	Profile()\AfterConvertingStartDefaultBrowser  = GetGadgetState(#frmAddEditProfile_optStartBrowser)
	Profile()\AfterConvertingStartSpecificBrowser = GetGadgetState(#frmAddEditProfile_optStartSpecificBrowser)
	Profile()\AfterConvertingSpecificBrowser      = GetGadgetText(#frmAddEditProfile_txtSpecificBrowser)
	
	Profile()\FtpHost         = GetGadgetText(#frmAddEditProfile_txtFtpHost)
	Profile()\FtpUser         = GetGadgetText(#frmAddEditProfile_txtFtpUser)
	Profile()\FtpPass         = GetGadgetText(#frmAddEditProfile_txtFtpPass)  
	
	CloseWindow(#frmAddEditProfile)
	DisableWindow(#frmMain, #False)
	
	FillList()
	
EndProcedure

Procedure frmAddEditProfile_cmdCancel_Event()
	
	CloseWindow(#frmAddEditProfile)
	DisableWindow(#frmMain, #False)
	
EndProcedure

Procedure frmMain_cmdAdd_Event()
	
	DisableWindow(#frmMain, #True)
	OpenfrmAddEditProfile()
	
	AddGadgetItem(#frmAddEditProfile_cboEncoding, -1, "Ascii")
	AddGadgetItem(#frmAddEditProfile_cboEncoding, -1, "UTF8")
	AddGadgetItem(#frmAddEditProfile_cboEncoding, -1, "Unicode")
	
	SetGadgetState(#frmAddEditProfile_cboEncoding, 1)
	
	GetThemes()
	
	SetGadgetText(#frmAddEditProfile_cboTheme, "smoothness")
	
	AddKeyboardShortcut(#frmAddEditProfile, #PB_Shortcut_Escape, #frmAddEditProfile_Shortcut_Escape)
	AddKeyboardShortcut(#frmAddEditProfile, #PB_Shortcut_Return, #frmAddEditProfile_Shortcut_Return)
	
	SetWindowTitle(#frmAddEditProfile, "Add profile")
	
	If NewProfileName <> ""
		SetGadgetText(#frmAddEditProfile_txtProfileName, NewProfileName)		
		SetActiveGadget(#frmAddEditProfile_txtServerPath)
	Else
		SetActiveGadget(#frmAddEditProfile_txtProfileName)
	EndIf
	
	frmAddEditProfile_optBrowser_Event()
	
	Action_AddEdit = #Action_Add
	
EndProcedure

Procedure frmMain_cmdEdit_Event()
	
	If GetGadgetState(#frmMain_lstProfiles) = -1
		ProcedureReturn 
	EndIf
	
	SelectElement(Profile(), GetGadgetState(#frmMain_lstProfiles))
	
	DisableWindow(#frmMain, #True)
	OpenfrmAddEditProfile()
	
	AddGadgetItem(#frmAddEditProfile_cboEncoding, -1, "Ascii")
	AddGadgetItem(#frmAddEditProfile_cboEncoding, -1, "UTF8")
	AddGadgetItem(#frmAddEditProfile_cboEncoding, -1, "Unicode")
	
	If Profile()\Encoding = "" : Profile()\Encoding = "UTF8" : EndIf
	
	AddKeyboardShortcut(#frmAddEditProfile, #PB_Shortcut_Escape, #frmAddEditProfile_Shortcut_Escape)
	AddKeyboardShortcut(#frmAddEditProfile, #PB_Shortcut_Return, #frmAddEditProfile_Shortcut_Return)
	
	SetWindowTitle(#frmAddEditProfile, "Edit profile")
	
	SetGadgetText(#frmAddEditProfile_txtProfileName,     Profile()\Name)
	
	SetGadgetText(#frmAddEditProfile_txtIndexPage,       Profile()\IndexPage)
	SetGadgetText(#frmAddEditProfile_txtServerPath,      Profile()\ServerPath)
	SetGadgetText(#frmAddEditProfile_txtServerAddress,   Profile()\ServerAddress)
	
	SetGadgetText(#frmAddEditProfile_txtCgiFilename,     Profile()\CgiFilename)
	SetGadgetText(#frmAddEditProfile_txtCgiAddress,      Profile()\CgiAddress)
	
	SetGadgetText(#frmAddEditProfile_txtAspFilename,     Profile()\AspFilename)
	SetGadgetText(#frmAddEditProfile_txtAspAddress,      Profile()\AspAddress)
	
	SetGadgetText(#frmAddEditProfile_txtAspxFilename,    Profile()\AspxFilename)
	SetGadgetText(#frmAddEditProfile_txtAspxAddress,     Profile()\AspxAddress)
	
	SetGadgetText(#frmAddEditProfile_txtPhpFilename,     Profile()\PhpFilename)
	SetGadgetText(#frmAddEditProfile_txtPhpAddress,      Profile()\PhpAddress)
	
	SetGadgetText(#frmAddEditProfile_txtNodeJsFilename,  Profile()\NodeJsFilename)
	SetGadgetText(#frmAddEditProfile_txtNodeJsAddress,   Profile()\NodeJsAddress)
	
	SetGadgetText(#frmAddEditProfile_txtPythonFilename,  Profile()\PythonFilename)
	SetGadgetText(#frmAddEditProfile_txtPythonAddress,   Profile()\PythonAddress)
	
	SetGadgetText(#frmAddEditProfile_txtApplicationName, Profile()\ApplicationName)
	
	GetThemes()
	
	SetGadgetText(#frmAddEditProfile_cboTheme,           Profile()\Theme)
	SetGadgetText(#frmAddEditProfile_cboEncoding,        Profile()\Encoding)
	
	SetGadgetText(#frmAddEditProfile_txtAdditionalScriptsAndStyleSheets, Profile()\AdditionalScriptsAndStylesheets)
	
	SetGadgetState(#frmAddEditProfile_optDoNothing,            Profile()\AfterConvertingDoNothing)
	SetGadgetState(#frmAddEditProfile_optStartBrowser,         Profile()\AfterConvertingStartDefaultBrowser)
	SetGadgetState(#frmAddEditProfile_optStartSpecificBrowser, Profile()\AfterConvertingStartSpecificBrowser)
	SetGadgetText(#frmAddEditProfile_txtSpecificBrowser,       Profile()\AfterConvertingSpecificBrowser)
	
	SetGadgetText(#frmAddEditProfile_txtFtpHost,         Profile()\FtpHost)
	SetGadgetText(#frmAddEditProfile_txtFtpUser,         Profile()\FtpUser)
	SetGadgetText(#frmAddEditProfile_txtFtpPass,         Profile()\FtpPass)
	
	SetActiveGadget(#frmAddEditProfile_txtProfileName)
	
	frmAddEditProfile_optBrowser_Event()
	
	Action_AddEdit = #Action_Edit
	
EndProcedure

Procedure frmMain_cmdDelete_Event()
	
	If GetGadgetState(#frmMain_lstProfiles) = -1
		ProcedureReturn 
	EndIf
	
	If MessageRequester(#APPNAME, "Sure?", #PB_MessageRequester_YesNo)=#PB_MessageRequester_No
		ProcedureReturn 
	EndIf
	
	SelectElement(Profile(), GetGadgetState(#frmMain_lstProfiles))
	
	DeleteElement(Profile())
	
	FillList()
	
EndProcedure

Procedure.s GetDuplicateProfileName(ProfileName.s)
	
	Protected *Old_Element
	
	Protected ProfileNames.s = #TAB$
	
	*Old_Element = @Profile() 
	ForEach Profile()
		ProfileNames + Profile()\Name + #TAB$
	Next
	ChangeCurrentElement(Profile(), *Old_Element) 
	
	Repeat
		ProfileName = "Copy of " + ProfileName
		If FindString(ProfileNames, #TAB$ + ProfileName + #TAB$) = 0
			Break
		EndIf
	ForEver
	
	ProcedureReturn ProfileName
	
EndProcedure

Procedure frmMain_cmdDuplicate_Event()
	
	If GetGadgetState(#frmMain_lstProfiles) = -1
		ProcedureReturn 
	EndIf
	
	SelectElement(Profile(), GetGadgetState(#frmMain_lstProfiles))
	
	Protected ProfileName.s            = Profile()\Name
	Protected ProfileServerPath.s      = Profile()\ServerPath
	Protected ProfileServerAddress.s   = Profile()\ServerAddress
	
	Protected ProfileAspFilename.s     = Profile()\AspFilename
	Protected ProfileAspAddress.s      = Profile()\AspAddress
	
	Protected ProfileAspxFilename.s    = Profile()\AspxFilename
	Protected ProfileAspxAddress.s     = Profile()\AspxAddress
	
	Protected ProfileCgiFilename.s     = Profile()\CgiFilename
	Protected ProfileCgiAddress.s      = Profile()\CgiAddress
	
	Protected ProfileNodeJsFilename.s  = Profile()\NodeJsFilename
	Protected ProfileNodeJsAddress.s   = Profile()\NodeJsAddress
	
	Protected ProfilePhpFilename.s     = Profile()\PhpFilename
	Protected ProfilePhpAddress.s      = Profile()\PhpAddress
	
	Protected ProfilePythonFilename.s  = Profile()\PythonFilename
	Protected ProfilePythonAddress.s   = Profile()\PythonAddress
	
	Protected ProfileApplicationName.s = Profile()\ApplicationName
	Protected Theme.s                  = Profile()\Theme
	Protected Encoding.s               = Profile()\Encoding
	
	Protected ProfileFtpHost.s         = Profile()\FtpHost
	Protected ProfileFtpUser.s         = Profile()\FtpUser
	Protected ProfileFtpPass.s         = Profile()\FtpPass
	
	Protected ProfileAdditionalScriptsAndStylesheets.s = Profile()\AdditionalScriptsAndStylesheets
	
	Protected AfterConvertingDoNothing.i            = Profile()\AfterConvertingDoNothing
	Protected AfterConvertingStartDefaultBrowser.i  = Profile()\AfterConvertingStartDefaultBrowser
	Protected AfterConvertingStartSpecificBrowser.i = Profile()\AfterConvertingStartSpecificBrowser
	Protected AfterConvertingSpecificBrowser.s      = Profile()\AfterConvertingSpecificBrowser
	
	; ##################	
	
	AddElement(Profile())
	
	Profile()\Name            = GetDuplicateProfileName(ProfileName)
	Profile()\ServerPath      = ProfileServerPath
	Profile()\ServerAddress   = ProfileServerAddress
	
	Profile()\AspFilename     = ProfileAspFilename
	Profile()\AspAddress      = ProfileAspAddress
	
	Profile()\AspxFilename     = ProfileAspxFilename
	Profile()\AspxAddress      = ProfileAspxAddress
	
	Profile()\CgiFilename     = ProfileCgiFilename
	Profile()\CgiAddress      = ProfileCgiAddress
	
	Profile()\NodeJsFilename  = ProfileNodeJsFilename
	Profile()\NodeJsAddress   = ProfileNodeJsAddress
	
	Profile()\PhpFilename     = ProfilePhpFilename
	Profile()\PhpAddress      = ProfilePhpAddress
	
	Profile()\PythonFilename  = ProfilePythonFilename
	Profile()\PythonAddress   = ProfilePythonAddress
	
	Profile()\ApplicationName = ProfileApplicationName
	Profile()\Theme           = Theme
	Profile()\Encoding        = Encoding
	
	Profile()\FtpHost         = ProfileFtpHost
	Profile()\FtpUser         = ProfileFtpUser
	Profile()\FtpPass         = ProfileFtpPass
	
	Profile()\AdditionalScriptsAndStylesheets = ProfileAdditionalScriptsAndStylesheets
	
	Profile()\AfterConvertingDoNothing            = AfterConvertingDoNothing
	Profile()\AfterConvertingStartDefaultBrowser  = AfterConvertingStartDefaultBrowser
	Profile()\AfterConvertingStartSpecificBrowser = AfterConvertingStartSpecificBrowser
	Profile()\AfterConvertingSpecificBrowser      = AfterConvertingSpecificBrowser
	
	FillList()
	
EndProcedure

OpenfrmMain()

#frmMain_Shortcut_Escape = 99

AddKeyboardShortcut(#frmMain, #PB_Shortcut_Escape, #frmMain_Shortcut_Escape)

SetWindowTitle(#frmMain, #APPNAME + " (V" + #Version + ")")

LoadProfiles(IniPath)

FillList()

Define WWE, Quit

Repeat
	
	WWE = WaitWindowEvent()
	
	Select WWE
			
		Case #PB_Event_Menu	
			Select EventMenu()
				Case #frmMain_Shortcut_Escape : Quit = #True
			EndSelect
			
		Case #PB_Event_CloseWindow
			
			Select EventWindow()
					
				Case #frmMain
					Quit = #True
					
				Case #frmAddEditProfile
					CloseWindow(#frmAddEditProfile)
					DisableWindow(#frmMain, #False)
					
			EndSelect
			
		Case #PB_Event_Gadget
			
			Select EventGadget()
					
				Case #frmMain_lstProfiles
					
					SetGadgetText(#frmMain_txtSetProfile, "P2W_Converter_SetProfile(" + Chr(34) + GetGadgetText(#frmMain_lstProfiles) + Chr(34) + ")")

					CheckButtons()
					
					Select EventType()
							
						Case #PB_EventType_LeftDoubleClick
							
							If GetGadgetState(#frmMain_lstProfiles) = -1
								frmMain_cmdAdd_Event()
							Else
								frmMain_cmdEdit_Event()
							EndIf
							
					EndSelect
					
				Case #frmMain_cmdAdd              : frmMain_cmdAdd_Event()
				Case #frmMain_cmdEdit             : frmMain_cmdEdit_Event()
				Case #frmMain_cmdDelete           : frmMain_cmdDelete_Event()
				Case #frmMain_cmdDuplicate        : frmMain_cmdDuplicate_Event()
				Case #frmMain_cmdCopyToClipboard  : SetClipboardText(GetGadgetText(#frmMain_txtSetProfile))
					
				Case #frmAddEditProfile_cmdServerPath      : frmAddEditProfile_cmdServerPath_Event()
				Case #frmAddEditProfile_cmdCgiFilename     : frmAddEditProfile_cmdCgiFilename_Event()
				Case #frmAddEditProfile_cmdPhpFilename     : frmAddEditProfile_cmdPhpFilename_Event()
				Case #frmAddEditProfile_cmdPythonFilename  : frmAddEditProfile_cmdPythonFilename_Event()
				Case #frmAddEditProfile_cmdNodeJsFilename  : frmAddEditProfile_cmdNodeJsFilename_Event()
				Case #frmAddEditProfile_cmdAspFilename     : frmAddEditProfile_cmdAspFilename_Event()
				Case #frmAddEditProfile_cmdAspxFilename    : frmAddEditProfile_cmdAspxFilename_Event()
				Case #frmAddEditProfile_cmdThemeRefresh    : frmAddEditProfile_cmdThemeRefresh_Event()
					
				Case #frmAddEditProfile_optDoNothing,
				     #frmAddEditProfile_optStartBrowser,
				     #frmAddEditProfile_optStartSpecificBrowser : frmAddEditProfile_optBrowser_Event()
					
				Case #frmAddEditProfile_cmdSpecificBrowser 			: frmAddEditProfile_cmdSpecificBrowser_Event()
					
				Case #frmAddEditProfile_cmdOK              			: frmAddEditProfile_cmdOK_Event()
				Case #frmAddEditProfile_cmdCancel          			: frmAddEditProfile_cmdCancel_Event()
					
			EndSelect
			
		Case #PB_Event_Menu
			
			Select EventMenu()
					
				Case #frmAddEditProfile_Shortcut_Return : frmAddEditProfile_cmdOK_Event()
				Case #frmAddEditProfile_Shortcut_Escape : frmAddEditProfile_cmdCancel_Event()
					
			EndSelect
			
		Default
			
			If NewProfileName <> ""
				frmMain_cmdAdd_Event()
				NewProfileName = ""
			EndIf

	EndSelect
	
Until Quit = #True

SaveProfiles(IniPath)


; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 8
; Folding = AAA5
; EnableXP
; UseIcon = ..\gfx\p2w.ico
; Executable = ..\ProfileManager.exe
; IncludeVersionInfo
; VersionField0 = 20.15.12.10
; VersionField1 = 20.15.12.10
; VersionField2 = tuebbentools
; VersionField3 = ProfileManager
; VersionField4 = 2015-12-10
; VersionField5 = 2015-12-10
; VersionField6 = ProfileManager for PB2Web
; VersionField7 = ProfileManager
; VersionField8 = ProfileManager.exe
; VersionField15 = VOS_NT
; VersionField16 = VFT_APP