﻿; AccordionGadget-Include

EnableExplicit

Enumeration
	#PB_EventType_Accordion_Activate = 1
	#PB_EventType_Accordion_BeforeActivate = 2
EndEnumeration

Procedure AccordionGadget_AddGadgetItem(Gadget, Position, Text, ImageID, Flags) 

	!	var selector = $("#g_" + Gadget);

	!	selector = selector.find(".ui-accordion");

	!	var headerItem = $("<h3 />");

	!	headerItem.html("<span class='ui-accordion-header-text'>" + Text + "</span>");

	!	var divItem = $("<div />");

	!	if (Position <= -1 || Position >= selector.find("h3").length) {
	!		selector.append(headerItem);
	!	} else {
	!		headerItem.insertBefore(selector.find("h3").eq(Position));
	!	}

	!	divItem.insertAfter(headerItem);

	!	selector.accordion("refresh");

	!	divItem.css("position", "relative");

	!	cCommon.CurrentContainer = divItem;

EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "AddGadgetItem", @AccordionGadget_AddGadgetItem())

Procedure AccordionGadget_GetGadgetState(Gadget)
	!	var selector = $("#g_" + Gadget);
	!	selector = selector.find(".ui-accordion");
	!	return selector.accordion("option", "active");
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "GetGadgetState", @AccordionGadget_GetGadgetState())

Procedure AccordionGadget_RemoveGadgetItem(Gadget, Position)
	!	var selector = $("#g_" + Gadget);
	!	selector.find("h3.ui-accordion-header").eq(Position).remove();
	!	selector.find("div.ui-accordion-content").eq(Position).remove();
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "RemoveGadgetItem", @AccordionGadget_RemoveGadgetItem())

Procedure AccordionGadget_SetGadgetState(Gadget, State)
	!	var selector = $("#g_" + Gadget);
	!	selector = selector.find(".ui-accordion");
	!	selector.accordion("option", "active", State);
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "SetGadgetState", @AccordionGadget_SetGadgetState())

Procedure AccordionGadget_GetGadgetItemText(Gadget, Position, Column)
	!	var selector = $("#g_" + Gadget);
	! return selector.find("h3.ui-accordion-header").eq(Item).find("span.ui-accordion-header-text").html();
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "GetGadgetItemText", @AccordionGadget_GetGadgetItemText())

Procedure AccordionGadget_OpenGadgetList(Gadget, GadgetItem)
	!	var selector = $("#g_" + Gadget);
	! cCommon.CurrentContainer = selector.find(".ui-accordion").find("div.ui-accordion-content").eq(GadgetItem);
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "OpenGadgetList", @AccordionGadget_OpenGadgetList())

Procedure AccordionGadget_SetGadgetItemText(Gadget, Position, Text, Column)
	!	var selector = $("#g_" + Gadget);
	! selector.find("h3.ui-accordion-header").eq(Position).find("span.ui-accordion-header-text").html(Text);
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "SetGadgetItemText", @AccordionGadget_SetGadgetItemText())

Procedure AccordionGadget_CloseGadgetList()
	! cCommon.CurrentContainer = cCommon.CurrentContainer.parent().parent();
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "CloseGadgetList", @AccordionGadget_CloseGadgetList())

Procedure AccordionGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget).children(0);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_Accordion_Activate |
		            #PB_EventType_Accordion_BeforeActivate
		
	EndIf
	
	!	var cb = Callback;
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Accordion_Activate)) selector.data("onActivate", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Accordion_BeforeActivate)) selector.data("onBeforeActivate", cb);
	
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "BindGadgetEvent", @AccordionGadget_BindGadgetEvent())

Procedure AccordionGadget_UnbindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget).children(0);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_Accordion_Activate |
		            #PB_EventType_Accordion_BeforeActivate
		
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Accordion_Activate)) selector.data("onActivate", null);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Accordion_BeforeActivate)) selector.data("onBeforeActivate", null);
	
EndProcedure
RegisterUserGadgetProcedure("AccordionGadget", "UnbindGadgetEvent", @AccordionGadget_UnbindGadgetEvent())

; ------------

Procedure AccordionGadget(Gadget, x, y, Width, Height, Flags = 0)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!	var resizeSelector = $("<div />");
	!	var accordionSelector = $("<div />");
	!	resizeSelector.append(accordionSelector);
	!	resizeSelector.attr("id", "g_" + Gadget);
	!	cCommon.SetGadgetPosition(resizeSelector, x, y, Width, Height);
	
	!	resizeSelector.data("GadgetType", "AccordionGadget");
	!	accordionSelector.data("GadgetType", "AccordionGadget");
	
	!	cCommon.CurrentContainer.append(resizeSelector);
	
	!	if (cCommon.DefaultGadgetFont) {
	!		accordionSelector.css("font-size", cCommon.DefaultGadgetFont.css("font-size"));
	!		accordionSelector.css("font-family", cCommon.DefaultGadgetFont.css("font-family"));
	!		accordionSelector.css("font-weight", cCommon.DefaultGadgetFont.css("font-weight"));
	!		accordionSelector.css("font-style", cCommon.DefaultGadgetFont.css("font-style"));
	!		accordionSelector.css("text-decoration", cCommon.DefaultGadgetFont.css("text-decoration"));
	!	}
	
	! accordionSelector.on( "accordionactivate", function( event, ui ) {
	! 	ui.newPanel.find('*').each(function () {
	! 		if ($(this).data("GadgetType") === cConstants.PB_GadgetType_ListIcon) {
	! 			var id = $(this).attr("id")
	! 			w2ui[id].refresh();
	! 		}
	! 	});
	
	!		if (typeof accordionSelector.data("onActivate") === "function") {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Accordion_Activate;
	!			return accordionSelector.data("onActivate")(event, ui);
	!		}
	!	});
	
	! accordionSelector.on( "accordionbeforeactivate", function( event, ui ) {
	!		if (typeof accordionSelector.data("onBeforeActivate") === "function") {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Accordion_BeforeActivate;
	!			return accordionSelector.data("onBeforeActivate")(event, ui);
	!		}
	!	});
	
	!	resizeSelector.resizable({
	!		resize: function () {
	!			accordionSelector.accordion("refresh");
	!		}
	!	});
	
	!	accordionSelector.accordion({
	!		heightStyle: "fill"
	!	});
	
	!	resizeSelector.resizable("destroy");
	
	!	// if ($.fn.GadgetsEvents) cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
	
	!	return Gadget;
	
EndProcedure

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 103
; FirstLine = 24
; Folding = B5-
; EnableUnicode
; EnableXP