﻿; AceEditorGadget-Include

; -> https://ace.c9.io/#nav=about

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/ace/ace.js")

Enumeration
	#PB_AceEditor_Theme = 1
	#PB_AceEditor_Mode = 2
	#PB_AceEditor_Border = 3
EndEnumeration

Procedure AceEditorGadget_GetGadgetItemText(Gadget, Item, Column)
	
	!	var selector = $("#g_" + Gadget);
	!	var editor = ace.edit(selector.attr("id"));
	!
	!	if (!editor) return "";
	!
	Select Item
			
		Case #PB_AceEditor_Theme
			!	return cString.ReplaceString(editor.getTheme(), "ace/theme/", "");
			
		Case #PB_AceEditor_Mode:
			!	cDebugger.Debug("ToDo");
			!	// return cString.ReplaceString(editor.getSession().getMode().$id, "ace/mode/", "");
			!	return "";
			
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("AceEditorGadget", "GetGadgetItemText", @AceEditorGadget_GetGadgetItemText())

Procedure AceEditorGadget_GetGadgetText(Gadget)

	!	var selector = $("#g_" + Gadget);
	! var editor = ace.edit(selector.attr("id"));
	! if (editor) return editor.getSession().getValue();
	! return "";

EndProcedure
RegisterUserGadgetProcedure("AceEditorGadget", "GetGadgetText", @AceEditorGadget_GetGadgetText())

Procedure AceEditorGadget_ResizeGadget(Gadget, x, y, Width, Height)

	!	var selector = $("#g_" + Gadget);
	!	var editor = ace.edit(selector.attr("id"));
	
	! if (editor) {
	!		if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!		if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!		if (Width !== cConstants.PB_Ignore) selector.css("width", Width);
	!		if (Height !== cConstants.PB_Ignore) selector.css("height", Height);	
	!		editor.resize(true);
	! }
	
EndProcedure
RegisterUserGadgetProcedure("AceEditorGadget", "ResizeGadget", @AceEditorGadget_ResizeGadget())

Procedure AceEditorGadget_SetGadgetItemText(Gadget, Item, Text, Column)
	
	!	var selector = $("#g_" + Gadget);
	!	var editor = ace.edit(selector.attr("id"));
	
	Select Item
		Case #PB_AceEditor_Theme
			!	editor.setTheme("ace/theme/" + Text);
		Case #PB_AceEditor_Mode
			!	editor.getSession().setMode("ace/mode/" + Text);
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("AceEditorGadget", "SetGadgetItemText", @AceEditorGadget_SetGadgetItemText())

Procedure AceEditorGadget_SetGadgetText(Gadget, Text)
	!	var selector = $("#g_" + Gadget);
	!	var editor = ace.edit(selector.attr("id"));
	!	if (editor) editor.getSession().setValue(Text);
EndProcedure
RegisterUserGadgetProcedure("AceEditorGadget", "SetGadgetText", @AceEditorGadget_SetGadgetText())

Procedure AceEditorGadget_SetActiveGadget(Gadget, Text)
	!	var selector = $("#g_" + Gadget);
	!	var editor = ace.edit(selector.attr("id"));
	!	if (editor) editor.focus();
EndProcedure
RegisterUserGadgetProcedure("AceEditorGadget", "SetActiveGadget", @AceEditorGadget_SetActiveGadget())

; ------

Procedure AceEditorGadget(Gadget, x, y, Width, Height, Flags = 0)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	
	!	var selector = $("<div />");
	
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	selector.attr("id", "g_" + Gadget);
	
	!	if (cCommon.CheckFlag(Flags, PB_AceEditor_Border)) {
	!		selector.css("border", "1px solid black");
	!	}
	
	!	selector.data("GadgetType", "AceEditorGadget");

	!	cCommon.CurrentContainer.append(selector);

	!	ace.edit("g_" + Gadget);
	
	! ace.config.set("basePath", "userlibraries/ace/");
	
	!	return Gadget;

EndProcedure

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 3
; Folding = B9
; EnableXP