﻿; FullCalendarGadget

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/fullcalendar/fullcalendar.css")
OpenLibrary(#PB_Any, "userlibraries/fullcalendar/fullcalendar.js")
OpenLibrary(#PB_Any, "userlibraries/fullcalendar/lang-all.js") ; if you want to include ALL languages. otherwise use...
; OpenLibrary(#PB_Any, "userlibraries/fullcalendar/lang/en-gb.js") ; ... for english

Enumeration
	
	#PB_FullCalendar_Editable = 1
	#PB_FullCalendar_Selectable = 2
	#PB_FullCalendar_EventLimit = 4
	
	#PB_FullCalendar_View = 1
	#PB_FullCalendar_ViewMonth = 2
	#PB_FullCalendar_ViewBasicWeek = 3
	#PB_FullCalendar_ViewBasicDay = 4
	#PB_FullCalendar_ViewAgendaWeek = 5
	#PB_FullCalendar_ViewAgendaDay = 6
	
	#PB_EventType_FullCalendar_DayClick = 1
	#PB_EventType_FullCalendar_EventClick = 2
	#PB_EventType_FullCalendar_EventDragStart = 4
	#PB_EventType_FullCalendar_EventDragStop = 8
	#PB_EventType_FullCalendar_EventDrop = 16
	#PB_EventType_FullCalendar_EventResize = 32
	#PB_EventType_FullCalendar_EventResizeStart = 64
	#PB_EventType_FullCalendar_EventResizeStop = 128
	#PB_EventType_FullCalendar_Select = 256
	#PB_EventType_FullCalendar_Unselect = 512
	
EndEnumeration

Procedure FullCalendarGadget_BindGadgetEvent(Gadget, Callback, EventType)
		
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_FullCalendar_Select |
		            #PB_EventType_FullCalendar_Unselect |
		            #PB_EventType_FullCalendar_DayClick |
		            #PB_EventType_FullCalendar_EventClick |
		            #PB_EventType_FullCalendar_EventDragStart |
		            #PB_EventType_FullCalendar_EventDragStop |
		            #PB_EventType_FullCalendar_EventDrop |
		            #PB_EventType_FullCalendar_EventResizeStart |
		            #PB_EventType_FullCalendar_EventResizeStop |
		            #PB_EventType_FullCalendar_EventResize
		
	EndIf
	
	!	var cb = Callback;
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_Select)) selector.data("onSelect", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_Unselect)) selector.data("onUnselect", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_DayClick)) selector.data("onDayClick", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventClick)) selector.data("onEventClick", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventDragStart)) selector.data("onEventDragStart", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventDragStop)) selector.data("onEventDragStop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventDrop)) selector.data("onEventDrop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventResizeStart)) selector.data("onEventResizeStart", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventResizeStop)) selector.data("onEventResizeStop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventResize)) selector.data("onEventResize", cb);
	
EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "BindGadgetEvent", @FullCalendarGadget_BindGadgetEvent())

Procedure FullCalendarGadget_UnbindGadgetEvent(Gadget, Callback, EventType)
		
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_FullCalendar_Select |
		            #PB_EventType_FullCalendar_Unselect |
		            #PB_EventType_FullCalendar_DayClick |
		            #PB_EventType_FullCalendar_EventClick |
		            #PB_EventType_FullCalendar_EventDragStart |
		            #PB_EventType_FullCalendar_EventDragStop |
		            #PB_EventType_FullCalendar_EventDrop |
		            #PB_EventType_FullCalendar_EventResizeStart |
		            #PB_EventType_FullCalendar_EventResizeStop |
		            #PB_EventType_FullCalendar_EventResize
		
	EndIf
	
	!	var cb = null;
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_Select)) selector.data("onSelect", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_Unselect)) selector.data("onUnselect", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_DayClick)) selector.data("onDayClick", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventClick)) selector.data("onEventClick", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventDragStart)) selector.data("onEventDragStart", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventDragStop)) selector.data("onEventDragStop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventDrop)) selector.data("onEventDrop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventResizeStart)) selector.data("onEventResizeStart", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventResizeStop)) selector.data("onEventResizeStop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_FullCalendar_EventResize)) selector.data("onEventResize", cb);
	
EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "UnbindGadgetEvent", @FullCalendarGadget_UnbindGadgetEvent())

Procedure FullCalendarGadget_RemoveGadgetItem(Gadget, Position)
	
	! var selector = $("#g_" + Gadget);
	! selector.fullCalendar('removeEvents', Position);
	
EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "RemoveGadgetItem", @FullCalendarGadget_RemoveGadgetItem())

Procedure FullCalendarGadget_ResizeGadget(Gadget, x, y, Width, Height)
	
	! var selector = $("#g_" + Gadget);
	
	!	if (x      !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y      !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width  !== cConstants.PB_Ignore) selector.css("width", Width);
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);
	
	! Width  = selector.css("width");
	! Height = selector.css("height");
	
	! selector.fullCalendar("option", "height", Height);
	
	! selector.fullCalendar("option", "aspectRatio",  parseInt(Width)/ parseInt(Height));
	
	! selector.fullCalendar( 'render' );

EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "ResizeGadget", @FullCalendarGadget_ResizeGadget())

Procedure FullCalendarGadget_AddGadgetItem(Gadget, Position, Text.s, ImageID, Flags)

!		var selector = $("#g_" + Gadget);
!
!		if (typeof Position === "string") {
!			Position = JSON.parse(Position);
!		}
!
!		if (Position.events) {
!			for (var eventCounter = 0; eventCounter <= Position.events.length - 1; eventCounter++) {
!				selector.fullCalendar("renderEvent", Position.events[eventCounter], true);
!			}
!		} else {
!			selector.fullCalendar("renderEvent", Position, true);
!		}

EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "AddGadgetItem", @FullCalendarGadget_AddGadgetItem())

Procedure FullCalendarGadget_SetGadgetAttribute(Gadget, Attribute, Value)
!
!		var selector = $("#g_" + Gadget);
!
!		switch (Attribute) {
!			case PB_FullCalendar_View:
!				switch (Value) {
!					case PB_FullCalendar_ViewMonth:
!						selector.fullCalendar('changeView', "month");
!						break;
!					case PB_FullCalendar_ViewBasicWeek:
!						selector.fullCalendar('changeView', "basicWeek");
!						break;
!					case PB_FullCalendar_ViewBasicDay:
!						selector.fullCalendar('changeView', "basicDay");
!						break;
!					case PB_FullCalendar_ViewAgendaWeek:
!						selector.fullCalendar('changeView', "agendaWeek");
!						break;
!					case PB_FullCalendar_ViewAgendaDay:
!						selector.fullCalendar('changeView', "agendaDay");
!						break;
!				}
!				break;
!		}
!
EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "SetGadgetAttribute", @FullCalendarGadget_SetGadgetAttribute())

Procedure FullCalendarGadget_SetGadgetItemColor(Gadget, Item, ColorType, Color, Column)
	
	!	var selector = $("#g_" + Gadget);
	!	var event = selector.fullCalendar('clientEvents', Item);
	!
	!	if (event.length > 0) {
	
	Select ColorType
		Case #PB_Gadget_Color
			! event[0].color = Color;
		Case #PB_Gadget_BorderColor
			! event[0].borderColor = Color;
		Case #PB_Gadget_BackColor
			! event[0].backgroundColor = Color;
		Case #PB_Gadget_FrontColor
			! event[0].textColor = Color;
		Default
			! cDebugger.Debug("Unknown ColorType");
	EndSelect
	
	!		selector.fullCalendar('removeEvents', event[0]);
	!		selector.fullCalendar('renderEvent', event[0], true);
	!
	!	} else {
	!
	Debug("Item not available")
	!
	!	}
	
EndProcedure
RegisterUserGadgetProcedure("FullCalendarGadget", "SetGadgetItemColor", @FullCalendarGadget_SetGadgetItemColor())

; -------

Procedure FullCalendarGadget(Gadget, x, y, Width, Height, Moment = 0, Flags = 0)
	
	! if (Moment === 0) { Moment = moment(new Date()); }
	
	!	// Flags 
	!	// PB_FullCalendar_Editable
	!	// PB_FullCalendar_Selectable
	!	// PB_FullCalendar_EventLimit
	
	!	var fullCalendarGadget = new cControl(Gadget, x, y, Width, Height, "<div />");
	
	!	fullCalendarGadget.selector.data("GadgetType", "FullCalendarGadget");
	
	!	cCommon.CurrentContainer.append(fullCalendarGadget.selector);
	
	!	var editable = false;
	!	var selectable = false;
	!	var eventlimit = false;
	
	!	if (cCommon.CheckFlag(Flags, PB_FullCalendar_Editable)) editable = true;
	!	if (cCommon.CheckFlag(Flags, PB_FullCalendar_Selectable)) selectable = true;
	!	if (cCommon.CheckFlag(Flags, PB_FullCalendar_EventLimit)) eventlimit = true;
	
	
	!	fullCalendarGadget.selector.fullCalendar({
	!		timezone: 'local',
	!		theme: true,
	!		defaultDate: Moment,
	!		editable: editable,
	!		selectable: selectable,
	!		eventLimit: eventlimit,
	!		lang: cSystem.GetBrowserLanguage(),
	!		header: {
	!			left: 'prev,next today',
	!			center: 'title',
	!			right: 'month,agendaWeek,agendaDay'
	!		},
	!		select: function (start, end, jsEvent, view) {
	!			if (fullCalendarGadget.selector.data("onSelect")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_Select;
	!				fullCalendarGadget.selector.data("onSelect")(start, end, jsEvent, view);
	!			}
	!		},
	!		unselect: function (view, jsEvent) {
	!			if (fullCalendarGadget.selector.data("onUnselect")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_Unselect;
	!				fullCalendarGadget.selector.data("onUnselect")(view, jsEvent);
	!			}
	!		},
	!		dayClick: function (date, jsEvent, view) {
	!			if (fullCalendarGadget.selector.data("onDayClick")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_DayClick;
	!				fullCalendarGadget.selector.data("onDayClick")(date, jsEvent, view);
	!			}
	!		},
	!		eventClick: function (calEvent, jsEvent, view) {
	!			if (fullCalendarGadget.selector.data("onEventClick")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventClick;
	!				fullCalendarGadget.selector.data("onEventClick")(calEvent, jsEvent, view);
	!			}
	!		},
	!		eventDragStart: function (event, jsEvent, ui, view) {
	!			if (fullCalendarGadget.selector.data("onEventDragStart")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventDragStart;
	!				fullCalendarGadget.selector.data("onEventDragStart")(event, jsEvent, ui, view);
	!			}
	!		},
	!		eventDragStop: function (event, jsEvent, ui, view) {
	!			if (fullCalendarGadget.selector.data("onEventDragStop")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventDragStop;
	!				fullCalendarGadget.selector.data("onEventDragStop")(event, jsEvent, ui, view);
	!			}
	!		},
	!		eventDrop: function (event, delta, revertFunc, jsEvent, ui, view) {
	!			if (fullCalendarGadget.selector.data("onEventDrop")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventDrop;
	!				fullCalendarGadget.selector.data("onEventDrop")(event, delta, revertFunc, jsEvent, ui, view);
	!			}
	!		},
	!		eventResizeStart: function (event, jsEvent, ui, view) {
	!			if (fullCalendarGadget.selector.data("onEventResizeStart")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventResizeStart;
	!				fullCalendarGadget.selector.data("onEventResizeStart")(event, jsEvent, ui, view);
	!			}
	!		},
	!		eventResizeStop: function (event, jsEvent, ui, view) {
	!			if (fullCalendarGadget.selector.data("onEventResizeStop")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventResizeStop;
	!				fullCalendarGadget.selector.data("onEventResizeStop")(event, jsEvent, ui, view);
	!			}
	!		},
	!		eventResize: function (event, delta, revertFunc, jsEvent, ui, view) {
	!			if (fullCalendarGadget.selector.data("onEventResize")) {
	!				cEvent.eventGadget = fullCalendarGadget.ident;
	!				cEvent.eventType = PB_EventType_FullCalendar_EventResize;
	!				fullCalendarGadget.selector.data("onEventResize")(event, delta, revertFunc, jsEvent, ui, view);
	!			}
	!		}
	!	});
	
	!	cGadget.GetDefaultColors(fullCalendarGadget.selector);
	
	!	if ($.fn.GadgetsEvents) cGadget.BindGadgetEvent(fullCalendarGadget.ident, $.fn.GadgetsEvents);
	
	! fullCalendarGadget.selector.fullCalendar("option", "width", Width);
	! fullCalendarGadget.selector.fullCalendar("option", "height", Height);
	! fullCalendarGadget.selector.fullCalendar("option", "aspectRatio", Width/Height);
	
	! fullCalendarGadget.selector.fullCalendar( 'render' );
	
	!	return fullCalendarGadget.ident;
	
EndProcedure



; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 102
; Folding = Q9
; EnableUnicode
; EnableXP