﻿; GoogleChart-Include

EnableExplicit

Enumeration
	#PB_GoogleChart_Border = 1
	#GoogleChartType = 1
	#GoogleChartTypeArea = 2
	#GoogleChartTypeBar = 3
	#GoogleChartTypeCandlestick = 4
	#GoogleChartTypeColumn = 5
	#GoogleChartTypeCombo = 6
	#GoogleChartTypeGeo = 7
	#GoogleChartTypeLine = 8
	#GoogleChartTypePie = 9
	#GoogleChartTypeScatter = 10
EndEnumeration	

Procedure GoogleChartGadgetDraw(Gadget, GoogleChartData.s, GoogleChartOptions.s = "")
	
	!	var myChart = $('#g_' + Gadget).data('chart');
	!
	!	if (GoogleChartOptions === "") {
	!		if ($('#g_' + Gadget).data('options')) {
	!			GoogleChartOptions = $('#g_' + Gadget).data('options');
	!		}
	!	}
	!
	!	if (GoogleChartOptions === "") {
	!		GoogleChartOptions = "[]";
	!	}
	!
	!	$('#g_' + Gadget).data('options', GoogleChartOptions);
	!
	!	myChart.draw(google.visualization.arrayToDataTable(JSON.parse(GoogleChartData)), JSON.parse(GoogleChartOptions));
	
EndProcedure

Procedure GoogleChartGadget(Gadget, x, y, Width, Height, ChartType.s = "", Flags = 0)
	!
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!
	!	var selector = $("<div />");
	!
	!	selector.attr("id", "g_" + Gadget);
	!
	!	if (cCommon.CheckFlag(Flags, cConstants.PB_GoogleChart_Border)) {
	!		selector.css("border", "1px solid black");
	!	}
	!
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	!
	!	cCommon.CurrentContainer.append(selector);
	!
	!	var Script = "var chart = new google.visualization." + ChartType + "(selector[0]);selector.data('chart', chart);"
	!
	!	eval(Script);
	!
	!	selector.data("GadgetType", "GoogleChart");
	!
	!	if ($.fn.GadgetsEvents) cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
	!
	!	return Gadget;
	!
EndProcedure

Procedure GoogleChartGadgetSetData(Gadget, ChartData)
	
	! var selector = $(spider_GadgetID(v_gadget).div).find('.dijitContentPane');
	! if (!selector) return;
	! selector.data("ChartData", v_chartdata);
	! var options = selector.data("ChartOptions");
	! var chart = selector.data("GoogleChart");
	
	! chart.draw(v_chartdata, options);
	
EndProcedure

Procedure GoogleChartGadgetSetOptions(Gadget, ChartOptions)
	
	! var selector = $(spider_GadgetID(v_gadget).div).find('.dijitContentPane');
	! if (!selector) return;
	! var data = selector.data("ChartData");
	! selector.data("ChartOptions", v_chartoptions);
	! var chart = selector.data("GoogleChart");
	
	! chart.draw(data, v_chartoptions);
	
EndProcedure

Procedure GoogleChartGadgetRefresh(Gadget)
	
	! var selector = $(spider_GadgetID(v_gadget).div).find('.dijitContentPane');
	! if (!selector) return;
	! var data = selector.data("ChartData");
	! var options = selector.data("ChartOptions");
	! var chart = selector.data("GoogleChart");
	
	! chart.draw(data, options);
	
EndProcedure
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 90
; FirstLine = 45
; Folding = --
; EnableXP