﻿; GraphGadget (based on cytoscape)

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/cytoscape/cytoscape.js")
OpenLibrary(#PB_Any, "userlibraries/cytoscape/dagre.js")
OpenLibrary(#PB_Any, "userlibraries/cytoscape/cytoscape-dagre.js")

Enumeration 1
	#PB_GraphGadget_Border
	#PB_GraphGadget_NodeHeight
	#PB_GraphGadget_Layout
EndEnumeration

Procedure GraphGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftClick |
		            #PB_EventType_RightClick
		
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("GraphGadget", "BindGadgetEvent", @GraphGadget_BindGadgetEvent())

Procedure GraphGadget_UnbindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftClick |
		            #PB_EventType_RightClick
		
	EndIf
	
EndProcedure
RegisterUserGadgetProcedure("GraphGadget", "UnbindGadgetEvent", @GraphGadget_UnbindGadgetEvent())

Procedure GraphGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
	! var selector = $("#g_" + Gadget);
	! var cy = selector.data("cy");
	
	Select Attribute
			
		Case #PB_GraphGadget_Layout
			! cy.layout(Value);
			
		Case #PB_GraphGadget_NodeHeight
			
			
			
	EndSelect
	
EndProcedure
RegisterUserGadgetProcedure("GraphGadget", "SetGadgetAttribute", @GraphGadget_SetGadgetAttribute())

Procedure GraphGadget_HideGadget(Gadget, State)
	
	! var selector = $("#g_" + Gadget);
	! if (State) {
	!		selector.css("visibility", "hidden");
	! } else {
	! 	selector.css("visibility", "");
	! }
	
EndProcedure
RegisterUserGadgetProcedure("GraphGadget", "HideGadget", @GraphGadget_HideGadget())


Procedure GraphGadget_AddNode(Gadget, ID.s, LabelText.s = "", Parent.s = "")
	
	! var selector = $("#g_" + Gadget);
	! var cy = selector.data("cy");
	
	If LabelText = ""
		LabelText = ID
	EndIf
	
	! cy.add([
	!		{ group: "nodes", data: { id: ID, label: LabelText, parent: Parent } }
	! ]);	
	
EndProcedure

Procedure GraphGadget_AddEdge(Gadget, ID.s, SourceNode.s, TargetNode.s, LabelText.s = "")
	
	! var selector = $("#g_" + Gadget);
	! var cy = selector.data("cy");
	
	! cy.add({
	!		data: { id: ID, source: SourceNode, target: TargetNode, label: LabelText }
	! });	
	
EndProcedure

Procedure GraphGadget(Gadget, x, y, Width, Height, Flags=0, Callback=0)
	
	! Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!
	! var selector = $("<div />");
	!
	! selector.attr("id", "g_" + Gadget);
	! 
	! if (cCommon.CheckFlag(Flags, PB_GraphGadget_Border)) {
	! 	selector.css("border", "1px solid black");
	! }
	! 
	! cCommon.CurrentContainer.append(selector);
	!
	! cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	! var cy = cytoscape({
	
	!		container: $('#g_' + Gadget),
	
	!		ready: function(evt){
	!			if (Callback) Callback();
	!		},
	
	!		elements: [],
	
	!		style: [
	!			{
	!				selector: 'node',
	!				style: {
	!					'text-valign': 'center',
	! 				'text-halign': 'center',
	! 				'color': 'white',
	! 				'background-color': '#11479e',
	!					'label': 'data(label)',
	!					'width': '150px',
	!					'height': '150px'
	! 			}
	! 		},
	! 		{
	! 			selector: 'edge',
	! 			style: {
	! 				'width': 4,
	! 				'target-arrow-shape': 'triangle',
	! 				'line-color': '#9dbaea',
	! 				'target-arrow-color': '#9dbaea',
	!					'label': 'data(label)'
	! 			}
	! 		}
	! 	],
	
	! 	layout: { name: 'preset'}
	
	! });	
	
	!	selector.data("cy", cy);
	!	selector.data("GadgetType", "GraphGadget");
	
	! return Gadget;	
	
EndProcedure


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 151
; FirstLine = 63
; Folding = Z+
; EnableUnicode
; EnableXP