﻿
Procedure GreenBoxGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftClick |
		            #PB_EventType_RightClick
		
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", Callback);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) selector.data("onRightClick", Callback);
	
EndProcedure
RegisterUserGadgetProcedure("GreenBoxGadget", "BindGadgetEvent", @GreenBoxGadget_BindGadgetEvent())

Procedure GreenBoxGadget_UnbindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		
		EventType = #PB_EventType_LeftClick |
		            #PB_EventType_RightClick
		
	EndIf
	
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onLeftClick", null);
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) selector.data("onRightClick", null);
	
EndProcedure
RegisterUserGadgetProcedure("GreenBoxGadget", "UnbindGadgetEvent", @GreenBoxGadget_UnbindGadgetEvent())

Procedure GreenBoxGadget(Gadget, x, y, Width, Height)
	
	! Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!
	! var selector = $("<div />");
	!
	! selector.attr("id", "g_" + Gadget);
	! 
	! selector.css("border", "1px solid black");
	! selector.css("background-color", "green");
	! 
	! cCommon.CurrentContainer.append(selector);
	!
	! cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	selector.data("GadgetType", "GreenBoxGadget");
	
	! selector.bind("click", function (event) {
	! 	var cb = selector.data("onLeftClick");
	! 	if (typeof cb === "function") {
	! 		if (event.which === 1) {
	! 			cEvent.eventGadget = Gadget;
	! 			cEvent.eventType = cConstants.PB_EventType_LeftClick;
	! 			cb();
	! 		}
	! 	}
	! });	
	! selector.bind("contextmenu", function (event) {
	! 	var cb = selector.data("onRightClick");
	! 	if (typeof cb === "function") {
	!   	event.preventDefault();
	! 		cEvent.eventGadget = Gadget;
	! 		cEvent.eventType = cConstants.PB_EventType_RightClick;
	! 		cb();
	! 	}
	! });
	
	! return Gadget;	
	
EndProcedure


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 14
; Folding = -
; EnableUnicode
; EnableXP