﻿; jsGrid-Include

; http://js-grid.com/

EnableExplicit

OpenLibrary(#PB_Any, "userlibraries/jsGrid/jsgrid.min.css")
OpenLibrary(#PB_Any, "userlibraries/jsGrid/jsgrid-theme.min.css")
OpenLibrary(#PB_Any, "userlibraries/jsGrid/jsgrid.min.js")

Enumeration
	
	; SetGadgetAttribute
	
	#JsGridData
	#JsGridFields
	#JsGridOptions
	
EndEnumeration

Procedure JsGridGadget(Gadget, x, y, Width, Height, JsGridOptions)
	
	If Gadget = #PB_Any
		Gadget = ContainerGadget(Gadget, x, y, Width, Height)
	Else
		ContainerGadget(Gadget, x, y, Width, Height)
	EndIf
	
	CloseGadgetList()
	
	!	selector = $("#g_" + Gadget);	
	
	!	selector.data("GadgetType", "JsGridGadget");
	
	! var JGO = {};
	!	JGO.width = "100%";
	!	JGO.height = "100%";
	!	JGO.rowClick = function(args) {
	!		if (typeof $("#g_" + Gadget).data("onRowClick") === "function") {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType   = cConstants.PB_EventType_LeftClick;
	!			$("#g_" + Gadget).data("onRowClick")(args);
	!		}
	!	};
	
	! var newJsGridOptions = {};
	! $.extend(true, newJsGridOptions, JGO, JsGridOptions);
	!	selector.jsGrid(newJsGridOptions);
	
	! selector.jsGrid("refresh");
	
	ProcedureReturn Gadget	
	
EndProcedure

Procedure JsGridGadget_SetGadgetAttribute(Gadget, Attribute, Value)
	
	Protected selector
	
	!	selector = $("#g_" + Gadget);	
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("SetGadgetAttribute");
	
	If selector
		
		Select Attribute
			Case #JsGridData
				! selector.jsGrid("option", "data", Value);
				! selector.jsGrid("refresh");
			Case #JsGridFields
				! selector.jsGrid("option", "fields", Value);
				! selector.jsGrid("refresh");
			Case #JsGridOptions
				! selector.jsGrid("option", "fields", Value);
				! selector.jsGrid("refresh");
		EndSelect
		
	EndIf
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "SetGadgetAttribute", @JsGridGadget_SetGadgetAttribute())

Procedure JsGridGadget_BindGadgetEvent(Gadget, Callback, EventType = #PB_All)
	
	If EventType = #PB_All
		EventType = #PB_EventType_LeftClick
	EndIf
	
	! var selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("BindGadgetEvent");
	!	var cb = Callback;
	!	if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) selector.data("onRowClick", cb);
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "BindGadgetEvent", @JsGridGadget_BindGadgetEvent())

Procedure JsGridGadget_FreeGadget(Gadget)
	
	! var selector = $("#" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("FreeGadget");
	! selector.jsGrid("destroy");
	!	selector.remove();
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "FreeGadget", @JsGridGadget_FreeGadget())

Procedure JsGridGadget_ResizeGadget(Gadget, x, y, Width, Height)
	
	! var selector = $("#g_" + Gadget);
	!	if (selector.length === 0) return cCommon.GadgetIsNotInitialized("ResizeGadget");
	
	!	if (x !== cConstants.PB_Ignore) selector.css("left", x);
	!	if (y !== cConstants.PB_Ignore) selector.css("top", y);
	!	if (Width !== cConstants.PB_Ignore) selector.css("width", Width);	
	!	if (Height !== cConstants.PB_Ignore) selector.css("height", Height);	
	
	! selector.jsGrid("refresh");
	
EndProcedure
RegisterUserGadgetProcedure("JsGridGadget", "ResizeGadget", @JsGridGadget_ResizeGadget())

; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 47
; FirstLine = 10
; Folding = D-
; EnableXP