﻿Enumeration
	; Attributes
	#PB_Table_RowSpan
	#PB_Table_ColSpan
	#PB_Table_CSS
EndEnumeration

Procedure TableLayoutGadget(Gadget, x, y, Width, Height, Rows, Columns, Flags = 0)
	
	!	var Gadget = cCommon.SetGadgetAndStuff(Gadget);
	!	var selector = $("<table />");
	
	! for (var row = 0; row < Rows; row++) {
	!		var tr = $("<tr>");
	!		for (var col = 0; col < Columns; col++) {
	!			$("<td />").appendTo(tr);
	!   }
	!		tr.appendTo(selector);
	! }	
	
	!	selector.attr("id", "g_" + Gadget);
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	!	selector.data("GadgetType", "TableLayoutGadget");
	!	cCommon.CurrentContainer.append(selector);
	!	return Gadget;
	
EndProcedure

Procedure TableLayoutGadget_AddGadgetItem(TableLayoutGadget, Position, Gadget.s)
	
	! // remove absolute-positioning
	! $("#g_" + Gadget).css("position", "");
	! $("#g_" + Gadget + "-button").css("position", "");
	
	! var row = Position.toFixed(1).split(".")[0];
	! var col = Position.toFixed(1).split(".")[1];
	! var table = $("#g_" + TableLayoutGadget)[0];
	! var cell = table.rows[row].cells[col];
	! // $(cell).empty();
	! $(cell).append($("#g_" + Gadget));
	! $(cell).append($("#g_" + Gadget + "-button"));
	
EndProcedure
RegisterUserGadgetProcedure("TableLayoutGadget", "AddGadgetItem", @TableLayoutGadget_AddGadgetItem())

Procedure TableLayoutGadget_RemoveGadgetItem(TableLayoutGadget, Position)
	
	! var row = Position.toFixed(1).split(".")[0];
	! var col = Position.toFixed(1).split(".")[1];
	! var table = $("#g_" + TableLayoutGadget)[0];
	! var cell = table.rows[row].cells[col];
	! $(cell).empty();
	
EndProcedure
RegisterUserGadgetProcedure("TableLayoutGadget", "RemoveGadgetItem", @TableLayoutGadget_RemoveGadgetItem())

Procedure TableLayoutGadget_SetGadgetItemAttribute(TableLayoutGadget, Item, Attribute, Value, Column = 0)
	
	! var row = Item.toFixed(1).split(".")[0];
	! var col = Item.toFixed(1).split(".")[1];
	! var table = $("#g_" + TableLayoutGadget)[0];
	! var cell = table.rows[row].cells[col];
	! switch (Attribute) {
	!		case PB_Table_RowSpan:
	!			$(cell).attr("rowspan", Value);
	!			break;
	!		case PB_Table_ColSpan:
	!			$(cell).attr("colspan", Value);
	!			break;
	!		case PB_Table_CSS:
	!			$(cell).css(Value, Column);
	!			break;
	! }
EndProcedure
RegisterUserGadgetProcedure("TableLayoutGadget", "SetGadgetItemAttribute", @TableLayoutGadget_SetGadgetItemAttribute())
; IDE Options = PureBasic 5.42 Beta 1 LTS (Windows - x86)
; CursorPosition = 30
; FirstLine = 16
; Folding = -
; EnableXP