﻿; UploadGadget

EnableExplicit

; OpenLibrary(#PB_Any, "userlibraries/dropzone/min/dropzone.min.css")
; OpenLibrary(#PB_Any, "userlibraries/dropzone/min/basic.min.css")
OpenLibrary(#PB_Any, "userlibraries/dropzone/min/dropzone.min.js")

; -------

Structure sUploadFile
	name.s
	size.i
	type.s
EndStructure

Structure sUploadResponse
	status.s
	message.s
EndStructure


Enumeration
	#PB_EventType_Upload_Drop = 1
	#PB_EventType_Upload_DragStart = 2
	#PB_EventType_Upload_DragEnd = 4
	#PB_EventType_Upload_DragEnter = 8
	#PB_EventType_Upload_DragOver = 16
	#PB_EventType_Upload_DragLeave = 32
	#PB_EventType_Upload_AddedFile = 64
	#PB_EventType_Upload_RemovedFile = 128
	#PB_EventType_Upload_Thumbnail = 256
	#PB_EventType_Upload_Error = 512
	#PB_EventType_Upload_Processing = 1024
	#PB_EventType_Upload_UploadProgress = 2048
	#PB_EventType_Upload_Sending = 4096
	#PB_EventType_Upload_Success = 8192
	#PB_EventType_Upload_Complete = 16384
	#PB_EventType_Upload_Canceled = 32768
	#PB_EventType_Upload_MaxFilesReached = 65536
	#PB_EventType_Upload_MaxFilesExceeded = 131072
	#PB_EventType_Upload_TotalUploadProgress = 262144
EndEnumeration

Procedure UploadGadget_BindGadgetEvent(Gadget, Callback, EventType)
	
	! var selector = $("#g_" + Gadget);
	
	If EventType = #PB_All
		EventType = #PB_EventType_Upload_Drop | 
		            #PB_EventType_Upload_DragStart | 
		            #PB_EventType_Upload_DragEnd | 
		            #PB_EventType_Upload_DragEnter | 
		            #PB_EventType_Upload_DragOver | 
		            #PB_EventType_Upload_DragLeave | 
		            #PB_EventType_Upload_AddedFile | 
		            #PB_EventType_Upload_RemovedFile | 
		            #PB_EventType_Upload_Thumbnail | 
		            #PB_EventType_Upload_Error | 
		            #PB_EventType_Upload_Processing | 
		            #PB_EventType_Upload_UploadProgress | 
		            #PB_EventType_Upload_Sending | 
		            #PB_EventType_Upload_Success | 
		            #PB_EventType_Upload_Complete | 
		            #PB_EventType_Upload_Canceled | 
		            #PB_EventType_Upload_MaxFilesReached | 
		            #PB_EventType_Upload_MaxFilesExceeded |
		            #PB_EventType_Upload_TotalUploadProgress
	EndIf	
	
	!	var cb = Callback;
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Drop))      selector.data("onDrop", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_DragStart)) selector.data("onDragStart", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_DragEnd))   selector.data("onDragEnd", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_DragEnter)) selector.data("onDragEnter", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_DragOver))  selector.data("onDragOver", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_DragLeave)) selector.data("onDragLeave", cb);
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_AddedFile))        selector.data("onAddedFile", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_RemovedFile))      selector.data("onRemovedFile", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Thumbnail))        selector.data("onThumbnail", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Error))            selector.data("onError", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Processing))       selector.data("onProcessing", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_UploadProgress))   selector.data("onUploadProgress", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Sending))          selector.data("onSending", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Success))          selector.data("onSuccess", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Complete))         selector.data("onComplete", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_Canceled))         selector.data("onCanceled", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_MaxFilesReached))  selector.data("onMaxFilesReached", cb);
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_MaxFilesExceeded)) selector.data("onMaxFilesExceeded", cb);
	
	!	if (cCommon.CheckFlag(EventType, PB_EventType_Upload_TotalUploadProgress)) selector.data("onTotalUploadProgress", cb);
	
EndProcedure
RegisterUserGadgetProcedure("UploadGadget", "BindGadgetEvent", @UploadGadget_BindGadgetEvent())

Procedure UploadGadget_RemoveGadgetItem(Gadget, Position)
	
	! var selector = $("#g_" + myUploadGadget);
	! if (selector) {
	! 	var myDropzone = selector.data("dropzone");
	! 	if (myDropzone) {
	! 		myDropzone.removeFile(Position);
	! 	}
	! }
	
EndProcedure
RegisterUserGadgetProcedure("UploadGadget", "RemoveGadgetItem", @UploadGadget_RemoveGadgetItem())

Procedure UploadGadget(Gadget, x, y, Width, Height, TargetUrl.s, Text.s = "Drop files here or click to upload.")
	
	!	if (Gadget === cConstants.PB_Any) { Gadget = cCommon.guid(); }
	!	if ($("#g_" + Gadget).length > 0) { cGadget.FreeGadget(Gadget); };
	!	if (cCommon.CurrentContainer === null) { cCommon.CurrentContainer = $("body"); }
	
	! var selector = $(	"<div>" + Text + "</div>" );	
	
	!	selector.attr("id", "g_" + Gadget);
	!	selector.css("border", "1px solid black");
	!	cCommon.SetGadgetPosition(selector, x, y, Width, Height);
	
	!	cCommon.CurrentContainer.append(selector);
	
	
	Protected previewTemplate.s = "<div class='dz-preview dz-file-preview' style='display:none'>" + 
	                              "<div class='dz-details'>" + 
	                              "<div class='dz-filename'><span data-dz-name></span></div>" + 
	                              "<div class='dz-size' data-dz-size></div>" + 
	                              "<img data-dz-thumbnail />" + 
	                              "</div>" + 
	                              "<div class='dz-progress'><span class='dz-upload' data-dz-uploadprogress></span></div>" + 
	                              "<div class='dz-success-mark'><span>OK</span></div>" + 
	                              "<div class='dz-error-mark'><span>Error</span></div>" + 
	                              "<div class='dz-error-message'><span data-dz-errormessage></span></div>" + 
	                              "</div>"	
	
	! var myDropzone = new Dropzone("#g_" + Gadget, { 
	! 	url: TargetUrl,
	! 	createImageThumbnails: false,
	! 	previewTemplate: previewTemplate,
	! });
	
	! selector.data("dropzone", myDropzone)
	
	; ******
	; Events
	; ******
	
	; All of these receive the event as first parameter:
	
	; drop: The user dropped something onto the dropzone
	! myDropzone.on('drop', function(event) { 
	!		if (selector.data("onDrop")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Drop;
	!			selector.data("onDrop")(event);
	!		}
	! });
	
	; dragstart: The user started to drag anywhere
	; dragend: Dragging has ended
	; dragenter: The user dragged a file onto the Dropzone
	; dragover: The user is dragging a file over the Dropzone
	; dragleave: The user dragged a file out of the Dropzone
	
	; [...]
	
	; All of these receive the file as first parameter:
	
	; addedfile: When a file is added to the list
	! myDropzone.on('addedfile', function(file) { 
	!		if (selector.data("onAddedFile")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_AddedFile;
	!			selector.data("onAddedFile")(file);
	!		}
	! });
	
	; removedfile: Called whenever a file is removed from the list. You can listen to this and delete the file from your server if you want to.
	! myDropzone.on('removedfile', function(file) { 
	!		if (selector.data("onRemovedFile")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_RemovedFile;
	!			selector.data("onRemovedFile")(file);
	!		}
	! });
	
	; thumbnail: When the thumbnail has been generated. Receives the dataUrl as second parameter.
	! myDropzone.on('thumbnail', function(file, dataUrl) { 
	!		if (selector.data("onThumbnail")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Thumbnail;
	!			selector.data("onThumbnail")(file, dataUrl);
	!		}
	! });
	
	; error: An error occured. Receives the errorMessage as second parameter and if the error was due to the XMLHttpRequest the xhr object as third.
	! myDropzone.on('error', function(file, errorMessage, xhr) { 
	!		if (selector.data("onError")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Error;
	!			selector.data("onError")(file, errorMessage, xhr);
	!		}
	! });

	; processing: When a file gets processed (since there is a queue not all files are processed immediately). This event was called processingfile previously.
	! myDropzone.on('processing', function(file) { 
	!		if (selector.data("onProcessing")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Processing;
	!			selector.data("onProcessing")(file);
	!		}
	! });
	
	; uploadprogress: Gets called periodically whenever the file upload progress changes. Gets the progress parameter as second parameter
	; which is a percentage (0-100) and the bytesSent parameter as third which is the number of the bytes that have been sent to the server.
	; When an upload finishes dropzone ensures that uploadprogress will be called with a percentage of 100 at least once. 
	; Warning: This function can potentially be called with the same progress multiple times.
	! myDropzone.on('uploadprogress', function(file, progress, bytesSent) { 
	!		if (selector.data("onUploadProgress")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_UploadProgress;
	!			selector.data("onUploadProgress")(file, progress, bytesSent);
	!		}
	! });
	
	; sending: Called just before each file is sent. Gets the xhr object and the formData objects as second and third parameters, so you can 
	; modify them (for example to add a CSRF token) or add additional data.
	! myDropzone.on('sending', function(file, xhr, formData) { 
	!		if (selector.data("onSending")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Sending;
	!			selector.data("onSending")(file, xhr, formData);
	!		}
	! });
	
	; success: The file has been uploaded successfully. Gets the server response as second argument. (This event was called finished previously)
	! myDropzone.on('success', function(file, response) { 
	!		if (selector.data("onSuccess")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Success;
	!			selector.data("onSuccess")(file, response);
	!		}
	! });
	
	; complete: Called when the upload was either successful or erroneous.
	! myDropzone.on('complete', function(file) { 
	!		if (selector.data("onComplete")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Complete;
	!			selector.data("onComplete")(file);
	!		}
	! });
	
	; canceled: Called when a file upload gets canceled.
	! myDropzone.on('canceled', function(file) { 
	!		if (selector.data("onCanceled")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_Canceled;
	!			selector.data("onCanceled")(file);
	!		}
	! });
	
	; maxfilesreached: Called when the number of files accepted reaches the maxFiles limit.
	! myDropzone.on('maxfilesreached', function(file) { 
	!		if (selector.data("onMaxFilesReached")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_MaxFilesReached;
	!			selector.data("onMaxFilesReached")(file);
	!		}
	! });
	
	; maxfilesexceeded: Called for each file that has been rejected because the number of files exceeds the maxFiles limit.	
	! myDropzone.on('maxfilesexceeded', function(file) { 
	!		if (selector.data("onMaxFilesExceeded")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_MaxFilesExceeded;
	!			selector.data("onMaxFilesExceeded")(file);
	!		}
	! });
	
	
	; All of these receive a list of files as first parameter and are only called if the uploadMultiple option is true:
	
	; processingmultiple: See processing for description.
	; sendingmultiple: See sending for description.
	; successmultiple: See success for description.
	; completemultiple: See complete for description.
	; canceledmultiple: See canceled for description.	
	
	; [...]
	
	; Special events:
	
	; totaluploadprogress: Called with the total uploadProgress (0-100), the totalBytes and the totalBytesSent. 
	; This event can be used to show the overall upload progress of all files.
	! myDropzone.on('totaluploadprogress', function(totalPercentage, totalBytesToBeSent, totalBytesSent) { 
	!		if (selector.data("onTotalUploadProgress")) {
	!			cEvent.eventGadget = Gadget;
	!			cEvent.eventType = PB_EventType_Upload_TotalUploadProgress;
	!			selector.data("onTotalUploadProgress")(totalPercentage, totalBytesToBeSent, totalBytesSent);
	!		}
	! });	
	
	
	; maxfilesexceeded: Called for each file that has been rejected because the number of files exceeds the maxFiles limit.	
	; reset: Called when all files in the list are removed and the dropzone is reset to initial state.
	; queuecomplete: Called when all files in the queue finish uploading.	
	
	; [...]
	
	
	
	!	selector.data("GadgetType", "UploadGadget");
	
	!	return Gadget;
	
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 284
; FirstLine = 268
; Folding = --
; EnableUnicode
; EnableXP