XIncludeFile "..\p2w.pbi"

XIncludeFile "2DDrawingTest.pbf"

P2W_Converter_SetProfile("pb2webtest")

OpenWindow_0()

EnableExplicit

Procedure DrawCircles(Output)
	
	Protected Radius
	
	StartDrawing(Output)
	
	For Radius = 100 To 10 Step -10
		Circle(100, 100, Radius, RGB(Random(255), Random(255), Random(255)))
	Next
	
	StopDrawing() 
	
EndProcedure

Procedure DrawBoxes(Output)
	
	Protected x, y
	
	StartDrawing(Output)
	
	y = 0
	
	For x = 0 To 95 Step 10
		Box(x, y, 200-2*x, 200-2*y, RGB(Random(255), Random(255), Random(255)))
		y + 10        ; the same as y = y + 10
	Next x
	
	StopDrawing() 
	
EndProcedure
 
Procedure DrawRoundBoxes(Output)
	
	Protected x, y
	
	StartDrawing(Output)
	
	y = 0
	
	For x = 0 To 95 Step 10
  	RoundBox(x, y, 200-2*x, 200-2*y, 10, 30, RGB(Random(255), Random(255), Random(255)))
		y + 10 
	Next x
	
	StopDrawing() 
	
EndProcedure

Procedure DrawTestText(Output)
	
	Protected x, y
	
	StartDrawing(Output)
	
	Protected myFont1 = LoadFont(#PB_Any, "Arial", 12)
	Protected myFont2 = LoadFont(#PB_Any, "Arial", 14, #PB_Font_Italic)
	Protected myFont3 = LoadFont(#PB_Any, "Arial", 14, #PB_Font_Bold)
	
	DrawingFont(myFont1)
	DrawText(10, 10, "Hello1", RGB(0, 0, 0))
	
	DrawingFont(myFont2)
	DrawText(10, 100, "Hello2", RGB(0, 0, 0))
	
	DrawingFont(myFont3)
	DrawText(10, 150, "Hello2", RGB(0, 0, 0))
	
	StopDrawing() 
	
EndProcedure

Procedure DrawLines(Output)
	
	Protected Width
	
	StartDrawing(Output)
	
	For Width = 1 To 180 Step 5
		Line(10, 10, Width, 180, RGB(Random(255), Random(255), Random(255)))	
	Next Width
	
	StopDrawing() 
	
EndProcedure

Procedure DrawXYLines(Output)
	
  Protected Angle
  Protected x1, y1, x2, y2
  
  StartDrawing(Output)
  
  For Angle = 0 To 360 Step 3
    
    x1 = 100
    y1 = 100
    x2 = 100 + Cos(Radian(Angle)) * 90
    y2 = 100 + Sin(Radian(Angle)) * 90
    
    LineXY(x1, y1, x2, y2, RGB(Random(255), Random(255), Random(255)))
    
  Next Angle
  
  StopDrawing() 
	
EndProcedure

Procedure DrawEllipses(Output)
	
; 	Protected radius
; 	
; 	StartDrawing(Output)
; 	For radius = 50 To 10 Step -10
; 		Ellipse(100, 100, radius*2, radius, RGB(Random(255), Random(255), Random(255)))
; 	Next radius
; 	StopDrawing() 
	
EndProcedure

Procedure PlotPixel(Output)
	
	Protected x, y
	
	StartDrawing(Output)
	For x = 0 To 199
		For y = 0 To 199
			Plot(x, y, RGB(Random(255), Random(255), Random(255)))
		Next y
	Next x
	StopDrawing() 	
	
EndProcedure

Define z1, z2

; ImageGadgets

z1 = ElapsedMilliseconds()

CreateImage(0, 200, 200) 
DrawCircles(ImageOutput(0))
SetGadgetState(#myImageGadget_0, ImageID(0))
FreeImage(0)

CreateImage(0, 200, 200) 
DrawBoxes(ImageOutput(0))
SetGadgetState(#myImageGadget_1, ImageID(0))
FreeImage(0)

CreateImage(0, 200, 200) 
DrawLines(ImageOutput(0))
SetGadgetState(#myImageGadget_2, ImageID(0))
FreeImage(0)

CreateImage(0, 200, 200) 
DrawXYLines(ImageOutput(0))
SetGadgetState(#myImageGadget_3, ImageID(0))
FreeImage(0)

CreateImage(0, 200, 200) 
PlotPixel(ImageOutput(0))
SetGadgetState(#myImageGadget_4, ImageID(0))
FreeImage(0)

z2 = ElapsedMilliseconds()

Debug "ImageOutput(): " + Str(z2-z1)

; CanvasGadgets

z1 = ElapsedMilliseconds()

DrawCircles(CanvasOutput(#myCanvasGadget_0))
DrawBoxes(CanvasOutput(#myCanvasGadget_1))
;DrawRoundBoxes(CanvasOutput(#myCanvasGadget_1))
;DrawTestText(CanvasOutput(#myCanvasGadget_1))
DrawLines(CanvasOutput(#myCanvasGadget_2))
DrawXYLines(CanvasOutput(#myCanvasGadget_3))
PlotPixel(CanvasOutput(#myCanvasGadget_4))

z2 = ElapsedMilliseconds()

Debug "CanvasOutput(): " + Str(z2-z1)

; IDE Options = PureBasic 5.42 Beta 5 LTS (Windows - x86)
; CursorPosition = 40
; Folding = B9
; EnableXP