XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Enumeration 
  #Window1
  #Window2
EndEnumeration

Enumeration 
  #Window1_CanvasGadget
  #Window1_TrackbarGadget
  #Window2_CanvasGadget
EndEnumeration

Procedure Draw(Angle.f)
  
  Protected Width  = GadgetWidth(#Window1_CanvasGadget)
  Protected Height = GadgetHeight(#Window1_CanvasGadget)
  
  Protected i
  
  If StartDrawing(CanvasOutput(#Window1_CanvasGadget))
    
    Box(0, 0, Width, Height, RGB($80,$80,$80))
    
    For i = 0 To 720 Step 20
      
      LineXY(Width * 0.5 + Sin((i - 360) / 270) * (Width * 0.4), Height * 0.8 - Cos((i - 360) / 270) * (Height * 0.4),
             Width * 0.5 + Sin((i - 360) / 270) * (Width * 0.45), Height * 0.8 - Cos((i - 360) / 270) * (Height * 0.45))
      
    Next
    
    LineXY(Width * 0.5, Height * 0.8, Width * 0.5 + Sin(Angle / 270) * (Width * 0.4), Height * 0.8 - Cos(Angle / 270) * (Height * 0.4), RGB(0, 0, 0))
    
    StopDrawing()
    
  EndIf
  
EndProcedure

Procedure CanvasEvent()
	
	Protected x, y
	
	If EventType() = #PB_EventType_LeftButtonDown Or
	   (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(#Window2_CanvasGadget, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
		
		If StartDrawing(CanvasOutput(#Window2_CanvasGadget))
			
			x = GetGadgetAttribute(2, #PB_Canvas_MouseX)
			y = GetGadgetAttribute(2, #PB_Canvas_MouseY)
			
			Circle(x, y, 10, RGB(Random(255), Random(255), Random(255)))
			
			StopDrawing()
			
		EndIf
		
	EndIf
  
EndProcedure

Procedure TrackBarGadgetEvent()
  
  Draw(GetGadgetState(#Window1_TrackbarGadget) - 360)
  
EndProcedure

; Window1 -> Needle

OpenWindow(#Window1, 100, 100, 200, 230, "Needle", #PB_Window_SystemMenu)
CanvasGadget(#Window1_CanvasGadget, 10, 10, 180, 180)
TrackBarGadget(#Window1_TrackbarGadget, 10, 200, 180, 20, 0, 720)
SetGadgetState(#Window1_TrackbarGadget, 360)
BindGadgetEvent(#Window1_TrackbarGadget, @TrackBarGadgetEvent())
TrackBarGadgetEvent()

; Window2 -> Paint!

OpenWindow(#Window2, 350, 350, 220, 220, "Paint!", #PB_Window_SystemMenu)
CanvasGadget(#Window2_CanvasGadget, 10, 10, 200, 200)

BindGadgetEvent(#Window2_CanvasGadget, @CanvasEvent(), #PB_EventType_LeftButtonDown)
BindGadgetEvent(#Window2_CanvasGadget, @CanvasEvent(), #PB_EventType_LeftButtonUp)
BindGadgetEvent(#Window2_CanvasGadget, @CanvasEvent(), #PB_EventType_MouseMove)

P2W_Converter_Begin_Comment
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
P2W_Converter_End_Comment


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 24
; Folding = -
; EnableXP