XIncludeFile "..\..\p2w.pbi"

EnableExplicit

Enumeration
	#ComboBoxRegular
	#ComboBoxEditable
	#ComboBoxImage
	#ComboBoxSimple
EndEnumeration

Global ComboBox_X      =  10
Global ComboBox_Y      =  20
Global ComboBox_Width  = 300
Global ComboBox_Height =  30

Procedure CheckValues(Value1, Value2, DebugOutputText.s)
	
	If Value1 = Value2
		Debug DebugOutputText + ": success"
	Else
		Debug "!!! " + DebugOutputText + ": failed"
		Debug "Value1: " + Str(Value1)
		Debug "Value2: " + Str(Value2)
	EndIf
	
EndProcedure

Procedure CheckValues2(Value1.s, Value2.s, DebugOutputText.s)
	
	If Value1 = Value2
		Debug DebugOutputText + ": success"
	Else
		Debug "!!! " + DebugOutputText + ": failed"
		Debug "Value1: " + Str(Value1)
		Debug "Value2: " + Str(Value2)
	EndIf
	
EndProcedure

Procedure TestComboBoxGadget(ComboBoxGadget)
	
	If IsGadget(ComboBoxGadget)
		Debug "IsGadget(): success"
	Else
		Debug "IsGadget(): failed"
	EndIf
	
	CheckValues(GadgetX     (ComboBoxGadget), ComboBox_X,      "GadgetX()")
	CheckValues(GadgetY     (ComboBoxGadget), ComboBox_Y,      "GadgetY()")
	CheckValues(GadgetWidth (ComboBoxGadget), ComboBox_Width,  "GadgetWidth()")
	CheckValues(GadgetHeight(ComboBoxGadget), ComboBox_Height, "GadgetHeight()")
	
	ResizeGadget(ComboBoxGadget, 
	             ComboBox_X + 10, 
	             ComboBox_Y + 10,
	             ComboBox_Width + 10, 
	             ComboBox_Height + 10)
	
	CheckValues(GadgetX     (ComboBoxGadget), ComboBox_X + 10,      "GadgetX() after ResizeGadget()")
	CheckValues(GadgetY     (ComboBoxGadget), ComboBox_Y + 10,      "GadgetY() after ResizeGadget()")
	CheckValues(GadgetWidth (ComboBoxGadget), ComboBox_Width + 10,  "GadgetWidth() after ResizeGadget()")
	CheckValues(GadgetHeight(ComboBoxGadget), ComboBox_Height + 10, "GadgetHeight() after ResizeGadget()")
	
	
	; CountGadgetItems()
	
	Protected Counter 
	
	For Counter = 0 To 10
		AddGadgetItem(ComboBoxGadget, -1, "Item " + Str(Counter))
	Next
	
	CheckValues(CountGadgetItems(ComboBoxGadget), 11, "CountGadgetItems()")
	
	; RemoveGadgetItem() / CountGadgetItems()
	
	RemoveGadgetItem(ComboBoxGadget, 0)
	
	CheckValues(CountGadgetItems(ComboBoxGadget), 10, "CountGadgetItems() after removing 1 item")
	
	; SetGadgetText() / GetGadgetText()
	
	SetGadgetText(ComboBoxGadget, "Item 5")
	
	CheckValues2(GetGadgetText(ComboBoxGadget), "Item 5", "GetGadgetText() after SetGadgetText()")
	
	; SetGadgetItemText() / GetGadgetItemText()
	
	SetGadgetItemText(ComboBoxGadget, 5, "TestItem 5")
	
	CheckValues2(GetGadgetItemText(ComboBoxGadget, 5), "TestItem 5", "GetGadgetItemText() after SetGadgetItemText()")
	
	; finally ClearGadgetItems() / CountGadgetItems()
	
	ClearGadgetItems(ComboBoxGadget)
	
	CheckValues(CountGadgetItems(ComboBoxGadget), 0, "CountGadgetItems() after ClearGadgetItems()")
	
	FreeGadget(ComboBoxGadget)
	
	If IsGadget(ComboBoxGadget)
		Debug "FreeGadget(): failed"
	Else
		Debug "FreeGadget(): success"
	EndIf
	
EndProcedure

; The following functions can be used to act on the list contents: 
; 
; - AddGadgetItem(): Add an item. 
; - ClearGadgetItems(): Remove all the items. 
; - CountGadgetItems(): Count the items in the current combobox. 
; - GetGadgetItemData(): Returns the value that was stored with item. 
; - GetGadgetItemText(): Returns the gadget item text. 
; - GetGadgetState(): Get the index (starting from 0) of the current element. 
; - GetGadgetText(): Get the (text) content of the current element. 
; - RemoveGadgetItem(): Remove an item. 
; - SetGadgetItemData(): Stores a value with the item. 
; - SetGadgetItemImage(): Changes the gadget item image (need to be created with the #PB_ComboBox_Image flag). 
; - SetGadgetItemText(): Changes the gadget item text. 
; - SetGadgetState(): Change the selected element. 
; - SetGadgetText(): Set the displayed text. If the ComboBoxGadget is not editable, the text must be in the dropdown list. 

Define NumberOfDomElements

Debug "Testing ComboBoxes..."

! NumberOfDomElements = $('*').length;

Debug "Number of DOM Elements: " + Str(NumberOfDomElements)

ComboBoxGadget(#ComboBoxRegular, ComboBox_X, ComboBox_Y, ComboBox_Width, ComboBox_Height)
Debug "Testing #ComboBoxRegular..."
TestComboBoxGadget(#ComboBoxRegular)
Debug "---- Ready ----"

ComboBoxGadget(#ComboBoxEditable, ComboBox_X, ComboBox_Y, ComboBox_Width, ComboBox_Height, #PB_ComboBox_Editable)
Debug "Testing #ComboBoxEditable..."
TestComboBoxGadget(#ComboBoxEditable)
Debug "---- Ready ----"

ComboBoxGadget(#ComboBoxImage, ComboBox_X, ComboBox_Y, ComboBox_Width, ComboBox_Height, #PB_ComboBox_Image)
Debug "Testing #ComboBoxImage..."
TestComboBoxGadget(#ComboBoxImage)
Debug "---- Ready ----"

ComboBoxGadget(#ComboBoxSimple, ComboBox_X, ComboBox_Y, ComboBox_Width, ComboBox_Height, #PB_ComboBox_Simple)
Debug "Testing #ComboBoxSimple..."
TestComboBoxGadget(#ComboBoxSimple)
Debug "---- Ready ----"

! NumberOfDomElements = $('*').length;

Debug "Number of DOM Elements: " + Str(NumberOfDomElements)
; IDE Options = PureBasic 5.40 LTS Beta 8 (Windows - x86)
; CursorPosition = 125
; FirstLine = 72
; Folding = 6
; EnableXP