EnableExplicit

XIncludeFile "..\..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

XIncludeFile "ListIconGadget.pbf"

Procedure Add100ItemsClassic()
	
  Protected Counter
  
  For Counter = 1 To 100
    AddGadgetItem(#ListIcon_0, -1, "Line " + Str(Counter) + " / Col 1" + #LF$ + "Line " + Str(Counter) + " / Col 2" + #LF$ + "Line " + Str(Counter) + " / Col 3")
  Next
  
  DisableGadget(#cmdAdd100ItemsClassic, #True)
  DisableGadget(#cmdAdd100ItemsFast,    #True)
  
  BlockWindow(#frmMain, #False)
	
EndProcedure

Procedure cmdAdd100ItemsClassic_Event()
	
	BlockWindow(#frmMain, #True, "Just a moment...", "", @Add100ItemsClassic())
  
EndProcedure

Procedure Add100ItemsFast()
	
  Protected Counter
  
  Protected Items.s = ""
  
  For Counter = 1 To 100
  	
  	Items + "Line " + Str(Counter) + " / Col 1" + #LF$ + "Line " + Str(Counter) + " / Col 2" + #LF$ + "Line " + Str(Counter) + " / Col 3"
  	
  	If Counter < 100
  		Items + #CR$
  	EndIf
  	
  Next
  
  AddGadgetItem(#ListIcon_0, -1, Items)
  
  DisableGadget(#cmdAdd100ItemsClassic, #True)
  DisableGadget(#cmdAdd100ItemsFast,    #True)

  BlockWindow(#frmMain, #False)
  
  SetGadgetState(#ListIcon_0, 50)
  
EndProcedure
	
Procedure cmdAdd100ItemsFast_Event()
  
 	BlockWindow(#frmMain, #True, "Just a moment...", "", @Add100ItemsFast())
  
EndProcedure

Procedure cmdClearGadgetItems_Event()
  ClearGadgetItems(#ListIcon_0)
  DisableGadget(#cmdAdd100ItemsClassic, #False)
  DisableGadget(#cmdAdd100ItemsFast,    #False)
EndProcedure

Procedure cmdSetGadgetState_Event()
  SetGadgetState(#ListIcon_0, 10)
EndProcedure

Procedure cmdSetGadgetStateMinusOne_Event()
  SetGadgetState(#ListIcon_0, -1)
EndProcedure

Procedure cmdGetGadgetState_Event()
	Debug GetGadgetState(#ListIcon_0)
EndProcedure

Procedure cmdSetGadgetItemAttribute_Event()
  SetGadgetItemAttribute(#ListIcon_0, 0, #PB_ListIcon_ColumnWidth, 200, 1)
EndProcedure

Procedure cmdGetGadgetItemAttribute_Event()
  Debug "ColumnWidth: " + Str(GetGadgetItemAttribute(#ListIcon_0, 0, #PB_ListIcon_ColumnWidth, 1))
EndProcedure

Procedure cmdGetGadgetText_Event()
  Debug GetGadgetText(#ListIcon_0)
EndProcedure

Procedure cmdSetGadgetText_Event()
	If GetGadgetState(#ListIcon_0)=-1
		Debug "Please select a row"
	Else
		SetGadgetText(#ListIcon_0, "Hello")
	EndIf
EndProcedure

Procedure cmdGetGadgetItemText_Event()
  Debug "RowHeader: " + GetGadgetItemText(#ListIcon_0, -1, 1)
  Debug GetGadgetItemText(#ListIcon_0, 1, 1)
EndProcedure

Procedure cmdSetGadgetItemText_Event()
  SetGadgetItemText(#ListIcon_0, -1, "New ColumnText", 1)
  SetGadgetItemText(#ListIcon_0,  1, "New CellText",   1)
EndProcedure

Procedure cmdGetGadgetCsv_Event()
	
	Protected CSV.s = GetGadgetCsv(#ListIcon_0)
	
	If Len(CSV) > 500
		CSV = Left(CSV, 500) + " ... and more."
	EndIf
	
	; for a better diplay: replace all spaces to @nbsp;
	CSV = ReplaceString(CSV, " ", "&nbsp;")
	
	MessageRequester("CSV", CSV)
	
EndProcedure

Procedure ListIconEvent()
	
	Select EventType()
			
		Case #PB_EventType_LeftClick
			Debug "LeftClick: " + Str(GetGadgetState(#ListIcon_0))
		Case #PB_EventType_LeftDoubleClick
			Debug "LeftDoubleClick: " + Str(GetGadgetState(#ListIcon_0))
		Case #PB_EventType_RightClick
			Debug "RightClick: " + Str(GetGadgetState(#ListIcon_0))
		Case #PB_EventType_Select
			Debug "Select: " + Str(GetGadgetState(#ListIcon_0))
		Case #PB_EventType_Unselect
			Debug "Unselect"
		Case #PB_EventType_Change
			Debug "Change: " + Str(GetGadgetState(#ListIcon_0))
		Default
			Debug "unknown event"
			
	EndSelect
	
EndProcedure

Procedure.s myCustomRenderer(record, index, column_index)
	
	ProcedureReturn "This is a <font color='" + StringField("#FF0000|#00FF00|#0000FF", Random(3,1), "|") + "'>rendered</font> content of line " + Str(index + 1) + " col " + Str(column_index + 1)
	
EndProcedure

OpenfrmMain()

WindowBounds(#frmMain, 570, 590, #PB_Ignore, #PB_Ignore) 

; make the first column non-resizable:
SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_Resizable, #False, 0)

; make the second column sortable:
SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_Sortable, #True, 1)

; make the second column editable:
If ParseJSON(0, "{ " + Chr(34) + "type" + Chr(34) + " : " + Chr(34) + "text" + Chr(34) + " }")
	SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_Editable, JSONValue(0), 1)
	FreeJSON(0)
Else
	Debug JSONErrorMessage()
EndIf


; set a custom renderer to the third column:
SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_CustomRenderer, @myCustomRenderer(), 2)

; if you want, you can set another ColumnDelimiter than #LF$ (for AddGadgetItem):
; SetGadgetAttribute(#ListIcon_0, #PB_ListIcon_ColumnDelimiter, @"|")

;  ... so: AddGadgetItem(#ListIcon_0, -1, "First" + #LF$ + "Second")
; becomes: AddGadgetItem(#ListIcon_0, -1, "First|Second")

; ... and also with Records...
; SetGadgetAttribute(#ListIcon_0, #PB_ListIcon_RecordDelimiter, @"#")

; Align first column left (standard):
SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_Alignment, #PB_ListIcon_Align_Left, 0)

; ... the second column center:
SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_Alignment, #PB_ListIcon_Align_Center, 1)

; ... and third column right:
SetGadgetItemAttribute(#ListIcon_0, #PB_Ignore, #PB_ListIcon_Alignment, #PB_ListIcon_Align_Right, 2)

; same for the column alignments (must be executed after every ListIconGadget-Manipulation):
; ! $("#grid_g_" + ListIcon_0 + "_column_0").css("text-align", "left");
; ! $("#grid_g_" + ListIcon_0 + "_column_1").css("text-align", "center");
; ! $("#grid_g_" + ListIcon_0 + "_column_2").css("text-align", "right");


BindEvent(#PB_Event_SizeWindow, @ResizeGadgetsfrmMain(), #frmMain)

BindGadgetEvent(#cmdAdd100ItemsClassic,     @cmdAdd100ItemsClassic_Event())
BindGadgetEvent(#cmdAdd100ItemsFast,        @cmdAdd100ItemsFast_Event())
BindGadgetEvent(#cmdClearGadgetItems,       @cmdClearGadgetItems_Event())

BindGadgetEvent(#cmdSetGadgetState,         @cmdSetGadgetState_Event())
BindGadgetEvent(#cmdSetGadgetStateMinusOne, @cmdSetGadgetStateMinusOne_Event())
BindGadgetEvent(#cmdGetGadgetState,         @cmdGetGadgetState_Event())

BindGadgetEvent(#cmdSetGadgetItemAttribute, @cmdSetGadgetItemAttribute_Event())
BindGadgetEvent(#cmdGetGadgetItemAttribute, @cmdGetGadgetItemAttribute_Event())

BindGadgetEvent(#cmdGetGadgetText,          @cmdGetGadgetText_Event())
BindGadgetEvent(#cmdSetGadgetText,          @cmdSetGadgetText_Event())

BindGadgetEvent(#cmdGetGadgetItemText,      @cmdGetGadgetItemText_Event())
BindGadgetEvent(#cmdSetGadgetItemText,      @cmdSetGadgetItemText_Event())
BindGadgetEvent(#cmdGetGadgetCsv,           @cmdGetGadgetCsv_Event())

; This are the possible events:
BindGadgetEvent(#ListIcon_0, @ListIconEvent(), #PB_EventType_LeftClick)
BindGadgetEvent(#ListIcon_0, @ListIconEvent(), #PB_EventType_LeftDoubleClick)
BindGadgetEvent(#ListIcon_0, @ListIconEvent(), #PB_EventType_RightClick)
BindGadgetEvent(#ListIcon_0, @ListIconEvent(), #PB_EventType_Change)
BindGadgetEvent(#ListIcon_0, @ListIconEvent(), #PB_EventType_Select)
BindGadgetEvent(#ListIcon_0, @ListIconEvent(), #PB_EventType_Unselect)
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 58
; FirstLine = 54
; Folding = PA1
; EnableXP