; SimplePhoneList

XIncludeFile "SimplePhoneList.pbf"
XIncludeFile "..\p2w.pbi"

P2W_Converter_SetProfile("pb2webtest")

OpenfrmPhoneList()

Structure sPerson
  FirstName.s
  Name.s
  Number.s
EndStructure

Global NewList Person.sPerson()

AddElement(Person())
Person()\FirstName = "Bruce"
Person()\Name      = "Wayne"
Person()\Number    = "123"

AddElement(Person())
Person()\FirstName = "Clark"
Person()\Name      = "Kent"
Person()\Number    = "456"

AddElement(Person())
Person()\FirstName = "Peter"
Person()\Name      = "Parker"
Person()\Number    = "789"

Procedure FillListIconGadget()
  
  ClearGadgetItems(#LIG_List)
  
   ForEach Person()
     AddGadgetItem(#LIG_List, -1, Person()\FirstName + #LF$ + Person()\Name + #LF$ + Person()\Number)
     SetGadgetItemData(#LIG_List, CountGadgetItems(#LIG_List) - 1, ListIndex(Person()))
   Next
  
EndProcedure

Procedure LIG_List_Event()
	
	Protected SelectedItem = GetGadgetState(#LIG_List)
	
	If SelectedItem = -1
		
		SetGadgetText(#txtFirstName, "")
		SetGadgetText(#txtName,      "")
		SetGadgetText(#txtNumber,    "")
		
		ProcedureReturn
		
	EndIf
	
	Protected SelectedIndex = GetGadgetItemData(#LIG_List, SelectedItem)
	
	SelectElement(Person(), SelectedIndex)
	
	SetGadgetText(#txtFirstName, Person()\FirstName)
	SetGadgetText(#txtName,      Person()\Name)
	SetGadgetText(#txtNumber,    Person()\Number)
	
EndProcedure

Procedure cmdNew_Event()
	
	LastElement(Person())
	AddElement(Person())
	Person()\FirstName = "Unknown"
	Person()\Name      = "Unknown"
	Person()\Number    = "Unknown"
	
	FillListIconGadget()
	
	SetGadgetState(#LIG_List, ListSize(Person()) - 1)
	
	LIG_List_Event()
	
EndProcedure

Procedure cmdUpdate_Event()
	
	Protected SelectedIndex = ListIndex(Person())
	
	Person()\FirstName = GetGadgetText(#txtFirstName)
	Person()\Name      = GetGadgetText(#txtName)
	Person()\Number    = GetGadgetText(#txtNumber)
	
	FillListIconGadget()
	
	SetGadgetState(#LIG_List, SelectedIndex)

EndProcedure

Procedure cmdDelete_Event()
	
	If ListSize(Person()) = 0
		
		SetGadgetText(#txtFirstName, "")
		SetGadgetText(#txtName,      "")
		SetGadgetText(#txtNumber,    "")
		
		ProcedureReturn
		
	EndIf
	
	Protected SelectedIndex = ListIndex(Person())
	
	DeleteElement(Person())
	
	FillListIconGadget()
	
	SetGadgetState(#LIG_List, SelectedIndex)
	
	LIG_List_Event()

EndProcedure

BindGadgetEvent(#cmdNew, @cmdNew_Event())
BindGadgetEvent(#cmdUpdate, @cmdUpdate_Event())
BindGadgetEvent(#cmdDelete, @cmdDelete_Event())
BindGadgetEvent(#LIG_List, @LIG_List_Event(), #PB_EventType_LeftClick)

FillListIconGadget()

P2W_Converter_Begin_Comment
  Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
P2W_Converter_End_Comment
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 32
; Folding = --
; EnableXP