﻿EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\ChartGadget\ChartGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Define newRule.s = "#flot-tooltip {" + 
                   "    font-size: 12px;" + 
                   "    font-family: Verdana, Arial, sans-serif;" + 
                   "    position: absolute;" + 
                   "    display: none;" + 
                   "    border: 2px solid;" + 
                   "    padding: 2px;" + 
                   "    background-color: #FFF;" + 
                   "    opacity: 0.8;" + 
                   "    -moz-border-radius: 5px;" + 
                   "    -webkit-border-radius: 5px;" + 
                   "    -khtml-border-radius: 5px;" + 
                   "    border-radius: 5px;" + 
                   "}"

! $("style").append(newRule);

! //Rome, Italy
! var d1 = [[1262304000000, 12], [1264982400000, 13], [1267401600000, 15], [1270080000000, 18], [1272672000000, 23], [1275350400000, 27], [1277942400000, 30], [1280620800000, 30], [1283299200000, 27], [1285891200000, 22], [1288569600000, 16], [1291161600000, 13]];
! // Paris, France
! var d2 = [[1262304000000, 6], [1264982400000, 7], [1267401600000, 12], [1270080000000, 16], [1272672000000, 20], [1275350400000, 23], [1277942400000, 25], [1280620800000, 24], [1283299200000, 21], [1285891200000, 16], [1288569600000, 10], [1291161600000, 7]];
! // Madrid, Spain
! var d3 = [[1262304000000, 11], [1264982400000, 13], [1267401600000, 16], [1270080000000, 18], [1272672000000, 22], [1275350400000, 28], [1277942400000, 33], [1280620800000, 32], [1283299200000, 28], [1285891200000, 21], [1288569600000, 15], [1291161600000, 11]];
! // London, UK
! var d4 = [[1262304000000, 7], [1264982400000, 7], [1267401600000, 10], [1270080000000, 13], [1272672000000, 16], [1275350400000, 20], [1277942400000, 22], [1280620800000, 21], [1283299200000, 19], [1285891200000, 15], [1288569600000, 10], [1291161600000, 8]];
!  

Define ChartData

! ChartData = [
!             {label: "Rome, Italy",    data: d1, points: { symbol: "circle",   fillColor: "#058DC7" }, color: "#058DC7"},
!             {label: "Paris, France",  data: d2, points: { symbol: "diamond",  fillColor: "#AA4643" }, color: "#AA4643"},
!             {label: "Madrid, Spain",  data: d3, points: { symbol: "square",   fillColor: "#50B432" }, color: "#50B432"},
!             {label: "London, UK",     data: d4, points: { symbol: "triangle", fillColor: "#ED561B" }, color: "#ED561B"}
!             ]; 


Define ChartOptions

! ChartOptions = {
!		xaxis: {
!			min: (new Date(2009, 11, 18)).getTime(),
!     max: (new Date(2010, 11, 15)).getTime(),
!     mode: "time",
!     tickSize: [1, "month"],
!     monthNames: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],
!     tickLength: 0,
!     axisLabel: 'Month',
!     axisLabelUseCanvas: true,
!     axisLabelFontSizePixels: 12,
!     axisLabelFontFamily: 'Verdana, Arial, Helvetica, Tahoma, sans-serif',
!     axisLabelPadding: 5
! 	},
!		yaxis: {
!			axisLabel: 'Temperature (C)',
!			axisLabelUseCanvas: true,
!     axisLabelFontSizePixels: 12,
!     axisLabelFontFamily: 'Verdana, Arial, Helvetica, Tahoma, sans-serif',
!     axisLabelPadding: 5
! 	},
! 	series: {
!			lines: { show: true },
!     points: {
!     	radius: 3,
!				show: true,
!				fill: true
!     },
! 	},
! 	grid: {
!   	hoverable: true,
!     clickable: true, 
!			borderWidth: 1
! 	},
! 	legend: {
!			labelBoxBorderColor: "none",
!     position: "right"
! 	}
! };

Procedure LeftClickEvent(event, pos, item)
	
	Debug "flot-event: " + event
	Debug "pos: " + pos
	Debug "item: " + item
	
EndProcedure

! var previousPoint = null;

Procedure ShowToolTip(event, pos, item)
	
	!	if (item) {
	!		if ((previousPoint != item.dataIndex) || (previousLabel != item.series.label)) {
	!   	previousPoint = item.dataIndex;
	!     previousLabel = item.series.label;
	!			$("#flot-tooltip").remove();
	
	!			var month = cMoment.Moment(item.datapoint[0]).format("MMM");
	!			var value = item.datapoint[1];
	
	! 	$('<div id="flot-tooltip"><b>' + item.series.label + '</b><br />' + month + ' = ' + value + 'mm</div>').css({
	!			top: item.pageY - 30,
	!			left: item.pageX - 135,
	!     'border-color': item.series.color,
	! 	}).appendTo("body").fadeIn(200);	
	
	!		}
	!	} else {
	!		$("#flot-tooltip").remove();
	!		previousPoint = null;
	!	}
	
EndProcedure

ChartGadget(0, 100, 100, 1000, 500)

BindGadgetEvent(0, @ShowToolTip(), #PB_EventType_PlotHover)
BindGadgetEvent(0, @LeftClickEvent(), #PB_EventType_LeftClick)

ChartGadgetDraw(0, ChartData, ChartOptions);


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; Folding = 9
; EnableUnicode
; EnableXP