﻿EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\FullCalendarGadget\FullCalendarGadget.pbi"
XIncludeFile "FullCalendarGadget.pbf"

P2W_Converter_SetProfile("pb2webtest")

Enumeration FormWindow
	#frmMain
EndEnumeration

Enumeration FormGadget
	#FC
	#cmdAddEvent
	#cmdColorEvent
	#cboChangeView
EndEnumeration

Procedure frmEvent_cmdRemove_Event()
	
	RemoveGadgetItem(#FC, Val(GetGadgetText(#frmEvent_lblID2)))
	
	CloseWindow(#frmEvent)
	
EndProcedure

Procedure frmEvent_cmdOK_Event()
	
	If GetGadgetState(#frmEvent_ToDate) < GetGadgetState(#frmEvent_FromDate)
		MessageRequester("FullCalendarGadget()", "FromDate is greater than ToDate")
		ProcedureReturn
	EndIf
	
	Protected Event
	
	CreateJSON(0)
	
	Event = SetJSONObject(JSONValue(0))
	
	; for a complete list of the event-members take a look at: http://fullcalendar.io/docs/event_data/Event_Object/
	
	; every event needs a unique id:
	
	Protected ID = Val(GetGadgetText(#frmEvent_lblID2))
	
	If ID <> 0
		RemoveGadgetItem(#FC, ID)
	Else
		ID = ElapsedMilliseconds()
	EndIf
	
	SetJSONString(AddJSONMember(Event, "id"),    Str(ID))
	SetJSONString(AddJSONMember(Event, "title"), GetGadgetText(#frmEvent_txtDescription))
	SetJSONQuad  (AddJSONMember(Event, "start"), MomentFromDate(GetGadgetState(#frmEvent_FromDate)))
	SetJSONQuad  (AddJSONMember(Event, "end"),   MomentFromDate(GetGadgetState(#frmEvent_ToDate)))
	
	If GetGadgetState(#frmEvent_chkAllDay) = #PB_Checkbox_Checked
		SetJSONBoolean(AddJSONMember(Event, "allDay"), #True)
	Else
		SetJSONBoolean(AddJSONMember(Event, "allDay"), #False)
	EndIf
	
	
	; SetJSONQuad  (AddJSONMember(Event, "backgroundColor"), RGB(255, 0, 0))
	
	RemoveGadgetItem(#FC, ID)
	
	AddGadgetItem(#FC, JSONValue(0))
	
	; Debug ComposeJSON(0, #PB_JSON_PrettyPrint)
	
	FreeJSON(0)	
	
	CloseWindow(#frmEvent)
	
EndProcedure

Procedure frmEvent_cmdCancel_Event()
	CloseWindow(#frmEvent)
EndProcedure

Procedure DayClick(date, jsEvent, view)
	
	Debug "DayClick()"
	Debug FormatMoment("DD.MM.YYYY hh:mm:ss", date)
	
EndProcedure

Procedure EventClick(calEvent, jsEvent, view)
	
 	OpenfrmEvent()
 	
 	SetGadgetText(#frmEvent_lblID2,         GetJSONString(GetJSONMember(calEvent, "id")))
 	SetGadgetText(#frmEvent_txtDescription, GetJSONString(GetJSONMember(calEvent, "title")))
 	
 	SetGadgetState(#frmEvent_FromDate, DateFromMoment(GetJSONQuad(GetJSONMember(calEvent, "start"))))
 	SetGadgetState(#frmEvent_ToDate,   DateFromMoment(GetJSONQuad(GetJSONMember(calEvent, "end"))))
 	
 	If GetJSONBoolean(GetJSONMember(calEvent, "allDay")) = #True
		SetGadgetState(#frmEvent_chkAllDay, #True)
	Else
		SetGadgetState(#frmEvent_chkAllDay, #False)
	EndIf
 	
	DisableGadget(#frmEvent_cmdRemove, #False)
	
	BindGadgetEvent(#frmEvent_cmdRemove, @frmEvent_cmdRemove_Event())
 	BindGadgetEvent(#frmEvent_cmdOK,     @frmEvent_cmdOK_Event())
 	BindGadgetEvent(#frmEvent_cmdCancel, @frmEvent_cmdCancel_Event())
	
EndProcedure

Procedure EventSelect(EventStart, EventEnd, jsEvent, view)
	Debug "EventSelect()"
	Debug "EventStart: " + FormatMoment("DD.MM.YYYY hh:mm:ss", EventStart)
	Debug "EventEnd: "   + FormatMoment("DD.MM.YYYY hh:mm:ss", EventEnd)
EndProcedure

Procedure EventUnselect(view, jsEvent)
	Debug "EventUnselect()"
EndProcedure

Procedure EventDragStart(event, jsEvent, ui, view)
	Debug "EventDragStart()"
EndProcedure

Procedure EventDragStop(event, jsEvent, ui, view)
	Debug "EventDragStop()"
EndProcedure

Procedure EventDrop(event, delta, revertFunc, jsEvent, ui, view)
	Debug "EventDrop()"
EndProcedure

Procedure EventResizeStart(event, jsEvent, ui, view)
	Debug "EventResizeStart()"
EndProcedure

Procedure EventResizeStop(event, jsEvent, ui, view)
	Debug "EventResizeStop()"
EndProcedure

Procedure EventResize(event, delta, revertFunc, jsEvent, ui, view)
	Debug "EventResize()"
EndProcedure

Procedure cmdAddEvent_Click()
	
 	OpenfrmEvent()
 	
 	SetGadgetState(#frmEvent_FromDate, Date())
 	SetGadgetState(#frmEvent_ToDate,   AddDate(Date(), #PB_Date_Hour, 1))
 	SetGadgetText(#frmEvent_txtDescription, "New Event")
	
 	DisableGadget(#frmEvent_cmdRemove, #True)
 	
 	BindGadgetEvent(#frmEvent_cmdOK,     @frmEvent_cmdOK_Event())
 	BindGadgetEvent(#frmEvent_cmdCancel, @frmEvent_cmdCancel_Event())
	
EndProcedure

Procedure cmdColorEvent_Click()
	
	Debug "See Code for details"
	
 ; SetGadgetItemColor(#FC, [ID], #PB_Gadget_Color, RGB(255, 0, 0))
 ; SetGadgetItemColor(#FC, [ID], #PB_Gadget_BackColor, RGB(255, 0, 0))
 ; SetGadgetItemColor(#FC, [ID], #PB_Gadget_FrontColor, RGB(0, 0, 0))
 ; SetGadgetItemColor(#FC, [ID], #PB_Gadget_BorderColor, RGB(0, 255, 0))
 	
EndProcedure

Procedure cboChangeView_Event()
	
	Select GetGadgetState(#cboChangeView)
		Case 0
			SetGadgetAttribute(#FC, #PB_FullCalendar_View, #PB_FullCalendar_ViewAgendaDay)
		Case 1
			SetGadgetAttribute(#FC, #PB_FullCalendar_View, #PB_FullCalendar_ViewAgendaWeek)
		Case 2
			SetGadgetAttribute(#FC, #PB_FullCalendar_View, #PB_FullCalendar_ViewBasicDay)
		Case 3
			SetGadgetAttribute(#FC, #PB_FullCalendar_View, #PB_FullCalendar_ViewBasicWeek)
		Case 4
			SetGadgetAttribute(#FC, #PB_FullCalendar_View, #PB_FullCalendar_ViewMonth)
	EndSelect
	
EndProcedure

OpenWindow(#frmMain, #PB_Ignore, #PB_Ignore, 820, 640, "FullCalendar-Demo", #PB_Window_ScreenCentered)

ButtonGadget(#cmdAddEvent, 10, 10, 100, 30, "Add event")
BindGadgetEvent(#cmdAddEvent, @cmdAddEvent_Click())

ButtonGadget(#cmdColorEvent, 150, 10, 100, 30, "Color event")
BindGadgetEvent(#cmdColorEvent, @cmdColorEvent_Click())

ComboBoxGadget(#cboChangeView, 260, 10, 100, 30)

AddGadgetItem(#cboChangeView, -1, "AgendaDay")
AddGadgetItem(#cboChangeView, -1, "AgendaWeek")
AddGadgetItem(#cboChangeView, -1, "BasicDay")
AddGadgetItem(#cboChangeView, -1, "BasicWeek")
AddGadgetItem(#cboChangeView, -1, "Month")

SetGadgetState(#cboChangeView, 4)

BindGadgetEvent(#cboChangeView, @cboChangeView_Event())

; FullCalendarGadget and -Events

; if you want to set another language for the FullCalendarGadget()
; you can set the browser language:

; SetBrowserLanguage("fr-FR")

FullCalendarGadget(#FC, 10, 50, 400, 400, Moment(), #PB_FullCalendar_Editable | #PB_FullCalendar_Selectable | #PB_FullCalendar_EventLimit)

BindGadgetEvent(#FC, @DayClick(),         #PB_EventType_FullCalendar_DayClick)
BindGadgetEvent(#FC, @EventClick(),       #PB_EventType_FullCalendar_EventClick)
BindGadgetEvent(#FC, @EventSelect(),      #PB_EventType_FullCalendar_Select)
BindGadgetEvent(#FC, @EventUnselect(),    #PB_EventType_FullCalendar_Unselect)

BindGadgetEvent(#FC, @EventDragStart(),   #PB_EventType_FullCalendar_EventDragStart)
BindGadgetEvent(#FC, @EventDragStop(),    #PB_EventType_FullCalendar_EventDragStop)
BindGadgetEvent(#FC, @EventDrop(),        #PB_EventType_FullCalendar_EventDrop)

BindGadgetEvent(#FC, @EventResizeStart(), #PB_EventType_FullCalendar_EventResizeStart)
BindGadgetEvent(#FC, @EventResizeStop(),  #PB_EventType_FullCalendar_EventResizeStop)
BindGadgetEvent(#FC, @EventResize(),      #PB_EventType_FullCalendar_EventResize)


ResizeGadget(#FC, #PB_Ignore, #PB_Ignore, 700, 500)

; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 4
; Folding = AAA-
; EnableUnicode
; EnableXP