﻿
XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\TabulatorGadget\TabulatorGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#myTabulatorGadget
EndEnumeration

Procedure GenderCellClick(e, val, cell, row)
	
	Debug e
	Debug val
	Debug cell
	Debug row
	
	! cDebugger.Debug(row.name);
	
	Debug "---"
	
EndProcedure

Procedure GenderEditor(cell, value, dta)
	
	!	// cell - JQuery object for current cell
	!	// value - the current value for current cell
	!	// dta - the data for the current row
	! 
	!	// create and style editor
	!	var editor = $("<select><option value=''></option><option value='male'>male</option><option value='female'>female</option></select>");
	! 		
	!	editor.css({
	!		"padding":"3px",
	!		"width":"100%",
	!		"box-sizing":"border-box",
	!	})
	! 
	!	// Set value of editor to the current value of the cell
	!	editor.val(value);
	! 
	!	// set focus on the select box when the editor is selected (timeout allows for editor to be added to DOM)
	!	if(cell.hasClass("tabulator-cell")){ //check to make sure this editor isnt being used as a header filter
	!		setTimeout(function(){
	!			editor.focus();
	!		}, 100);
	!	}
	! 
	!	// when the value has been set, trigger the cell to update
	!	editor.on("change blur", function(e){
	!		cell.trigger("editval", editor.val());
	!	});
	! 
	!	// return the editor element
	!	return editor;

EndProcedure

; --------------------

TabulatorGadget(#myTabulatorGadget, 100, 100, 800, 600)

; ###########################################
; # set Columns
; ###########################################

NewList TabulatorGadgetColumn.sTabulatorGadgetColumn()

; Name
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title    = "Name"
TabulatorGadgetColumn()\field    = "name"
TabulatorGadgetColumn()\sortable = #True
TabulatorGadgetColumn()\sorter   = "string"
TabulatorGadgetColumn()\width    = 200
TabulatorGadgetColumn()\editable = #True

; Age
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title = "Age"
TabulatorGadgetColumn()\field = "age"
TabulatorGadgetColumn()\sortable = #True
TabulatorGadgetColumn()\sorter = "number"
TabulatorGadgetColumn()\align = "right"
TabulatorGadgetColumn()\formatter = "progress"
TabulatorGadgetColumn()\editable = #True

; Gender
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title = "Gender"
TabulatorGadgetColumn()\field = "gender"
TabulatorGadgetColumn()\sortable = #True
TabulatorGadgetColumn()\sorter = "string"
TabulatorGadgetColumn()\onClick = @GenderCellClick()
TabulatorGadgetColumn()\editor = @GenderEditor()
TabulatorGadgetColumn()\editable = #True

; Height
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title     = "Height"
TabulatorGadgetColumn()\field     = "height"
TabulatorGadgetColumn()\sortable  = #True
TabulatorGadgetColumn()\formatter = "star"
TabulatorGadgetColumn()\align     = "center"
TabulatorGadgetColumn()\width     = 100
TabulatorGadgetColumn()\editable  = #True

; Color
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title = "Favourite Color"
TabulatorGadgetColumn()\field = "col"
TabulatorGadgetColumn()\sortable = #False	
TabulatorGadgetColumn()\sorter = "string"
TabulatorGadgetColumn()\editable  = #True

; Date of Birth
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title = "Date of Birth"
TabulatorGadgetColumn()\field = "dob"
TabulatorGadgetColumn()\sortable = #True
TabulatorGadgetColumn()\sorter = "date"
TabulatorGadgetColumn()\align = "center"
TabulatorGadgetColumn()\editable = #True

; Cheese Preference
AddElement(TabulatorGadgetColumn())
TabulatorGadgetColumn()\title = "Cheese Preference"
TabulatorGadgetColumn()\field = "cheese"
TabulatorGadgetColumn()\sortable = #True
TabulatorGadgetColumn()\sorter = "boolean"
TabulatorGadgetColumn()\align = "center"
TabulatorGadgetColumn()\formatter = "tickCross"
TabulatorGadgetColumn()\editable = #True

CreateJSON(0)
InsertJSONList(JSONValue(0), TabulatorGadgetColumn())
SetGadgetAttribute(#myTabulatorGadget, #TabulatorGadgetColumns, JSONValue(0))

Define myData

! myData = [
!		{id: 1, name:"Billy Bob", age:"12", gender:"male", height:1, col:"red", dob:"", cheese:1},
!		{id: 2, name:"Mary May", age:"1", gender:"female", height:2, col:"blue", dob:"14.05.1982", cheese:true},
!		{id: 3, name:"Christine Lobowski", age:"42", height:0, col:"green", dob:"22.05.1982", cheese:"true"},
!		{id: 4, name:"Brendon Philips", age:"125", gender:"male", height:1, col:"orange", dob:"01.08.1980"},
!		{id: 5, name:"Margret Marmajuke", age:"16", gender:"female", height:5, col:"yellow", dob:"31.01.1999"}
!	];

SetGadgetAttribute(#myTabulatorGadget, #TabulatorGadgetData, myData)

; SetGadgetAttribute(#myTabulatorGadget, #TabulatorGadgetGroupBy, @"gender")

SetGadgetAttribute(#myTabulatorGadget, #TabulatorGadgetFitColumns, #True)

; ResizeGadget(#myTabulatorGadget, #PB_Ignore, #PB_Ignore, 900, 700)


; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 153
; FirstLine = 56
; Folding = 6
; EnableXP