EnableExplicit

XIncludeFile "..\..\..\p2w.pbi"
XIncludeFile "..\..\..\UserGadgets\UploadGadget\UploadGadget.pbi"

P2W_Converter_SetProfile("pb2webtest")

Enumeration
	#myWindow
	#myUploadGadget
EndEnumeration

EnableCGI

ProcedureDLL Upload()
	
	Protected FF
	Protected ReturnValue.s
	
  CreateDirectory("uploads")
  
  ForEach CGIParameter()
  	
  	If CGIParameter()\Type = #PB_CGI_File
  		
  		FF = CreateFile(#PB_Any, "uploads\" + CGIParameter()\Value)
  		If FF
  			WriteData(FF, CGIParameter()\Data, CGIParameter()\DataSize)
  			CloseFile(FF)
  			ReturnValue = "ok"
  		Else
  			ReturnValue = "error"
  		EndIf
  		
  	EndIf
  	
  Next
		
	WriteCGIHeader(#PB_CGI_HeaderContentLength, Str(Len(ReturnValue)), #PB_CGI_LastHeader)
	WriteCGIString(ReturnValue)
	
EndProcedure

DisableCGI

Procedure DebugFileInfo(*file.sUploadFile)
	
	Debug "Filename: " + *file\name
	Debug "Filesize: " + *file\size
	Debug "Filetype: " + *file\type
	
EndProcedure

Procedure onDrop(event)
	
	Debug "onDrop()"
	Debug event	
	
EndProcedure

Procedure onAddedFile(*file.sUploadFile)
	
	Debug "onAddedFile()"
	
	DebugFileInfo(*file)	

	If LCase(GetExtensionPart(*file\name)) <> "png" ; accept only png-files (for example)
		Debug "Only PNG-Files are allowed!"
		Debug "---------------------"
		RemoveGadgetItem(#myUploadGadget, *file) ; this will fire a
	EndIf
	
	Debug "---------------------"
	
EndProcedure

Procedure onRemovedFile(*file.sUploadFile)
	
	Debug "onRemovedFile()"
	
	DebugFileInfo(*file)	

	Debug "---------------------"
	
EndProcedure

Procedure onError(*file.sUploadFile, errorMessage)
	
	Debug "onError()"
	
	DebugFileInfo(*file)
	
	Debug errorMessage
	Debug "---------------------"
	
EndProcedure

Procedure onUploadProgress(*file, progress, bytesSent)
	
	Debug "onUploadProgress()"
	
	DebugFileInfo(*file)
		
	Debug "progress: " + Str(progress)
	Debug "bytesSent: " + Str(bytesSent)
	
	Debug "---------------------"
	
EndProcedure

Procedure onTotalUploadProgress(totalPercentage, totalBytesToBeSent, totalBytesSent)
	
	Debug "onTotalUploadProgress()"
	Debug "totalPercentage: " + Str(totalPercentage)
	Debug "totalBytesToBeSent: " + Str(totalBytesToBeSent)
	Debug "totalBytesSent: " + Str(totalBytesSent)
	
	Debug "---------------------"
	
EndProcedure

Procedure onSuccess(*file, response)
	
	Debug "onSuccess()"
	
	DebugFileInfo(*file)
	
 	Debug "Response: " + response
 	
 	Debug "---------------------"
	
EndProcedure

Procedure onAll(a,b,c,d)
	
	Select EventType()
			
		Case #PB_EventType_Upload_Drop : Debug "PB_EventType_Upload_Drop"
		Case #PB_EventType_Upload_DragStart : Debug "PB_EventType_Upload_DragStart"
		Case #PB_EventType_Upload_DragEnd : Debug "PB_EventType_Upload_DragEnd"
		Case #PB_EventType_Upload_DragEnter : Debug "PB_EventType_Upload_DragEnter"
		Case #PB_EventType_Upload_DragOver : Debug "PB_EventType_Upload_DragOver"
		Case #PB_EventType_Upload_DragLeave : Debug "PB_EventType_Upload_DragLeave"
		Case #PB_EventType_Upload_AddedFile : Debug "PB_EventType_Upload_AddedFile"
		Case #PB_EventType_Upload_RemovedFile : Debug "PB_EventType_Upload_RemovedFile"
		Case #PB_EventType_Upload_Thumbnail : Debug "PB_EventType_Upload_Thumbnail"
		Case #PB_EventType_Upload_Error : Debug "PB_EventType_Upload_Error"
		Case #PB_EventType_Upload_Processing : Debug "PB_EventType_Upload_Processing"
		Case #PB_EventType_Upload_Sending : Debug "PB_EventType_Upload_Sending"
		Case #PB_EventType_Upload_Complete : Debug "PB_EventType_Upload_Complete"
		Case #PB_EventType_Upload_Canceled : Debug "PB_EventType_Upload_Canceled"
		Case #PB_EventType_Upload_MaxFilesReached : Debug "PB_EventType_Upload_MaxFilesReached"
		Case #PB_EventType_Upload_MaxFilesExceeded : Debug "PB_EventType_Upload_MaxFilesExceeded"
		
	EndSelect
	
	If a : Debug "a: " + Str(a) : EndIf
	If b : Debug "b: " + Str(b) : EndIf
	If c : Debug "c: " + Str(c) : EndIf
	If d : Debug "d: " + Str(d) : EndIf
	
	Debug "---------------------"
	
EndProcedure

OpenWindow(#myWindow, #PB_Ignore, #PB_Ignore, 400, 400, "UploadGadget()", #PB_Window_ScreenCentered)

; Usage:

; UploadGadget(#myUploadGadget, 
;              x, 
;              y, 
;              Width,
;              Height,
;              Target.s,
;              Text.s)


Define TargetUrl.s = "http://localhost/cgi-bin/pb2webtest.exe?p2wrequest=Upload"

UploadGadget(#myUploadGadget, 10, 10, WindowWidth(#myWindow) - 20, WindowHeight(#myWindow) - 20, TargetUrl)

;	  BindGadgetEvent(#myUploadGadget, @onAll(), #PB_All)
BindGadgetEvent(#myUploadGadget, @onAddedFile(), #PB_EventType_Upload_AddedFile)
BindGadgetEvent(#myUploadGadget, @onUploadProgress(), #PB_EventType_Upload_UploadProgress)
BindGadgetEvent(#myUploadGadget, @onTotalUploadProgress(), #PB_EventType_Upload_TotalUploadProgress)
BindGadgetEvent(#myUploadGadget, @onSuccess(), #PB_EventType_Upload_Success)
BindGadgetEvent(#myUploadGadget, @onRemovedFile(), #PB_EventType_Upload_RemovedFile)


; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 126
; FirstLine = 12
; Folding = Bo
; EnableXP