
; Example to work with the websocket-server from infratec:
; http://www.purebasic.fr/english/viewtopic.php?p=426768#p426768

XIncludeFile "..\..\p2w.pbi"

XIncludeFile "Websocket.pbf"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

Global myWebsocket

Global Connected = #False	

Procedure AddLog(Message.s)
	AddGadgetItem(#lstMessages, -1, Message)
	SetGadgetState(#lstMessages, CountGadgetItems(#lstMessages) - 1)
EndProcedure

Procedure WS_OnOpen()
	
	Connected = #True
	
	SetGadgetText(#cmdConnect, "Disconnect")
	
	AddLog("WS_OnOpen")
	
EndProcedure

Procedure WS_OnClose()
	
	Connected = #False
	
	SetGadgetText(#cmdConnect, "Connect")
	
	AddLog("WS_OnClose")
	
EndProcedure

Procedure WS_OnMessage(Message.s)
	
	AddLog("WS_OnMessage: " + Message)
	
EndProcedure

Procedure WS_OnError(Error.s)
	
	AddLog("WS_OnError: " + Error)
	
EndProcedure

Procedure cmdConnect_Event()
	
	If Not Connected
		
		myWebsocket = OpenWebsocket("ws://127.0.0.1:800")
		
		If myWebsocket
			
			BindNetworkEvent(myWebsocket, @WS_OnOpen(),    #PB_Event_Websocket_OnOpen)
			BindNetworkEvent(myWebsocket, @WS_OnClose(),   #PB_Event_Websocket_OnClose)
			BindNetworkEvent(myWebsocket, @WS_OnMessage(), #PB_Event_Websocket_OnMessage)
			BindNetworkEvent(myWebsocket, @WS_OnError(),   #PB_Event_Websocket_OnError)
			
			AddLog("WebSocket: OK")
			
		Else
		  
		  AddLog("WebSocket: not OK!")
			
		EndIf		
		
	Else
		
		AddLog("Closing connection...")
		CloseWebsocket(myWebsocket)
		
	EndIf
	
EndProcedure

Procedure cmdSend_Event()
	
	If Not Connected
		ProcedureReturn
	EndIf
	
	Protected TextToSend.s = GetGadgetText(#txtSend)
	
	If TextToSend = ""
		ProcedureReturn
	EndIf
	
	AddLog("Sending '" + TextToSend + "'")
	
	SendWebsocket(myWebsocket, @TextToSend)

EndProcedure

OpenWindow_0()

BindGadgetEvent(#cmdConnect, @cmdConnect_Event())
BindGadgetEvent(#cmdSend, @cmdSend_Event())

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 97
; FirstLine = 62
; Folding = --
; EnableXP