XIncludeFile "..\p2w.pbi"

XIncludeFile "musictest.pbf"

P2W_Converter_SetProfile("pb2webtest")

EnableExplicit

#myMusic = 1

Global DoNotUpdatePosition = #False

Procedure ChangeVolume()
	P2W_SetMusicAttribute(#myMusic, #PB_Music_Volume, GetGadgetState(#trkVolume))
EndProcedure

Procedure ChangePosition()
	
	If Not(DoNotUpdatePosition) ; avoid stutter
		P2W_SetMusicAttribute(#myMusic, #PB_Music_Position, GetGadgetState(#trkPosition))
	EndIf
	
	DoNotUpdatePosition = #False
	
EndProcedure

Procedure cmdEvent()
	
	Select EventGadget()
		Case #cmdPlay  : PlayMusic(#myMusic)
		Case #cmdPause : P2W_PauseMusic(#myMusic)
		Case #cmdStop  : StopMusic(#myMusic)		
	EndSelect
	
EndProcedure

Procedure HyperLinkEvent()
	
	RunProgram("http://opsound.org/artist/davehowes/")
	
EndProcedure

Procedure MusicEvent()
	
	Select EventType()
			
		Case #PB_Event_Music_Abort          : ; Debug("#PB_Event_Music_Abort")
		Case #PB_Event_Music_CanPlay        : ; Debug("#PB_Event_Music_CanPlay")
		Case #PB_Event_Music_CanPlayThrough : ; Debug("#PB_Event_Music_CanPlayThrough")
		Case #PB_Event_Music_DurationChange : ; Debug("#PB_Event_Music_DurationChange")
		Case #PB_Event_Music_Emptied        : ; Debug("#PB_Event_Music_Emptied")
		Case #PB_Event_Music_Ended          : ; Debug("#PB_Event_Music_Ended")
		Case #PB_Event_Music_Error          : ; Debug("#PB_Event_Music_Error")
		Case #PB_Event_Music_LoadedData     : ; Debug("#PB_Event_Music_LoadedData")
			
			If Not(IsWindow(#frmMusic))
				
				OpenfrmMusic()
				
				; Volume
				
				SetGadgetText(#txtVolume, Str(P2W_GetMusicAttribute(#myMusic, #PB_Music_Volume)))
				SetGadgetState(#trkVolume, P2W_GetMusicAttribute(#myMusic, #PB_Music_Volume))
				SetGadgetState(#prgVolume, P2W_GetMusicAttribute(#myMusic, #PB_Music_Volume))
				
				; Position
				
				SetGadgetText(#txtPosition, Str(P2W_GetMusicAttribute(#myMusic, #PB_Music_Volume)))
				
				; IE9 sometimes returns 'infinite' on P2W_GetMusicAttribute(#myMusic, #PB_Music_Length)
				; see: https://groups.google.com/forum/#!msg/jplayer/4AhD978ClpM/3sdrBOaznlIJ
				
				SetGadgetAttribute(#trkPosition, #PB_TrackBar_Maximum, P2W_GetMusicAttribute(#myMusic, #PB_Music_Length))
				SetGadgetState(#trkPosition, P2W_GetMusicAttribute(#myMusic, #PB_Music_Position))
				
				SetGadgetState(#prgPosition, P2W_GetMusicAttribute(#myMusic, #PB_Music_Position))
				SetGadgetAttribute(#prgPosition, #PB_ProgressBar_Maximum, P2W_GetMusicAttribute(#myMusic, #PB_Music_Length))
				
				BindGadgetEvent(#cmdPlay,  @cmdEvent())
				BindGadgetEvent(#cmdPause, @cmdEvent())
				BindGadgetEvent(#cmdStop,  @cmdEvent())
				
 				BindGadgetEvent(#trkVolume,   @ChangeVolume())
 				BindGadgetEvent(#trkPosition, @ChangePosition())
				
				PlayMusic(#myMusic)
				
			EndIf
			
		Case #PB_Event_Music_LoadedMetaData : ; Debug("#PB_Event_Music_LoadedMetaData")
		Case #PB_Event_Music_LoadStart      : ; Debug("#PB_Event_Music_LoadStart")
		Case #PB_Event_Music_Pause          : ; Debug("#PB_Event_Music_Pause")
		Case #PB_Event_Music_Play           : ; Debug("#PB_Event_Music_Play")
		Case #PB_Event_Music_Playing        : ; Debug("#PB_Event_Music_Playing")
		Case #PB_Event_Music_Progress       : ; Debug("#PB_Event_Music_Progress")
		Case #PB_Event_Music_RateChange     : ; Debug("#PB_Event_Music_RateChange")
		Case #PB_Event_Music_Seeked         : ; Debug("#PB_Event_Music_Seeked")
		Case #PB_Event_Music_Seeking        : ; Debug("#PB_Event_Music_Seeking")
		Case #PB_Event_Music_Stalled        : ; Debug("#PB_Event_Music_Stalled")
		Case #PB_Event_Music_Suspend        : ; Debug("#PB_Event_Music_Suspend")
		Case #PB_Event_Music_TimeUpdate     : ; Debug("#PB_Event_Music_TimeUpdate")
			
			If IsWindow(#frmMusic)
				DoNotUpdatePosition = #True
				Protected Position = P2W_GetMusicAttribute(#myMusic, #PB_Music_Position)
				SetGadgetText(#txtPosition, Str(Position))
				SetGadgetState(#trkPosition, Position)
				SetGadgetState(#prgPosition, Position)
			EndIf
		
		Case #PB_Event_Music_VolumeChange   : ; Debug("#PB_Event_Music_VolumeChange")
			
			If IsWindow(#frmMusic)
				Protected Volume = P2W_GetMusicAttribute(#myMusic, #PB_Music_Volume)
				SetGadgetText(#txtVolume, Str(Volume))
				SetGadgetState(#trkVolume, Volume)
				SetGadgetState(#prgVolume, Volume)
			EndIf
			
		Case #PB_Event_Music_Waiting        : ; Debug("#PB_Event_Music_Waiting")
			
		Default
			
			Debug "???: Unknown event"
			
	EndSelect
	
EndProcedure

; http://caniuse.com/#feat=audio
; http://www.w3.org/wiki/HTML/Elements/audio

Define myHyperLink = HyperLinkGadget(#PB_Any, 10, 10, 500, 20, "mp3-Samplesound 'TUESDAY GROOVE' from: http://opsound.org/artist/davehowes/", RGB(255, 0, 0))

BindGadgetEvent(myHyperLink, @HyperLinkEvent())

; http://opsound.org/artist/davehowes/
; https://archive.org/download/TuesdayGroove/Tuesday%20Groove.mp3

If LoadMusic(#myMusic, "mp3.mp3") ; or use LoadMusic(#myMusic, "mp3.mp3", @MusicEvent()) to bind all events
	
	P2W_BindMusicEvent(#myMusic, @MusicEvent()) ; Bind all events
	
	; ... or bind events separately:
	
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Abort)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_CanPlay)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_CanPlayThrough)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_DurationChange)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Emptied)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Ended)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Error)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_LoadedData)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_LoadedMetaData)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_LoadStart)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Pause)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Play)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Playing)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Progress)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_RateChange)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Seeked)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Seeking)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Stalled)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Suspend)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_TimeUpdate)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_VolumeChange)
	;	P2W_BindMusicEvent(#myMusic, @MusicEvent(), #PB_Event_Music_Waiting)
	
Else
	
	MessageRequester("Music", "Your browser does not support the audio tag.<br />See <a href='http://caniuse.com/#feat=audio' target='_blank'>supported browser.</a>")
	
EndIf
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 2
; Folding = v
; EnableXP