<?php

/**
 * cFile short summary.
 *
 * cFile description.
 *
 * @version 1.0
 * @author Peter
 */

require_once("cCommon.php");
require_once("cConstants.php");

class cFile
{
	
	static $FileHandler = [];
	
	// CloseFile(#File)
	static function CloseFile($File) {
		
		fclose(cFile::$FileHandler[$File]);
		unset(cFile::$FileHandler[$File]);
		
	}
	
	// Result = CreateFile(#File, Filename$ [, Flags])
	static function CreateFile($File, $Filename, $Flags = 0) {
		
		return fopen($Filename, "w");
		
	}
	
	// Result = Eof(#File)
	static function Eof($File) {
		
		return feof(cFile::$FileHandler[$File]);
		
	}
	
	static function FileBuffersSize() {}
	
	// Result = FileID(#File)
	static function FileID($File) {
		
		return cFile::$FileHandler[$File];
		
	}
	
	static function FileSeek() {}
	
	static function FileExists($File) {
		
		
		
	}
	
	static function FlushFileBuffers() {}
	
	// Result = IsFile(#File)
	static function IsFile($File) {
		
		return (get_resource_type(cFile::$FileHandler[$File]) === 'stream');
		
	}
	
	// Position.q = Loc(#File)
	static function Loc($File) {
		
		return ftell(cFile::$FileHandler[$File]);
		
	}
	
	// Length.q = Lof(#File)
	static function Lof($File) {
		
		$FS =  fstat(cFile::$FileHandler[$File]);
		return $FS["size"];
		
	}
	
	// Result = OpenFile(#File, Filename$ [, Flags])
	static function OpenFile($File, $Filename, $Flags = 0) {
		
		if ($File == cConstants::PB_Any) {
			$File = cCommon::GUID();
		}
		
		if (cFile::$FileHandler[$File]) {
			cFile::CloseFile(cFile::$FileHandler[$File]);
			unset(cFile::$FileHandler[$File]);
		}
		
		cFile::$FileHandler[$File] = fopen($Filename, "r+");
		
		if ($File === 0) {
			return TRUE;
		}
		
		return $File;
		
	}
	
	static function ReadAsciiCharacter() {}
	
	static function ReadByte() {}
	
	static function ReadCharacter() {}
	
	static function ReadData() {}
	
	static function ReadDouble() {}
	
	// Result = ReadFile(#File, Filename$ [, Flags])
	static function ReadFile($File, $Filename, $Flags = 0) {
		
		if ($File == cConstants::PB_Any) {
			$File = cCommon::GUID();
		}
		
		if (array_key_exists($File, cFile::$FileHandler)) {
			cFile::CloseFile($File);
			unset(cFile::$FileHandler[$File]);
		}
		
		if (file_exists ($Filename)) {
			
			cFile::$FileHandler[$File] = fopen($Filename, "r");
			
			if (cFile::$FileHandler[$File] === false) {
				unset(cFile::$FileHandler[$File]);
				return false;	
			} else {
				
				if ($File === 0) {
					return true;
				} else {
					return $File;
				}
			}
			
		} else {
			return false;	
		}
		
	}
	
	static function ReadFloat() {}
	
	static function ReadInteger() {}

	static function ReadLong() {}
	
	static function ReadQuad() {}
	
	// Text$ = ReadString(#File [, Flags [, Length]])
	static function ReadString($File, $Flags = 0, $Length = 0) {

		return fgets(cFile::$FileHandler[$File]);
		
	}
	
	static function ReadStringFormat() {}
	
	static function ReadUnicodeCharacter() {}
	
	static function ReadWord() {}
	
	// TruncateFile(#File)
	static function TruncateFile($File) {
		
		ftruncate(cFile::$FileHandler[$File], ftell(cFile::$FileHandler[$File]));
		
	}
	
	static function WriteAsciiCharacter() {}
	
	static function WriteByte() {}
	
	static function WriteCharacter() {}
	
	static function WriteData() {}
	
	static function WriteDouble() {}
	
	static function WriteFloat() {}
	
	static function WriteInteger() {}
	
	static function WriteLong() {}
	
	static function WriteQuad() {}
	
	// Result = WriteString(#File, Text$ [, Format])
	static function WriteString($File, $Text, $Format = 0) {
		
		// Possible Format-Values: #PB_Ascii or #PB_UTF8 or #PB_Unicode
		// If not specified -> UTF8 (if compiled in unicode mode). Otherwise ASCII format.
		
		switch ($Format) {
			case cConstants::PB_Ascii:
				break;
			case cConstants::PB_UTF8:
				$Text = utf8_encode($Text);
				break;
			case cConstants::PB_Unicode:
				break;
		}
		
		fputs(cFile::$FileHandler[$File], $Text);
		
	}
	
	static function WriteStringFormat() {}
	
	// Result = WriteStringN(#File, Text$ [, Format])
	static function WriteStringN($File, $Text, $Format = 0) {
		
		WriteString($File, $Text . "\n", $Format);
		
	}
	
	static function WriteUnicodeCharacter() {}
	
	static function WriteWord() {}
	
}
