﻿EnableExplicit

If Not InitCGI() : End : EndIf

Structure sCGIParameter
	Name.s
	Value.s
	Type.i
	Data.i
	DataSize.i
EndStructure

Global NewMap CGIParameter.sCGIParameter()

Global P2W_CGI_HeaderContentType.s = "text/plain;charset=UTF-8"
Global P2W_CGI_HeaderLocation.s = ""

;do you want to debug? --> use the proc deb() 
Global P2W_CGI_Debug = #True

;add your pattern here (formatdate)
#CGI_SETTINGS_DEBUG_TIMEPATTERN   = "[%dd.%mm.%yyyy::%hh:%ii:%ss]  "  
#CGI_SETTINGS_LOGFILENAME_PATTERN = "%yyyy_%mm_%dd_"

Procedure AnalyzeCgiParameter()
	
	Protected Counter
	Protected QueryString.s
	Protected NameValuePair.s
	Protected Name.s
	Protected Value.s
	
	ReadCGI()
	
	QueryString = CGIVariable(#PB_CGI_QueryString)
	
	Counter = 0
	
	; Analyze QueryString:
	
	Repeat
		
		Counter + 1
		
		NameValuePair = Trim(StringField(QueryString, Counter, "&"))
		
		If NameValuePair = "" : Break : EndIf
		
		Name  = Trim(StringField(NameValuePair, 1, "="))
		Value = Trim(StringField(NameValuePair, 2, "="))
		
		AddMapElement(CGIParameter(), LCase(Name))
		
		CGIParameter()\Name  = Name
		CGIParameter()\Value = Value
		CGIParameter()\Type  = #PB_CGI_Text
		
	ForEver
	
	; Analyze Post-, Get- und Multipart-Parameter:
	
	For Counter = 0 To CountCGIParameters() - 1 
		
		AddMapElement(CGIParameter(), LCase(CGIParameterName(Counter)))
		
		CGIParameter()\Name  = CGIParameterName (Counter)
		CGIParameter()\Value = CGIParameterValue("", Counter)
		CGIParameter()\Type  = CGIParameterType ("", Counter)
		
		If CGIParameterType("", Counter) = #PB_CGI_File
			
			CGIParameter()\Data     = CGIParameterData    ("", Counter) 
			CGIParameter()\DataSize = CGIParameterDataSize("", Counter) 
			
		EndIf
		
	Next
	
EndProcedure

Procedure.s GetValue(Name.s)
  Protected ReturnValue.s = ""
  ForEach CGIParameter()
  	If CGIParameter()\Name = Name
  		ReturnValue = CGIParameter()\Value
  		Break
  	EndIf
  Next
  ProcedureReturn ReturnValue
EndProcedure

CompilerIf Defined(CurrentProcessId, #PB_Procedure)
CompilerElse
	Procedure.l CurrentProcessId()
		Protected lPID.l
		lPID = 0
		CompilerSelect #PB_Compiler_OS
			CompilerCase #PB_OS_Windows
				lPID = GetCurrentProcessId_()
			CompilerCase #PB_OS_Linux
				lPID = getpid_()
			CompilerCase #PB_OS_MacOS
				;-todo
		CompilerEndSelect
		ProcedureReturn lPID
	EndProcedure
CompilerEndIf

;can be used for debuging
Procedure Deb(Str.s)
	
	Protected FileID
	
	Debug Str
	
	Protected CGI_SETTINGS_DEBUG_FILE.s = GetFilePart(ProgramFilename(), #PB_FileSystem_NoExtension)	
	
	If P2W_CGI_Debug = #True
		
		FileID = OpenFile(#PB_Any, 
		                  FormatDate(#CGI_SETTINGS_LOGFILENAME_PATTERN, Date()) +
		                  CGI_SETTINGS_DEBUG_FILE + ".log", #PB_File_Append)
		
		If FileID
			
			WriteStringN(FileID, FormatDate(#CGI_SETTINGS_DEBUG_TIMEPATTERN, Date()) + 
			                     "(" + Str(CurrentProcessId())+") " + 
			                     Str)
			
			CloseFile(FileID)
			
		EndIf
		
	EndIf
	
EndProcedure

AnalyzeCgiParameter()

; -------------------------
; ### PB2Web ServerCode ###
; -------------------------

Define Request.s = LCase(CGIParameter("p2wrequest")\Value)
Define ReturnValue.s

; ----------------------------
; ### PB2Web RequestSelect ###
; ----------------------------

WriteCGIHeader(#PB_CGI_HeaderContentType, P2W_CGI_HeaderContentType)

If P2W_CGI_HeaderLocation <> ""
	WriteCGIHeader(#PB_CGI_HeaderLocation, P2W_CGI_HeaderLocation)
EndIf

WriteCGIHeader("Access-Control-Allow-Origin:", "*", #PB_CGI_LastHeader)

WriteCGIData(@ReturnValue, Len(ReturnValue))


; IDE Options = PureBasic 5.41 LTS (Windows - x86)
; ExecutableFormat = Console
; CursorPosition = 156
; FirstLine = 29
; Folding = w
; EnableUnicode
; Executable = D:\xampp\cgi-bin\cgi54.exe