var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var PB2WebLibraryVersion = 20161107;
var p2w_PbGadget = p2w_PbGadget || [];
var p2w_UserGadget = p2w_UserGadget || [];
var c2DDrawing = (function () {
    function c2DDrawing() {
    }
    c2DDrawing.Alpha = function (Color) {
        var alpha = jQuery.Color(Color).alpha() * 255;
        return alpha;
    };
    c2DDrawing.AlphaBlend = function () {
        
    };
    c2DDrawing.BackColor = function (Color) {
        cCommon.CurrentBackColor = Color;
    };
    c2DDrawing.Blue = function (Color) {
        if (typeof Color === 'number') {
            return jQuery.Color("#" + cString.RSet(cCommon.decimal2hex(Color), 6, "0")).blue();
        }
        else {
            return jQuery.Color(Color).blue();
        }
    };
    c2DDrawing.Box = function (x, y, Width, Height, Color) {
        if (Color === void 0) { Color = cCommon.CurrentFrontColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        if (cString.IsNumeric(Color))
            Color = cCommon.hexToBgr(cCommon.decimal2hex(Color));
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.save();
        drawingContext.fillStyle = Color;
        drawingContext.fillRect(x, y, Width, Height);
        drawingContext.restore();
    };
    c2DDrawing.BoxedGradient = function () {
        
    };
    c2DDrawing.Circle = function (x, y, Radius, Color) {
        if (Color === void 0) { Color = cCommon.CurrentFrontColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        if (cString.IsNumeric(Color))
            Color = cCommon.hexToBgr(cCommon.decimal2hex(Color));
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.save();
        drawingContext.fillStyle = Color;
        drawingContext.beginPath();
        drawingContext.arc(x, y, Radius, 0, Math.PI * 2, true);
        drawingContext.fill();
        drawingContext.closePath();
        drawingContext.restore();
    };
    c2DDrawing.CircularGradient = function () {
        
    };
    c2DDrawing.ConicalGradient = function () {
        
    };
    c2DDrawing.CustomFilterCallback = function () {
        
    };
    c2DDrawing.CustomGradient = function () {
        
    };
    c2DDrawing.DrawAlphaImage = function () {
        
    };
    c2DDrawing.DrawImage = function (ImageID, x, y, Width, Height) {
        if (Width === void 0) { Width = -1; }
        if (Height === void 0) { Height = -1; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        var img = cCommon.P2W_ImageList[ImageID];
        if (img === null) {
            cCommon.ImageIsNotInitialized("DrawImage()");
            return;
        }
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.save();
        if (Width > -1 && Height > -1) {
            drawingContext.drawImage(img, x, y, Width, Height);
        }
        else {
            drawingContext.drawImage(img, x, y);
        }
        drawingContext.restore();
    };
    c2DDrawing.DrawRotatedText = function () {
        
    };
    c2DDrawing.DrawText = function (x, y, Text, FrontColor, BackColor) {
        if (FrontColor === void 0) { FrontColor = cCommon.CurrentFrontColor; }
        if (BackColor === void 0) { BackColor = cCommon.CurrentBackColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        if (cString.IsNumeric(FrontColor))
            FrontColor = cCommon.hexToBgr(cCommon.decimal2hex(FrontColor));
        if (cString.IsNumeric(BackColor))
            BackColor = cCommon.hexToBgr(cCommon.decimal2hex(BackColor));
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.save();
        drawingContext.font = cCommon.CurrentDrawingFont;
        drawingContext.textBaseline = "top";
        var w = c2DDrawing.TextWidth(Text);
        var h = c2DDrawing.TextHeight(Text);
        drawingContext.fillStyle = BackColor;
        drawingContext.fillRect(x, y, w, h);
        drawingContext.fillStyle = FrontColor;
        drawingContext.fillText(Text, x, y);
        drawingContext.restore();
    };
    c2DDrawing.DrawingBuffer = function () {
        
    };
    c2DDrawing.DrawingBufferPitch = function () {
        
    };
    c2DDrawing.DrawingBufferPixelFormat = function () {
        
    };
    c2DDrawing.DrawingFont = function (FontID) {
        if (FontID == cConstants.PB_Default) {
            cCommon.CurrentDrawingFont = 'normal normal 12px Arial';
            return;
        }
        var font = cCommon.P2W_FontList[FontID];
        if (font === null) {
            
            return;
        }
        cCommon.CurrentDrawingFont = font.Style + " " + font.Weight + " " + font.Size + "px " + font.Family;
    };
    c2DDrawing.DrawingMode = function (Mode) {
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_Default)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_Transparent)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_XOr)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_Outlined)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_AlphaBlend)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_AlphaClip)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_AlphaChannel)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_AllChannels)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_Gradient)) { }
        if (cCommon.CheckFlag(Mode, cConstants.PB_2DDrawing_CustomFilter)) { }
        
    };
    c2DDrawing.Ellipse = function (x, y, RadiusX, RadiusY, Color) {
        
    };
    c2DDrawing.EllipticalGradient = function () {
        
    };
    c2DDrawing.FillArea = function () {
        
    };
    c2DDrawing.FrontColor = function (Color) {
        cCommon.CurrentFrontColor = Color;
    };
    c2DDrawing.GrabDrawingImage = function () {
        
    };
    c2DDrawing.GradientColor = function () {
        
    };
    c2DDrawing.Green = function (Color) {
        if (typeof Color === 'number') {
            return jQuery.Color("#" + cString.RSet(cCommon.decimal2hex(Color), 6, "0")).green();
        }
        else {
            return jQuery.Color(Color).green();
        }
    };
    c2DDrawing.Line = function (x, y, Width, Height, Color) {
        if (Color === void 0) { Color = cCommon.CurrentFrontColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        var drawingCanvas;
        if (cString.IsNumeric(Color))
            Color = cCommon.hexToBgr(cCommon.decimal2hex(Color));
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.save();
        drawingContext.strokeStyle = Color;
        drawingContext.beginPath();
        drawingContext.moveTo(x, y);
        drawingContext.lineTo(x + Width, y + Height);
        drawingContext.stroke();
        drawingContext.restore();
    };
    c2DDrawing.LineXY = function (x1, y1, x2, y2, Color) {
        if (Color === void 0) { Color = cCommon.CurrentFrontColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        if (cString.IsNumeric(Color))
            Color = cCommon.hexToBgr(cCommon.decimal2hex(Color));
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.strokeStyle = Color;
        drawingContext.save();
        drawingContext.beginPath();
        drawingContext.moveTo(x1, y1);
        drawingContext.lineTo(x2, y2);
        drawingContext.stroke();
        drawingContext.restore();
    };
    c2DDrawing.LinearGradient = function () {
        
    };
    c2DDrawing.OutputDepth = function () {
        
    };
    c2DDrawing.OutputHeight = function () {
        if (cCommon.CurrentDrawingOutput == null) {
            
            return -1;
        }
        return cCommon.CurrentDrawingOutput.height();
    };
    c2DDrawing.OutputWidth = function () {
        if (cCommon.CurrentDrawingOutput == null) {
            
            return -1;
        }
        return cCommon.CurrentDrawingOutput.width();
    };
    c2DDrawing.Plot = function (x, y, Color) {
        if (Color === void 0) { Color = cCommon.CurrentFrontColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        if (cString.IsNumeric(Color))
            Color = cCommon.hexToBgr(cCommon.decimal2hex(Color));
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.save();
        drawingContext.fillStyle = Color;
        drawingContext.fillRect(x, y, 1, 1);
        drawingContext.restore();
    };
    c2DDrawing.Point = function (x, y) {
        
        return 0;
    };
    c2DDrawing.RGB = function (Red, Green, Blue) {
        Red = Math.floor(Red);
        Green = Math.floor(Green);
        Blue = Math.floor(Blue);
        var color = "rgba(" + Red.toString() + "," + Green.toString() + "," + Blue.toString() + ",255)";
        return color;
    };
    c2DDrawing.RGBA = function (Red, Green, Blue, Alpha) {
        Red = Math.floor(Red);
        Green = Math.floor(Green);
        Blue = Math.floor(Blue);
        Alpha = Math.floor(Alpha);
        var color = "rgba(" + Red.toString() + "," + Green.toString() + "," + Blue.toString() + "," + (Alpha / 256).toString() + ")";
        return color;
    };
    c2DDrawing.Red = function (Color) {
        if (typeof Color === 'number') {
            return jQuery.Color("#" + cString.RSet(cCommon.decimal2hex(Color), 6, "0")).red();
        }
        else {
            return jQuery.Color(Color).red();
        }
    };
    c2DDrawing.ResetGradientColors = function () {
        
    };
    c2DDrawing.RoundBox = function (x, y, Width, Height, RoundX, RoundY, Color) {
        if (Color === void 0) { Color = cCommon.CurrentFrontColor; }
        if (cCommon.CurrentDrawingOutput == null) {
            
            return;
        }
        if (cString.IsNumeric(Color))
            Color = cCommon.hexToBgr(cCommon.decimal2hex(Color));
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        var radiusX = RoundX;
        var radiusY = RoundY;
        drawingContext.fillStyle = Color;
        drawingContext.save();
        drawingContext.beginPath();
        drawingContext.moveTo(x + radiusX, y);
        drawingContext.lineTo(x + Width - radiusX, y);
        drawingContext.quadraticCurveTo(x + Width, y, x + Width, y + radiusY);
        drawingContext.lineTo(x + Width, y + Height - radiusY);
        drawingContext.quadraticCurveTo(x + Width, y + Height, x + Width - radiusX, y + Height);
        drawingContext.lineTo(x + radiusX, y + Height);
        drawingContext.quadraticCurveTo(x, y + Height, x, y + Height - radiusY);
        drawingContext.lineTo(x, y + radiusY);
        drawingContext.quadraticCurveTo(x, y, x + radiusX, y);
        drawingContext.closePath();
        drawingContext.fill();
        drawingContext.restore();
    };
    c2DDrawing.StartDrawing = function (OutputID) {
        var functionName = "StartDrawing";
        var isImage = false;
        switch (cString.Left(OutputID, 1)) {
            case "s":
                isImage = true;
                break;
            case "i":
                isImage = true;
                break;
            case "g":
                break;
            default:
                
                return false;
        }
        if (isImage == true) {
            var img = cCommon.P2W_ImageList[cString.Mid(OutputID, 3)];
            if (img === null) {
                
                return false;
            }
            var drawingCanvas = document.createElement("canvas");
            drawingCanvas.width = img.width;
            drawingCanvas.height = img.height;
            cCommon.CurrentDrawingOutput = $(img);
            cCommon.CurrentDrawingOutput.data("drawingCanvas", drawingCanvas);
        }
        else {
            var selector = $("#" + OutputID);
            if (selector.length == 0) {
                
                return false;
            }
            cCommon.CurrentDrawingOutput = selector;
        }
        return true;
    };
    c2DDrawing.StopDrawing = function () {
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
        }
        else {
            var drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
            cCommon.CurrentDrawingOutput.attr("src", drawingCanvas.toDataURL());
            cCommon.CurrentDrawingOutput.removeData("drawingCanvas");
        }
        cCommon.CurrentDrawingOutput = null;
    };
    c2DDrawing.getTextHeight = function (Text) {
        var text = $('<span>' + Text + '</span>');
        text.css("font-style", cString.StringField(cCommon.CurrentDrawingFont, 1, " "));
        text.css("font-weight", cString.StringField(cCommon.CurrentDrawingFont, 2, " "));
        text.css("font-size", cString.StringField(cCommon.CurrentDrawingFont, 3, " "));
        text.css("font-family", cString.StringField(cCommon.CurrentDrawingFont, 4, " "));
        var block = $('<div style="display: inline-block; width: 1px; height: 0px;"></div>');
        var div = $('<div></div>');
        div.append(text, block);
        var body = $('body');
        body.append(div);
        try {
            var result = {};
            block.css({ verticalAlign: 'baseline' });
            result.ascent = block.offset().top - text.offset().top;
            block.css({ verticalAlign: 'bottom' });
            result.height = block.offset().top - text.offset().top;
            result.descent = result.height - result.ascent;
        }
        finally {
            div.remove();
        }
        return result;
    };
    c2DDrawing.TextHeight = function (Text) {
        var returnValue = 0;
        returnValue = c2DDrawing.getTextHeight(Text).height;
        return returnValue;
    };
    c2DDrawing.TextWidth = function (Text) {
        var drawingCanvas;
        if (cCommon.CurrentDrawingOutput.data("GadgetType") == cConstants.PB_GadgetType_Canvas) {
            drawingCanvas = cCommon.CurrentDrawingOutput[0];
        }
        else {
            drawingCanvas = cCommon.CurrentDrawingOutput.data("drawingCanvas");
        }
        var drawingContext = drawingCanvas.getContext("2d");
        drawingContext.font = cCommon.CurrentDrawingFont;
        drawingContext.textBaseline = "top";
        var textMetrics = drawingContext.measureText(Text);
        return textMetrics.width;
    };
    return c2DDrawing;
}());
var cArray = (function () {
    function cArray() {
    }
    cArray.ArraySize = function (Array, Dimension) {
        if (Dimension === void 0) { Dimension = 1; }
        switch (Dimension) {
            case 1: return Array.length;
            case 2: return Array[0].length;
            case 3: return Array[0][0].length;
            case 4: return Array[0][0][0].length;
            case 5: return Array[0][0][0][0].length;
            default: return -1;
        }
    };
    cArray.CopyArray = function (SourceArray, DestinationArray) {
        return SourceArray.slice();
    };
    cArray.FreeArray = function (Array) {
        Array = null;
    };
    cArray.Dim = function (Structure, DimArray) {
        return multiArray(DimArray, Structure);
    };
    cArray.ReDim = function (ReDimArray) {
    };
    return cArray;
}());
function multiArray(arr, struc) {
    var result = [];
    if (arr.length == 1) {
        for (var i = 0; i <= arr[0]; i++) {
            if (struc == null) {
                result.push(struc);
            }
            else {
                result.push(jQuery.extend(true, {}, struc));
            }
        }
    }
    else {
        var children = arr.slice(1);
        for (var i = 0; i <= arr[0]; i++) {
            result.push(multiArray(children, struc));
        }
    }
    return result;
}
var cCipher = (function () {
    function cCipher() {
    }
    cCipher.AESDecoder = function (Input, Output, Size, Key, Bits, InitializationVector, Mode) {
        if (Mode === void 0) { Mode = 0; }
        
        return 0;
    };
    cCipher.AESEncoder = function (Input, Output, Size, Key, Bits, InitializationVector, Mode) {
        if (Mode === void 0) { Mode = 0; }
        
        return 0;
    };
    cCipher.AddCipherBuffer = function (Cipher, Input, Output, Size) {
        
    };
    cCipher.P2W_Base64Decoder = function (Input) {
        return CryptoJS.enc.Utf8.stringify(CryptoJS.enc.Base64.parse(Input));
    };
    cCipher.Base64Decoder = function (InputBuffer, InputSize, OutputBuffer, OutputSize) {
        
        return 0;
    };
    cCipher.P2W_Base64Encoder = function (Input) {
        return CryptoJS.enc.Base64.stringify(CryptoJS.enc.Utf8.parse(Input));
    };
    cCipher.Base64Encoder = function (InputBuffer, InputSize, OutputBuffer, OutputSize, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return 0;
    };
    cCipher.CRC32FileFingerprint = function () {
        
    };
    cCipher.CRC32Fingerprint = function () {
        
    };
    cCipher.CloseCryptRandom = function () {
        
    };
    cCipher.CryptRandom = function () {
        
    };
    cCipher.CryptRandomData = function () {
        
    };
    cCipher.DESFingerprint = function () {
        
    };
    cCipher.ExamineMD5Fingerprint = function () {
        
    };
    cCipher.ExamineSHA1Fingerprint = function () {
        
    };
    cCipher.FinishCipher = function () {
        
    };
    cCipher.FinishFingerprint = function () {
        
    };
    cCipher.IsFingerprint = function () {
        
    };
    cCipher.MD5FileFingerprint = function () {
        
    };
    cCipher.MD5Fingerprint = function (Buffer, Size) {
        return CryptoJS.MD5(cString.Left(Buffer, Size));
    };
    cCipher.NextFingerprint = function () {
        
    };
    cCipher.OpenCryptRandom = function () {
        
    };
    cCipher.SHA1FileFingerprint = function () {
        
    };
    cCipher.SHA1Fingerprint = function () {
        
    };
    cCipher.StartAESCipher = function () {
        
    };
    return cCipher;
}());
var cClipboard = (function () {
    function cClipboard() {
    }
    cClipboard.ClearClipboard = function () {
        var w = window;
        w.clipboardData.setData('Text', '');
    };
    cClipboard.GetClipboardImage = function (Image, Depth) {
        if (Depth === void 0) { Depth = 0; }
        
        return null;
    };
    cClipboard.GetClipboardText = function () {
        var w = window;
        return w.clipboardData.getData('Text');
    };
    cClipboard.SetClipboardImage = function (Image) {
        
    };
    cClipboard.SetClipboardText = function (Text) {
        var w = window;
        w.clipboardData.setData('Text', Text);
    };
    return cClipboard;
}());
var Exception = (function () {
    function Exception(message) {
        if (message === void 0) { message = ""; }
        this.Message = message;
    }
    Exception.prototype.ToString = function () {
        return "Exception: " + this.Message;
    };
    return Exception;
}());
var NotImplementedException = (function (_super) {
    __extends(NotImplementedException, _super);
    function NotImplementedException(message) {
        if (message === void 0) { message = "Not implemented"; }
        _super.call(this, message);
    }
    return NotImplementedException;
}(Exception));
var FontItem = (function () {
    function FontItem() {
    }
    return FontItem;
}());
var cCommon = (function () {
    function cCommon() {
    }
    cCommon.isUserGadgetProcedure = function (gadgetType, functionName) {
        if (typeof p2w_UserGadget[gadgetType] !== 'undefined') {
            if (typeof p2w_UserGadget[gadgetType][functionName] === "function") {
                return true;
            }
        }
        return false;
    };
    cCommon.isPbGadgetProcedure = function (gadgetType, functionName) {
        if (typeof p2w_PbGadget[gadgetType] !== 'undefined') {
            if (typeof p2w_PbGadget[gadgetType][functionName] === "function") {
                return true;
            }
        }
        return false;
    };
    cCommon.UnsupportedGadgetAttribute = function (FunctionName, Gadget) {
        
    };
    cCommon.UnsupportedGadgetType = function (FunctionName, Gadget) {
        
    };
    cCommon.UnsupportedEventType = function (FunctionName, Gadget) {
        
    };
    cCommon.NotImplemented = function (NotImplementedItem) {
        
    };
    cCommon.NotSupported = function (NotSupportedItem) {
        
    };
    cCommon.GadgetIsNotInitialized = function (functionName) {
        
    };
    cCommon.FontIsNotInitialized = function (functionName) {
        
    };
    cCommon.WidgetIsNotInitialized = function (functionName) {
        
    };
    cCommon.MenuIsNotInitialized = function (functionName) {
        
    };
    cCommon.WindowIsNotInitialized = function (functionName) {
        
    };
    cCommon.MovieIsNotInitialized = function (functionName) {
        
    };
    cCommon.MusicIsNotInitialized = function (functionName) {
        
    };
    cCommon.ImageIsNotInitialized = function (functionName) {
        
    };
    cCommon.TimerIsNotInitialized = function (functionName) {
        
    };
    cCommon.ToolbarIsNotInitialized = function (functionName) {
        
    };
    cCommon.camelize = function (str) {
        return str.replace(/[\-_](\w)/g, function (match) { return match[1].toUpperCase(); });
    };
    cCommon.guid = function () {
        return parseInt(Math.floor(Math.random() * 1000).toString() +
            Math.floor(Math.random() * 1000).toString() +
            Math.floor(Math.random() * 1000).toString());
    };
    cCommon.generateUUID = function () {
        var d = new Date().getTime();
        var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = (d + Math.random() * 16) % 16 | 0;
            d = Math.floor(d / 16);
            return (c == 'x' ? r : (r & 0x3 | 0x8)).toString(16);
        });
        return uuid;
    };
    cCommon.getCurrentContainer = function () {
        if (this.CurrentContainer == null) {
            return $("body");
        }
        else {
            return this.CurrentContainer;
        }
    };
    cCommon.SetGadgetAndStuff = function (Gadget) {
        if (Gadget == cConstants.PB_Any)
            Gadget = cCommon.guid();
        if ($("#g_" + Gadget).length > 0)
            cGadget.FreeGadget(Gadget);
        if (cCommon.CurrentContainer == null)
            cCommon.CurrentContainer = $("body");
        return Gadget;
    };
    cCommon.SetMovieAndStuff = function (Movie) {
        if (Movie == cConstants.PB_Any) {
            Movie = cCommon.guid();
        }
        if ($("#v_" + Movie).length > 0) {
            cMovie.FreeMovie(Movie);
        }
        if (cCommon.CurrentContainer == null) {
            cCommon.CurrentContainer = $("body");
        }
        return Movie;
    };
    cCommon.SetMusicAndStuff = function (Music) {
        if (Music == cConstants.PB_Any) {
            Music = cCommon.guid();
        }
        if ($("#a_" + Music).length > 0) {
            cMusic.FreeMusic(Music);
        }
        if (cCommon.CurrentContainer == null) {
            cCommon.CurrentContainer = $("body");
        }
        return Music;
    };
    cCommon.SetGadgetPosition = function (selector, x, y, Width, Height) {
        selector.css("position", "absolute");
        if (x != cConstants.PB_Ignore)
            selector.css("left", x);
        if (y != cConstants.PB_Ignore)
            selector.css("top", y);
        if (Width != cConstants.PB_Ignore)
            selector.css("width", Width);
        if (Height != cConstants.PB_Ignore)
            selector.css("height", Height);
        selector.addClass("p2w-gadget");
    };
    cCommon.CheckFlag32 = function (Flags, Flag) {
        return ((Flags & Flag) === Flag);
    };
    cCommon.CheckFlag = function (Flags, Flag) {
        var w = 4294967296;
        var aHI = Flags / w;
        var aLO = Flags % w;
        var bHI = Flag / w;
        var bLO = Flag % w;
        return (((aHI & bHI) * w + (aLO & bLO)) === Flag);
    };
    cCommon.decimal2hex = function (decimal) {
        return decimal.toString(16);
    };
    cCommon.hex2decimal = function (hex) {
        return parseInt(hex, 16);
    };
    cCommon.hexToRgb = function (hex) {
        var bigint = parseInt(hex, 16);
        var r = (bigint >> 16) & 255;
        var g = (bigint >> 8) & 255;
        var b = bigint & 255;
        return "rgb(" + r + "," + g + "," + b + ")";
    };
    cCommon.hexToBgr = function (hex) {
        var bigint = parseInt(hex, 16);
        var r = (bigint >> 16) & 255;
        var g = (bigint >> 8) & 255;
        var b = bigint & 255;
        return "rgb(" + b + "," + g + "," + r + ")";
    };
    cCommon.rgb2hex = function (rgb) {
        var rgb1 = rgb.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
        if (rgb1) {
            return "#" + ("0" + parseInt(rgb1[1], 10).toString(16)).slice(-2) + ("0" + parseInt(rgb1[2], 10).toString(16)).slice(-2) + ("0" + parseInt(rgb1[3], 10).toString(16)).slice(-2);
        }
        else {
            var rgb2 = rgb.match(/^rgba\((\d+),\s*(\d+),\s*(\d+),\s*(\d+)\)$/);
            if (rgb2) {
                return "#" + ("0" + parseInt(rgb2[1], 10).toString(16)).slice(-2) + ("0" + parseInt(rgb2[2], 10).toString(16)).slice(-2) + ("0" + parseInt(rgb2[3], 10).toString(16)).slice(-2);
            }
        }
        return "";
    };
    cCommon.bgr2hex = function (bgr) {
        bgr = bgr.match(/^rgb\((\d+),\s*(\d+),\s*(\d+)\)$/);
        return "#" +
            ("0" + parseInt(bgr[3], 10).toString(16)).slice(-2) +
            ("0" + parseInt(bgr[2], 10).toString(16)).slice(-2) +
            ("0" + parseInt(bgr[1], 10).toString(16)).slice(-2);
    };
    cCommon.checkBlob = function () {
        try {
            if (Blob) {
                return true;
            }
            else {
                
                return false;
            }
        }
        catch (ex) {
            
            return false;
        }
    };
    cCommon.CurrentMouseX = 0;
    cCommon.CurrentMouseY = 0;
    cCommon.SwipeThreshold = 75;
    cCommon.DoubleTapThreshold = 200;
    cCommon.CancelThreshold = null;
    cCommon.LongTapThreshold = 500;
    cCommon.CurrentContainer = null;
    cCommon.EmptyImage = "data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==";
    cCommon.CurrentToolbar = null;
    cCommon.CurrentMenu = null;
    cCommon.CurrentSubMenu = null;
    cCommon.CurrentSubMenuParent = null;
    cCommon.CurrentDrawingOutput = null;
    cCommon.CurrentFrontColor = 'white';
    cCommon.CurrentBackColor = 'black';
    cCommon.BrowserLanguage = (navigator.language || 'en-EN');
    cCommon.CurrentDrawingFont = 'normal normal 12px Arial';
    cCommon.P2W_Global_Label = 0;
    cCommon.P2W_ListOfDatabase = [];
    cCommon.P2W_ImageList = [];
    cCommon.P2W_FontList = new Array();
    cCommon.JSONErrorMessage = '';
    cCommon.P2W_Global_ProgramParameter_Counter = 0;
    cCommon.PB_Compiler_EnumerationValue = 0;
    cCommon.largeWindowFix = false;
    cCommon.Debugger = false;
    cCommon.DebugWindow = -1;
    cCommon.DebugWindow_txtDebug = -1;
    return cCommon;
}());
var cCompiler = (function () {
    function cCompiler() {
    }
    cCompiler.SizeOf = function (Object) {
        var objectList = [];
        var stack = [Object];
        var bytes = 0;
        while (stack.length) {
            var value = stack.pop();
            if (typeof value === 'boolean') {
                bytes += 4;
            }
            else if (typeof value === 'string') {
                bytes += value.length * 2;
            }
            else if (typeof value === 'number') {
                bytes += 8;
            }
            else if (typeof value === 'object'
                && objectList.indexOf(value) === -1) {
                objectList.push(value);
                for (var i in value) {
                    stack.push(value[i]);
                }
            }
        }
        return bytes;
    };
    cCompiler.TypeOf = function (Object) {
        if (jQuery.isArray(Object)) {
            return cConstants.PB_Array;
        }
        else if (jQuery.isFunction(Object)) {
            return cConstants.PB_Function;
        }
        else if (jQuery.isNumeric(Object)) {
            return cConstants.PB_Number;
        }
        switch (typeof Object) {
            case "undefined": return cConstants.PB_Undefined;
            case "string": return cConstants.PB_String;
            case "boolean": return cConstants.PB_Boolean;
            case "symbol": return cConstants.PB_Symbol;
            case "object": return cConstants.PB_Object;
            default: return cConstants.PB_Unknown;
        }
    };
    cCompiler.Bool = function (Value) {
        if (Value)
            return true;
        return false;
    };
    return cCompiler;
}());
var cCompilerDirectives = (function () {
    function cCompilerDirectives() {
    }
    cCompilerDirectives.EnableExplicit = function () { };
    cCompilerDirectives.DisableExplicit = function () { };
    return cCompilerDirectives;
}());
var cConsole = (function () {
    function cConsole() {
    }
    cConsole.ClearConsole = function () {
        $("#p2w_console").empty();
        console.clear();
    };
    cConsole.CloseConsole = function () {
        $("#p2w_console").remove();
    };
    cConsole.ConsoleColor = function () {
        
    };
    cConsole.ConsoleCursor = function () {
        
    };
    cConsole.ConsoleError = function () {
        
    };
    cConsole.ConsoleLocate = function () {
        
    };
    cConsole.ConsoleTitle = function () {
        
    };
    cConsole.EnableGraphicalConsole = function () {
        
    };
    cConsole.Inkey = function () {
        
    };
    cConsole.Input = function () {
        
    };
    cConsole.OpenConsole = function () {
        $("#p2w_console").remove();
        var selector = $("<div />");
        selector.attr("id", "p2w_console");
        $("body").prepend(selector);
    };
    cConsole.Print = function (Text) {
        $("#p2w_console").append(Text);
        console.log(Text);
    };
    cConsole.PrintN = function (Text) {
        $("#p2w_console").append("<div>" + Text + "</div>");
        console.log(Text);
    };
    cConsole.RawKey = function () {
        
    };
    cConsole.ReadConsoleData = function () {
        
    };
    cConsole.WriteConsoleData = function () {
        
    };
    return cConsole;
}());
var cConstants = (function () {
    function cConstants() {
    }
    cConstants.PB_Compiler_OS = 1;
    cConstants.PB_OS_Windows = 1;
    cConstants.PB_OS_Linux = 2;
    cConstants.PB_OS_AmigaOS = 3;
    cConstants.PB_OS_MacOS = 4;
    cConstants.PB_Compiler_Processor = 2;
    cConstants.PB_Processor_x86 = 2;
    cConstants.PB_Processor_x64 = 4;
    cConstants.PB_Processor_PowerPC = 3;
    cConstants.PB_Processor_mc68000 = 1;
    cConstants.PB_Compiler_ExecutableFormat = 0;
    cConstants.PB_Compiler_Executable = 0;
    cConstants.PB_Compiler_Console = 2;
    cConstants.PB_Compiler_DLL = 1;
    cConstants.PB_Compiler_Date = 1389778573;
    cConstants.PB_Compiler_File = "";
    cConstants.PB_Compiler_FilePath = "";
    cConstants.PB_Compiler_Filename = "";
    cConstants.PB_Compiler_Line = 19;
    cConstants.PB_Compiler_Procedure = "";
    cConstants.PB_Compiler_Module = "";
    cConstants.PB_Compiler_Version = 521;
    cConstants.PB_Compiler_Home = "";
    cConstants.PB_Compiler_Debugger = 1;
    cConstants.PB_Compiler_Thread = 0;
    cConstants.PB_Compiler_Unicode = 0;
    cConstants.PB_Compiler_LineNumbering = 0;
    cConstants.PB_Compiler_InlineAssembly = 0;
    cConstants.PB_Compiler_EnableExplicit = 0;
    cConstants.PB_Compiler_IsMainFile = 1;
    cConstants.PB_Compiler_IsIncludeFile = 0;
    cConstants.PB_Center_Horizontal = 1;
    cConstants.PB_Center_Vertical = 2;
    cConstants.PB_Center_Both = 3;
    cConstants.PB_2DDrawing_AllChannels = 256;
    cConstants.PB_2DDrawing_AlphaBlend = 16;
    cConstants.PB_2DDrawing_AlphaChannel = 8;
    cConstants.PB_2DDrawing_AlphaClip = 32;
    cConstants.PB_2DDrawing_CustomFilter = 128;
    cConstants.PB_2DDrawing_Default = 0;
    cConstants.PB_2DDrawing_Gradient = 64;
    cConstants.PB_2DDrawing_Outlined = 4;
    cConstants.PB_2DDrawing_Transparent = 1;
    cConstants.PB_2DDrawing_XOr = 2;
    cConstants.PB_Absolute = 0;
    cConstants.PB_All = -1;
    cConstants.PB_Any = -1;
    cConstants.PB_BillboardGroup = 4;
    cConstants.PB_Button_Default = 1;
    cConstants.PB_Button_Image = 2;
    cConstants.PB_Button_Left = 4;
    cConstants.PB_Button_MultiLine = 8;
    cConstants.PB_Button_PressedImage = 16;
    cConstants.PB_Button_Right = 32;
    cConstants.PB_Button_Split = 64;
    cConstants.PB_Button_Toggle = 128;
    cConstants.PB_Calendar_Bold = 1;
    cConstants.PB_Calendar_Borderless = 8388608;
    cConstants.PB_Calendar_Maximum = 2;
    cConstants.PB_Calendar_Minimum = 1;
    cConstants.PB_Calendar_Normal = 0;
    cConstants.PB_Canvas_Alt = 2;
    cConstants.PB_Canvas_Border = 1;
    cConstants.PB_Canvas_Buttons = 4;
    cConstants.PB_Canvas_Clip = 10;
    cConstants.PB_Canvas_ClipMouse = 2;
    cConstants.PB_Canvas_Command = 4;
    cConstants.PB_Canvas_Control = 4;
    cConstants.PB_Canvas_Cursor = 7;
    cConstants.PB_Canvas_CustomCursor = 11;
    cConstants.PB_Canvas_DrawFocus = 12;
    cConstants.PB_Canvas_Image = 1;
    cConstants.PB_Canvas_Input = 9;
    cConstants.PB_Canvas_Key = 5;
    cConstants.PB_Canvas_Keyboard = 4;
    cConstants.PB_Canvas_LeftButton = 1;
    cConstants.PB_Canvas_MiddleButton = 4;
    cConstants.PB_Canvas_Modifiers = 6;
    cConstants.PB_Canvas_MouseX = 2;
    cConstants.PB_Canvas_MouseY = 3;
    cConstants.PB_Canvas_RightButton = 2;
    cConstants.PB_Canvas_Shift = 1;
    cConstants.PB_Canvas_WheelDelta = 8;
    cConstants.PB_CheckBox_Center = 768;
    cConstants.PB_Checkbox_Checked = 1;
    cConstants.PB_Checkbox_Inbetween = -1;
    cConstants.PB_CheckBox_Right = 512;
    cConstants.PB_CheckBox_ThreeState = 5;
    cConstants.PB_Checkbox_Unchecked = 0;
    cConstants.PB_Cipher_CBC = 4;
    cConstants.PB_Cipher_Decode = 1;
    cConstants.PB_Cipher_ECB = 8;
    cConstants.PB_Cipher_Encode = 2;
    cConstants.PB_Cipher_NoPadding = 32;
    cConstants.PB_Cipher_URL = 16;
    cConstants.PB_Clipboard_Image = 8;
    cConstants.PB_ComboBox_Editable = 1;
    cConstants.PB_ComboBox_Image = 2;
    cConstants.PB_ComboBox_Simple = 4;
    cConstants.PB_ComboBox_LowerCase = 8;
    cConstants.PB_ComboBox_UpperCase = 16;
    cConstants.PB_ComboBox_MaxHeight = 32;
    cConstants.PB_Constant = 50;
    cConstants.PB_Container_BorderLess = 0;
    cConstants.PB_Container_Double = 8;
    cConstants.PB_Container_Flat = 1;
    cConstants.PB_Container_Raised = 2;
    cConstants.PB_Container_Single = 4;
    cConstants.PB_Cursor_Arrows = 6;
    cConstants.PB_Cursor_Busy = 4;
    cConstants.PB_Cursor_Cross = 1;
    cConstants.PB_Cursor_Default = 0;
    cConstants.PB_Cursor_Denied = 5;
    cConstants.PB_Cursor_Hand = 3;
    cConstants.PB_Cursor_IBeam = 2;
    cConstants.PB_Cursor_Invisible = 11;
    cConstants.PB_Cursor_LeftDownRightUp = 10;
    cConstants.PB_Cursor_LeftRight = 7;
    cConstants.PB_Cursor_LeftUpRightDown = 9;
    cConstants.PB_Cursor_UpDown = 8;
    cConstants.PB_Database_Blob = 6;
    cConstants.PB_Database_Double = 4;
    cConstants.PB_Database_Float = 3;
    cConstants.PB_Database_Long = 1;
    cConstants.PB_Database_ODBC = 1;
    cConstants.PB_Database_PostgreSQL = 3;
    cConstants.PB_Database_Quad = 5;
    cConstants.PB_Database_SQLite = 2;
    cConstants.PB_Database_String = 2;
    cConstants.PB_Date_Accessed = 1;
    cConstants.PB_Date_Calendar = 0;
    cConstants.PB_Date_CheckBox = 2;
    cConstants.PB_Date_Created = 0;
    cConstants.PB_Date_Day = 3;
    cConstants.PB_Date_Hour = 4;
    cConstants.PB_Date_Maximum = 2;
    cConstants.PB_Date_Minimum = 1;
    cConstants.PB_Date_Minute = 5;
    cConstants.PB_Date_Modified = 2;
    cConstants.PB_Date_Month = 1;
    cConstants.PB_Date_Second = 6;
    cConstants.PB_Date_UpDown = 1;
    cConstants.PB_Date_Week = 2;
    cConstants.PB_Date_Year = 0;
    cConstants.PB_Default = -1;
    cConstants.PB_DirectoryEntry_Directory = 2;
    cConstants.PB_DirectoryEntry_File = 1;
    cConstants.PB_Drag_Copy = 1;
    cConstants.PB_Drag_Enter = 1;
    cConstants.PB_Drag_Finish = 4;
    cConstants.PB_Drag_Leave = 3;
    cConstants.PB_Drag_Link = 4;
    cConstants.PB_Drag_Move = 2;
    cConstants.PB_Drag_None = 0;
    cConstants.PB_Drag_Update = 2;
    cConstants.PB_Drop_Files = 15;
    cConstants.PB_Drop_Image = 8;
    cConstants.PB_Drop_Private = 512;
    cConstants.PB_Drop_Text = 1;
    cConstants.PB_Editor_ReadOnly = 1;
    cConstants.PB_Editor_WordWrap = 4;
    cConstants.PB_Event_ActivateWindow = 13104;
    cConstants.PB_Event_ClientConnected = 1;
    cConstants.PB_Event_ClientDisconnected = 4;
    cConstants.PB_Event_CloseWindow = 16;
    cConstants.PB_Event_DataReceived = 2;
    cConstants.PB_Event_DeactivateWindow = 13114;
    cConstants.PB_Event_FileReceived = 3;
    cConstants.PB_Event_FirstCustomValue = 65536;
    cConstants.PB_Event_Gadget = 13100;
    cConstants.PB_Event_GadgetDrop = 13106;
    cConstants.PB_Event_LeftClick = 13112;
    cConstants.PB_Event_LeftDoubleClick = 13113;
    cConstants.PB_Event_MaximizeWindow = 13108;
    cConstants.PB_Event_Menu = 13101;
    cConstants.PB_Event_MinimizeWindow = 13107;
    cConstants.PB_Event_MoveWindow = 3;
    cConstants.PB_Event_None = 0;
    cConstants.PB_Event_Repaint = 15;
    cConstants.PB_Event_RestoreWindow = 13109;
    cConstants.PB_Event_RightClick = 13111;
    cConstants.PB_Event_SizeWindow = 5;
    cConstants.PB_Event_SizeWindowStart = 6;
    cConstants.PB_Event_SizeWindowStop = 7;
    cConstants.PB_Event_SysTray = 13102;
    cConstants.PB_Event_Timer = 13110;
    cConstants.PB_Event_WindowDrop = 13105;
    cConstants.PB_Event_BatteryStatus = 13199;
    cConstants.PB_File_Append = 8;
    cConstants.PB_File_IgnoreEOL = 65536;
    cConstants.PB_File_NoBuffering = 4;
    cConstants.PB_File_NoShare = 0;
    cConstants.PB_File_SharedRead = 1;
    cConstants.PB_File_SharedWrite = 2;
    cConstants.PB_FileSystem_Archive = 32;
    cConstants.PB_FileSystem_Compressed = 2048;
    cConstants.PB_FileSystem_Force = 2;
    cConstants.PB_FileSystem_Hidden = 2;
    cConstants.PB_FileSystem_NoExtension = 1;
    cConstants.PB_FileSystem_Normal = 128;
    cConstants.PB_FileSystem_ReadOnly = 1;
    cConstants.PB_FileSystem_Recursive = 1;
    cConstants.PB_FileSystem_System = 4;
    cConstants.PB_Font_Bold = 256;
    cConstants.PB_Font_HighQuality = 16;
    cConstants.PB_Font_Italic = 512;
    cConstants.PB_Font_StrikeOut = 8;
    cConstants.PB_Font_Underline = 4;
    cConstants.PB_FontRequester_Effects = 256;
    cConstants.PB_Frame_Double = 1;
    cConstants.PB_Frame_Flat = 3;
    cConstants.PB_Frame_Single = 2;
    cConstants.PB_Gadget_ActualSize = 0;
    cConstants.PB_Gadget_FrontColor = 1;
    cConstants.PB_Gadget_BackColor = 2;
    cConstants.PB_Gadget_Color = 3;
    cConstants.PB_Gadget_BorderColor = 4;
    cConstants.PB_Gadget_ContainerCoordinate = 0;
    cConstants.PB_Gadget_GrayTextColor = 6;
    cConstants.PB_Gadget_LineColor = 3;
    cConstants.PB_Gadget_RequiredSize = 1;
    cConstants.PB_Gadget_ScreenCoordinate = 1;
    cConstants.PB_Gadget_TitleBackColor = 5;
    cConstants.PB_Gadget_TitleFrontColor = 4;
    cConstants.PB_Gadget_WindowCoordinate = 2;
    cConstants.PB_GadgetType_Button = "ButtonGadget";
    cConstants.PB_GadgetType_ButtonImage = "ButtonImageGadget";
    cConstants.PB_GadgetType_Calendar = "CalendarGadget";
    cConstants.PB_GadgetType_Canvas = "CanvasGadget";
    cConstants.PB_GadgetType_CheckBox = "CheckBoxGadget";
    cConstants.PB_GadgetType_ComboBox = "ComboBoxGadget";
    cConstants.PB_GadgetType_Container = "ContainerGadget";
    cConstants.PB_GadgetType_Date = "DateGadget";
    cConstants.PB_GadgetType_Editor = "EditorGadget";
    cConstants.PB_GadgetType_ExplorerCombo = "ExplorerComboGadget";
    cConstants.PB_GadgetType_ExplorerList = "ExplorerListGadget";
    cConstants.PB_GadgetType_ExplorerTree = "ExplorerTreeGadget";
    cConstants.PB_GadgetType_Frame = "FrameGadget";
    cConstants.PB_GadgetType_Html = "HtmlGadget";
    cConstants.PB_GadgetType_HyperLink = "HyperLinkGadget";
    cConstants.PB_GadgetType_IFrame = "IFrameGadget";
    cConstants.PB_GadgetType_Image = "ImageGadget";
    cConstants.PB_GadgetType_IPAddress = "IPAddressGadget";
    cConstants.PB_GadgetType_ListIcon = "ListIconGadget";
    cConstants.PB_GadgetType_ListView = "ListViewGadget";
    cConstants.PB_GadgetType_MDI = "MDIGadget";
    cConstants.PB_GadgetType_Movie = "MovieGadget";
    cConstants.PB_GadgetType_Music = "MusicGadget";
    cConstants.PB_GadgetType_Option = "OptionGadget";
    cConstants.PB_GadgetType_Panel = "PanelGadget";
    cConstants.PB_GadgetType_ProgressBar = "ProgressBarGadget";
    cConstants.PB_GadgetType_Scintilla = "ScintillaGadget";
    cConstants.PB_GadgetType_ScrollArea = "ScrollAreaGadget";
    cConstants.PB_GadgetType_ScrollBar = "ScrollBarGadget";
    cConstants.PB_GadgetType_Shortcut = "ShortcutGadget";
    cConstants.PB_GadgetType_Spin = "SpinGadget";
    cConstants.PB_GadgetType_Splitter = "SplitterGadget";
    cConstants.PB_GadgetType_String = "StringGadget";
    cConstants.PB_GadgetType_Text = "TextGadget";
    cConstants.PB_GadgetType_TrackBar = "TrackBarGadget";
    cConstants.PB_GadgetType_Tree = "TreeGadget";
    cConstants.PB_GadgetType_Web = "WebGadget";
    cConstants.PB_WindowType_Window = 1;
    cConstants.PB_WindowType_UploadRequester = 2;
    cConstants.PB_HingeJoint_LowerLimit = 8;
    cConstants.PB_HingeJoint_UpperLimit = 9;
    cConstants.PB_HyperLink_Underline = 1;
    cConstants.PB_HTTP_Asynchronous = 1;
    cConstants.PB_HTTP_NoRedirect = 2;
    cConstants.PB_HTTP_Get = 0;
    cConstants.PB_HTTP_Post = 1;
    cConstants.PB_Ignore = -65535;
    cConstants.PB_Image_Border = 512;
    cConstants.PB_Image_DisplayFormat = 24;
    cConstants.PB_Image_FloydSteinberg = 256;
    cConstants.PB_Image_InternalDepth = -3;
    cConstants.PB_Image_OriginalDepth = -2;
    cConstants.PB_Image_Raised = 1;
    cConstants.PB_Image_Raw = 1;
    cConstants.PB_Image_Smooth = 0;
    cConstants.PB_Image_Transparent = -1;
    cConstants.PB_ImagePlugin_BMP = 5262658;
    cConstants.PB_ImagePlugin_ICON = 1313817417;
    cConstants.PB_ImagePlugin_JPEG = 1195724874;
    cConstants.PB_ImagePlugin_JPEG2000 = 1261588554;
    cConstants.PB_ImagePlugin_PNG = 4673104;
    cConstants.PB_ImagePlugin_TGA = 4278100;
    cConstants.PB_ImagePlugin_TIFF = 1179011412;
    cConstants.PB_InputRequester_Password = 1;
    cConstants.PB_Interface = 52;
    cConstants.PB_Key_0 = 11;
    cConstants.PB_Key_1 = 2;
    cConstants.PB_Key_2 = 3;
    cConstants.PB_Key_3 = 4;
    cConstants.PB_Key_4 = 5;
    cConstants.PB_Key_5 = 6;
    cConstants.PB_Key_6 = 7;
    cConstants.PB_Key_7 = 8;
    cConstants.PB_Key_8 = 9;
    cConstants.PB_Key_9 = 10;
    cConstants.PB_Key_A = 30;
    cConstants.PB_Key_Add = 78;
    cConstants.PB_Key_All = -1;
    cConstants.PB_Key_Apostrophe = 40;
    cConstants.PB_Key_B = 48;
    cConstants.PB_Key_Back = 14;
    cConstants.PB_Key_BackSlash = 43;
    cConstants.PB_Key_C = 46;
    cConstants.PB_Key_Capital = 58;
    cConstants.PB_Key_Comma = 51;
    cConstants.PB_Key_D = 32;
    cConstants.PB_Key_Decimal = 83;
    cConstants.PB_Key_Delete = 211;
    cConstants.PB_Key_Divide = 181;
    cConstants.PB_Key_Down = 208;
    cConstants.PB_Key_E = 18;
    cConstants.PB_Key_End = 207;
    cConstants.PB_Key_Equals = 13;
    cConstants.PB_Key_Escape = 1;
    cConstants.PB_Key_F = 33;
    cConstants.PB_Key_F1 = 59;
    cConstants.PB_Key_F10 = 68;
    cConstants.PB_Key_F11 = 87;
    cConstants.PB_Key_F12 = 88;
    cConstants.PB_Key_F2 = 60;
    cConstants.PB_Key_F3 = 61;
    cConstants.PB_Key_F4 = 62;
    cConstants.PB_Key_F5 = 63;
    cConstants.PB_Key_F6 = 64;
    cConstants.PB_Key_F7 = 65;
    cConstants.PB_Key_F8 = 66;
    cConstants.PB_Key_F9 = 67;
    cConstants.PB_Key_G = 34;
    cConstants.PB_Key_Grave = 41;
    cConstants.PB_Key_H = 35;
    cConstants.PB_Key_Home = 199;
    cConstants.PB_Key_I = 23;
    cConstants.PB_Key_Insert = 210;
    cConstants.PB_Key_J = 36;
    cConstants.PB_Key_K = 37;
    cConstants.PB_Key_L = 38;
    cConstants.PB_Key_Left = 203;
    cConstants.PB_Key_LeftAlt = 56;
    cConstants.PB_Key_LeftBracket = 26;
    cConstants.PB_Key_LeftControl = 29;
    cConstants.PB_Key_LeftShift = 42;
    cConstants.PB_Key_M = 50;
    cConstants.PB_Key_Minus = 12;
    cConstants.PB_Key_Multiply = 55;
    cConstants.PB_Key_N = 49;
    cConstants.PB_Key_NumLock = 69;
    cConstants.PB_Key_O = 24;
    cConstants.PB_Key_P = 25;
    cConstants.PB_Key_Pad0 = 82;
    cConstants.PB_Key_Pad1 = 79;
    cConstants.PB_Key_Pad2 = 80;
    cConstants.PB_Key_Pad3 = 81;
    cConstants.PB_Key_Pad4 = 75;
    cConstants.PB_Key_Pad5 = 76;
    cConstants.PB_Key_Pad6 = 77;
    cConstants.PB_Key_Pad7 = 71;
    cConstants.PB_Key_Pad8 = 72;
    cConstants.PB_Key_Pad9 = 73;
    cConstants.PB_Key_PadComma = 179;
    cConstants.PB_Key_PadEnter = 156;
    cConstants.PB_Key_PageDown = 209;
    cConstants.PB_Key_PageUp = 201;
    cConstants.PB_Key_Pause = 197;
    cConstants.PB_Key_Period = 52;
    cConstants.PB_Key_Q = 16;
    cConstants.PB_Key_R = 19;
    cConstants.PB_Key_Return = 28;
    cConstants.PB_Key_Right = 205;
    cConstants.PB_Key_RightAlt = 184;
    cConstants.PB_Key_RightBracket = 27;
    cConstants.PB_Key_RightControl = 157;
    cConstants.PB_Key_RightShift = 54;
    cConstants.PB_Key_S = 31;
    cConstants.PB_Key_Scroll = 70;
    cConstants.PB_Key_SemiColon = 39;
    cConstants.PB_Key_Slash = 53;
    cConstants.PB_Key_Space = 57;
    cConstants.PB_Key_Subtract = 74;
    cConstants.PB_Key_T = 20;
    cConstants.PB_Key_Tab = 15;
    cConstants.PB_Key_U = 22;
    cConstants.PB_Key_Up = 200;
    cConstants.PB_Key_V = 47;
    cConstants.PB_Key_W = 17;
    cConstants.PB_Key_X = 45;
    cConstants.PB_Key_Y = 21;
    cConstants.PB_Key_Z = 44;
    cConstants.PB_Keyboard_AllowSystemKeys = 2;
    cConstants.PB_Keyboard_International = 1;
    cConstants.PB_Keyboard_Qwerty = 0;
    cConstants.PB_Label = 56;
    cConstants.PB_LinkedList = 14;
    cConstants.PB_List_First = 1;
    cConstants.PB_List_Last = 2;
    cConstants.PB_List_After = 4;
    cConstants.PB_List_Before = 3;
    cConstants.PB_ListIcon_AlwaysShowSelection = 1;
    cConstants.PB_ListIcon_CheckBoxes = 2;
    cConstants.PB_ListIcon_Checked = 4;
    cConstants.PB_ListIcon_DisplayMode = 8;
    cConstants.PB_ListIcon_FullRowSelect = 16;
    cConstants.PB_ListIcon_GridLines = 32;
    cConstants.PB_ListIcon_HeaderDragDrop = 64;
    cConstants.PB_ListIcon_Inbetween = 128;
    cConstants.PB_ListIcon_LargeIcon = 256;
    cConstants.PB_ListIcon_List = 512;
    cConstants.PB_ListIcon_MultiSelect = 1024;
    cConstants.PB_ListIcon_Report = 2048;
    cConstants.PB_ListIcon_Selected = 4096;
    cConstants.PB_ListIcon_SmallIcon = 8192;
    cConstants.PB_ListIcon_ThreeState = 16384;
    cConstants.PB_ListIcon_Changed = 32768;
    cConstants.PB_ListIcon_Header = 65536;
    cConstants.PB_ListIcon_Toolbar = 131072;
    cConstants.PB_ListIcon_Footer = 262144;
    cConstants.PB_ListIcon_ColumnHeaders = 524288;
    cConstants.PB_ListIcon_LineNumbers = 1048576;
    cConstants.PB_ListIcon_ExpandColumn = 2097152;
    cConstants.PB_ListIcon_SelectColumn = 4194304;
    cConstants.PB_ListIcon_EmptyRecords = 8388608;
    cConstants.PB_ListIcon_ToolbarReload = 16777216;
    cConstants.PB_ListIcon_ToolbarColumns = 33554432;
    cConstants.PB_ListIcon_ToolbarSearch = 67108864;
    cConstants.PB_ListIcon_ToolbarAdd = 134217728;
    cConstants.PB_ListIcon_ToolbarEdit = 268435456;
    cConstants.PB_ListIcon_ToolbarDelete = 536870912;
    cConstants.PB_ListIcon_ToolbarSave = 1073741824;
    cConstants.PB_ListIcon_SelectionBorder = 2147483648;
    cConstants.PB_ListIcon_RecordTitles = 4294967296;
    cConstants.PB_ListIcon_SkipRecords = 8589934592;
    cConstants.PB_ListIcon_SelectTypeCell = 17179869184;
    cConstants.PB_ListIcon_ColumnDelimiter = 1;
    cConstants.PB_ListIcon_RecordDelimiter = 2;
    cConstants.PB_ListIcon_Columns = 3;
    cConstants.PB_ListIcon_Records = 4;
    cConstants.PB_ListIcon_SearchFields = 5;
    cConstants.PB_ListIcon_HeaderText = 6;
    cConstants.PB_ListIcon_URL = 7;
    cConstants.PB_ListIcon_CustomRenderer = 1;
    cConstants.PB_ListIcon_Editable = 2;
    cConstants.PB_ListIcon_ColumnWidth = 4;
    cConstants.PB_ListIcon_Resizable = 8;
    cConstants.PB_ListIcon_Sortable = 16;
    cConstants.PB_ListIcon_Alignment = 32;
    cConstants.PB_ListIcon_Align_Left = 1;
    cConstants.PB_ListIcon_Align_Right = 2;
    cConstants.PB_ListIcon_Align_Center = 3;
    cConstants.PB_ListView_MultiSelect = 8;
    cConstants.PB_ListView_ClickSelect = 2048;
    cConstants.PB_Local = 2;
    cConstants.PB_Map_ElementCheck = 1;
    cConstants.PB_Map_NoElementCheck = 0;
    cConstants.PB_MDI_Arrange = -6;
    cConstants.PB_MDI_AutoSize = 2;
    cConstants.PB_MDI_BorderLess = 1;
    cConstants.PB_MDI_Cascade = -1;
    cConstants.PB_MDI_Image = 3;
    cConstants.PB_MDI_Next = -4;
    cConstants.PB_MDI_NoScrollBars = 4;
    cConstants.PB_MDI_Previous = -5;
    cConstants.PB_MDI_TileHorizontally = -3;
    cConstants.PB_MDI_TileImage = 4;
    cConstants.PB_MDI_TileVertically = -2;
    cConstants.PB_Memory_NoClear = 1;
    cConstants.PB_Menu_ModernLook = 1;
    cConstants.PB_MessageRequester_Cancel = 2;
    cConstants.PB_MessageRequester_No = 7;
    cConstants.PB_MessageRequester_Ok = 0;
    cConstants.PB_MessageRequester_Yes = 6;
    cConstants.PB_MessageRequester_YesNo = 4;
    cConstants.PB_MessageRequester_YesNoCancel = 3;
    cConstants.PB_Module = 58;
    cConstants.PB_MouseButton_Left = 1;
    cConstants.PB_MouseButton_Middle = 3;
    cConstants.PB_MouseButton_Right = 2;
    cConstants.PB_Network_IPv4 = 0;
    cConstants.PB_Network_IPv6 = 268435456;
    cConstants.PB_Network_TCP = 1;
    cConstants.PB_Network_UDP = 2;
    cConstants.PB_NetworkEvent_Connect = 1;
    cConstants.PB_NetworkEvent_Data = 2;
    cConstants.PB_NetworkEvent_Disconnect = 4;
    cConstants.PB_NetworkEvent_None = 0;
    cConstants.PB_Packer_CompressedSize = 1;
    cConstants.PB_Packer_Directory = 1;
    cConstants.PB_Packer_File = 0;
    cConstants.PB_Packer_UncompressedSize = 0;
    cConstants.PB_PackerPlugin_BriefLZ = 1651666042;
    cConstants.PB_PackerPlugin_JCALG1 = 1784900657;
    cConstants.PB_PackerPlugin_LZMA = 1819962721;
    cConstants.PB_PackerPlugin_Zip = 8022384;
    cConstants.PB_Panel_ItemHeight = 2;
    cConstants.PB_Panel_ItemWidth = 1;
    cConstants.PB_Panel_TabHeight = 3;
    cConstants.PB_Parent = 4;
    cConstants.PB_Preference_GroupSeparator = 2;
    cConstants.PB_Preference_NoSpace = 1;
    cConstants.PB_Procedure = 53;
    cConstants.PB_ProcessPureBasicEvents = -522133279;
    cConstants.PB_Program_Connect = 64;
    cConstants.PB_Program_Eof = 1;
    cConstants.PB_Program_Error = 32;
    cConstants.PB_Program_Hide = 2;
    cConstants.PB_Program_Open = 4;
    cConstants.PB_Program_Read = 8;
    cConstants.PB_Program_Wait = 1;
    cConstants.PB_Program_Write = 16;
    cConstants.PB_ProgressBar_Maximum = 2;
    cConstants.PB_ProgressBar_Minimum = 1;
    cConstants.PB_ProgressBar_Smooth = 1;
    cConstants.PB_ProgressBar_Vertical = 4;
    cConstants.PB_Prototype = 57;
    cConstants.PB_RegularExpression_AnyNewLine = 5242880;
    cConstants.PB_RegularExpression_DotAll = 4;
    cConstants.PB_RegularExpression_Extended = 8;
    cConstants.PB_RegularExpression_MultiLine = 2;
    cConstants.PB_RegularExpression_NoCase = 1;
    cConstants.PB_Relative = 1;
    cConstants.PB_Requester_MultiSelection = 1;
    cConstants.PB_Round_Down = 0;
    cConstants.PB_Round_Nearest = 2;
    cConstants.PB_Round_Up = 1;
    cConstants.PB_Screen_NoSynchronization = 0;
    cConstants.PB_Screen_SmartSynchronization = 2;
    cConstants.PB_Screen_WaitSynchronization = 1;
    cConstants.PB_ScrollArea_BorderLess = 8;
    cConstants.PB_ScrollArea_Center = 16;
    cConstants.PB_ScrollArea_Flat = 1;
    cConstants.PB_ScrollArea_InnerHeight = 2;
    cConstants.PB_ScrollArea_InnerWidth = 1;
    cConstants.PB_ScrollArea_Raised = 2;
    cConstants.PB_ScrollArea_ScrollStep = 5;
    cConstants.PB_ScrollArea_Single = 4;
    cConstants.PB_ScrollArea_X = 3;
    cConstants.PB_ScrollArea_Y = 4;
    cConstants.PB_ScrollBar_Maximum = 2;
    cConstants.PB_ScrollBar_Minimum = 1;
    cConstants.PB_ScrollBar_PageLength = 3;
    cConstants.PB_ScrollBar_Vertical = 1;
    cConstants.PB_Shortcut_0 = 48;
    cConstants.PB_Shortcut_1 = 49;
    cConstants.PB_Shortcut_2 = 50;
    cConstants.PB_Shortcut_3 = 51;
    cConstants.PB_Shortcut_4 = 52;
    cConstants.PB_Shortcut_5 = 53;
    cConstants.PB_Shortcut_6 = 54;
    cConstants.PB_Shortcut_7 = 55;
    cConstants.PB_Shortcut_8 = 56;
    cConstants.PB_Shortcut_9 = 57;
    cConstants.PB_Shortcut_Pad0 = 96;
    cConstants.PB_Shortcut_Pad1 = 97;
    cConstants.PB_Shortcut_Pad2 = 98;
    cConstants.PB_Shortcut_Pad3 = 99;
    cConstants.PB_Shortcut_Pad4 = 100;
    cConstants.PB_Shortcut_Pad5 = 101;
    cConstants.PB_Shortcut_Pad6 = 102;
    cConstants.PB_Shortcut_Pad7 = 103;
    cConstants.PB_Shortcut_Pad8 = 104;
    cConstants.PB_Shortcut_Pad9 = 105;
    cConstants.PB_Shortcut_A = 65;
    cConstants.PB_Shortcut_B = 66;
    cConstants.PB_Shortcut_C = 67;
    cConstants.PB_Shortcut_D = 68;
    cConstants.PB_Shortcut_E = 69;
    cConstants.PB_Shortcut_F = 70;
    cConstants.PB_Shortcut_G = 71;
    cConstants.PB_Shortcut_H = 72;
    cConstants.PB_Shortcut_I = 73;
    cConstants.PB_Shortcut_J = 74;
    cConstants.PB_Shortcut_K = 75;
    cConstants.PB_Shortcut_L = 76;
    cConstants.PB_Shortcut_M = 77;
    cConstants.PB_Shortcut_N = 78;
    cConstants.PB_Shortcut_O = 79;
    cConstants.PB_Shortcut_P = 80;
    cConstants.PB_Shortcut_Q = 81;
    cConstants.PB_Shortcut_R = 82;
    cConstants.PB_Shortcut_S = 83;
    cConstants.PB_Shortcut_T = 84;
    cConstants.PB_Shortcut_U = 85;
    cConstants.PB_Shortcut_V = 86;
    cConstants.PB_Shortcut_W = 87;
    cConstants.PB_Shortcut_X = 88;
    cConstants.PB_Shortcut_Y = 89;
    cConstants.PB_Shortcut_Z = 90;
    cConstants.PB_Shortcut_F1 = 112;
    cConstants.PB_Shortcut_F2 = 113;
    cConstants.PB_Shortcut_F3 = 114;
    cConstants.PB_Shortcut_F4 = 115;
    cConstants.PB_Shortcut_F5 = 116;
    cConstants.PB_Shortcut_F6 = 117;
    cConstants.PB_Shortcut_F7 = 118;
    cConstants.PB_Shortcut_F8 = 119;
    cConstants.PB_Shortcut_F9 = 120;
    cConstants.PB_Shortcut_F10 = 121;
    cConstants.PB_Shortcut_F11 = 122;
    cConstants.PB_Shortcut_F12 = 123;
    cConstants.PB_Shortcut_F13 = 124;
    cConstants.PB_Shortcut_F14 = 125;
    cConstants.PB_Shortcut_F15 = 126;
    cConstants.PB_Shortcut_F16 = 127;
    cConstants.PB_Shortcut_F17 = 128;
    cConstants.PB_Shortcut_F18 = 129;
    cConstants.PB_Shortcut_F19 = 130;
    cConstants.PB_Shortcut_F20 = 131;
    cConstants.PB_Shortcut_F21 = 132;
    cConstants.PB_Shortcut_F22 = 133;
    cConstants.PB_Shortcut_F23 = 134;
    cConstants.PB_Shortcut_F24 = 135;
    cConstants.PB_Shortcut_Add = 107;
    cConstants.PB_Shortcut_All = -1;
    cConstants.PB_Shortcut_Apps = 93;
    cConstants.PB_Shortcut_Back = 8;
    cConstants.PB_Shortcut_Capital = 20;
    cConstants.PB_Shortcut_Clear = 12;
    cConstants.PB_Shortcut_Decimal = 110;
    cConstants.PB_Shortcut_Delete = 46;
    cConstants.PB_Shortcut_Divide = 111;
    cConstants.PB_Shortcut_Down = 40;
    cConstants.PB_Shortcut_End = 35;
    cConstants.PB_Shortcut_Escape = 27;
    cConstants.PB_Shortcut_Execute = 43;
    cConstants.PB_Shortcut_Help = 47;
    cConstants.PB_Shortcut_Home = 36;
    cConstants.PB_Shortcut_Insert = 45;
    cConstants.PB_Shortcut_Left = 37;
    cConstants.PB_Shortcut_LeftWindows = 91;
    cConstants.PB_Shortcut_Menu = 18;
    cConstants.PB_Shortcut_Multiply = 106;
    cConstants.PB_Shortcut_Numlock = 144;
    cConstants.PB_Shortcut_PageDown = 34;
    cConstants.PB_Shortcut_PageUp = 33;
    cConstants.PB_Shortcut_Pause = 19;
    cConstants.PB_Shortcut_Print = 42;
    cConstants.PB_Shortcut_Return = 13;
    cConstants.PB_Shortcut_Right = 39;
    cConstants.PB_Shortcut_RightWindows = 92;
    cConstants.PB_Shortcut_Scroll = 145;
    cConstants.PB_Shortcut_Select = 41;
    cConstants.PB_Shortcut_Separator = 108;
    cConstants.PB_Shortcut_Snapshot = 44;
    cConstants.PB_Shortcut_Space = 32;
    cConstants.PB_Shortcut_Subtract = 109;
    cConstants.PB_Shortcut_Tab = 9;
    cConstants.PB_Shortcut_Up = 38;
    cConstants.PB_Shortcut_Alt = 262144;
    cConstants.PB_Shortcut_Command = 131072;
    cConstants.PB_Shortcut_Control = 131072;
    cConstants.PB_Shortcut_Shift = 65536;
    cConstants.PB_Sort_Ascending = 0;
    cConstants.PB_Sort_Descending = 1;
    cConstants.PB_Sort_NoCase = 2;
    cConstants.PB_Sound_Loop = 1;
    cConstants.PB_Spin_Maximum = 1;
    cConstants.PB_Spin_Minimum = 2;
    cConstants.PB_Spin_Numeric = 3;
    cConstants.PB_Spin_ReadOnly = 4;
    cConstants.PB_Spin_Step = 5;
    cConstants.PB_Splitter_FirstFixed = 4;
    cConstants.PB_Splitter_FirstGadget = 3;
    cConstants.PB_Splitter_FirstMinimumSize = 1;
    cConstants.PB_Splitter_SecondFixed = 8;
    cConstants.PB_Splitter_SecondGadget = 4;
    cConstants.PB_Splitter_SecondMinimumSize = 2;
    cConstants.PB_Splitter_Separator = 2;
    cConstants.PB_Splitter_Vertical = 1;
    cConstants.PB_StatusBar_BorderLess = 2;
    cConstants.PB_StatusBar_Center = 4;
    cConstants.PB_StatusBar_Raised = 1;
    cConstants.PB_StatusBar_Right = 8;
    cConstants.PB_String_CaseSensitive = 0;
    cConstants.PB_String_NoCase = 1;
    cConstants.PB_String_InPlace = 2;
    cConstants.PB_String_AutoInsert = 1;
    cConstants.PB_String_BorderLess = 2;
    cConstants.PB_String_Center = 4;
    cConstants.PB_String_Color = 8;
    cConstants.PB_String_Date = 16;
    cConstants.PB_String_DateTime = 32;
    cConstants.PB_String_DateTimeLocal = 64;
    cConstants.PB_String_Email = 128;
    cConstants.PB_String_Equal = 256;
    cConstants.PB_String_Greater = 512;
    cConstants.PB_String_IsValid = 1024;
    cConstants.PB_String_Left = 2048;
    cConstants.PB_String_Lower = 4096;
    cConstants.PB_String_LowerCase = 8192;
    cConstants.PB_String_Month = 16384;
    cConstants.PB_String_Numeric = 32768;
    cConstants.PB_String_Password = 65536;
    cConstants.PB_String_Range = 131072;
    cConstants.PB_String_ReadOnly = 262144;
    cConstants.PB_String_Right = 524288;
    cConstants.PB_String_Search = 1048576;
    cConstants.PB_String_Tel = 2097152;
    cConstants.PB_String_Time = 4194304;
    cConstants.PB_String_UpperCase = 8388608;
    cConstants.PB_String_Url = 16777216;
    cConstants.PB_String_Week = 33554432;
    cConstants.PB_String_MaximumLength = 1;
    cConstants.PB_String_Type = 2;
    cConstants.PB_String_Pattern = 3;
    cConstants.PB_String_Placeholder = 4;
    cConstants.PB_String_Required = 5;
    cConstants.PB_String_AllowedChars = 6;
    cConstants.PB_String_Autocomplete_Datasource = 7;
    cConstants.PB_String_Autocomplete_MinLength = 8;
    cConstants.PB_Structure_AlignC = -1;
    cConstants.PB_System_CPUs = 0;
    cConstants.PB_System_FreePhysical = 1;
    cConstants.PB_System_FreeSwap = 5;
    cConstants.PB_System_FreeVirtual = 3;
    cConstants.PB_System_PageSize = 6;
    cConstants.PB_System_ProcessCPUs = 1;
    cConstants.PB_System_TotalPhysical = 0;
    cConstants.PB_System_TotalSwap = 4;
    cConstants.PB_System_TotalVirtual = 2;
    cConstants.PB_Text_Border = 1;
    cConstants.PB_Text_Center = 2;
    cConstants.PB_Text_Middle = 4;
    cConstants.PB_Text_Right = 8;
    cConstants.PB_Text_Rounded_Corners = 16;
    cConstants.PB_ToolBar_Normal = 0;
    cConstants.PB_ToolBar_Toggle = 1;
    cConstants.PB_ToolBarIcon_Copy = 1;
    cConstants.PB_ToolBarIcon_Cut = 0;
    cConstants.PB_ToolBarIcon_Delete = 5;
    cConstants.PB_ToolBarIcon_Find = 12;
    cConstants.PB_ToolBarIcon_Help = 11;
    cConstants.PB_ToolBarIcon_New = 6;
    cConstants.PB_ToolBarIcon_Open = 7;
    cConstants.PB_ToolBarIcon_Paste = 2;
    cConstants.PB_ToolBarIcon_Print = 14;
    cConstants.PB_ToolBarIcon_PrintPreview = 9;
    cConstants.PB_ToolBarIcon_Properties = 10;
    cConstants.PB_ToolBarIcon_Redo = 4;
    cConstants.PB_ToolBarIcon_Replace = 13;
    cConstants.PB_ToolBarIcon_Save = 8;
    cConstants.PB_ToolBarIcon_Undo = 3;
    cConstants.PB_TrackBar_Maximum = 2;
    cConstants.PB_TrackBar_Minimum = 1;
    cConstants.PB_TrackBar_Ticks = 1;
    cConstants.PB_TrackBar_Vertical = 2;
    cConstants.PB_Tree_AlwaysShowSelection = 32;
    cConstants.PB_Tree_CheckBoxes = 256;
    cConstants.PB_Tree_NoButtons = 1;
    cConstants.PB_Tree_NoLines = 2;
    cConstants.PB_Tree_SubLevel = 1;
    cConstants.PB_Tree_ThreeState = 65536;
    cConstants.PB_Tree_Selected = 1;
    cConstants.PB_Tree_Expanded = 2;
    cConstants.PB_Tree_Checked = 4;
    cConstants.PB_Tree_Collapsed = 8;
    cConstants.PB_Tree_Inbetween = 16;
    cConstants.PB_UTF16 = 25;
    cConstants.PB_UTF16BE = 4;
    cConstants.PB_UTF32 = 5;
    cConstants.PB_UTF32BE = 6;
    cConstants.PB_UTF8 = 2;
    cConstants.PB_Variable = 51;
    cConstants.PB_Web_Back = 1;
    cConstants.PB_Web_BlockPopupMenu = 2;
    cConstants.PB_Web_BlockPopups = 1;
    cConstants.PB_Web_Busy = 6;
    cConstants.PB_Web_Forward = 2;
    cConstants.PB_Web_HtmlCode = 1;
    cConstants.PB_Web_NavigationCallback = 3;
    cConstants.PB_Web_PageTitle = 2;
    cConstants.PB_Web_Progress = 4;
    cConstants.PB_Web_ProgressMax = 5;
    cConstants.PB_Web_Refresh = 4;
    cConstants.PB_Web_ScrollX = 7;
    cConstants.PB_Web_ScrollY = 8;
    cConstants.PB_Web_SelectedText = 4;
    cConstants.PB_Web_StatusMessage = 3;
    cConstants.PB_Web_Stop = 3;
    cConstants.PB_Window_BorderLess = 1;
    cConstants.PB_Window_Collapsed = 2;
    cConstants.PB_Window_FrameCoordinate = 4;
    cConstants.PB_Window_InnerCoordinate = 8;
    cConstants.PB_Window_Invisible = 16;
    cConstants.PB_Window_Maximize = 32;
    cConstants.PB_Window_MaximizeGadget = 64;
    cConstants.PB_Window_Minimize = 128;
    cConstants.PB_Window_MinimizeGadget = 256;
    cConstants.PB_Window_NoActivate = 512;
    cConstants.PB_Window_NoGadgets = 1024;
    cConstants.PB_Window_Normal = 2048;
    cConstants.PB_Window_ScreenCentered = 4096;
    cConstants.PB_Window_SizeGadget = 8192;
    cConstants.PB_Window_SystemMenu = 16384;
    cConstants.PB_Window_TitleBar = 32768;
    cConstants.PB_Window_Tool = 65536;
    cConstants.PB_Window_WindowCentered = 131072;
    cConstants.PB_XML_Aborted = 35;
    cConstants.PB_XML_AsyncEntity = 13;
    cConstants.PB_XML_AttributeExternalEntityRef = 16;
    cConstants.PB_XML_BadCharacterRef = 14;
    cConstants.PB_XML_BinaryEntityRef = 15;
    cConstants.PB_XML_CantChangeFeatures = 26;
    cConstants.PB_XML_CData = 3;
    cConstants.PB_XML_Comment = 2;
    cConstants.PB_XML_CutNewline = 8;
    cConstants.PB_XML_CutSpace = 32;
    cConstants.PB_XML_DTD = 4;
    cConstants.PB_XML_DublicateAttribute = 8;
    cConstants.PB_XML_EntityDeclaredInPE = 24;
    cConstants.PB_XML_ExternalEntityHandling = 21;
    cConstants.PB_XML_FeatureRequiresDTD = 25;
    cConstants.PB_XML_Finished = 36;
    cConstants.PB_XML_IncompletePE = 29;
    cConstants.PB_XML_IncorrectEncoding = 19;
    cConstants.PB_XML_Instruction = 5;
    cConstants.PB_XML_InvalidToken = 4;
    cConstants.PB_XML_JunkAfterDocElement = 9;
    cConstants.PB_XML_LinuxNewline = 2;
    cConstants.PB_XML_MacNewline = 4;
    cConstants.PB_XML_MisplacedXML = 17;
    cConstants.PB_XML_NoDeclaration = 2;
    cConstants.PB_XML_NoElements = 3;
    cConstants.PB_XML_NoMemory = 1;
    cConstants.PB_XML_Normal = 1;
    cConstants.PB_XML_NotStandalone = 22;
    cConstants.PB_XML_NotSuspended = 34;
    cConstants.PB_XML_ParamEntityRef = 10;
    cConstants.PB_XML_PartialCharacter = 6;
    cConstants.PB_XML_PublicID = 32;
    cConstants.PB_XML_RecursiveEntityRef = 12;
    cConstants.PB_XML_ReduceNewline = 16;
    cConstants.PB_XML_ReduceSpace = 64;
    cConstants.PB_XML_ReFormat = 128;
    cConstants.PB_XML_ReIndent = 256;
    cConstants.PB_XML_ReservedNamespaceURI = 40;
    cConstants.PB_XML_ReservedPrefixXML = 38;
    cConstants.PB_XML_ReservedPrefixXMLNS = 39;
    cConstants.PB_XML_Root = 0;
    cConstants.PB_XML_StandaloneNo = 0;
    cConstants.PB_XML_StandaloneUnset = -1;
    cConstants.PB_XML_StandaloneYes = 1;
    cConstants.PB_XML_StreamEnd = 3;
    cConstants.PB_XML_StreamNext = 2;
    cConstants.PB_XML_StreamStart = 1;
    cConstants.PB_XML_StringFormat = 1;
    cConstants.PB_XML_Success = 0;
    cConstants.PB_XML_Suspended = 33;
    cConstants.PB_XML_SuspendedPE = 37;
    cConstants.PB_XML_Syntax = 2;
    cConstants.PB_XML_TagMismatch = 7;
    cConstants.PB_XML_TextDeclaration = 31;
    cConstants.PB_XML_UnboundPrefix = 27;
    cConstants.PB_XML_UnclosedCDataSection = 20;
    cConstants.PB_XML_UnclosedToken = 5;
    cConstants.PB_XML_UndeclaringPrefix = 28;
    cConstants.PB_XML_UndefinedEntity = 11;
    cConstants.PB_XML_UnexpectedState = 23;
    cConstants.PB_XML_UnknownEncoding = 18;
    cConstants.PB_XML_WindowsNewline = 1;
    cConstants.PB_XML_XMLDeclaration = 30;
    cConstants.PB_Event_Websocket_OnOpen = 107;
    cConstants.PB_Event_Websocket_OnClose = 108;
    cConstants.PB_Event_Websocket_OnMessage = 109;
    cConstants.PB_Event_Websocket_OnError = 110;
    cConstants.PB_Event_Movie_Abort = 1;
    cConstants.PB_Event_Movie_CanPlay = 2;
    cConstants.PB_Event_Movie_CanPlayThrough = 4;
    cConstants.PB_Event_Movie_DurationChange = 8;
    cConstants.PB_Event_Movie_Emptied = 16;
    cConstants.PB_Event_Movie_Ended = 32;
    cConstants.PB_Event_Movie_Error = 64;
    cConstants.PB_Event_Movie_LoadedData = 128;
    cConstants.PB_Event_Movie_LoadedMetaData = 256;
    cConstants.PB_Event_Movie_LoadStart = 512;
    cConstants.PB_Event_Movie_Pause = 1024;
    cConstants.PB_Event_Movie_Play = 2048;
    cConstants.PB_Event_Movie_Playing = 4096;
    cConstants.PB_Event_Movie_Progress = 8192;
    cConstants.PB_Event_Movie_RateChange = 16384;
    cConstants.PB_Event_Movie_Seeked = 32768;
    cConstants.PB_Event_Movie_Seeking = 65536;
    cConstants.PB_Event_Movie_Stalled = 131072;
    cConstants.PB_Event_Movie_Suspend = 262144;
    cConstants.PB_Event_Movie_TimeUpdate = 524288;
    cConstants.PB_Event_Movie_VolumeChange = 1048576;
    cConstants.PB_Event_Movie_Waiting = 2097152;
    cConstants.PB_Movie_ShowControls = 134;
    cConstants.PB_Movie_Position = 135;
    cConstants.PB_Movie_Length = 136;
    cConstants.PB_Movie_Volume = 137;
    cConstants.PB_Event_Music_Abort = 1;
    cConstants.PB_Event_Music_CanPlay = 2;
    cConstants.PB_Event_Music_CanPlayThrough = 4;
    cConstants.PB_Event_Music_DurationChange = 8;
    cConstants.PB_Event_Music_Emptied = 16;
    cConstants.PB_Event_Music_Ended = 32;
    cConstants.PB_Event_Music_Error = 64;
    cConstants.PB_Event_Music_LoadedData = 128;
    cConstants.PB_Event_Music_LoadedMetaData = 256;
    cConstants.PB_Event_Music_LoadStart = 512;
    cConstants.PB_Event_Music_Pause = 1024;
    cConstants.PB_Event_Music_Play = 2048;
    cConstants.PB_Event_Music_Playing = 4096;
    cConstants.PB_Event_Music_Progress = 8192;
    cConstants.PB_Event_Music_RateChange = 16384;
    cConstants.PB_Event_Music_Seeked = 32768;
    cConstants.PB_Event_Music_Seeking = 65536;
    cConstants.PB_Event_Music_Stalled = 131072;
    cConstants.PB_Event_Music_Suspend = 262144;
    cConstants.PB_Event_Music_TimeUpdate = 524288;
    cConstants.PB_Event_Music_VolumeChange = 1048576;
    cConstants.PB_Event_Music_Waiting = 2097152;
    cConstants.PB_Music_ShowControls = 134;
    cConstants.PB_Music_Position = 135;
    cConstants.PB_Music_Length = 136;
    cConstants.PB_Music_Volume = 137;
    cConstants.PB_Event_Upload_BeforeSend = 1;
    cConstants.PB_Event_Upload_UploadProgress = 2;
    cConstants.PB_Event_Upload_Complete = 4;
    cConstants.PB_Event_Upload_Success = 8;
    cConstants.PB_Event_Upload_Error = 16;
    cConstants.PB_WidgetType_Button = 1;
    cConstants.PB_WidgetType_ButtonImage = 2;
    cConstants.PB_WidgetType_Calendar = 3;
    cConstants.PB_WidgetType_Canvas = 4;
    cConstants.PB_WidgetType_CheckBox = 5;
    cConstants.PB_WidgetType_ComboBox = 6;
    cConstants.PB_WidgetType_Container = 7;
    cConstants.PB_WidgetType_ControlGroup = 8;
    cConstants.PB_WidgetType_Date = 9;
    cConstants.PB_WidgetType_Editor = 10;
    cConstants.PB_WidgetType_FlipSwitch = 11;
    cConstants.PB_WidgetType_Frame = 12;
    cConstants.PB_WidgetType_HyperLink = 13;
    cConstants.PB_WidgetType_Image = 14;
    cConstants.PB_WidgetType_ListView = 16;
    cConstants.PB_WidgetType_Option = 17;
    cConstants.PB_WidgetType_Panel = 18;
    cConstants.PB_WidgetType_ProgressBar = 19;
    cConstants.PB_WidgetType_ScrollArea = 20;
    cConstants.PB_WidgetType_ScrollBar = 21;
    cConstants.PB_WidgetType_Slider = 22;
    cConstants.PB_WidgetType_Spin = 23;
    cConstants.PB_WidgetType_Text = 24;
    cConstants.PB_WidgetType_TextInput = 25;
    cConstants.PB_WidgetType_Tree = 26;
    cConstants.PB_WidgetType_Unknown = 27;
    cConstants.PB_WidgetType_Collapsible = 28;
    cConstants.PB_WidgetType_Dialog = 29;
    cConstants.PB_WidgetType_Tabs = 30;
    cConstants.PB_WidgetType_ToolBar = 31;
    cConstants.PB_WidgetType_Table = 32;
    cConstants.PB_WidgetType_Html = 33;
    cConstants.PB_WidgetType_Header = 34;
    cConstants.PB_WidgetType_Footer = 35;
    cConstants.PB_WidgetType_NavBar = 36;
    cConstants.PB_Widget_Html = 1;
    cConstants.PB_Widget_LabelText = 2;
    cConstants.PB_Widget_LabelHtml = 3;
    cConstants.PB_Widget_Corners = 4;
    cConstants.PB_Widget_Icon = 5;
    cConstants.PB_Widget_IconPosition = 6;
    cConstants.PB_Widget_Position = 7;
    cConstants.PB_Widget_Inline = 8;
    cConstants.PB_Widget_Mini = 9;
    cConstants.PB_Widget_Shadow = 10;
    cConstants.PB_Widget_Theme = 11;
    cConstants.PB_Widget_ClearButton = 12;
    cConstants.PB_Widget_ClearButtonText = 13;
    cConstants.PB_Widget_Role = 14;
    cConstants.PB_Widget_InputType = 15;
    cConstants.PB_Widget_ExcludeInvisible = 16;
    cConstants.PB_Widget_Type = 17;
    cConstants.PB_Widget_TrackTheme = 18;
    cConstants.PB_Widget_Highlight = 19;
    cConstants.PB_Widget_Minimum = 20;
    cConstants.PB_Widget_Maximum = 21;
    cConstants.PB_Widget_Step = 22;
    cConstants.PB_Widget_Value = 23;
    cConstants.PB_ControlGroup_Vertical = 1;
    cConstants.PB_ControlGroup_Horizontal = 2;
    cConstants.PB_FlipSwitch_On = 1;
    cConstants.PB_FlipSwitch_Off = 2;
    cConstants.PB_TextInput_Color = 1;
    cConstants.PB_TextInput_Date = 2;
    cConstants.PB_TextInput_DateTime = 3;
    cConstants.PB_TextInput_DateTimeLocal = 4;
    cConstants.PB_TextInput_Email = 5;
    cConstants.PB_TextInput_Month = 6;
    cConstants.PB_TextInput_Number = 7;
    cConstants.PB_TextInput_Password = 8;
    cConstants.PB_TextInput_Range = 9;
    cConstants.PB_TextInput_Search = 10;
    cConstants.PB_TextInput_Tel = 11;
    cConstants.PB_TextInput_Text = 12;
    cConstants.PB_TextInput_Time = 13;
    cConstants.PB_TextInput_Url = 14;
    cConstants.PB_TextInput_Week = 15;
    cConstants.PB_Transition_Slide = 1;
    cConstants.PB_Transition_SlideUp = 2;
    cConstants.PB_Transition_SlideDown = 3;
    cConstants.PB_Transition_Pop = 4;
    cConstants.PB_Transition_Fade = 5;
    cConstants.PB_Transition_Flip = 6;
    cConstants.PB_PanelGadget_Sortable = 1;
    cConstants.PB_PanelGadget_Closable = 2;
    cConstants.PB_JSON_Array = 1;
    cConstants.PB_JSON_Boolean = 2;
    cConstants.PB_JSON_NoCase = 4;
    cConstants.PB_JSON_Null = 8;
    cConstants.PB_JSON_Number = 16;
    cConstants.PB_JSON_Object = 32;
    cConstants.PB_JSON_PrettyPrint = 64;
    cConstants.PB_JSON_String = 128;
    cConstants.Black = c2DDrawing.RGB(0, 0, 0);
    cConstants.Blue = c2DDrawing.RGB(0, 0, 255);
    cConstants.Cyan = c2DDrawing.RGB(0, 255, 255);
    cConstants.Gray = c2DDrawing.RGB(192, 192, 192);
    cConstants.Green = c2DDrawing.RGB(0, 255, 0);
    cConstants.Magenta = c2DDrawing.RGB(255, 0, 255);
    cConstants.Red = c2DDrawing.RGB(255, 0, 0);
    cConstants.White = c2DDrawing.RGB(255, 255, 255);
    cConstants.Yellow = c2DDrawing.RGB(255, 255, 0);
    cConstants.PB_Array = 15;
    cConstants.PB_Ascii = 24;
    cConstants.PB_Byte = 1;
    cConstants.PB_Character = 11;
    cConstants.PB_Double = 12;
    cConstants.PB_Float = 9;
    cConstants.PB_Integer = 21;
    cConstants.PB_List = 14;
    cConstants.PB_Long = 5;
    cConstants.PB_Map = 22;
    cConstants.PB_Quad = 13;
    cConstants.PB_String = 8;
    cConstants.PB_Structure = 7;
    cConstants.PB_Unicode = 25;
    cConstants.PB_Word = 3;
    cConstants.PB_Undefined = 26;
    cConstants.PB_Boolean = 27;
    cConstants.PB_Number = 28;
    cConstants.PB_Symbol = 29;
    cConstants.PB_Object = 30;
    cConstants.PB_Function = 31;
    cConstants.PB_Unknown = 32;
    cConstants.PB_EventType_DownloadEnd = 1;
    cConstants.PB_EventType_DownloadProgress = 2;
    cConstants.PB_EventType_DownloadStart = 4;
    cConstants.PB_EventType_PopupMenu = 8;
    cConstants.PB_EventType_PopupWindow = 16;
    cConstants.PB_EventType_StatusChange = 32;
    cConstants.PB_EventType_TitleChange = 64;
    cConstants.PB_EventType_Change = 1;
    cConstants.PB_EventType_CloseItem = 2;
    cConstants.PB_EventType_Down = 4;
    cConstants.PB_EventType_DragStart = 8;
    cConstants.PB_EventType_Focus = 16;
    cConstants.PB_EventType_Input = 32;
    cConstants.PB_EventType_KeyDown = 64;
    cConstants.PB_EventType_KeyPress = 128;
    cConstants.PB_EventType_KeyUp = 256;
    cConstants.PB_EventType_LeftButtonDown = 512;
    cConstants.PB_EventType_LeftButtonUp = 1024;
    cConstants.PB_EventType_LeftClick = 2048;
    cConstants.PB_EventType_LeftDoubleClick = 4096;
    cConstants.PB_EventType_LostFocus = 8192;
    cConstants.PB_EventType_MiddleButtonDown = 16384;
    cConstants.PB_EventType_MiddleButtonUp = 32768;
    cConstants.PB_EventType_MouseEnter = 65536;
    cConstants.PB_EventType_MouseLeave = 131072;
    cConstants.PB_EventType_MouseMove = 262144;
    cConstants.PB_EventType_MouseWheel = 524288;
    cConstants.PB_EventType_RightButtonDown = 1048576;
    cConstants.PB_EventType_RightButtonUp = 2097152;
    cConstants.PB_EventType_RightClick = 4194304;
    cConstants.PB_EventType_RightDoubleClick = 8388608;
    cConstants.PB_EventType_Select = 16777216;
    cConstants.PB_EventType_Unselect = 33554432;
    cConstants.PB_EventType_Up = 67108864;
    cConstants.PB_EventType_ReturnKey = 134217728;
    cConstants.PB_EventType_Scroll = 1;
    cConstants.PB_EventType_Swipe = 1;
    return cConstants;
}());
var cCordova = (function () {
    function cCordova() {
    }
    return cCordova;
}());
var cData = (function () {
    function cData() {
    }
    cData.Read = function () {
        if (cCommon.P2W_DataArray[cCommon.P2W_Global_Label]) {
            var returnValue = cCommon.P2W_DataArray[cCommon.P2W_Global_Label];
            cCommon.P2W_Global_Label += 1;
            return returnValue;
        }
        else {
            
        }
    };
    cData.Restore = function (label) {
        cCommon.P2W_Global_Label = label;
    };
    return cData;
}());
var cDatabase = (function () {
    function cDatabase() {
    }
    cDatabase.AffectedDatabaseRows = function (Database) {
        
        return 0;
    };
    cDatabase.CheckDatabaseNull = function (Database, Column) {
        
        return false;
    };
    cDatabase.CloseDatabase = function (Database, Save) {
        if (Save === void 0) { Save = true; }
        if (Save == true) {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            cP2W.P2W_LocalStorage_SetItem(dbo.databasename, dbo.db.tables);
        }
        delete cCommon.P2W_ListOfDatabase[Database];
    };
    cDatabase.DatabaseColumnIndex = function (Database, ColumnName) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return -1;
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        if (dbo.result == null)
            return -1;
        for (var index in Object.keys(dbo.result[0])) {
            if (Object.keys(dbo.result[0])[index] == ColumnName)
                return index;
        }
        return -1;
    };
    cDatabase.DatabaseColumnName = function (Database, Column) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return "";
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        if (dbo.result == null)
            return "";
        try {
            return Object.keys(dbo.result[0])[Column];
        }
        catch (e) {
            return "";
        }
    };
    cDatabase.DatabaseColumnSize = function (Database, Column) {
        
        return -1;
    };
    cDatabase.DatabaseColumnType = function (Database, Column) {
        
        return -1;
    };
    cDatabase.DatabaseColumns = function (Database) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        if (dbo.result == null)
            return 0;
        try {
            return Object.keys(dbo.result[0]).length;
        }
        catch (e) {
            return 0;
        }
    };
    cDatabase.DatabaseDriverDescription = function () {
        
        return "";
    };
    cDatabase.DatabaseDriverName = function () {
        
        return "";
    };
    cDatabase.DatabaseError = function () {
        return cCommon.LastDatabaseErrorMessage;
    };
    cDatabase.DatabaseID = function (Database) {
        
        return -1;
    };
    cDatabase.DatabaseQuery = function (Database, Request, Flags) {
        if (Flags === void 0) { Flags = 0; }
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        cCommon.LastDatabaseErrorMessage = "";
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            dbo.result = dbo.db.exec(Request);
            dbo.rowCounter = -1;
            return 1;
        }
        catch (e) {
            cCommon.LastDatabaseErrorMessage = e.message;
            return 0;
        }
    };
    cDatabase.DatabaseUpdate = function (Database, Request) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        cCommon.LastDatabaseErrorMessage = "";
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            dbo.db.exec(Request);
            return 1;
        }
        catch (e) {
            cCommon.LastDatabaseErrorMessage = e.message;
            return 0;
        }
    };
    cDatabase.DeleteDatabase = function (DatabaseName) {
        cP2W.P2W_LocalStorage_RemoveItem(DatabaseName);
    };
    cDatabase.ExamineDatabaseDrivers = function () {
        return 0;
    };
    cDatabase.FinishDatabaseQuery = function (Database) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return;
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        dbo.result = null;
        dbo.rowCounter = -1;
    };
    cDatabase.FirstDatabaseRow = function (Database) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        dbo.rowCounter = 0;
    };
    cDatabase.GetDatabaseBlob = function (Database, Column, Buffer, BufferLength) {
        
        return 0;
    };
    cDatabase.GetDatabaseDouble = function (Database, Column) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            var key = Object.keys(dbo.result[dbo.rowCounter])[Column];
            return dbo.result[dbo.rowCounter][key];
        }
        catch (e) {
            return 0;
        }
    };
    cDatabase.GetDatabaseFloat = function (Database, Column) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            var key = Object.keys(dbo.result[dbo.rowCounter])[Column];
            return dbo.result[dbo.rowCounter][key];
        }
        catch (e) {
            return 0;
        }
    };
    cDatabase.GetDatabaseLong = function (Database, Column) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            var key = Object.keys(dbo.result[dbo.rowCounter])[Column];
            return dbo.result[dbo.rowCounter][key];
        }
        catch (e) {
            return 0;
        }
    };
    cDatabase.GetDatabaseQuad = function (Database, Column) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            var key = Object.keys(dbo.result[dbo.rowCounter])[Column];
            return dbo.result[dbo.rowCounter][key];
        }
        catch (e) {
            return 0;
        }
    };
    cDatabase.GetDatabaseString = function (Database, Column) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return "";
        }
        try {
            var dbo = cCommon.P2W_ListOfDatabase[Database];
            var key = Object.keys(dbo.result[dbo.rowCounter])[Column];
            return dbo.result[dbo.rowCounter][key];
        }
        catch (e) {
            return "";
        }
    };
    cDatabase.IsDatabase = function (Database) {
        return !(cCommon.P2W_ListOfDatabase[Database] === undefined);
    };
    cDatabase.NextDatabaseDriver = function () {
        
        return 0;
    };
    cDatabase.NextDatabaseRow = function (Database) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        if (dbo.result.length - 1 > dbo.rowCounter) {
            dbo.rowCounter += 1;
            return 1;
        }
        else {
            return 0;
        }
    };
    cDatabase.OpenDatabase = function (Database, DatabaseName, User, Password, Plugin) {
        if (Plugin === void 0) { Plugin = 0; }
        if (Database == cConstants.PB_Any)
            Database = cCommon.guid();
        var dbo = {
            db: new alasql.Database(DatabaseName),
            databasename: DatabaseName,
            result: null,
            rowCounter: -1
        };
        var dboTables = cP2W.P2W_LocalStorage_GetItem(DatabaseName, null);
        if (dboTables != null) {
            dbo.db.tables = dboTables;
        }
        cCommon.P2W_ListOfDatabase[Database] = dbo;
        if (Database == 0) {
            return true;
        }
        else {
            return Database;
        }
    };
    cDatabase.OpenDatabaseRequester = function (Database, Plugin) {
        if (Plugin === void 0) { Plugin = 0; }
        
        return 0;
    };
    cDatabase.PreviousDatabaseRow = function (Database) {
        if (!cDatabase.IsDatabase(Database)) {
            
            return 0;
        }
        var dbo = cCommon.P2W_ListOfDatabase[Database];
        if (dbo.rowCounter > -1) {
            dbo.rowCounter -= 1;
            return 1;
        }
        else {
            return 0;
        }
    };
    cDatabase.SetDatabaseBlob = function (Database, StatementIndex, Buffer, BufferLength) {
        
    };
    cDatabase.UseODBCDatabase = function () {
        return true;
    };
    cDatabase.UsePostgreSQLDatabase = function () {
        return true;
    };
    cDatabase.UseSQLiteDatabase = function () {
        return true;
    };
    return cDatabase;
}());
var cDate = (function () {
    function cDate() {
    }
    cDate.dateFromISO8601 = function (isoDateString) {
        var parts = isoDateString.match(/\d+/g);
        var isoTime = Date.UTC(parts[0], parts[1] - 1, parts[2], parts[3], parts[4], parts[5]);
        var isoDate = new Date(isoTime);
        return isoDate;
    };
    cDate.AddDate = function (Date, Type, Value) {
        var myMoment = moment.unix(Date);
        var returnValue;
        switch (Type) {
            case cConstants.PB_Date_Year:
                returnValue = myMoment.add(Value, 'y');
                break;
            case cConstants.PB_Date_Month:
                returnValue = myMoment.add(Value, 'M');
                break;
            case cConstants.PB_Date_Week:
                returnValue = myMoment.add(Value, 'w');
                break;
            case cConstants.PB_Date_Day:
                returnValue = myMoment.add(Value, 'd');
                break;
            case cConstants.PB_Date_Hour:
                returnValue = myMoment.add(Value, 'h');
                break;
            case cConstants.PB_Date_Minute:
                returnValue = myMoment.add(Value, 'm');
                break;
            case cConstants.PB_Date_Second:
                returnValue = myMoment.add(Value, 's');
                break;
        }
        return parseInt(returnValue.format("X"));
    };
    cDate.Date = function (Year, Month, Day, Hour, Minute, Second) {
        if (Year === void 0) { Year = 0; }
        if (Month === void 0) { Month = 0; }
        if (Day === void 0) { Day = 0; }
        if (Hour === void 0) { Hour = 0; }
        if (Minute === void 0) { Minute = 0; }
        if (Second === void 0) { Second = 0; }
        if (Year == 0) {
            return parseInt(moment(new Date()).format("X"));
        }
        else {
            return parseInt(moment(new Date(Year, Month - 1, Day, Hour, Minute, Second)).format("X"));
        }
    };
    cDate.Day = function (Date) {
        return moment.unix(Date).date();
    };
    cDate.DayOfWeek = function (Date) {
        return moment.unix(Date).weekday();
    };
    cDate.DayOfYear = function (Date) {
        return moment.unix(Date).dayOfYear();
    };
    cDate.FormatDate = function (Mask, Date) {
        var myMoment = moment.unix(Date);
        Mask = cString.ReplaceString(Mask, "%SSS", "|" + cString.Chr(248) + "|");
        Mask = cString.ReplaceString(Mask, "%yyyy", "|" + cString.Chr(249) + "|");
        Mask = cString.ReplaceString(Mask, "%yy", "|" + cString.Chr(250) + "|");
        Mask = cString.ReplaceString(Mask, "%mm", "|" + cString.Chr(251) + "|");
        Mask = cString.ReplaceString(Mask, "%dd", "|" + cString.Chr(252) + "|");
        Mask = cString.ReplaceString(Mask, "%hh", "|" + cString.Chr(253) + "|");
        Mask = cString.ReplaceString(Mask, "%ii", "|" + cString.Chr(254) + "|");
        Mask = cString.ReplaceString(Mask, "%ss", "|" + cString.Chr(255) + "|");
        var replaceArray = new Array("ZZ", "zz", "Z", "z", "YYYY", "YY", "X", "WW", "ww", "Wo", "wo", "W", "w", "SSS", "SS", "ss", "S", "s", "Mo", "MMMM", "MMM", "MM", "mm", "M", "m", "HH", "hh", "H", "h", "GGGG", "gggg", "GG", "gg", "E", "e", "Do", "do", "DDDo", "DDDD", "dddd", "DDD", "ddd", "DD", "dd", "D", "d", "A", "a");
        for (var counter = 0; counter <= replaceArray.length; counter++) {
            Mask = cString.ReplaceString(Mask, replaceArray[counter], "|" + cString.Chr(counter + 1) + "|");
        }
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(248) + "|", moment().format("SSS"));
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(249) + "|", "YYYY");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(250) + "|", "YY");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(251) + "|", "MM");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(252) + "|", "DD");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(253) + "|", "HH");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(254) + "|", "mm");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(255) + "|", "ss");
        var returnValue = myMoment.format(Mask);
        for (var counter = 0; counter <= replaceArray.length; counter++) {
            returnValue = cString.ReplaceString(returnValue, "|" + cString.Chr(counter + 1) + "|", replaceArray[counter]);
        }
        return returnValue;
    };
    cDate.Hour = function (Date) {
        return moment.unix(Date).hours();
    };
    cDate.Minute = function (Date) {
        return moment.unix(Date).minutes();
    };
    cDate.Month = function (Date) {
        return moment.unix(Date).month() + 1;
    };
    cDate.ParseDate = function (Mask, String) {
        Mask = cString.ReplaceString(Mask, "%yyyy", "|" + cString.Chr(249) + "|");
        Mask = cString.ReplaceString(Mask, "%yy", "|" + cString.Chr(250) + "|");
        Mask = cString.ReplaceString(Mask, "%mm", "|" + cString.Chr(251) + "|");
        Mask = cString.ReplaceString(Mask, "%dd", "|" + cString.Chr(252) + "|");
        Mask = cString.ReplaceString(Mask, "%hh", "|" + cString.Chr(253) + "|");
        Mask = cString.ReplaceString(Mask, "%ii", "|" + cString.Chr(254) + "|");
        Mask = cString.ReplaceString(Mask, "%ss", "|" + cString.Chr(255) + "|");
        var replaceArray = new Array("ZZ", "zz", "Z", "z", "YYYY", "YY", "X", "WW", "ww", "Wo", "wo", "W", "w", "SSS", "SS", "ss", "S", "s", "Mo", "MMMM", "MMM", "MM", "mm", "M", "m", "HH", "hh", "H", "h", "GGGG", "gggg", "GG", "gg", "E", "e", "Do", "do", "DDDo", "DDDD", "dddd", "DDD", "ddd", "DD", "dd", "D", "d", "A", "a");
        for (var counter = 0; counter <= replaceArray.length; counter++) {
            Mask = cString.ReplaceString(Mask, replaceArray[counter], "|" + cString.Chr(counter + 1) + "|");
        }
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(249) + "|", "YYYY");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(250) + "|", "YY");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(251) + "|", "MM");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(252) + "|", "DD");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(253) + "|", "HH");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(254) + "|", "mm");
        Mask = cString.ReplaceString(Mask, "|" + cString.Chr(255) + "|", "ss");
        return parseInt(moment(String, Mask).format("X"));
    };
    cDate.Second = function (Date) {
        return moment.unix(Date).seconds();
    };
    cDate.Year = function (Date) {
        return moment.unix(Date).year();
    };
    return cDate;
}());
var cDebugger = (function () {
    function cDebugger() {
    }
    cDebugger.PurifierGranularity = function () {  };
    cDebugger.ResetProfiler = function () {  };
    cDebugger.ShowAssemblyViewer = function () {  };
    cDebugger.ShowCallstack = function () {  };
    cDebugger.ShowLibraryViewer = function () {  };
    cDebugger.ShowMemoryViewer = function () {  };
    cDebugger.ShowProfiler = function () {  };
    cDebugger.ShowVariableViewer = function () {  };
    cDebugger.ShowWatchlist = function () {  };
    cDebugger.StartProfiler = function () {  };
    cDebugger.StopProfiler = function () {  };
    cDebugger.ClearDebugOutput = function () {
        if (cWindow.IsWindow(cCommon.DebugWindow))
            cGadget.ClearGadgetItems(cCommon.DebugWindow_txtDebug);
    };
    cDebugger.CloseDebugOutput = function () {
        if (cWindow.IsWindow(cCommon.DebugWindow))
            cWindow.CloseWindow(cCommon.DebugWindow);
    };
    cDebugger.DisableDebugger = function () {
        cCommon.Debugger = false;
    };
    cDebugger.EnableDebugger = function () {
        cCommon.Debugger = true;
    };
    cDebugger.SaveDebugOutput = function (Filename) {
        if (cWindow.IsWindow(cCommon.DebugWindow)) {
            cP2W.SaveText(cGadget.GetGadgetText(cCommon.DebugWindow_txtDebug), Filename);
        }
    };
    cDebugger.ShowDebugOutput = function () {
        if (cWindow.IsWindow(cCommon.DebugWindow)) {
            cWindow.HideWindow(cCommon.DebugWindow, false);
        }
        else {
            cDebugger.OpenDebugWindow();
        }
    };
    cDebugger.HideDebugOutput = function () {
        if (cWindow.IsWindow(cCommon.DebugWindow))
            cWindow.HideWindow(cCommon.DebugWindow, true);
    };
    cDebugger.Debug = function (String) {
        try {
            console.debug(String);
        }
        catch (ex) { }
        if (cCommon.Debugger) {
            if (!cWindow.IsWindow(cCommon.DebugWindow)) {
                cDebugger.OpenDebugWindow();
            }
            try {
                var selector = $("#g_" + cCommon.DebugWindow_txtDebug);
                if (selector.length) {
                    if (cCompiler.TypeOf(String) == cConstants.PB_Object)
                        String = JSON.stringify(String);
                    selector.val(selector.val() + moment().format("H:mm:ss:SSSS").toString() + ": " + String + "\n");
                    $('#g_' + cCommon.DebugWindow_txtDebug).scrollTop($('#g_' + cCommon.DebugWindow_txtDebug)[0].scrollHeight);
                }
            }
            catch (ex) { }
        }
    };
    cDebugger.DebugWindow_SizeWindow_Event = function () {
        cGadget.ResizeGadget(cCommon.DebugWindow_txtDebug, cConstants.PB_Ignore, cConstants.PB_Ignore, cWindow.WindowWidth(cCommon.DebugWindow) - 20, cWindow.WindowHeight(cCommon.DebugWindow) - 20);
    };
    cDebugger.DebugWindowCloseEvent = function () {
        cWindow.CloseWindow(cCommon.DebugWindow);
    };
    cDebugger.OpenDebugWindow = function () {
        var OldCurrentContainer = cCommon.CurrentContainer;
        cCommon.CurrentContainer = $("body");
        var newX = (cDesktop.DesktopWidth(0) - 20) / 2;
        var newW = (cDesktop.DesktopWidth(0) - 20) / 2;
        var newY = cDesktop.DesktopHeight(0) - 250;
        var newH = 200;
        cCommon.DebugWindow = cWindow.OpenWindow(cConstants.PB_Any, newX, newY, newW, newH, "Debug", cConstants.PB_Window_SystemMenu | cConstants.PB_Window_SizeGadget);
        cWindow.BindEvent(cConstants.PB_Event_SizeWindow, cDebugger.DebugWindow_SizeWindow_Event, cCommon.DebugWindow);
        cCommon.DebugWindow_txtDebug = cGadget.EditorGadget(cConstants.PB_Any, 10, 10, 0, 0);
        $("#g_" + cCommon.DebugWindow_txtDebug).css("resize", "none");
        $("#g_" + cCommon.DebugWindow_txtDebug).parent().css("overflow", "hidden");
        var cbClear = cGadget.WindowTitleButtonGadget(cConstants.PB_Any, "ui-icon-trash", "Clear");
        cGadget.BindGadgetEvent(cbClear, function (event) { cDebugger.ClearDebugOutput(); }, cConstants.PB_EventType_LeftClick);
        var cbSave = cGadget.WindowTitleButtonGadget(cConstants.PB_Any, "ui-icon-disk", "Save");
        cGadget.BindGadgetEvent(cbSave, function (event) { cDebugger.SaveDebugOutput("DebugOutput.txt"); }, cConstants.PB_EventType_LeftClick);
        cDebugger.DebugWindow_SizeWindow_Event();
        $("#w_" + cCommon.DebugWindow).dialog().resize();
        cCommon.CurrentContainer = OldCurrentContainer;
        cWindow.BindEvent(cConstants.PB_Event_CloseWindow, cDebugger.DebugWindowCloseEvent, cCommon.DebugWindow);
    };
    return cDebugger;
}());
var cDesktop = (function () {
    function cDesktop() {
    }
    cDesktop.DesktopDepth = function (Desktop) {
        
        return 0;
    };
    cDesktop.DesktopFrequency = function (Desktop) {
        
        return 0;
    };
    cDesktop.DesktopHeight = function (Desktop) {
        return $(window).height();
    };
    cDesktop.DesktopMouseX = function () {
        return cCommon.CurrentMouseX;
    };
    cDesktop.DesktopMouseY = function () {
        return cCommon.CurrentMouseY;
    };
    cDesktop.DesktopName = function (Desktop) {
        return navigator.userAgent;
    };
    cDesktop.DesktopWidth = function (Desktop) {
        return $(window).width();
    };
    cDesktop.DesktopX = function (Desktop) {
        
        return 0;
    };
    cDesktop.DesktopY = function (Desktop) {
        
        return 0;
    };
    cDesktop.ExamineDesktops = function () {
        
        return 1;
    };
    return cDesktop;
}());
var cDragDrop = (function () {
    function cDragDrop() {
    }
    cDragDrop.DragFiles = function () {  };
    cDragDrop.DragImage = function () {  };
    cDragDrop.DragOSFormats = function () {  };
    cDragDrop.DragPrivate = function () {  };
    cDragDrop.DragText = function () {  };
    cDragDrop.EnableGadgetDrop = function (Gadget, State, Options) {
        if (Options === void 0) { Options = {}; }
        var selector = $("#g_" + Gadget);
        if (Options === null)
            Options = {};
        var AdditionalOptions = {
            hoverClass: "glowingborder",
            drop: function (event, ui) {
                if (typeof cCommon.DropCallback === "function") {
                    cDragDrop.eventDropGadget = Gadget;
                    cDragDrop.eventDropX = ui.position.left;
                    cDragDrop.eventDropY = ui.position.top;
                    cCommon.DropCallback(event, ui);
                }
            }
        };
        $.extend(Options, AdditionalOptions);
        selector.droppable(Options);
    };
    cDragDrop.EnableGadgetDrag = function (Gadget, State, Options) {
        if (Options === void 0) { Options = {}; }
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("EnableGadgetDrag()");
        if (Options === null)
            Options = {};
        var AdditionalOptions = {
            stack: selector,
            scroll: false,
            cursor: "move",
            zIndex: 9999,
            start: function () {
                $(this).data("origPosition", $(this).position());
            },
            drag: function (event, ui) {
                if (typeof cCommon.DragCallback === "function") {
                    cDragDrop.eventDragGadget = Gadget;
                    cDragDrop.eventDragX = ui.position.left;
                    cDragDrop.eventDragY = ui.position.top;
                    cCommon.DragCallback(event, ui);
                }
            }
        };
        $.extend(Options, AdditionalOptions);
        if (State === 0 || State === false) {
            if (selector.is('.ui-draggable'))
                selector.draggable("destroy");
        }
        else {
            selector.draggable(Options);
        }
    };
    cDragDrop.EnableWindowDrop = function () {  };
    cDragDrop.EventDropAction = function () {  };
    cDragDrop.EventDropBuffer = function () {  };
    cDragDrop.EventDropFiles = function () {  };
    cDragDrop.EventDropImage = function () {  };
    cDragDrop.EventDropPrivate = function () {  };
    cDragDrop.EventDropSize = function () {  };
    cDragDrop.EventDropText = function () {  };
    cDragDrop.EventDropType = function () {  };
    cDragDrop.EventDragGadget = function () { return cDragDrop.eventDragGadget; };
    cDragDrop.EventDragX = function () { return cDragDrop.eventDragX; };
    cDragDrop.EventDragY = function () { return cDragDrop.eventDragY; };
    cDragDrop.EventDropGadget = function () { return cDragDrop.eventDropGadget; };
    cDragDrop.EventDropX = function () { return cDragDrop.eventDropX; };
    cDragDrop.EventDropY = function () { return cDragDrop.eventDropY; };
    cDragDrop.SetDragCallback = function (DragCallback) { cCommon.DragCallback = DragCallback; };
    cDragDrop.SetDropCallback = function (DropCallback) { cCommon.DropCallback = DropCallback; };
    cDragDrop.eventDragGadget = -1;
    cDragDrop.eventDragX = -1;
    cDragDrop.eventDragY = -1;
    cDragDrop.eventDropGadget = -1;
    cDragDrop.eventDropX = -1;
    cDragDrop.eventDropY = -1;
    return cDragDrop;
}());
var cEngine3D = (function () {
    function cEngine3D() {
    }
    cEngine3D.Add3DArchive = function () {  };
    cEngine3D.AmbientColor = function () {  };
    cEngine3D.AntialiasingMode = function () {  };
    cEngine3D.CheckObjectVisibility = function () {  };
    cEngine3D.ConvertLocalToWorldPosition = function () {  };
    cEngine3D.ConvertWorldToLocalPosition = function () {  };
    cEngine3D.CreateWater = function () {  };
    cEngine3D.EnableWorldCollisions = function () {  };
    cEngine3D.EnableWorldPhysics = function () {  };
    cEngine3D.Engine3DStatus = function () {  };
    cEngine3D.ExamineWorldCollisions = function () {  };
    cEngine3D.FetchOrientation = function () {  };
    cEngine3D.FirstWorldCollisionEntity = function () {  };
    cEngine3D.Fog = function () {  };
    cEngine3D.FreeWater = function () {  };
    cEngine3D.GetW = function () {  };
    cEngine3D.GetX = function () {  };
    cEngine3D.GetY = function () {  };
    cEngine3D.GetZ = function () {  };
    cEngine3D.InitEngine3D = function () {  };
    cEngine3D.InputEvent3D = function () {  };
    cEngine3D.LoadWorld = function () {  };
    cEngine3D.MousePick = function () {  };
    cEngine3D.MouseRayCast = function () {  };
    cEngine3D.NextWorldCollision = function () {  };
    cEngine3D.NormalX = function () {  };
    cEngine3D.NormalY = function () {  };
    cEngine3D.NormalZ = function () {  };
    cEngine3D.Parse3DScripts = function () {  };
    cEngine3D.PickX = function () {  };
    cEngine3D.PickY = function () {  };
    cEngine3D.PickZ = function () {  };
    cEngine3D.Pitch = function () {  };
    cEngine3D.PointPick = function () {  };
    cEngine3D.RayCast = function () {  };
    cEngine3D.RayCollide = function () {  };
    cEngine3D.RayPick = function () {  };
    cEngine3D.RenderWorld = function () {  };
    cEngine3D.Roll = function () {  };
    cEngine3D.SecondWorldCollisionEntity = function () {  };
    cEngine3D.SetGUITheme3D = function () {  };
    cEngine3D.SetOrientation = function () {  };
    cEngine3D.SetRenderQueue = function () {  };
    cEngine3D.ShowGUI = function () {  };
    cEngine3D.SkyBox = function () {  };
    cEngine3D.SkyDome = function () {  };
    cEngine3D.Sun = function () {  };
    cEngine3D.WaterColor = function () {  };
    cEngine3D.WaterHeight = function () {  };
    cEngine3D.WorldCollisionAppliedImpulse = function () {  };
    cEngine3D.WorldCollisionContact = function () {  };
    cEngine3D.WorldCollisionNormal = function () {  };
    cEngine3D.WorldDebug = function () {  };
    cEngine3D.WorldGravity = function () {  };
    cEngine3D.WorldShadows = function () {  };
    cEngine3D.Yaw = function () {  };
    return cEngine3D;
}());
var cEvent = (function () {
    function cEvent() {
    }
    cEvent.EventType = function () {
        return this.eventType;
    };
    cEvent.EventGadget = function () {
        return this.eventGadget;
    };
    cEvent.EventMenu = function () {
        return this.eventMenu;
    };
    cEvent.EventWindow = function () {
        return this.eventWindow;
    };
    cEvent.HandleEvent = function (selector, event, Gadget, eventType) {
        var cb;
        switch (eventType) {
            case cConstants.PB_EventType_LeftClick:
                cb = selector.data("onLeftClick");
                if (typeof cb === "function") {
                    if (event.which === 1) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = eventType;
                        cb();
                    }
                }
                break;
            case cConstants.PB_EventType_LeftDoubleClick:
                cb = selector.data("onLeftDoubleClick");
                if (typeof cb === "function") {
                    if (event.which === 1) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = eventType;
                        cb();
                    }
                }
                break;
            case cConstants.PB_EventType_RightClick:
                cb = selector.data("onRightClick");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_RightDoubleClick:
                cb = selector.data("onRightDoubleClick");
                if (typeof cb === "function") {
                    if (event.which === 3) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = eventType;
                        cb();
                    }
                }
                break;
            case cConstants.PB_EventType_Change:
                cb = selector.data("onChange");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_Focus:
                cb = selector.data("onFocus");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_LostFocus:
                cb = selector.data("onLostFocus");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_ReturnKey:
                cb = selector.data("onReturnKey");
                if (event.which == 13) {
                    if (typeof cb === "function") {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = eventType;
                        cb();
                    }
                }
                break;
            default:
                alert("!");
                break;
        }
    };
    cEvent.eventType = -1;
    cEvent.eventGadget = -1;
    cEvent.eventMenu = -1;
    cEvent.eventWindow = -1;
    return cEvent;
}());
var cGadgetEvent = (function () {
    function cGadgetEvent() {
    }
    cGadgetEvent.BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var functionName = "BindGadgetEvent";
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Callback, EventType, bind);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Callback, EventType, bind);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Button:
                cGadgetEvent.ButtonGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_ButtonImage:
                cGadgetEvent.ButtonImageGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Calendar:
                cGadgetEvent.CalendarGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Canvas:
                cGadgetEvent.CanvasGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_CheckBox:
                cGadgetEvent.CheckBoxGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_ComboBox:
                cGadgetEvent.ComboBoxGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Container:
                cGadgetEvent.ContainerGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Date:
                cGadgetEvent.DateGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Editor:
                cGadgetEvent.EditorGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Html:
                cGadgetEvent.HtmlGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_HyperLink:
                cGadgetEvent.HyperLinkGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Image:
                cGadgetEvent.ImageGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadgetEvent.ListIconGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_ListView:
                cGadgetEvent.ListViewGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Option:
                cGadgetEvent.OptionGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Panel:
                cGadgetEvent.PanelGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_ScrollArea:
                cGadgetEvent.ScrollArea_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Spin:
                cGadgetEvent.SpinGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_String:
                cGadgetEvent.StringGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Text:
                cGadgetEvent.TextGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadgetEvent.TreeGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_TrackBar:
                cGadgetEvent.TrackBarGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Web:
                cGadgetEvent.WebGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            case cConstants.PB_GadgetType_Container:
            case cConstants.PB_GadgetType_Html:
                cGadgetEvent.OtherGadget_BindGadgetEvent(Gadget, Callback, EventType, bind);
                break;
            default:
                cCommon.UnsupportedGadgetType("Un-/BindGadgetEvent()", Gadget);
                break;
        }
    };
    cGadgetEvent.AutocompleteGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change |
                cConstants.PB_EventType_Focus |
                cConstants.PB_EventType_LostFocus;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus))
            selector.data("onFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus))
            selector.data("onLostFocus", cb);
    };
    cGadgetEvent.ButtonGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_RightClick |
                cConstants.PB_EventType_RightDoubleClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick))
            selector.data("onRightDoubleClick", cb);
    };
    cGadgetEvent.ButtonImageGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_RightClick |
                cConstants.PB_EventType_RightDoubleClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick))
            selector.data("onRightDoubleClick", cb);
    };
    cGadgetEvent.CalendarGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
    };
    cGadgetEvent.CanvasGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType =
                cConstants.PB_EventType_MouseEnter |
                    cConstants.PB_EventType_MouseLeave |
                    cConstants.PB_EventType_MouseMove |
                    cConstants.PB_EventType_MouseWheel |
                    cConstants.PB_EventType_LeftButtonDown |
                    cConstants.PB_EventType_LeftButtonUp |
                    cConstants.PB_EventType_LeftClick |
                    cConstants.PB_EventType_LeftDoubleClick |
                    cConstants.PB_EventType_RightButtonDown |
                    cConstants.PB_EventType_RightButtonUp |
                    cConstants.PB_EventType_RightClick |
                    cConstants.PB_EventType_RightDoubleClick |
                    cConstants.PB_EventType_MiddleButtonDown |
                    cConstants.PB_EventType_MiddleButtonUp |
                    cConstants.PB_EventType_Focus |
                    cConstants.PB_EventType_LostFocus |
                    cConstants.PB_EventType_KeyDown |
                    cConstants.PB_EventType_KeyUp;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_MouseEnter))
            selector.data("onMouseEnter", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_MouseLeave))
            selector.data("onMouseLeave", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_MouseMove))
            selector.data("onMouseMove", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_MouseWheel))
            selector.data("onMouseWheel", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftButtonDown))
            selector.data("onLeftButtonDown", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftButtonUp))
            selector.data("onLeftButtonUp", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightButtonDown))
            selector.data("onRightButtonDown", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightButtonUp))
            selector.data("onRightButtonUp", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick))
            selector.data("onRightDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_MiddleButtonDown))
            selector.data("onMiddleButtonDown", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_MiddleButtonUp))
            selector.data("onMiddleButtonUp", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus))
            selector.data("onFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus))
            selector.data("onLostFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyDown))
            selector.data("onKeyDown", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp))
            selector.data("onKeyUp", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Input))
            selector.data("onInput", cb);
    };
    cGadgetEvent.CheckBoxGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget + "_checkbox");
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
    };
    cGadgetEvent.ComboBoxGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType =
                cConstants.PB_EventType_LeftClick |
                    cConstants.PB_EventType_Change;
            cConstants.PB_EventType_Focus |
                cConstants.PB_EventType_LostFocus;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus))
            selector.data("onFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus))
            selector.data("onLostFocus", cb);
    };
    cGadgetEvent.ContainerGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Scroll;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Scroll))
            selector.data("onScroll", cb);
    };
    cGadgetEvent.DateGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change |
                cConstants.PB_EventType_CloseItem;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_CloseItem))
            selector.data("onClose", cb);
    };
    cGadgetEvent.EditorGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType =
                cConstants.PB_EventType_Change |
                    cConstants.PB_EventType_Focus |
                    cConstants.PB_EventType_LostFocus |
                    cConstants.PB_EventType_ReturnKey;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus))
            selector.data("onFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus))
            selector.data("onLostFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_ReturnKey))
            selector.data("onReturnKey", cb);
    };
    cGadgetEvent.HtmlGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_RightClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
    };
    cGadgetEvent.HyperLinkGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
    };
    cGadgetEvent.ImageGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_RightClick |
                cConstants.PB_EventType_RightDoubleClick |
                cConstants.PB_EventType_DragStart;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick))
            selector.data("onRightDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DragStart))
            selector.data("onDragStart", cb);
    };
    cGadgetEvent.ListIconGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_Select |
                cConstants.PB_EventType_Unselect |
                cConstants.PB_EventType_RightClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_Change;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Select))
            selector.data("onSelect", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Unselect))
            selector.data("onUnselect", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
    };
    cGadgetEvent.ListViewGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_RightClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
    };
    cGadgetEvent.OptionGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget + "_radio");
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
    };
    cGadgetEvent.PanelGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
    };
    cGadgetEvent.SpinGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change |
                cConstants.PB_EventType_Up |
                cConstants.PB_EventType_Down;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Up))
            selector.data("onUp", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Down))
            selector.data("onDown", cb);
    };
    cGadgetEvent.ScrollArea_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Scroll;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Scroll))
            selector.data("onScroll", cb);
    };
    cGadgetEvent.StringGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change |
                cConstants.PB_EventType_Focus |
                cConstants.PB_EventType_LostFocus |
                cConstants.PB_EventType_ReturnKey;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus))
            selector.data("onFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus))
            selector.data("onLostFocus", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_ReturnKey))
            selector.data("onReturnKey", cb);
    };
    cGadgetEvent.TextGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_RightClick |
                cConstants.PB_EventType_RightDoubleClick;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
    };
    cGadgetEvent.TrackBarGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_Change;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
    };
    cGadgetEvent.TreeGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_EventType_LeftClick |
                cConstants.PB_EventType_LeftDoubleClick |
                cConstants.PB_EventType_RightClick |
                cConstants.PB_EventType_RightDoubleClick |
                cConstants.PB_EventType_Change |
                cConstants.PB_EventType_DragStart;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick))
            selector.data("onLeftClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick))
            selector.data("onLeftDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick))
            selector.data("onRightClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick))
            selector.data("onRightDoubleClick", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change))
            selector.data("onChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DragStart))
            selector.data("onDragStart", cb);
    };
    cGadgetEvent.WebGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (EventType === cConstants.PB_All) {
            EventType =
                cConstants.PB_EventType_TitleChange |
                    cConstants.PB_EventType_StatusChange |
                    cConstants.PB_EventType_DownloadStart |
                    cConstants.PB_EventType_DownloadProgress |
                    cConstants.PB_EventType_DownloadEnd |
                    cConstants.PB_EventType_PopupWindow |
                    cConstants.PB_EventType_PopupMenu;
        }
        var cb = null;
        if (bind)
            cb = Callback;
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_TitleChange))
            selector.data("onTitleChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_StatusChange))
            selector.data("onStatusChange", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DownloadStart))
            selector.data("onDownloadStart", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DownloadProgress))
            selector.data("onDownloadProgress", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_DownloadEnd))
            selector.data("onDownloadEnd", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_PopupWindow))
            selector.data("onPopupWindow", cb);
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_PopupMenu))
            selector.data("onPopupMenu", cb);
    };
    cGadgetEvent.OtherGadget_BindGadgetEvent = function (Gadget, Callback, EventType, bind) {
        var selector = $("#g_" + Gadget);
        if (bind) {
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change)) {
                selector.bind("change", function (event) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_Change;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyDown)) {
                selector.bind("keydown", function (event) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_KeyDown;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) {
                selector.bind("keyup", function (event) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_KeyUp;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyPress)) {
                selector.bind("keypress", function (event) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_KeyPress;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) {
                selector.click(function (event) {
                    if (event.which === 1) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = cConstants.PB_EventType_LeftClick;
                        Callback();
                    }
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick)) {
                selector.dblclick(function (event) {
                    if (event.which === 1) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = cConstants.PB_EventType_LeftDoubleClick;
                        Callback();
                    }
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) {
                selector.bind("contextmenu", function (event) {
                    event.preventDefault();
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_RightClick;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick)) {
                selector.dblclick(function (event) {
                    if (event.which === 3) {
                        event.preventDefault();
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = cConstants.PB_EventType_RightDoubleClick;
                        Callback();
                    }
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus)) {
                selector.focus(function (event) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_Focus;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus)) {
                selector.focusout(function (event) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_LostFocus;
                    Callback();
                });
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Swipe)) {
                selector.swipe({
                    swipeStatus: function (event, phase, direction, distance, duration, fingerCount) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = cConstants.PB_EventType_Swipe;
                        Callback(event, phase, direction, distance, duration, fingerCount);
                    },
                    threshold: cCommon.SwipeThreshold
                });
            }
        }
        else {
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Change)) {
                selector.unbind("change");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyDown)) {
                selector.unbind("keydown");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) {
                selector.bind("keyup");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyPress)) {
                selector.unbind("keypress");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) {
                selector.unbind("click");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftDoubleClick)) {
                selector.unbind("dblclick");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightClick)) {
                selector.unbind("contextmenu");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_RightDoubleClick)) {
                selector.unbind("dblclick");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Focus)) {
                selector.unbind("focus");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LostFocus)) {
                selector.unbind("focusout");
            }
            if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_Swipe)) {
                selector.swipe({
                    swipeStatus: null
                });
            }
        }
    };
    return cGadgetEvent;
}());
var cWindowEvent = (function () {
    function cWindowEvent() {
    }
    cWindowEvent.BindEvent = function (Event, Callback, Window, Object, EventType, bind) {
        var winSelector;
        if (Window === cConstants.PB_All) {
            winSelector = $("[id^='w_']");
        }
        else {
            winSelector = $("#w_" + Window);
        }
        var objSelector;
        if (Window === cConstants.PB_All) {
            objSelector = $("[id^='g_']");
        }
        else {
            objSelector = $("#g_" + Object);
        }
        switch (Event) {
            case cConstants.PB_Event_ActivateWindow:
                cWindowEvent.BindEvent_ActivateWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_CloseWindow:
                cWindowEvent.BindEvent_CloseWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_DeactivateWindow:
                cWindowEvent.BindEvent_DeactivateWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_Gadget:
                cWindowEvent.BindEvent_Gadget(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_GadgetDrop:
                cWindowEvent.BindEvent_GadgetDrop(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_LeftClick:
                cWindowEvent.BindEvent_LeftClick(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_LeftDoubleClick:
                cWindowEvent.BindEvent_LeftDoubleClick(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_MaximizeWindow:
                cWindowEvent.BindEvent_MaximizeWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_Menu:
                cWindowEvent.BindEvent_Menu(winSelector, Object, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_MinimizeWindow:
                cWindowEvent.BindEvent_MinimizeWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_MoveWindow:
                cWindowEvent.BindEvent_MoveWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_Repaint:
                cWindowEvent.BindEvent_Repaint(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_RestoreWindow:
                cWindowEvent.BindEvent_RestoreWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_RightClick:
                cWindowEvent.BindEvent_RightClick(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_SizeWindow:
                cWindowEvent.BindEvent_SizeWindow(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_SizeWindowStart:
                cWindowEvent.BindEvent_SizeWindowStart(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_SizeWindowStop:
                cWindowEvent.BindEvent_SizeWindowStop(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_SysTray:
                cWindowEvent.BindEvent_SysTray(winSelector, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_Timer:
                cWindowEvent.BindEvent_Timer(winSelector, Object, Callback, EventType, bind);
                break;
            case cConstants.PB_Event_BatteryStatus:
                window.addEventListener('batterystatus', function (ev) {
                    event.preventDefault();
                    cEvent.eventWindow = Window;
                    cEvent.eventType = EventType;
                    Callback(ev.level);
                });
                break;
        }
    };
    cWindowEvent.BindEvent_ActivateWindow = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                $(w).on("focus", function (event, ui) {
                    cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                    Callback();
                });
            }
            else {
                $(w).off("focus");
            }
        });
    };
    cWindowEvent.BindEvent_CloseWindow = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if ($(w).prop("tagName") === "BODY") {
                $(window).on("close", function () {
                    cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                    return Callback();
                });
            }
            else {
                $(w).data("closeCallback", Callback);
            }
        });
    };
    cWindowEvent.BindEvent_DeactivateWindow = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                $(w).dialog().on("blur", function (event, ui) {
                    cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                    Callback();
                });
            }
            else {
                $(w).dialog().off("blur");
            }
        });
    };
    cWindowEvent.BindEvent_Gadget = function (winSelector, Callback, EventType, bind) {
        
    };
    cWindowEvent.BindEvent_GadgetDrop = function (winSelector, Callback, EventType, bind) {
        
    };
    cWindowEvent.BindEvent_LeftClick = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if ($(w).prop("tagName") === "BODY")
                w = document;
            if (bind) {
                $(w).bind("click", function (event) {
                    if (event.which === 1) {
                        cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                        cEvent.eventType = cConstants.PB_EventType_LeftClick;
                        Callback();
                    }
                });
            }
            else {
                $(w).unbind("click");
            }
        });
    };
    cWindowEvent.BindEvent_LeftDoubleClick = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if ($(w).prop("tagName") === "BODY")
                w = document;
            if (bind) {
                $(w).bind("dblclick", function (event) {
                    if (event.which === 1) {
                        cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                        cEvent.eventType = cConstants.PB_EventType_LeftClick;
                        Callback();
                    }
                });
            }
            else {
                $(w).unbind("dblclick");
            }
        });
    };
    cWindowEvent.BindEvent_MaximizeWindow = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).data("maximizeCallback", Callback);
                }
            }
            else {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).data("maximizeCallback", null);
                }
            }
        });
    };
    cWindowEvent.BindEvent_Menu = function (winSelector, Object, Callback, EventType, bind) {
        if (winSelector.prop("tagName") !== "BODY") {
            winSelector = winSelector.parent();
        }
        var keyboardshortcuts = winSelector.data("keyboardshortcuts");
        var result;
        if (keyboardshortcuts)
            result = $.grep(keyboardshortcuts, function (e) { return e.event === Object; })[0];
        if (result) {
            var selector = winSelector;
            if (EventType === cConstants.PB_All) {
                EventType = cConstants.PB_EventType_KeyDown |
                    cConstants.PB_EventType_KeyUp;
            }
            if (bind) {
                if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyDown)) {
                    selector.bind("keydown." + result.hotkey, result.hotkey, function () {
                        cEvent.eventMenu = result.event;
                        cEvent.eventType = cConstants.PB_EventType_KeyDown;
                        Callback();
                        return false;
                    });
                }
                if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) {
                    selector.bind("keyup." + result.hotkey, result.hotkey, function () {
                        cEvent.eventMenu = result.event;
                        cEvent.eventType = cConstants.PB_EventType_KeyUp;
                        Callback();
                        return false;
                    });
                }
            }
            else {
                if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyDown)) {
                    selector.unbind("keydown." + result.hotkey, result.hotkey);
                }
                if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) {
                    selector.unbind("keyup." + result.hotkey, result.hotkey);
                }
            }
        }
        else {
            var objSelector = winSelector.find("#tbb_" + Object);
            if (objSelector.length === 0) {
                
                return;
            }
            if (EventType === cConstants.PB_All) {
                EventType = cConstants.PB_EventType_LeftClick;
            }
            if (bind) {
                if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) {
                    objSelector.button().on("click", function (event) {
                        cEvent.eventMenu = Object;
                        Callback();
                    });
                }
            }
            else {
                if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_LeftClick)) {
                    objSelector.button().off("click");
                }
            }
        }
    };
    cWindowEvent.BindEvent_MinimizeWindow = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).data("minimizeCallback", Callback);
                }
            }
            else {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).data("minimizeCallback", null);
                }
            }
        });
    };
    cWindowEvent.BindEvent_MoveWindow = function (winSelector, Callback, EventType, bind) {
        
    };
    cWindowEvent.BindEvent_Repaint = function (winSelector, Callback, EventType, bind) {
        
    };
    cWindowEvent.BindEvent_SizeWindow = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                if ($(w).prop("tagName") === "BODY") {
                    $(window).on("resize", function () {
                        cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                        Callback();
                    });
                }
                else {
                    $(w).data("resizeCallback", Callback);
                    $(w).on("dialogresize", function () {
                        cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                        Callback();
                    });
                }
            }
            else {
                if ($(w).prop("tagName") === "BODY") {
                    $(window).off("resize");
                }
                else {
                    $(w).data("resizeCallback", null);
                    $(w).off("dialogresize");
                }
            }
        });
    };
    cWindowEvent.BindEvent_SizeWindowStart = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).on("dialogresizestart", function () {
                        cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                        Callback();
                    });
                }
            }
            else {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).off("dialogresizestart");
                }
            }
        });
    };
    cWindowEvent.BindEvent_SizeWindowStop = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if (bind) {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).on("dialogresizestop", function () {
                        cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                        Callback();
                    });
                }
            }
            else {
                if ($(w).prop("tagName") === "BODY") {
                }
                else {
                    $(w).off("dialogresizestop");
                }
            }
        });
    };
    cWindowEvent.BindEvent_SysTray = function (winSelector, Callback, EventType, bind) {
        
    };
    cWindowEvent.BindEvent_RestoreWindow = function (winSelector, Callback, EventType, bind) {
        
    };
    cWindowEvent.BindEvent_RightClick = function (winSelector, Callback, EventType, bind) {
        $.each(winSelector, function (index, w) {
            if ($(w).prop("tagName") === "BODY")
                w = document;
            if (bind) {
                $(w).bind("contextmenu", function (event) {
                    event.preventDefault();
                    cEvent.eventWindow = cString.Val(cString.Mid(w.id, 3));
                    cEvent.eventType = cConstants.PB_EventType_RightClick;
                    Callback();
                });
            }
            else {
                $(w).unbind("contextmenu");
            }
        });
    };
    cWindowEvent.BindEvent_Timer = function (winSelector, Timer, Callback, EventType, bind) {
        $.each(winSelector, function (wIndex, w) {
            var myTimer = $(w).data("timer_" + Timer);
            if (bind) {
                if (myTimer) {
                    myTimer.start(Callback);
                }
                else {
                    
                }
            }
            else {
                if (myTimer) {
                    myTimer.stop();
                }
                else {
                    
                }
            }
        });
    };
    return cWindowEvent;
}());
var cEventMobile = (function () {
    function cEventMobile() {
    }
    cEventMobile.EventType = function () {
        return this.eventType;
    };
    cEventMobile.EventWidget = function () {
        return this.eventWidget;
    };
    cEventMobile.HandleEvent = function (selector, event, Widget, eventType) {
        var cb;
        switch (eventType) {
            case cConstants.PB_EventType_LeftClick:
                cb = selector.data("onLeftClick");
                if (typeof cb === "function") {
                    if (event.which === 1) {
                        cEventMobile.eventWidget = Widget;
                        cEventMobile.eventType = eventType;
                        cb();
                    }
                }
                break;
            case cConstants.PB_EventType_LeftDoubleClick:
                cb = selector.data("onLeftDoubleClick");
                if (typeof cb === "function") {
                    if (event.which === 1) {
                        cEventMobile.eventWidget = Widget;
                        cEventMobile.eventType = eventType;
                        cb();
                    }
                }
                break;
            case cConstants.PB_EventType_RightClick:
                cb = selector.data("onRightClick");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEventMobile.eventWidget = Widget;
                    cEventMobile.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_RightDoubleClick:
                cb = selector.data("onRightDoubleClick");
                if (typeof cb === "function") {
                    if (event.which === 3) {
                        cEventMobile.eventWidget = Widget;
                        cEventMobile.eventType = eventType;
                        cb();
                    }
                }
                break;
            case cConstants.PB_EventType_Change:
                cb = selector.data("onChange");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEventMobile.eventWidget = Widget;
                    cEventMobile.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_Focus:
                cb = selector.data("onFocus");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEventMobile.eventWidget = Widget;
                    cEventMobile.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_LostFocus:
                cb = selector.data("onLostFocus");
                if (typeof cb === "function") {
                    event.preventDefault();
                    cEventMobile.eventWidget = Widget;
                    cEventMobile.eventType = eventType;
                    cb();
                }
                break;
            case cConstants.PB_EventType_ReturnKey:
                cb = selector.data("onReturnKey");
                if (event.which == 13) {
                    if (typeof cb === "function") {
                        cEventMobile.eventWidget = Widget;
                        cEventMobile.eventType = eventType;
                        cb();
                    }
                }
                break;
            default:
                alert("!");
                break;
        }
    };
    cEventMobile.eventType = -1;
    cEventMobile.eventWidget = -1;
    return cEventMobile;
}());
var cFile = (function () {
    function cFile() {
    }
    cFile.CloseFile = function () {  };
    cFile.CreateFile = function () {  };
    cFile.Eof = function () {  };
    cFile.FileBuffersSize = function () {  };
    cFile.FileID = function () {  };
    cFile.FileSeek = function () {  };
    cFile.FlushFileBuffers = function () {  };
    cFile.IsFile = function () {  };
    cFile.Loc = function () {  };
    cFile.Lof = function () {  };
    cFile.OpenFile = function () {  };
    cFile.ReadAsciiCharacter = function () {  };
    cFile.ReadByte = function () {  };
    cFile.ReadCharacter = function () {  };
    cFile.ReadData = function () {  };
    cFile.ReadDouble = function () {  };
    cFile.ReadFile = function () {  };
    cFile.ReadFloat = function () {  };
    cFile.ReadInteger = function () {  };
    cFile.ReadLong = function () {  };
    cFile.ReadQuad = function () {  };
    cFile.ReadString = function () {  };
    cFile.ReadStringFormat = function () {  };
    cFile.ReadUnicodeCharacter = function () {  };
    cFile.ReadWord = function () {  };
    cFile.TruncateFile = function () {  };
    cFile.WriteAsciiCharacter = function () {  };
    cFile.WriteByte = function () {  };
    cFile.WriteCharacter = function () {  };
    cFile.WriteData = function () {  };
    cFile.WriteDouble = function () {  };
    cFile.WriteFloat = function () {  };
    cFile.WriteInteger = function () {  };
    cFile.WriteLong = function () {  };
    cFile.WriteQuad = function () {  };
    cFile.WriteString = function () {  };
    cFile.WriteStringFormat = function () {  };
    cFile.WriteStringN = function () {  };
    cFile.WriteUnicodeCharacter = function () {  };
    cFile.WriteWord = function () {  };
    return cFile;
}());
var cFileSystem = (function () {
    function cFileSystem() {
    }
    cFileSystem.CheckFilename = function () {  };
    cFileSystem.CopyDirectory = function () {  };
    cFileSystem.CopyFile = function () {  };
    cFileSystem.CreateDirectory = function () {  };
    cFileSystem.DeleteDirectory = function () {  };
    cFileSystem.DeleteFile = function () {  };
    cFileSystem.DirectoryEntryAttributes = function () {  };
    cFileSystem.DirectoryEntryDate = function () {  };
    cFileSystem.DirectoryEntryName = function () {  };
    cFileSystem.DirectoryEntrySize = function () {  };
    cFileSystem.DirectoryEntryType = function () {  };
    cFileSystem.ExamineDirectory = function () {  };
    cFileSystem.FileSize = function () {  };
    cFileSystem.FinishDirectory = function () {  };
    cFileSystem.GetCurrentDirectory = function () {  };
    cFileSystem.GetExtensionPart = function (FullPathName) {
        return FullPathName.substr((~-FullPathName.lastIndexOf(".") >>> 0) + 2);
    };
    cFileSystem.GetFileAttributes = function () {  };
    cFileSystem.GetFileDate = function () {  };
    cFileSystem.GetFilePart = function (FullPathName, Mode) {
        if (Mode === void 0) { Mode = 0; }
        var FilePart = FullPathName.replace(/^.*[\\\/]/, '');
        if (Mode == cConstants.PB_FileSystem_NoExtension)
            FilePart = FilePart.replace(/\.[^/.]+$/, "");
        return FilePart;
    };
    cFileSystem.GetHomeDirectory = function () {  };
    cFileSystem.GetPathPart = function () {  };
    cFileSystem.GetTemporaryDirectory = function () {  };
    cFileSystem.IsDirectory = function () {  };
    cFileSystem.NextDirectoryEntry = function () {  };
    cFileSystem.RenameFile = function () {  };
    cFileSystem.SetCurrentDirectory = function () {  };
    cFileSystem.SetFileAttributes = function () {  };
    cFileSystem.SetFileDate = function () {  };
    return cFileSystem;
}());
var cFont = (function () {
    function cFont() {
    }
    cFont.FontID = function (F) {
        return F;
    };
    cFont.FreeFont = function (F) {
        cCommon.P2W_FontList[F] = null;
        delete cCommon.P2W_FontList[F];
    };
    cFont.IsFont = function (F) {
        return (cCommon.P2W_FontList[F] != null);
    };
    cFont.LoadFont = function (F, Name, YSize, Flags) {
        if (Flags === void 0) { Flags = 0; }
        if (F === cConstants.PB_Any) {
            F = cCommon.guid();
        }
        var font = {
            Size: YSize.toString(),
            Family: Name,
            Weight: "normal",
            Style: "normal",
            Decoration: "none"
        };
        if (cCommon.CheckFlag(Flags, cConstants.PB_Font_Bold))
            font.Weight = "bold";
        if (cCommon.CheckFlag(Flags, cConstants.PB_Font_Italic))
            font.Style = "italic";
        if (cCommon.CheckFlag(Flags, cConstants.PB_Font_Underline))
            font.Decoration = "unterline";
        if (cCommon.CheckFlag(Flags, cConstants.PB_Font_StrikeOut))
            font.Decoration = "line-through";
        cCommon.P2W_FontList[F] = font;
        if (F === 0)
            return true;
        return F;
    };
    cFont.SetDefaultFont = function (selector) {
        if (cCommon.DefaultGadgetFont != null) {
            selector.css("font-size", cCommon.DefaultGadgetFont.Size);
            selector.css("font-family", cCommon.DefaultGadgetFont.Family);
            selector.css("font-weight", cCommon.DefaultGadgetFont.Weight);
            selector.css("font-style", cCommon.DefaultGadgetFont.Style);
            selector.css("text-decoration", cCommon.DefaultGadgetFont.Decoration);
        }
    };
    return cFont;
}());
var cGadget = (function () {
    function cGadget() {
    }
    cGadget.AddGadgetColumn_ListIcon = function (Gadget, Position, Title, Width) {
        var Columns = w2ui["w2ui_g_" + Gadget].columns;
        if (Position < -1) {
            Position = 0;
        }
        if (Position >= Columns.length) {
            Position = Columns.length;
        }
        if (Position === -1) {
            Position = Columns.length;
        }
        var sWidth = cString.Str(Width);
        if (cString.EndsWith(sWidth, "%") || cString.EndsWith(sWidth, "px")) {
        }
        else {
            sWidth = sWidth + "px";
        }
        w2ui["w2ui_g_" + Gadget].addColumn(Position, { field: cCommon.guid(), caption: Title, size: sWidth });
        w2ui["w2ui_g_" + Gadget].refresh();
    };
    cGadget.AddGadgetColumn = function (Gadget, Position, Title, Width) {
        var functionName = "AddGadgetColumn";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.AddGadgetColumn_ListIcon(Gadget, Position, Title, Width);
                break;
            case cConstants.PB_GadgetType_ExplorerList:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.AddGadgetItem_ListIcon = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var selector = $("#g_" + Gadget);
        var Columns = w2ui["w2ui_g_" + Gadget].columns;
        var Records = w2ui["w2ui_g_" + Gadget].records;
        if (Position < -1)
            Position = 0;
        if (Position >= Records.length)
            Position = Records.length;
        if (Position === -1)
            Position = Records.length;
        var myLineArray = Text.split(selector.data("RecordDelimiter"));
        for (var lineCounter = 0; lineCounter <= myLineArray.length - 1; lineCounter++) {
            var newRecord = {};
            var myFieldArray = myLineArray[lineCounter].split(selector.data("ColumnDelimiter"));
            for (var fieldCounter = 0; fieldCounter <= Columns.length - 1; fieldCounter++) {
                newRecord[Columns[fieldCounter].field] = myFieldArray[fieldCounter];
            }
            Records.splice(Position, 0, newRecord);
            Position += 1;
        }
        for (var i = 0; i <= Records.length - 1; i++) {
            Records[i].recid = i;
        }
        w2ui["w2ui_g_" + Gadget].clear();
        w2ui["w2ui_g_" + Gadget].reset();
        w2ui["w2ui_g_" + Gadget].add(Records);
    };
    cGadget.AddGadgetItem_ListView = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var selector = $("#g_" + Gadget);
        var oArray = selector.children().toArray();
        if (oArray === null)
            oArray = [];
        if (Position === -1)
            Position = oArray.length;
        var o = $("<option />");
        if (ImageID != -1) {
            var img = cCommon.P2W_ImageList[ImageID];
            if (img != null) {
                o.attr("imgs", img.src);
                o.attr("imgw", img.width);
                o.attr("imgh", img.height);
            }
        }
        o.text(Text);
        oArray.splice(Position, 0, o);
        selector.empty();
        selector.append(oArray);
    };
    cGadget.AddGadgetItem_Panel = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var id = "gp_li_" + cCommon.guid();
        var selector = $("#g_" + Gadget);
        var Image = "";
        var CloseButton = "";
        var li = $("<li><a href='#" + id + "'><span style='display:inline-block;vertical-align:middle;'>" + Image + Text + "</span></a>" + CloseButton + "</li>");
        var ul = selector.tabs("widget").find("ul").first();
        ul.append(li);
        var div = $("<div id='" + id + "'></div>");
        div.css("padding", "0");
        div.css("position", "relative");
        div.css("overflow", "auto");
        selector.append(div);
        selector.tabs("refresh");
        cCommon.CurrentContainer = div;
        if (cGadget.CountGadgetItems(Gadget) === 1)
            cGadget.SetGadgetState_Panel(Gadget, 0);
        var cb = $("#g_" + Gadget).data("onChange");
        $("#g_" + Gadget).data("onChange", null);
        var selectedIndex = cGadget.GetGadgetState(Gadget);
        $('a[href="#' + id + '"]').trigger('click');
        cGadget.SetGadgetState_Panel(Gadget, selectedIndex);
        $("#g_" + Gadget).data("onChange", cb);
    };
    cGadget.AddGadgetItem_ComboBox = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var selector = $("#g_" + Gadget);
        var oArray = selector.children().toArray();
        if (oArray === null)
            oArray = [];
        if (Position === -1)
            Position = oArray.length;
        if (Position > oArray.length)
            Position = oArray.length;
        var o = $("<option />");
        if (ImageID != -1) {
            var img = cCommon.P2W_ImageList[ImageID];
            if (img != null) {
                o.attr("imgs", img.src);
                o.attr("imgw", img.width);
                o.attr("imgh", img.height);
            }
        }
        o.text(Text);
        oArray.splice(Position, 0, o);
        selector.empty();
        selector.append(oArray);
        switch (selector.data("cbtype")) {
            case "combobox":
                selector.combobox("refresh");
                break;
            case "selectmenu":
                selector.selectmenu("refresh");
                break;
            case "simple":
                break;
        }
    };
    cGadget.AddGadgetItem_Editor = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var selector = $("#g_" + Gadget);
        var editorContent = selector.val();
        var textArray = editorContent.split("\n");
        if (Position === -1)
            Position = textArray.length - 1;
        if (Position > textArray.length - 1)
            Position = textArray.length - 1;
        textArray.splice(Position, 0, Text);
        selector.val(textArray.join("\n"));
    };
    cGadget.AddGadgetItem_Html = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var selector = $("#g_" + Gadget);
        selector.append(Text);
    };
    cGadget.AddGadgetItem_Tree = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var selector = $("#g_" + Gadget);
        if (Position === -1)
            Position = cGadget.CountGadgetItems(Gadget);
        var pos = 1;
        var match = null;
        selector.fancytree("getRootNode").visit(function (node) {
            if (pos === Position) {
                match = node;
                return false;
            }
            pos += 1;
        });
        var newNode;
        if (match === null) {
            newNode = selector.fancytree("getRootNode").addChildren({ title: Text });
        }
        else {
            for (var c = match.getLevel(); c > Flags; c--) {
                match = match.getParent();
            }
            newNode = match.addChildren({ title: Text });
        }
        if (ImageID != -1) {
            var img = cCommon.P2W_ImageList[ImageID];
            if (img != null) {
                newNode.data.icon = img.src;
            }
        }
        newNode.renderTitle();
    };
    cGadget.AddGadgetItem = function (Gadget, Position, Text, ImageID, Flags) {
        if (ImageID === void 0) { ImageID = -1; }
        if (Flags === void 0) { Flags = 0; }
        var functionName = "AddGadgetItem";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Position, Text, ImageID, Flags);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Position, Text, ImageID, Flags);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.AddGadgetItem_ComboBox(Gadget, Position, Text, ImageID, Flags);
                break;
            case cConstants.PB_GadgetType_Editor:
                cGadget.AddGadgetItem_Editor(Gadget, Position, Text, ImageID, Flags);
                break;
            case cConstants.PB_GadgetType_Html:
                cGadget.AddGadgetItem_Html(Gadget, Position, Text, ImageID, Flags);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.AddGadgetItem_ListIcon(Gadget, Position, Text, ImageID, Flags);
                break;
            case cConstants.PB_GadgetType_ListView:
                cGadget.AddGadgetItem_ListView(Gadget, Position, Text, ImageID, Flags);
                break;
            case cConstants.PB_GadgetType_MDI:
                
                break;
            case cConstants.PB_GadgetType_Panel:
                cGadget.AddGadgetItem_Panel(Gadget, Position, Text, ImageID, Flags);
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadget.AddGadgetItem_Tree(Gadget, Position, Text, ImageID, Flags);
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.BindGadgetEvent = function (Gadget, Callback, EventType) {
        if (EventType === void 0) { EventType = cConstants.PB_All; }
        var functionName = "BindGadgetEvent";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        cGadgetEvent.BindGadgetEvent(Gadget, Callback, EventType, true);
    };
    cGadget.BindGadgetItemEvent = function (Gadget, Item, Callback, EventType) {
        if (EventType === void 0) { EventType = 0; }
        var functionName = "BindGadgetItemEvent";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, Callback, EventType);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, Callback, EventType);
        }
        cCommon.UnsupportedGadgetType(functionName, Gadget);
    };
    cGadget.ButtonGadget = function (Gadget, x, y, Width, Height, Text, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var functionName = "ButtonGadget";
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector;
        if (cCommon.CheckFlag(Flags, cConstants.PB_Button_Toggle)) {
            selector = $("<input type='checkbox' id='g_" + Gadget + "' /><label id='g_" + Gadget + "_label' for='g_" + Gadget + "'>" + Text + "</label>");
            cCommon.getCurrentContainer().append(selector);
            $("#g_" + Gadget).button();
        }
        else {
            selector = $("<button id='g_" + Gadget + "'>" + Text + "</button>");
            cCommon.getCurrentContainer().append(selector);
            selector.button();
        }
        if (cCommon.CurrentContainer.data("GadgetType") !== "ButtonsetGadget") {
            cCommon.SetGadgetPosition($("#g_" + Gadget), x, y, Width, Height);
            if ($("#g_" + Gadget + "_label")) {
                cCommon.SetGadgetPosition($("#g_" + Gadget + "_label"), x, y, Width, Height);
            }
        }
        else {
            $("#g_" + Gadget).css("height", "100%");
            $("#g_" + Gadget + "_label").css("height", "100%");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Button_Right))
            selector.find("span").css("text-align", "right");
        if (cCommon.CheckFlag(Flags, cConstants.PB_Button_Left))
            selector.find("span").css("text-align", "left");
        if (cCommon.CheckFlag(Flags, cConstants.PB_Button_Default))
            
        if (!cCommon.CheckFlag(Flags, cConstants.PB_Button_MultiLine))
            selector.css("white-space", "nowrap");
        selector.data("GadgetType", cConstants.PB_GadgetType_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "SetGadgetState", cGadget.SetGadgetState_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "GetGadgetState", cGadget.GetGadgetState_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "SetGadgetText", cGadget.SetGadgetText_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "GetGadgetText", cGadget.GetGadgetText_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "DisableGadget", cGadget.DisableGadget_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "ResizeGadget", cGadget.ResizeGadget_Button);
        cP2W.RegisterPbGadgetProcedure(cConstants.PB_GadgetType_Button, "FreeGadget", cGadget.FreeGadget_Button);
        if (cCommon.CurrentContainer.data("GadgetType") === "ButtonsetGadget") {
            cCommon.CurrentContainer.buttonset();
            var bc = cCommon.CurrentContainer.find("button").length;
            cCommon.CurrentContainer.find("button").css("width", 100 / bc + "%");
        }
        cGadget.GetDefaultColors(selector);
        cFont.SetDefaultFont(selector);
        selector.bind("click", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_LeftClick);
        });
        selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_LeftDoubleClick);
        });
        selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_RightClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.ButtonImageGadget = function (Gadget, x, y, Width, Height, ImageID, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var buttonImageGadget = new cControl(Gadget, x, y, Width, Height, "<button />");
        if (cCommon.CheckFlag(Flags, cConstants.PB_Button_Toggle)) {
            
        }
        if (typeof ImageID === 'number') {
            buttonImageGadget.selector.button({ text: false });
            var img = cCommon.P2W_ImageList[ImageID];
            if (img != null) {
                buttonImageGadget.selector.css("background-image", "url(" + img.src + ")");
                buttonImageGadget.selector.css("background-repeat", "no-repeat");
            }
        }
        else {
            buttonImageGadget.selector.button({ text: false, icons: { primary: ImageID } });
        }
        buttonImageGadget.selector.css("border", "none");
        buttonImageGadget.selector.css("font-size", "0px");
        buttonImageGadget.selector.data("GadgetType", cConstants.PB_GadgetType_ButtonImage);
        cCommon.CurrentContainer.append(buttonImageGadget.selector);
        cGadget.GetDefaultColors(buttonImageGadget.selector);
        buttonImageGadget.selector.bind("click", function (event) {
            cEvent.HandleEvent(buttonImageGadget.selector, event, buttonImageGadget.ident, cConstants.PB_EventType_LeftClick);
        });
        buttonImageGadget.selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(buttonImageGadget.selector, event, buttonImageGadget.ident, cConstants.PB_EventType_LeftDoubleClick);
        });
        buttonImageGadget.selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(buttonImageGadget.selector, event, buttonImageGadget.ident, cConstants.PB_EventType_RightClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return buttonImageGadget.ident;
    };
    cGadget.CalendarGadget = function (Gadget, x, y, Width, Height, Date, Flags, Callback) {
        if (Date === void 0) { Date = cDate.Date(); }
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        var calendarGadget = new cControl(Gadget, x, y, Width, Height, "<div />");
        cCommon.CurrentContainer.append(calendarGadget.selector);
        calendarGadget.selector.data("onChange", Callback);
        calendarGadget.selector.datepicker({
            onSelect: function () {
                if (calendarGadget.selector.data("onChange")) {
                    cEvent.eventGadget = calendarGadget.ident;
                    cEvent.eventType = cConstants.PB_EventType_Change;
                    calendarGadget.selector.data("onChange")();
                }
            }
        });
        calendarGadget.selector.datepicker("setDate", moment.unix(Date).toDate());
        if (Flags !== cConstants.PB_Calendar_Borderless) {
            calendarGadget.selector.css("border", "1px solid black");
        }
        calendarGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Calendar);
        cGadget.GetDefaultColors(calendarGadget.selector);
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return calendarGadget.ident;
    };
    cGadget.CanvasGadget = function (Gadget, x, y, Width, Height, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var canvasGadget = new cControl(Gadget, x, y, Width, Height, "<canvas />");
        if (cCommon.CheckFlag(Flags, cConstants.PB_Canvas_Border)) {
            canvasGadget.selector.css("border", "1px solid black");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Canvas_ClipMouse)) {
            
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Canvas_DrawFocus)) {
            
        }
        canvasGadget.selector.attr("tabindex", "0");
        canvasGadget.selector.data("PB_Canvas_Buttons", 0);
        canvasGadget.selector.data("PB_Canvas_Modifiers", 0);
        cCommon.CurrentContainer.append(canvasGadget.selector);
        var c = canvasGadget.selector[0];
        c.width = Width;
        c.height = Height;
        canvasGadget.selector.bind("contextmenu", function (e) {
            return false;
        });
        canvasGadget.selector.mousemove(function (event) {
            var rect = canvasGadget.selector[0].getBoundingClientRect();
            canvasGadget.selector.data("PB_Canvas_MouseX", event.clientX - rect.left);
            canvasGadget.selector.data("PB_Canvas_MouseY", event.clientY - rect.top);
        });
        canvasGadget.selector.bind("mousewheel", function (event) {
            canvasGadget.selector.data("PB_Canvas_WheelDelta", event.originalEvent.wheelDelta);
        });
        canvasGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Canvas);
        cGadget.GetDefaultColors(canvasGadget.selector);
        canvasGadget.selector.mouseenter(function () {
            if (canvasGadget.selector.data("onMouseEnter")) {
                cEvent.eventType = cConstants.PB_EventType_MouseEnter;
                cEvent.eventGadget = canvasGadget.ident;
                canvasGadget.selector.data("onMouseEnter")();
            }
        });
        canvasGadget.selector.mouseleave(function () {
            if (canvasGadget.selector.data("onMouseLeave")) {
                cEvent.eventType = cConstants.PB_EventType_MouseLeave;
                cEvent.eventGadget = canvasGadget.ident;
                canvasGadget.selector.data("onMouseLeave")();
            }
        });
        canvasGadget.selector.mousemove(function () {
            if (canvasGadget.selector.data("onMouseMove")) {
                cEvent.eventType = cConstants.PB_EventType_MouseMove;
                cEvent.eventGadget = canvasGadget.ident;
                canvasGadget.selector.data("onMouseMove")();
            }
        });
        canvasGadget.selector.bind("mousewheel", function (event) {
            if (canvasGadget.selector.data("onMouseWheel")) {
                cEvent.eventType = cConstants.PB_EventType_MouseWheel;
                cEvent.eventGadget = canvasGadget.ident;
                canvasGadget.selector.data("onMouseWheel")();
            }
        });
        canvasGadget.selector.mousedown(function (event) {
            if (canvasGadget.selector.data("onLeftButtonDown")) {
                if (event.which === 1) {
                    cEvent.eventType = cConstants.PB_EventType_LeftButtonDown;
                    cEvent.eventGadget = canvasGadget.ident;
                    canvasGadget.selector.data("PB_Canvas_Buttons", canvasGadget.selector.data("PB_Canvas_Buttons") | cConstants.PB_Canvas_LeftButton);
                    canvasGadget.selector.data("onLeftButtonDown")();
                }
            }
            if (canvasGadget.selector.data("onMiddleButtonDown")) {
                if (event.which === 2) {
                    cEvent.eventType = cConstants.PB_EventType_MiddleButtonDown;
                    cEvent.eventGadget = canvasGadget.ident;
                    canvasGadget.selector.data("PB_Canvas_Buttons", canvasGadget.selector.data("PB_Canvas_Buttons") | cConstants.PB_Canvas_MiddleButton);
                    canvasGadget.selector.data("onMiddleButtonDown")();
                }
            }
            if (canvasGadget.selector.data("onRightButtonDown")) {
                if (event.which === 3) {
                    cEvent.eventType = cConstants.PB_EventType_RightButtonDown;
                    cEvent.eventGadget = canvasGadget.ident;
                    canvasGadget.selector.data("PB_Canvas_Buttons", canvasGadget.selector.data("PB_Canvas_Buttons") | cConstants.PB_Canvas_RightButton);
                    canvasGadget.selector.data("onRightButtonDown")();
                }
            }
        });
        canvasGadget.selector.mouseup(function (event) {
            if (canvasGadget.selector.data("onLeftButtonUp")) {
                if (event.which === 1) {
                    cEvent.eventType = cConstants.PB_EventType_LeftButtonUp;
                    cEvent.eventGadget = canvasGadget.ident;
                    canvasGadget.selector.data("PB_Canvas_Buttons", canvasGadget.selector.data("PB_Canvas_Buttons") & ~cConstants.PB_Canvas_LeftButton);
                    canvasGadget.selector.data("onLeftButtonUp")();
                }
            }
            if (canvasGadget.selector.data("onMiddleButtonUp")) {
                if (event.which === 2) {
                    cEvent.eventType = cConstants.PB_EventType_MiddleButtonUp;
                    cEvent.eventGadget = canvasGadget.ident;
                    canvasGadget.selector.data("PB_Canvas_Buttons", canvasGadget.selector.data("PB_Canvas_Buttons") & ~cConstants.PB_Canvas_MiddleButton);
                    canvasGadget.selector.data("onMiddleButtonUp")();
                }
            }
            if (canvasGadget.selector.data("onRightButtonUp")) {
                if (event.which === 3) {
                    cEvent.eventType = cConstants.PB_EventType_RightButtonUp;
                    cEvent.eventGadget = canvasGadget.ident;
                    canvasGadget.selector.data("PB_Canvas_Buttons", canvasGadget.selector.data("PB_Canvas_Buttons") & ~cConstants.PB_Canvas_RightButton);
                    canvasGadget.selector.data("onRightButtonUp")();
                }
            }
        });
        canvasGadget.selector.click(function (event) {
            cEvent.HandleEvent(canvasGadget.selector, event, canvasGadget.ident, cConstants.PB_EventType_LeftClick);
            cEvent.HandleEvent(canvasGadget.selector, event, canvasGadget.ident, cConstants.PB_EventType_RightClick);
        });
        canvasGadget.selector.dblclick(function (event) {
            cEvent.HandleEvent(canvasGadget.selector, event, canvasGadget.ident, cConstants.PB_EventType_LeftDoubleClick);
            cEvent.HandleEvent(canvasGadget.selector, event, canvasGadget.ident, cConstants.PB_EventType_RightDoubleClick);
        });
        canvasGadget.selector.bind({
            focusin: function (event) {
                cEvent.HandleEvent(canvasGadget.selector, event, canvasGadget.ident, cConstants.PB_EventType_Focus);
            }
        });
        canvasGadget.selector.bind({
            focusout: function (event) {
                cEvent.HandleEvent(canvasGadget.selector, event, canvasGadget.ident, cConstants.PB_EventType_LostFocus);
            }
        });
        canvasGadget.selector.keydown(function (event) {
            if (canvasGadget.selector.data("onKeyDown")) {
                cEvent.eventType = cConstants.PB_EventType_KeyDown;
                cEvent.eventGadget = canvasGadget.ident;
                switch (event.which) {
                    case 16:
                        canvasGadget.selector.data("PB_Canvas_Modifiers", canvasGadget.selector.data("PB_Canvas_Modifiers") | cConstants.PB_Canvas_Shift);
                        break;
                    case 17:
                        canvasGadget.selector.data("PB_Canvas_Modifiers", canvasGadget.selector.data("PB_Canvas_Modifiers") | cConstants.PB_Canvas_Control);
                        break;
                    case 18:
                        canvasGadget.selector.data("PB_Canvas_Modifiers", canvasGadget.selector.data("PB_Canvas_Modifiers") | cConstants.PB_Canvas_Alt);
                        break;
                }
                canvasGadget.selector.data("PB_Canvas_Key", event.charCode);
                canvasGadget.selector.data("PB_Canvas_Input", event.charCode);
                canvasGadget.selector.data("onKeyDown")();
            }
        });
        canvasGadget.selector.keyup(function (event) {
            if (canvasGadget.selector.data("onKeyUp")) {
                cEvent.eventType = cConstants.PB_EventType_KeyUp;
                cEvent.eventGadget = canvasGadget.ident;
                switch (event.which) {
                    case 16:
                        canvasGadget.selector.data("PB_Canvas_Modifiers", canvasGadget.selector.data("PB_Canvas_Modifiers") & ~cConstants.PB_Canvas_Shift);
                        break;
                    case 17:
                        canvasGadget.selector.data("PB_Canvas_Modifiers", canvasGadget.selector.data("PB_Canvas_Modifiers") & ~cConstants.PB_Canvas_Control);
                        break;
                    case 18:
                        canvasGadget.selector.data("PB_Canvas_Modifiers", canvasGadget.selector.data("PB_Canvas_Modifiers") & ~cConstants.PB_Canvas_Alt);
                        break;
                }
                canvasGadget.selector.data("onKeyUp")();
            }
        });
        canvasGadget.selector.focus();
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(canvasGadget.ident, $.fn.GadgetsEvents);
        return canvasGadget.ident;
    };
    cGadget.CanvasOutput = function (Gadget) {
        if (cGadget.GadgetType(Gadget) === cConstants.PB_GadgetType_Canvas) {
            return "g_" + Gadget;
        }
        else {
            return "";
        }
    };
    cGadget.CenterGadget = function (Gadget, Direction) {
        if (Direction === void 0) { Direction = cConstants.PB_Center_Both; }
        var selector = $("#g_" + Gadget);
        var parent = selector.parent();
        if (parent.prop("tagName").toLowerCase() === "body")
            parent = $(window);
        var newX = (parent.innerWidth() - selector.outerWidth()) / 2;
        var newY = (parent.innerHeight() - selector.outerHeight()) / 2;
        switch (Direction) {
            case cConstants.PB_Center_Horizontal:
                cGadget.ResizeGadget(Gadget, newX, cConstants.PB_Ignore, cConstants.PB_Ignore, cConstants.PB_Ignore);
                break;
            case cConstants.PB_Center_Vertical:
                cGadget.ResizeGadget(Gadget, cConstants.PB_Ignore, newY, cConstants.PB_Ignore, cConstants.PB_Ignore);
                break;
            case cConstants.PB_Center_Both:
                cGadget.ResizeGadget(Gadget, newX, newY, cConstants.PB_Ignore, cConstants.PB_Ignore);
                break;
        }
    };
    cGadget.GetParentWindow = function (Gadget) {
        var selector = $("#g_" + Gadget);
        if (selector.length) {
            var windowSelector = selector.closest(".ui-dialog-content");
            if (windowSelector.length) {
                return cString.Val(cString.RemoveString(windowSelector.attr("id"), "w_"));
                ;
            }
        }
        return -1;
    };
    cGadget.CheckBoxGadget = function (Gadget, x, y, Width, Height, Text, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<div class='ui-widget' />");
        selector.attr("id", "g_" + Gadget);
        selector.append($("<input  id='g_" + Gadget + "_checkbox' type='checkbox' style='vertical-align:middle' />"));
        selector.append($("<label for='g_" + Gadget + "_checkbox' id='g_" + Gadget + "_label'>" + Text + "</label>"));
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        cCommon.CurrentContainer.append(selector);
        if (cCommon.CheckFlag(Flags, cConstants.PB_CheckBox_Right)) {
            $("#g_" + Gadget + "_label").css("float", "right");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_CheckBox_Center)) {
            
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_CheckBox_ThreeState)) {
            $("#g_" + Gadget + "_checkbox").tristate();
            selector.data("isTriState", true);
        }
        selector.data("GadgetType", cConstants.PB_GadgetType_CheckBox);
        cGadget.GetDefaultColors(selector);
        cFont.SetDefaultFont(selector);
        $("#g_" + Gadget + "_checkbox").click(function (event) {
            cEvent.HandleEvent($("#g_" + Gadget + "_checkbox"), event, Gadget, cConstants.PB_EventType_LeftClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.ClearGadgetItems_ComboBox = function (Gadget) {
        var selector = $("#g_" + Gadget);
        switch (selector.data("cbtype")) {
            case "combobox":
                $("#g_" + Gadget).empty();
                break;
            case "selectmenu":
                var x = cGadget.GadgetX(Gadget);
                var y = cGadget.GadgetY(Gadget);
                var w = cGadget.GadgetWidth(Gadget);
                var h = cGadget.GadgetHeight(Gadget);
                var f = selector.data("flags");
                var p = selector.parent();
                var e1 = selector.data("onChange");
                var e2 = selector.data("onFocus");
                var e3 = selector.data("onLost");
                var oldContainer = cCommon.CurrentContainer;
                cGadget.FreeGadget(Gadget);
                cCommon.CurrentContainer = p;
                cGadget.ComboBoxGadget(Gadget, x, y, w, h, f);
                cCommon.CurrentContainer = oldContainer;
                $("#g_" + Gadget).data("onChange", e1);
                $("#g_" + Gadget).data("onFocus", e2);
                $("#g_" + Gadget).data("onLostFocus", e3);
                break;
            case "simple":
                $("#g_" + Gadget).empty();
                break;
        }
    };
    cGadget.ClearGadgetItems = function (Gadget) {
        var functionName = "ClearGadgetItems";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.ClearGadgetItems_ComboBox(Gadget);
                break;
            case cConstants.PB_GadgetType_Editor:
                selector.val("");
                break;
            case cConstants.PB_GadgetType_Html:
                selector.empty();
                break;
            case cConstants.PB_GadgetType_ListIcon:
                w2ui["w2ui_g_" + Gadget].clear();
                w2ui["w2ui_g_" + Gadget].reset();
                break;
            case cConstants.PB_GadgetType_ListView:
                $("#g_" + Gadget).empty();
                break;
            case cConstants.PB_GadgetType_MDI:
                
                break;
            case cConstants.PB_GadgetType_Panel:
                selector.find("li").remove();
                selector.find("div").remove();
                break;
            case cConstants.PB_GadgetType_Tree:
                selector.fancytree("getRootNode").removeChildren();
                break;
            case cConstants.PB_GadgetType_ScrollArea:
                selector = $("#g_i_" + Gadget);
                selector.empty();
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.CloseGadgetList = function () {
        var functionName = "CloseGadgetList";
        var gadgetType = cCommon.CurrentContainer.data("GadgetType");
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName]();
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName]();
        }
        var currentContainerParent = $(cCommon.CurrentContainer).data("currentContainerParent");
        if (currentContainerParent) {
            cCommon.CurrentContainer = currentContainerParent;
        }
        else {
            if (cCommon.CurrentContainer.hasClass("ui-tabs-panel")) {
                cCommon.CurrentContainer = cCommon.CurrentContainer.parent().parent();
            }
            else {
                cCommon.CurrentContainer = cCommon.CurrentContainer.parent();
            }
        }
    };
    cGadget.cbRenderItem = function (ul, item) {
        var li = $("<li>");
        if ($(item.element[0]).attr("imgs")) {
            var imgs = $(item.element[0]).attr("imgs");
            var imgw = $(item.element[0]).attr("imgw");
            var imgh = $(item.element[0]).attr("imgh");
            li.html("<img src='" + imgs + "' style='vertical-align:middle;width:" + imgw + "px;height:" + imgh + "px;' />&nbsp;" + item.label);
        }
        else {
            li.html(item.label);
        }
        if (item.disabled)
            li.addClass("ui-state-disabled");
        return li.appendTo(ul);
    };
    cGadget.ComboBoxGadget_Simple = function (Gadget, x, y, Width, Height, Flags) {
        Width -= cPixelPerfect.ComboBoxGadgetSimpleWidth;
        Height -= cPixelPerfect.ComboBoxGadgetSimpleHeight;
        var comboBoxGadget = new cControl(Gadget, x, y, Width, Height, "<select />");
        comboBoxGadget.selector.appendTo(cCommon.CurrentContainer);
        comboBoxGadget.selector.attr("size", 1);
        comboBoxGadget.selector.data("cbtype", "simple");
        comboBoxGadget.selector.data("GadgetType", cConstants.PB_GadgetType_ComboBox);
        cGadget.GetDefaultColors(comboBoxGadget.selector);
        var cb;
        comboBoxGadget.selector.bind("change", function (event) {
            cb = comboBoxGadget.selector.data("onLeftClick");
            if (typeof cb === "function") {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_LeftClick;
                cb();
            }
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return comboBoxGadget.ident;
    };
    cGadget.ComboBoxGadget = function (Gadget, x, y, Width, Height, Flags) {
        if (Flags === void 0) { Flags = 0; }
        if (cCommon.CheckFlag(Flags, cConstants.PB_ComboBox_UpperCase)) {
            
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_ComboBox_LowerCase)) {
            
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_ComboBox_Simple)) {
            Gadget = cGadget.ComboBoxGadget_Simple(Gadget, x, y, Width, Height, Flags);
        }
        else if (cCommon.CheckFlag(Flags, cConstants.PB_ComboBox_Editable)) {
            
            return -1;
        }
        else if (cCommon.CheckFlag(Flags, cConstants.PB_ComboBox_Image)) {
            
            return -1;
        }
        else {
            Gadget = cGadget.ComboBoxGadget_Simple(Gadget, x, y, Width, Height, Flags);
        }
        return Gadget;
    };
    cGadget.ContainerGadget = function (Gadget, x, y, Width, Height, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var containerGadget = new cControl(Gadget, x, y, Width, Height, "<div />");
        containerGadget.selector.css("overflow", "auto");
        containerGadget.selector.addClass("ui-widget");
        if (Flags !== cConstants.PB_Container_BorderLess) {
            containerGadget.selector.addClass("ui-widget-content");
            containerGadget.selector.addClass("ui-corner-all");
        }
        containerGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Container);
        cCommon.CurrentContainer.append(containerGadget.selector);
        cCommon.CurrentContainer = containerGadget.selector;
        cGadget.GetDefaultColors(containerGadget.selector);
        cFont.SetDefaultFont(containerGadget.selector);
        containerGadget.selector.bind("scroll", function (event) {
            var cb = containerGadget.selector.data("onScroll");
            if (typeof cb === "function") {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_Scroll;
                cb();
            }
        });
        return containerGadget.ident;
    };
    cGadget.CountGadgetItems_ComboBox = function (selector) {
        return selector.children().length;
    };
    cGadget.CountGadgetItems = function (Gadget) {
        var functionName = "CountGadgetItems";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                return cGadget.CountGadgetItems_ComboBox(selector);
            case cConstants.PB_GadgetType_Editor:
                return selector.text().split("\n").length;
            case cConstants.PB_GadgetType_ExplorerList:
                
                return -1;
            case cConstants.PB_GadgetType_ListIcon:
                return w2ui["w2ui_g_" + Gadget].records.length;
            case cConstants.PB_GadgetType_ListView:
                return $("#g_" + Gadget).children().length;
            case cConstants.PB_GadgetType_MDI:
                
                return -1;
            case cConstants.PB_GadgetType_Panel:
                return $("#g_" + Gadget + " > ul > li").length;
            case cConstants.PB_GadgetType_Tree:
                return selector.fancytree("getTree").count();
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return -1;
        }
    };
    cGadget.DateGadget = function (Gadget, x, y, Width, Height, Mask, xDate, Flags, Callback) {
        if (Mask === void 0) { Mask = ""; }
        if (xDate === void 0) { xDate = 0; }
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        Height -= cPixelPerfect.DateGadgetHeight;
        var dateGadget = new cControl(Gadget, x, y, Width, Height, "<input type='text' />");
        if (Mask === "") {
            Mask = "%dd.%mm.%yyyy # %hh:%ii";
        }
        if (xDate === 0) {
            xDate = moment(new Date()).format("X");
        }
        var isDate = false;
        var isTime = false;
        var isDateTime = false;
        if (cString.FindString(Mask, "%dd") > 0 || cString.FindString(Mask, "%mm") > 0 || cString.FindString(Mask, "%yy") > 0) {
            isDate = true;
        }
        if (cString.FindString(Mask, "%hh") > 0 || cString.FindString(Mask, "%ii") > 0 || cString.FindString(Mask, "%ss") > 0) {
            isTime = true;
        }
        if (isDate && isTime) {
            isDateTime = true;
        }
        Mask = cString.ReplaceString(Mask, "%yyyy", "|" + cString.Chr(249) + "|");
        Mask = cString.ReplaceString(Mask, "%yy", "|" + cString.Chr(250) + "|");
        Mask = cString.ReplaceString(Mask, "%mm", "|" + cString.Chr(251) + "|");
        Mask = cString.ReplaceString(Mask, "%dd", "|" + cString.Chr(252) + "|");
        Mask = cString.ReplaceString(Mask, "%hh", "|" + cString.Chr(253) + "|");
        Mask = cString.ReplaceString(Mask, "%ii", "|" + cString.Chr(254) + "|");
        Mask = cString.ReplaceString(Mask, "%ss", "|" + cString.Chr(255) + "|");
        var replaceArray = new Array("dd", "d", "oo", "o", "DD", "D", "mm", "m", "MM", "M", "YY", "Y", "@", "!", "HH", "H", "hh", "h", "ss", "s", "l", "c", "tt", "t", "TT", "T", "z", "Z");
        for (var counter = 0; counter <= replaceArray.length; counter++) {
            Mask = cString.ReplaceString(Mask, replaceArray[counter], "'" + replaceArray[counter] + "'");
        }
        var DateMask = "";
        if (isDate) {
            DateMask = cString.StringField(Mask, 1, "#");
            if (DateMask) {
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(249) + "|", "yy");
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(250) + "|", "y");
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(251) + "|", "mm");
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(252) + "|", "dd");
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(253) + "|", "");
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(254) + "|", "");
                DateMask = cString.ReplaceString(DateMask, "|" + cString.Chr(255) + "|", "");
                DateMask = cString.Trim(DateMask);
            }
        }
        var TimeMask = "";
        if (isTime) {
            TimeMask = cString.StringField(Mask, 2, "#");
            if (TimeMask) {
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(249) + "|", "");
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(250) + "|", "");
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(251) + "|", "");
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(252) + "|", "");
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(253) + "|", "HH");
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(254) + "|", "mm");
                TimeMask = cString.ReplaceString(TimeMask, "|" + cString.Chr(255) + "|", "ss");
                TimeMask = cString.Trim(TimeMask);
            }
        }
        dateGadget.selector.data("onChange", Callback);
        if (isDateTime === true) {
            dateGadget.selector.datetimepicker({
                dateFormat: DateMask,
                timeFormat: TimeMask
            });
            dateGadget.selector.datetimepicker("setDate", moment.unix(xDate).toDate());
            dateGadget.selector.data("type", "datetimepicker");
        }
        else if (isDate === true) {
            dateGadget.selector.datepicker({
                dateFormat: DateMask
            });
            dateGadget.selector.datepicker("setDate", moment.unix(xDate).toDate());
            dateGadget.selector.data("type", "datepicker");
        }
        else if (isTime === true) {
            dateGadget.selector.datetimepicker({
                timeFormat: TimeMask
            });
            dateGadget.selector.datetimepicker("setDate", moment.unix(xDate).toDate());
            dateGadget.selector.data("type", "timepicker");
        }
        dateGadget.selector.data("Mask", Mask);
        dateGadget.selector.data("Date", xDate);
        dateGadget.selector.data("Flags", Flags);
        dateGadget.selector.addClass("ui-widget ui-widget-content ui-corner-all");
        dateGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Date);
        if (Flags !== 0) {
            
        }
        cCommon.CurrentContainer.append(dateGadget.selector);
        cGadget.GetDefaultColors(dateGadget.selector);
        dateGadget.selector.datepicker('option', 'onClose', function () {
            if (typeof dateGadget.selector.data("onClose") === "function") {
                cEvent.eventGadget = dateGadget.ident;
                cEvent.eventType = cConstants.PB_EventType_CloseItem;
                dateGadget.selector.data("onClose")();
            }
        });
        dateGadget.selector.datepicker('option', 'onSelect', function (selectedDateTime) {
            if (typeof dateGadget.selector.data("onChange") === "function") {
                cEvent.eventGadget = dateGadget.ident;
                cEvent.eventType = cConstants.PB_EventType_Change;
                dateGadget.selector.data("onChange")();
            }
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(dateGadget.ident, $.fn.GadgetsEvents);
        return dateGadget.ident;
    };
    cGadget.DisableGadget_Button = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        if (State) {
            selector.button("disable");
        }
        else {
            selector.button("enable");
        }
    };
    cGadget.DisableGadget = function (Gadget, State) {
        var functionName = "DisableGadget";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized("DisableGadget()");
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, State);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, State);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        var selector1 = $("#g_" + Gadget + "_customcombobox");
                        var selector2 = selector1.find(".ui-button");
                        var selector3 = $("#g_" + Gadget + "_uiautocompleteinput");
                        if (State) {
                            selector1.attr("disabled", "disabled");
                            selector1.addClass("ui-state-disabled");
                            selector2.attr("disabled", "disabled");
                            selector2.addClass("ui-state-disabled");
                            selector3.attr("disabled", "disabled");
                            selector3.addClass("ui-state-disabled");
                        }
                        else {
                            selector1.removeAttr("disabled");
                            selector1.removeClass("ui-state-disabled");
                            selector2.removeAttr("disabled");
                            selector2.removeClass("ui-state-disabled");
                            selector3.removeAttr("disabled");
                            selector3.removeClass("ui-state-disabled");
                        }
                        break;
                    case "selectmenu":
                        if (State) {
                            selector.selectmenu("disable");
                        }
                        else {
                            selector.selectmenu("enable");
                        }
                        break;
                    case "simple":
                        if (State) {
                            selector.attr("disabled", "disabled");
                            selector.addClass("ui-state-disabled");
                        }
                        else {
                            selector.removeAttr("disabled");
                            selector.removeClass("ui-state-disabled");
                        }
                        break;
                }
                break;
            default:
                if (State) {
                    selector.attr("disabled", "disabled");
                    selector.addClass("ui-state-disabled");
                }
                else {
                    selector.removeAttr("disabled");
                    selector.removeClass("ui-state-disabled");
                }
                break;
        }
    };
    cGadget.EditorGadget = function (Gadget, x, y, Width, Height, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        if (!isNaN(Width)) {
            Width -= cPixelPerfect.EditorGadgetWidthOffset;
        }
        if (!isNaN(Height)) {
            Height -= cPixelPerfect.EditorGadgetHeightOffset;
        }
        var editorGadget = new cControl(Gadget, x, y, Width, Height, "<textarea></textarea>");
        cCommon.CurrentContainer.append(editorGadget.selector);
        editorGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Editor);
        if (cCommon.CheckFlag(Flags, cConstants.PB_Editor_ReadOnly)) {
            editorGadget.selector.prop("readonly", true);
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Editor_WordWrap)) {
            editorGadget.selector.removeAttr("wrap");
        }
        else {
            editorGadget.selector.attr("wrap", "off");
        }
        cCommon.SetGadgetPosition(editorGadget.selector, x, y, Width, Height);
        editorGadget.selector.css("wrap", "off");
        editorGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Editor);
        editorGadget.selector.addClass("ui-widget ui-widget-content ui-corner-all");
        cGadget.GetDefaultColors(editorGadget.selector);
        editorGadget.selector.bind("change", function (event) {
            cEvent.HandleEvent(editorGadget.selector, event, editorGadget.ident, cConstants.PB_EventType_Change);
        });
        editorGadget.selector.bind("focus", function (event) {
            cEvent.HandleEvent(editorGadget.selector, event, editorGadget.ident, cConstants.PB_EventType_Focus);
        });
        editorGadget.selector.bind("focusout", function (event) {
            cEvent.HandleEvent(editorGadget.selector, event, editorGadget.ident, cConstants.PB_EventType_LostFocus);
        });
        editorGadget.selector.bind("keypress", function (event) {
            cEvent.HandleEvent(editorGadget.selector, event, editorGadget.ident, cConstants.PB_EventType_ReturnKey);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(editorGadget.ident, $.fn.GadgetsEvents);
        return editorGadget.ident;
    };
    cGadget.ExplorerComboGadget = function (Gadget, x, y, Width, Height, Directory, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return -1;
    };
    cGadget.ExplorerListGadget = function (Gadget, x, y, Width, Height, Directory, Flags) {
        
        return -1;
    };
    cGadget.ExplorerTreeGadget = function (Gadget, x, y, Width, Height, Directory, Flags) {
        
        return -1;
    };
    cGadget.FrameGadget = function (Gadget, x, y, Width, Height, Text, Flags) {
        if (Flags === void 0) { Flags = 0; }
        Width -= cPixelPerfect.FrameGadgetWidthOffset;
        Height -= cPixelPerfect.FrameGadgetHeightOffset;
        var frameGadget = new cControl(Gadget, x, y, Width, Height, "<fieldset />");
        var legend = frameGadget.selector.append("<legend>" + Text + "</legend>");
        cFont.SetDefaultFont(legend);
        frameGadget.selector.css("wrap", "off");
        frameGadget.selector.addClass("ui-widget");
        frameGadget.selector.addClass("ui-widget-content");
        frameGadget.selector.addClass("ui-corner-all");
        frameGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Frame);
        cCommon.CurrentContainer.append(frameGadget.selector);
        cGadget.GetDefaultColors(frameGadget.selector);
        return frameGadget.ident;
    };
    cGadget.FreeGadget_Button = function (Gadget) {
        var selector = $("#g_" + Gadget);
        if (selector.parent().data("GadgetType") === "ButtonsetGadget") {
            var buttonSet = selector.parent();
            selector.remove();
            var bc = buttonSet.find("button").length;
            buttonSet.find("button").css("width", 100 / bc + "%");
            buttonSet.buttonset();
        }
        else {
            $("#g_" + Gadget + "_label").remove();
            selector.remove();
        }
    };
    cGadget.FreeGadget_ComboBox = function (Gadget) {
        var selector = $("#g_" + Gadget);
        switch (selector.data("cbtype")) {
            case "combobox":
                $("#g_" + Gadget).remove();
                $("#g_" + Gadget + "_customcombobox").remove();
                $("#g_" + Gadget + "_uiautocompleteinput").remove();
                $("#g_" + Gadget + "_uihelperhiddenaccessible").remove();
                break;
            case "selectmenu":
                selector.selectmenu();
                selector.selectmenu('destroy');
                break;
            case "simple":
                selector.remove();
                break;
        }
    };
    cGadget.FreeGadget = function (Gadget) {
        var functionName = "FreeGadget";
        var selector;
        if (typeof Gadget === "string") {
            selector = $("#" + Gadget);
        }
        else {
            selector = $("#g_" + Gadget);
        }
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_CheckBox:
            case cConstants.PB_GadgetType_Option:
                $("#g_" + Gadget + "_label").remove();
                break;
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.FreeGadget_ComboBox(Gadget);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                if (w2ui["w2ui_" + Gadget])
                    w2ui["w2ui_" + Gadget].destroy();
                break;
        }
        selector.find('*').each(function () {
            if ($(this).data("GadgetType")) {
                var id = $(this).attr("id");
                cGadget.FreeGadget(id);
            }
        });
        selector.remove();
    };
    cGadget.GadgetHeight = function (Gadget, Mode) {
        if (Mode === void 0) { Mode = -1; }
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GadgetHeight()");
        var gadgetType = cGadget.GadgetType(Gadget);
        var height = 0;
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Button:
                if (selector.is("input")) {
                    height = $("#g_" + Gadget + "_label").outerHeight();
                }
                else {
                    height = selector.outerHeight();
                }
                break;
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        height = $("#g_" + Gadget + "_uiautocompleteinput").outerHeight() + cPixelPerfect.ComboBoxEditableGadgetHeight;
                        break;
                    case "selectmenu":
                        height = $("#g_" + Gadget + "-button").outerHeight() + cPixelPerfect.ComboBoxGadgetHeight;
                        break;
                    case "simple":
                        height = selector.outerHeight() - cPixelPerfect.ComboBoxGadgetSimpleHeight;
                        break;
                }
                break;
            case cConstants.PB_GadgetType_Frame:
                height = selector.outerHeight() + cPixelPerfect.FrameGadgetHeightOffset;
                break;
            case cConstants.PB_GadgetType_Spin:
                height = selector.outerHeight() + cPixelPerfect.SpinGadgetHeightOffset;
                break;
            case cConstants.PB_GadgetType_String:
                height = selector.outerHeight() + cPixelPerfect.StringGadgetHeightOffset;
                break;
            case cConstants.PB_GadgetType_Tree:
                height = selector.outerHeight() + cPixelPerfect.TreeGadgetHeightOffset;
                break;
            case cConstants.PB_GadgetType_Editor:
                height = selector.outerHeight() + cPixelPerfect.EditorGadgetHeightOffset;
                break;
            default:
                height = selector.outerHeight();
                break;
        }
        return Math.round(height);
    };
    cGadget.GadgetID = function (Gadget) {
        return Gadget;
    };
    cGadget.GadgetItemID = function (Gadget, Item) {
        
        return -1;
    };
    cGadget.GadgetToolTip = function (Gadget, Text) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized("GadgetToolTip()");
        }
        switch (cGadget.GadgetType(Gadget)) {
            case cConstants.PB_GadgetType_ComboBox:
                switch ($("#g_" + Gadget).data("cbtype")) {
                    case "combobox":
                        $('#g_' + Gadget + '_customcombobox').children().each(function () { $(this).attr("title", Text); });
                        break;
                    case "selectmenu":
                        $('#g_' + Gadget + '-button').attr("title", Text);
                        break;
                    case "simple":
                        selector.attr("title", Text);
                        break;
                }
                break;
            default:
                selector.attr("title", Text);
                break;
        }
    };
    cGadget.GadgetType = function (Gadget) {
        var selector;
        if (typeof Gadget === "string") {
            selector = $("#" + Gadget);
        }
        else {
            selector = $("#g_" + Gadget);
        }
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GadgetType()");
        return selector.data("GadgetType");
    };
    cGadget.GadgetWidth = function (Gadget, Mode) {
        if (Mode === void 0) { Mode = -1; }
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GadgetWidth()");
        var gadgetType = cGadget.GadgetType(Gadget);
        var width = 0;
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Button:
                if (selector.is("input")) {
                    width = $("#g_" + Gadget + "_label").outerWidth();
                }
                else {
                    width = selector.outerWidth();
                }
                break;
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        width = $("#g_" + Gadget + "_uiautocompleteinput").outerWidth() + cPixelPerfect.ComboBoxEditableGadgetWidth;
                        break;
                    case "selectmenu":
                        width = $("#g_" + Gadget + "-button").outerWidth() + cPixelPerfect.ComboBoxGadgetWidth;
                        break;
                    case "simple":
                        width = selector.outerWidth() - cPixelPerfect.ComboBoxGadgetSimpleWidth;
                        break;
                }
                break;
            case cConstants.PB_GadgetType_Frame:
                width = selector.outerWidth() + cPixelPerfect.FrameGadgetWidthOffset;
                break;
            case cConstants.PB_GadgetType_Spin:
                width = selector.outerWidth() + cPixelPerfect.SpinGadgetWidthOffset;
                break;
            case cConstants.PB_GadgetType_String:
                width = selector.outerWidth() + cPixelPerfect.StringGadgetWidthOffset;
                break;
            case cConstants.PB_GadgetType_Tree:
                width = selector.outerWidth() + cPixelPerfect.TreeGadgetWidthOffset;
                break;
            case cConstants.PB_GadgetType_Editor:
                width = selector.outerWidth() + cPixelPerfect.EditorGadgetWidthOffset;
                break;
            default:
                width = selector.outerWidth();
                break;
        }
        return Math.round(width);
    };
    cGadget.GadgetX = function (Gadget, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var functionName = "GadgetX";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        var left = 0;
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Spin:
                left = selector.spinner("widget").position().left;
                break;
            case cConstants.PB_GadgetType_Button:
                if (selector.is("input")) {
                    left = $("#g_" + Gadget + "_label").position().left;
                }
                else {
                    left = selector.position().left;
                }
                break;
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        left = $("#g_" + Gadget + "_customcombobox").position().left;
                        break;
                    case "selectmenu":
                        left = $("#g_" + Gadget + "-button").position().left;
                        break;
                    case "simple":
                        left = selector.position().left;
                        break;
                }
                break;
            default:
                left = selector.position().left;
                break;
        }
        return Math.round(left);
    };
    cGadget.GadgetY = function (Gadget, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var functionName = "GadgetY";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var top = 0;
        var gadgetType = cGadget.GadgetType(Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Spin:
                top = selector.spinner("widget").position().top;
                break;
            case cConstants.PB_GadgetType_Button:
                if (selector.is("input")) {
                    top = $("#g_" + Gadget + "_label").position().top;
                }
                else {
                    top = selector.position().top;
                }
                break;
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        top = $("#g_" + Gadget + "_customcombobox").position().top;
                        break;
                    case "selectmenu":
                        top = $("#g_" + Gadget + "-button").position().top;
                        break;
                    case "simple":
                        top = selector.position().top;
                        break;
                }
                break;
            default:
                top = selector.position().top;
                break;
        }
        return Math.round(top);
    };
    cGadget.GetActiveGadget = function () {
        var focusedGadget = $("*:focus");
        if (focusedGadget.length > 0)
            return parseInt(focusedGadget.attr("id").substring(2));
        return -1;
    };
    cGadget.GetGadgetAttr = function (Gadget, propertyName) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GetGadgetAttr()");
        return selector.attr(propertyName);
    };
    cGadget.GetGadgetAttribute_Calendar = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Date_Minimum:
                return parseInt(moment(selector.datepicker('option', 'minDate')).format("X"));
            case cConstants.PB_Date_Maximum:
                return parseInt(moment(selector.datepicker('option', 'maxDate')).format("X"));
            default:
                return -1;
        }
    };
    cGadget.GetGadgetAttribute_Canvas = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Canvas_MouseX: return (selector.data("PB_Canvas_MouseX")) ? selector.data("PB_Canvas_MouseX") : 0;
            case cConstants.PB_Canvas_MouseY: return (selector.data("PB_Canvas_MouseY")) ? selector.data("PB_Canvas_MouseY") : 0;
            case cConstants.PB_Canvas_Buttons: return (selector.data("PB_Canvas_Buttons")) ? selector.data("PB_Canvas_Buttons") : 0;
            case cConstants.PB_Canvas_Modifiers: return selector.data("PB_Canvas_Modifiers");
            case cConstants.PB_Canvas_WheelDelta: return (selector.data("PB_Canvas_WheelDelta")) ? selector.data("PB_Canvas_WheelDelta") : 0;
            case cConstants.PB_Canvas_Key: return selector.data("PB_Canvas_Key");
            case cConstants.PB_Canvas_Input: return selector.data("PB_Canvas_Input");
            case cConstants.PB_Canvas_Image: return selector.data("PB_Canvas_Image");
            case cConstants.PB_Canvas_Clip: return selector.data("PB_Canvas_Clip");
            case cConstants.PB_Canvas_Cursor: return selector.data("PB_Canvas_Cursor");
            case cConstants.PB_Canvas_CustomCursor: return selector.data("PB_Canvas_CustomCursor");
            default: return -1;
        }
    };
    cGadget.GetGadgetAttribute_Editor = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Editor_ReadOnly:
                if (selector.is('[readonly]'))
                    return 1;
                return 0;
            case cConstants.PB_Editor_WordWrap:
                if (selector.attr("wrap") === "off")
                    return 0;
                return 1;
        }
    };
    cGadget.GetGadgetAttribute_Date = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Date_Minimum:
                return parseInt(moment(selector.datepicker('option', 'minDate')).format("X"));
            case cConstants.PB_Date_Maximum:
                return parseInt(moment(selector.datepicker('option', 'maxDate')).format("X"));
            default:
                return -1;
        }
    };
    cGadget.GetGadgetAttribute_Panel = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        var tabsPanel = selector.find(".ui-tabs-panel");
        var tabsNav = selector.find(".ui-tabs-nav");
        switch (Attribute) {
            case cConstants.PB_Panel_ItemWidth:
                return tabsPanel.width();
            case cConstants.PB_Panel_ItemHeight:
                return tabsPanel.height();
            case cConstants.PB_Panel_TabHeight:
                return tabsNav.height();
            default:
                
                return -1;
        }
    };
    cGadget.GetGadgetAttribute_ProgressBar = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_ProgressBar_Minimum:
                
                return -1;
            case cConstants.PB_ProgressBar_Maximum:
                return selector.progressbar("option", "max");
            default:
                cCommon.UnsupportedGadgetAttribute("GetGadgetAttribute", Gadget);
                return -1;
        }
    };
    cGadget.GetGadgetAttribute_ScrollArea = function (Gadget, Attribute) {
        var selector = $("#g_i_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_ScrollArea_InnerWidth:
                return selector.width();
            case cConstants.PB_ScrollArea_InnerHeight:
                return selector.height();
            case cConstants.PB_ScrollArea_X:
                return selector.parent().offset().left - selector.offset().left;
            case cConstants.PB_ScrollArea_Y:
                return selector.parent().offset().top - selector.offset().top;
            case cConstants.PB_ScrollArea_ScrollStep:
                
                return -1;
        }
    };
    cGadget.GetGadgetAttribute_Spin = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Spin_Minimum: return selector.spinner("option", "min");
            case cConstants.PB_Spin_Maximum: return selector.spinner("option", "max");
            case cConstants.PB_Spin_Step: return selector.spinner("option", "step");
            default: return -1;
        }
    };
    cGadget.GetGadgetAttribute_String = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_String_Autocomplete_Datasource:
                return selector.autocomplete("option", "source");
            case cConstants.PB_String_Autocomplete_MinLength:
                return selector.autocomplete("option", "minLength");
            case cConstants.PB_String_Required:
                return selector.prop("required");
            default:
                return -1;
        }
    };
    cGadget.GetGadgetAttribute_TrackBar = function (Gadget, Attribute) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_TrackBar_Minimum: return selector.slider("option", "min");
            case cConstants.PB_TrackBar_Maximum: return selector.slider("option", "max");
            default: return -1;
        }
    };
    cGadget.GetGadgetAttribute = function (Gadget, Attribute) {
        var functionName = "GetGadgetAttribute";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget, Attribute);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget, Attribute);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Calendar:
                return cGadget.GetGadgetAttribute_Calendar(Gadget, Attribute);
            case cConstants.PB_GadgetType_Canvas:
                return cGadget.GetGadgetAttribute_Canvas(Gadget, Attribute);
            case cConstants.PB_GadgetType_Editor:
                return cGadget.GetGadgetAttribute_Editor(Gadget, Attribute);
            case cConstants.PB_GadgetType_Date:
                return cGadget.GetGadgetAttribute_Date(Gadget, Attribute);
            case cConstants.PB_GadgetType_Panel:
                return cGadget.GetGadgetAttribute_Panel(Gadget, Attribute);
            case cConstants.PB_GadgetType_ProgressBar:
                return cGadget.GetGadgetAttribute_ProgressBar(Gadget, Attribute);
            case cConstants.PB_GadgetType_ScrollArea:
                return cGadget.GetGadgetAttribute_ScrollArea(Gadget, Attribute);
            case cConstants.PB_GadgetType_Spin:
                return cGadget.GetGadgetAttribute_Spin(Gadget, Attribute);
            case cConstants.PB_GadgetType_String:
                return cGadget.GetGadgetAttribute_String(Gadget, Attribute);
            case cConstants.PB_GadgetType_TrackBar:
                return cGadget.GetGadgetAttribute_TrackBar(Gadget, Attribute);
            case cConstants.PB_GadgetType_ButtonImage:
            case cConstants.PB_GadgetType_Date:
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_ListIcon:
            case cConstants.PB_GadgetType_ScrollBar:
            case cConstants.PB_GadgetType_Splitter:
            case cConstants.PB_GadgetType_Web:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return -1;
        }
    };
    cGadget.GetGadgetColor = function (Gadget, ColorType) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GetGadgetColor()");
        var color = "-1";
        var defaultColor = "-1";
        switch (ColorType) {
            case cConstants.PB_Gadget_FrontColor:
                color = selector.css("color");
                defaultColor = selector.data("defaultFrontColor");
                if (color === defaultColor)
                    color = "-1";
                break;
            case cConstants.PB_Gadget_BackColor:
                color = selector.css("background-color");
                defaultColor = selector.data("defaultBackColor");
                if (color === defaultColor)
                    color = "-1";
                break;
            case cConstants.PB_Gadget_LineColor:
                
                break;
            case cConstants.PB_Gadget_TitleFrontColor:
                
                break;
            case cConstants.PB_Gadget_TitleBackColor:
                
                break;
            case cConstants.PB_Gadget_GrayTextColor:
                
                break;
            default:
                
                break;
        }
        if (color !== null && color !== "-1") {
            var colorhex = cCommon.bgr2hex(color);
            color = cCommon.hex2decimal(cString.Mid(colorhex, 2)).toString();
        }
        return parseInt(color);
    };
    cGadget.GetGadgetCss = function (Gadget, propertyName) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GetGadgetCss()");
        return selector.css(propertyName);
    };
    cGadget.GetGadgetData = function (Gadget, Key) {
        if (Key === void 0) { Key = "data"; }
        var functionName = "GetGadgetData";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        if (selector.data(Key) === undefined)
            return 0;
        return selector.data(Key);
    };
    cGadget.GetGadgetFont = function (Gadget) {
        
        return -1;
    };
    cGadget.GetGadgetHtml = function (Gadget, Html) {
        var functionName = "GetGadgetHtml";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget, Html);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget, Html);
    };
    cGadget.GetGadgetItemAttribute = function (Gadget, Item, Attribute, Column) {
        if (Column === void 0) { Column = 0; }
        var functionName = "GetGadgetItemAttribute";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, Attribute, Column);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, Attribute, Column);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ExplorerList:
                cCommon.NotSupported(functionName + " / " + gadgetType);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                if (Attribute === cConstants.PB_ListIcon_ColumnWidth) {
                    if (w2ui["w2ui_g_" + Gadget].columns[Column])
                        return parseInt(w2ui["w2ui_g_" + Gadget].columns[Column].size);
                    return 0;
                }
                else {
                    
                }
                break;
            case cConstants.PB_GadgetType_Tree:
                cCommon.NotSupported(functionName + " / " + gadgetType);
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
        return -1;
    };
    cGadget.GetGadgetItemColor = function (Gadget, Item, ColorType, Column) {
        if (Column === void 0) { Column = 0; }
        
        return -1;
    };
    cGadget.GetGadgetItemData = function (Gadget, Item, Key) {
        if (Key === void 0) { Key = "data"; }
        var functionName = "GetGadgetItemData";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var data = selector.data(Key + "|" + Item);
        if (data === undefined)
            return 0;
        return data;
    };
    cGadget.GetGadgetItemState_ListIcon = function (Gadget, Item) {
        var returnValue = 0;
        var selectedRecords = w2ui["w2ui_g_" + Gadget].getSelection(true);
        if ($.inArray(Item, selectedRecords) > -1) {
            returnValue = cConstants.PB_ListIcon_Selected;
        }
        return returnValue;
    };
    cGadget.GetGadgetItemState_String = function (Gadget, Item) {
        var selector = $("#g_" + Gadget);
        if (Item === cConstants.PB_String_IsValid) {
            if (selector.attr("pattern")) {
                if (selector.val().match(new RegExp(selector.attr("pattern")))) {
                    return true;
                }
                else {
                    return false;
                }
            }
            else {
                return selector[0].checkValidity();
            }
        }
    };
    cGadget.GetGadgetItemState_Tree = function (Gadget, Item) {
        var selector = $("#g_" + Gadget);
        var tree = selector.fancytree("getTree");
        var match = null;
        var pos = 0;
        tree.visit(function (node) {
            if (pos === Item) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (match === null) {
            return 0;
        }
        var Flags = 0;
        if (match.isActive()) {
            Flags |= cConstants.PB_Tree_Selected;
        }
        if (match.isSelected()) {
            Flags |= cConstants.PB_Tree_Checked;
        }
        if (match.isExpanded()) {
            Flags |= cConstants.PB_Tree_Expanded;
        }
        else {
            Flags |= cConstants.PB_Tree_Collapsed;
        }
        return Flags;
    };
    cGadget.GetGadgetItemState = function (Gadget, Item) {
        var functionName = "GetGadgetItemState";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ListIcon:
                return cGadget.GetGadgetItemState_ListIcon(Gadget, Item);
            case cConstants.PB_GadgetType_String:
                return cGadget.GetGadgetItemState_String(Gadget, Item);
            case cConstants.PB_GadgetType_Tree:
                return cGadget.GetGadgetItemState_Tree(Gadget, Item);
            case cConstants.PB_GadgetType_Calendar:
            case cConstants.PB_GadgetType_ExplorerList:
                
                return -1;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return -1;
        }
    };
    cGadget.GetGadgetItemText_ComboBox = function (Gadget, Item, Column) {
        var selector = $("#g_" + Gadget);
        var liArray = selector.children().toArray();
        if (liArray === null || liArray.length === 0)
            return "";
        if (Item < 0)
            Item = 0;
        if (Item > liArray.length - 1)
            Item = liArray.length - 1;
        return $(liArray[Item]).text();
    };
    cGadget.GetGadgetItemText_Editor = function (Gadget, Item, Column) {
        var selector = $("#g_" + Gadget);
        var editorContent = selector.val();
        var textArray = editorContent.split("\n");
        if (Item < 0)
            Item = 0;
        if (Item > textArray.length - 1)
            Item = textArray.length - 1;
        return textArray[Item];
    };
    cGadget.GetGadgetItemText_ListIcon = function (Gadget, Item, Column) {
        var Columns = w2ui["w2ui_g_" + Gadget].columns;
        if (Column === -1)
            Column = 0;
        if (Item === -1) {
            try {
                return Columns[Column].caption;
            }
            catch (e) {
                return "";
            }
        }
        else {
            try {
                return w2ui["w2ui_g_" + Gadget].records[Item][Columns[Column].field];
            }
            catch (e) {
                return "";
            }
        }
    };
    cGadget.GetGadgetItemText_ListView = function (Gadget, Item, Column) {
        var selector = $("#g_" + Gadget);
        return selector.find("option:eq(" + Item + ")").text();
    };
    cGadget.GetGadgetItemText_Tree = function (Gadget, Item, Column) {
        var selector = $("#g_" + Gadget);
        var tree = selector.fancytree("getTree");
        var match = null;
        var pos = 0;
        tree.visit(function (node) {
            if (pos === Item) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (match === null)
            return "";
        return match.title;
    };
    cGadget.GetGadgetItemText_Web = function (Gadget, Item, Column) {
        var returnValue = "";
        var selector = $("#g_" + Gadget);
        switch (Item) {
            case cConstants.PB_Web_HtmlCode:
                try {
                    var myIFrameElement = selector[0];
                    if (myIFrameElement) {
                        var myDocument = myIFrameElement.contentWindow.document;
                        if (myDocument) {
                            returnValue = myDocument.body.innerHTML;
                        }
                    }
                }
                catch (exception) {
                    returnValue = exception;
                }
                break;
            case cConstants.PB_Web_PageTitle:
                try {
                    var myIFrameElement = selector[0];
                    if (myIFrameElement) {
                        var myDocument = myIFrameElement.contentWindow.document;
                        if (myDocument) {
                            returnValue = myDocument.title;
                        }
                    }
                }
                catch (exception) {
                    returnValue = exception;
                }
                break;
            case cConstants.PB_Web_StatusMessage:
                
                break;
            case cConstants.PB_Web_SelectedText:
                
                break;
        }
        return returnValue;
    };
    cGadget.GetGadgetItemText = function (Gadget, Item, Column) {
        if (Column === void 0) { Column = cConstants.PB_Ignore; }
        var functionName = "GetGadgetItemText";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, Column);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, Column);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                return cGadget.GetGadgetItemText_ComboBox(Gadget, Item, Column);
            case cConstants.PB_GadgetType_Editor:
                return cGadget.GetGadgetItemText_Editor(Gadget, Item, Column);
            case cConstants.PB_GadgetType_ListIcon:
                return cGadget.GetGadgetItemText_ListIcon(Gadget, Item, Column);
            case cConstants.PB_GadgetType_ListView:
                return cGadget.GetGadgetItemText_ListView(Gadget, Item, Column);
            case cConstants.PB_GadgetType_Panel:
                return selector.find("li:eq(" + Item + ") a").text();
            case cConstants.PB_GadgetType_Tree:
                return cGadget.GetGadgetItemText_Tree(Gadget, Item, Column);
            case cConstants.PB_GadgetType_Web:
                return cGadget.GetGadgetItemText_Web(Gadget, Item, Column);
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_MDI:
                
                return "";
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return "";
        }
    };
    cGadget.GetGadgetState_Button = function (Gadget) {
        var selector = $("#g_" + Gadget);
        if (selector.is("input")) {
            if (selector.is(':checked'))
                return 1;
            return 0;
        }
        return 0;
    };
    cGadget.GetGadgetState_Calendar = function (selector) {
        return parseInt(moment(selector.datepicker("getDate")).format("X"));
    };
    cGadget.GetGadgetState_CheckBox = function (selector) {
        if (selector.find("input").is(':checked')) {
            return cConstants.PB_Checkbox_Checked;
        }
        else if (selector.find("input").is(':indeterminate')) {
            return cConstants.PB_Checkbox_Inbetween;
        }
        else {
            return cConstants.PB_Checkbox_Unchecked;
        }
    };
    cGadget.GetGadgetState_ComboBox = function (selector) {
        return selector.prop("selectedIndex");
    };
    cGadget.GetGadgetState_Date = function (selector) {
        switch (selector.data("type")) {
            case "datetimepicker": return parseInt(moment(selector.datetimepicker("getDate")).format("X"));
            case "datepicker": return parseInt(moment(selector.datepicker("getDate")).format("X"));
            case "timepicker": return parseInt(moment(selector.datetimepicker("getDate")).format("X"));
        }
        return 0;
    };
    cGadget.GetGadgetState_Image = function (selector) {
        if (selector.attr("src") == cCommon.EmptyImage)
            return 0;
        return selector.attr("src");
    };
    cGadget.GetGadgetState_ListIcon = function (Gadget) {
        if (w2ui["w2ui_g_" + Gadget].getSelection().length === 0)
            return -1;
        return w2ui["w2ui_g_" + Gadget].getSelection(true)[0];
    };
    cGadget.GetGadgetState_ListView = function (Gadget) {
        var selectedIndex = $("#g_" + Gadget + " option").index($("#g_" + Gadget + " option").filter(":selected"));
        if (typeof (selectedIndex) === "undefined")
            selectedIndex = -1;
        return selectedIndex;
    };
    cGadget.GetGadgetState_Option = function (selector) {
        if (selector.find("input").is(':checked'))
            return 1;
        return 0;
    };
    cGadget.GetGadgetState_Splitter = function (Gadget) {
        var selector = $("#g_" + Gadget);
        var splitterGadget = selector.split({});
        return splitterGadget.position();
    };
    cGadget.GetGadgetState_Tree = function (selector) {
        var activeNode = selector.fancytree("getActiveNode");
        if (activeNode === null)
            return -1;
        var match = null;
        var pos = 0;
        selector.fancytree("getTree").visit(function (node) {
            if (node === activeNode) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (match !== null)
            return pos;
        return -1;
    };
    cGadget.GetGadgetState = function (Gadget) {
        var functionName = "GetGadgetState";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Calendar:
                return cGadget.GetGadgetState_Calendar(selector);
            case cConstants.PB_GadgetType_CheckBox:
                return cGadget.GetGadgetState_CheckBox(selector);
            case cConstants.PB_GadgetType_ComboBox:
                return cGadget.GetGadgetState_ComboBox(selector);
            case cConstants.PB_GadgetType_Date:
                return cGadget.GetGadgetState_Date(selector);
            case cConstants.PB_GadgetType_Image:
                return cGadget.GetGadgetState_Image(selector);
            case cConstants.PB_GadgetType_ListIcon:
                return cGadget.GetGadgetState_ListIcon(Gadget);
            case cConstants.PB_GadgetType_ListView:
                return cGadget.GetGadgetState_ListView(Gadget);
            case cConstants.PB_GadgetType_Option:
                return cGadget.GetGadgetState_Option(selector);
            case cConstants.PB_GadgetType_Panel:
                return selector.tabs("option", "active");
            case cConstants.PB_GadgetType_ProgressBar:
                return selector.progressbar("option", "value");
            case cConstants.PB_GadgetType_Spin:
                return selector.spinner("value");
            case cConstants.PB_GadgetType_Splitter:
                return cGadget.GetGadgetState_Splitter(Gadget);
            case cConstants.PB_GadgetType_TrackBar:
                return selector.slider("option", "value");
            case cConstants.PB_GadgetType_Tree:
                return cGadget.GetGadgetState_Tree(selector);
            case cConstants.PB_GadgetType_ButtonImage:
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_ExplorerTree:
            case cConstants.PB_GadgetType_IPAddress:
            case cConstants.PB_GadgetType_MDI:
            case cConstants.PB_GadgetType_Shortcut:
            case cConstants.PB_GadgetType_ScrollBar:
                
                return null;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return null;
        }
    };
    cGadget.GetGadgetCsv = function (Gadget, IncludeHeader, FieldDelimiter, TextDelimiter) {
        if (IncludeHeader === void 0) { IncludeHeader = true; }
        if (FieldDelimiter === void 0) { FieldDelimiter = ";"; }
        if (TextDelimiter === void 0) { TextDelimiter = cString.Chr(34); }
        var functionName = "GetGadgetCsv";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ListIcon:
                var data = [];
                var ReturnArray = [];
                var Columns = w2ui["w2ui_g_" + Gadget].columns;
                if (IncludeHeader) {
                    for (var i = 0; i < Columns.length; i++) {
                        data.push(Columns[i].caption);
                    }
                    ReturnArray.push(TextDelimiter + data.join(TextDelimiter + FieldDelimiter + TextDelimiter) + TextDelimiter);
                }
                var Records = w2ui["w2ui_g_" + Gadget].records;
                data = [];
                for (var recordCounter = 0; recordCounter < Records.length; recordCounter++) {
                    for (var columnCounter = 0; columnCounter < Columns.length; columnCounter++) {
                        data.push(Records[recordCounter][Columns[columnCounter].field]);
                    }
                    ReturnArray.push(TextDelimiter + data.join(TextDelimiter + FieldDelimiter + TextDelimiter) + TextDelimiter);
                    data = [];
                }
                return ReturnArray.join('\r\n');
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return "";
        }
    };
    cGadget.GetGadgetText_Button = function (Gadget) {
        var selector = $("#g_" + Gadget);
        if (selector.is("input")) {
            return $("#g_" + Gadget + "_label").text();
        }
        else {
            return selector.button().text();
        }
    };
    cGadget.GetGadgetText_ComboBox = function (Gadget) {
        switch ($("#g_" + Gadget).data("cbtype")) {
            case "combobox":
                return $("#g_" + Gadget + "_uiautocompleteinput").val();
            case "selectmenu":
                return $("#g_" + Gadget + "-button").find(".ui-selectmenu-text").html();
            case "simple":
                return $("#g_" + Gadget).find("option:selected").text();
        }
    };
    cGadget.GetGadgetText_ListIcon = function (Gadget, Attribute) {
        switch (Attribute) {
            case cConstants.PB_ListIcon_Changed:
                return JSON.stringify(w2ui["w2ui_g_" + Gadget].getChanges());
            default:
                var selectedItem = cGadget.GetGadgetState(Gadget);
                if (selectedItem > -1) {
                    var Columns = w2ui["w2ui_g_" + Gadget].columns;
                    return w2ui["w2ui_g_" + Gadget].records[selectedItem][Columns[0].field];
                }
                else {
                    return "";
                }
        }
    };
    cGadget.GetGadgetText_ListView = function (Gadget) {
        var selector = $("#g_" + Gadget);
        return selector.val();
    };
    cGadget.GetGadgetText_Tree = function (Gadget) {
        var selector = $("#g_" + Gadget);
        var node = selector.fancytree("getActiveNode");
        if (node)
            return node.title;
        return "";
    };
    cGadget.GetGadgetText = function (Gadget, Attribute) {
        if (Attribute === void 0) { Attribute = 0; }
        var functionName = "GetGadgetText";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget, Text);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget, Text);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_CheckBox:
                return selector.find("label").html();
            case cConstants.PB_GadgetType_ComboBox:
                return cGadget.GetGadgetText_ComboBox(Gadget);
            case cConstants.PB_GadgetType_Date:
                return selector.val();
            case cConstants.PB_GadgetType_Editor:
                return selector.val();
            case cConstants.PB_GadgetType_Html:
                return selector.html();
            case cConstants.PB_GadgetType_ListIcon:
                return cGadget.GetGadgetText_ListIcon(Gadget, Attribute);
            case cConstants.PB_GadgetType_ListView:
                return cGadget.GetGadgetText_ListView(Gadget);
            case cConstants.PB_GadgetType_Option:
                return selector.find("label").html();
            case cConstants.PB_GadgetType_Spin:
                return cString.Str(selector.spinner("value"));
            case cConstants.PB_GadgetType_String:
                return selector.val();
            case cConstants.PB_GadgetType_Text:
            case cConstants.PB_GadgetType_HyperLink:
                return selector.html();
            case cConstants.PB_GadgetType_Tree:
                return cGadget.GetGadgetText_Tree(Gadget);
            case cConstants.PB_GadgetType_Web:
                return selector.attr("src");
            case cConstants.PB_GadgetType_ExplorerCombo:
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_ExplorerTree:
                
                return "";
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                return "";
        }
    };
    cGadget.HideGadget = function (Gadget, State, Effect, Duration, Callback) {
        if (Effect === void 0) { Effect = ""; }
        if (Duration === void 0) { Duration = 0; }
        if (Callback === void 0) { Callback = null; }
        var functionName = "HideGadget";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName))
            return p2w_UserGadget[gadgetType][functionName](Gadget, State, Duration, Callback);
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName))
            return p2w_PbGadget[gadgetType][functionName](Gadget, State, Duration, Callback);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        selector = $("#g_" + Gadget + "_customcombobox");
                        break;
                    case "selectmenu":
                        selector = selector.selectmenu("widget");
                        break;
                    case "simple":
                        break;
                }
                break;
        }
        if (State === true || State === 1) {
            if ((Duration > 0) && (Callback !== null)) {
                selector.fadeOut(Duration, function () {
                    Callback();
                });
            }
            else {
                selector.hide();
            }
        }
        else {
            if ((Duration > 0) && (Callback !== null)) {
                selector.fadeIn(Duration, function () {
                    Callback();
                });
            }
            else {
                selector.show();
            }
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ListIcon:
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
        }
    };
    cGadget.HtmlGadget = function (Gadget, x, y, Width, Height, Html) {
        var htmlGadget = new cControl(Gadget, x, y, Width, Height, Html);
        cCommon.CurrentContainer.append(htmlGadget.selector);
        htmlGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Html);
        cGadget.GetDefaultColors(htmlGadget.selector);
        cFont.SetDefaultFont(htmlGadget.selector);
        htmlGadget.selector.bind("click", function (event) {
            cEvent.HandleEvent(htmlGadget.selector, event, htmlGadget.ident, cConstants.PB_EventType_LeftClick);
        });
        htmlGadget.selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(htmlGadget.selector, event, htmlGadget.ident, cConstants.PB_EventType_LeftDoubleClick);
        });
        htmlGadget.selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(htmlGadget.selector, event, htmlGadget.ident, cConstants.PB_EventType_RightClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(htmlGadget.ident, $.fn.GadgetsEvents);
        return htmlGadget.ident;
    };
    cGadget.HyperLinkGadget = function (Gadget, x, y, Width, Height, Text, Color, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var hyperLinkGadget = new cControl(Gadget, x, y, Width, Height, "<label />");
        hyperLinkGadget.selector.html(Text);
        hyperLinkGadget.selector.css("overflow", "hidden");
        hyperLinkGadget.selector.css("white-space", "pre-wrap");
        if (Height === -1) {
            hyperLinkGadget.selector.css("height", "auto");
        }
        else {
            hyperLinkGadget.selector.css("height", Height);
        }
        hyperLinkGadget.selector.data("GadgetType", cConstants.PB_GadgetType_HyperLink);
        cCommon.CurrentContainer.append(hyperLinkGadget.selector);
        cGadget.SetGadgetColor(hyperLinkGadget.ident, cConstants.PB_Gadget_FrontColor, Color);
        cGadget.SetGadgetCursor(hyperLinkGadget.ident, cConstants.PB_Cursor_Hand);
        if (cCommon.CheckFlag(Flags, cConstants.PB_HyperLink_Underline)) {
            hyperLinkGadget.selector.css("text-decoration", "underline !important");
        }
        cGadget.GetDefaultColors(hyperLinkGadget.selector);
        hyperLinkGadget.selector.click(function (event) {
            cEvent.HandleEvent(hyperLinkGadget.selector, event, hyperLinkGadget.ident, cConstants.PB_EventType_LeftClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(hyperLinkGadget.ident, $.fn.GadgetsEvents);
        return hyperLinkGadget.ident;
    };
    cGadget.IFrameGadget = function (Gadget, x, y, Width, Height) {
        var iFrameGadget = new cControl(Gadget, x, y, Width, Height, "<iframe />");
        iFrameGadget.selector.css("border", "1px solid black");
        iFrameGadget.selector.css("frameborder", "0");
        iFrameGadget.selector.data("GadgetType", cConstants.PB_GadgetType_IFrame);
        cCommon.CurrentContainer.append(iFrameGadget.selector);
        cCommon.CurrentContainer = iFrameGadget.selector.contents().find("body");
        cGadget.GetDefaultColors(iFrameGadget.selector);
        return iFrameGadget.ident;
    };
    cGadget.ImageGadget = function (Gadget, x, y, Width, Height, ImageID, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var imageGadget = new cControl(Gadget, x, y, Width, Height, "<img />");
        cCommon.CurrentContainer.append(imageGadget.selector);
        if (cString.StartsWith(ImageID, "data:image")) {
            imageGadget.selector.attr("src", ImageID);
        }
        else {
            var img = cCommon.P2W_ImageList[ImageID];
            if (img != null) {
                imageGadget.selector.attr("src", img.src);
            }
            else {
                imageGadget.selector.attr("src", cCommon.EmptyImage);
            }
        }
        var tempImage = new Image();
        if (cString.StartsWith(ImageID, "data:image")) {
            tempImage.src = ImageID;
        }
        else {
            var img = cCommon.P2W_ImageList[ImageID];
            if (img != null) {
                tempImage.src = img.src;
            }
            else {
                tempImage.src = cCommon.EmptyImage;
            }
        }
        var imageWidth = tempImage.width;
        var imageHeight = tempImage.height;
        tempImage = null;
        if (Height === -1 || Height === cConstants.PB_Ignore) {
            $("#g_" + imageGadget.ident).css({ "height": imageHeight });
        }
        else {
            imageGadget.selector.css("height", Height);
        }
        if (Width === -1 || Width === cConstants.PB_Ignore) {
            $("#g_" + imageGadget.ident).css({ "width": imageWidth });
        }
        else {
            imageGadget.selector.css("width", Width);
        }
        imageGadget.selector.css("position", "absolute");
        imageGadget.selector.css("left", x);
        imageGadget.selector.css("top", y);
        imageGadget.selector.addClass("p2w-gadget");
        imageGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Image);
        if (cCommon.CheckFlag(Flags, cConstants.PB_Image_Border)) {
            imageGadget.selector.css("border", "1px solid black");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Image_Raised)) {
            
        }
        cGadget.GetDefaultColors(imageGadget.selector);
        imageGadget.selector.bind("click", function (event) {
            cEvent.HandleEvent(imageGadget.selector, event, imageGadget.ident, cConstants.PB_EventType_LeftClick);
        });
        imageGadget.selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(imageGadget.selector, event, imageGadget.ident, cConstants.PB_EventType_LeftDoubleClick);
        });
        imageGadget.selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(imageGadget.selector, event, imageGadget.ident, cConstants.PB_EventType_RightClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(imageGadget.ident, $.fn.GadgetsEvents);
        return imageGadget.ident;
    };
    cGadget.IPAddressGadget = function (Gadget, x, y, Width, Height) {
        
        return -1;
    };
    cGadget.IsGadget = function (Gadget) {
        return $("#g_" + Gadget).length > 0;
    };
    cGadget.ListIconGadget = function (Gadget, x, y, Width, Height, Title, TitleWidth, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var s;
        if (Flags === 0) {
            s = {
                header: false,
                toolbar: false,
                footer: false,
                columnHeaders: true,
                lineNumbers: false,
                expandColumn: false,
                selectColumn: false,
                emptyRecords: true,
                toolbarReload: true,
                toolbarColumns: true,
                toolbarSearch: true,
                toolbarAdd: true,
                toolbarEdit: true,
                toolbarDelete: true,
                toolbarSave: true,
                selectionBorder: true,
                recordTitles: true,
                skipRecords: true,
                multiSelect: false,
                reorderColumns: false
            };
        }
        else {
            s = {
                header: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_Header),
                toolbar: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_Toolbar),
                footer: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_Footer),
                columnHeaders: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ColumnHeaders),
                lineNumbers: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_LineNumbers),
                expandColumn: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ExpandColumn),
                selectColumn: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_SelectColumn),
                emptyRecords: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_EmptyRecords),
                toolbarReload: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarReload),
                toolbarColumns: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarColumns),
                toolbarSearch: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarSearch),
                toolbarAdd: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarAdd),
                toolbarEdit: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarEdit),
                toolbarDelete: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarDelete),
                toolbarSave: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_ToolbarSave),
                selectionBorder: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_SelectionBorder),
                recordTitles: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_RecordTitles),
                skipRecords: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_SkipRecords),
                multiSelect: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_MultiSelect),
                reorderColumns: cCommon.CheckFlag(Flags, cConstants.PB_ListIcon_HeaderDragDrop)
            };
        }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<div />");
        selector.attr("id", "g_" + Gadget);
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        cCommon.CurrentContainer.append(selector);
        selector.data("GadgetType", cConstants.PB_GadgetType_ListIcon);
        selector.w2grid({
            name: "w2ui_g_" + Gadget,
            show: s,
            multiSelect: s.multiSelect,
            reorderColumns: s.reorderColumns
        });
        selector.data("ColumnDelimiter", cString.Chr(10));
        selector.data("RecordDelimiter", cString.Chr(13));
        cGadget.AddGadgetColumn(Gadget, 0, Title, TitleWidth);
        w2ui["w2ui_g_" + Gadget].refresh();
        var cb;
        w2ui["w2ui_g_" + Gadget].on('click', function (event) {
            event.onComplete = function () {
                cb = selector.data("onLeftClick");
                if (cb) {
                    if (event.originalEvent.which === 1) {
                        cEvent.eventGadget = Gadget;
                        cEvent.eventType = cConstants.PB_EventType_LeftClick;
                        cb(event);
                    }
                }
            };
        });
        w2ui["w2ui_g_" + Gadget].on('select', function (event) {
            event.onComplete = function () {
                cb = selector.data("onSelect");
                if (cb) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_Select;
                    cb(event);
                }
            };
        });
        w2ui["w2ui_g_" + Gadget].on('unselect', function (event) {
            event.onComplete = function () {
                cb = selector.data("onUnselect");
                if (cb) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_Unselect;
                    cb(event);
                }
            };
        });
        w2ui["w2ui_g_" + Gadget].on('contextMenu', function (event) {
            event.onComplete = function () {
                cb = selector.data("onRightClick");
                if (cb) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_RightClick;
                    cb(event);
                }
            };
        });
        w2ui["w2ui_g_" + Gadget].on('dblClick', function (event) {
            event.onComplete = function () {
                cb = selector.data("onLeftDoubleClick");
                if (cb) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_LeftDoubleClick;
                    cb(event);
                }
            };
        });
        w2ui["w2ui_g_" + Gadget].on('change', function (event) {
            event.onComplete = function () {
                cb = selector.data("onChange");
                if (cb) {
                    cEvent.eventGadget = Gadget;
                    cEvent.eventType = cConstants.PB_EventType_Change;
                    cb(event);
                }
            };
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.ListViewGadget = function (Gadget, x, y, Width, Height, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var listViewGadget;
        if (cCommon.CheckFlag(Flags, cConstants.PB_ListView_MultiSelect)) {
            listViewGadget = new cControl(Gadget, x, y, Width, Height, "<select multiple size='2' />");
        }
        else {
            listViewGadget = new cControl(Gadget, x, y, Width, Height, "<select size='2' />");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_ListView_ClickSelect)) {
            
        }
        listViewGadget.selector.addClass("ui-widget");
        listViewGadget.selector.data("GadgetType", "ListViewGadget");
        cCommon.CurrentContainer.append(listViewGadget.selector);
        cGadget.GetDefaultColors(listViewGadget.selector);
        cFont.SetDefaultFont(listViewGadget.selector);
        listViewGadget.selector.bind("click", function (event) {
            cEvent.HandleEvent(listViewGadget.selector, event, listViewGadget.ident, cConstants.PB_EventType_LeftClick);
        });
        listViewGadget.selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(listViewGadget.selector, event, listViewGadget.ident, cConstants.PB_EventType_LeftDoubleClick);
        });
        listViewGadget.selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(listViewGadget.selector, event, listViewGadget.ident, cConstants.PB_EventType_RightClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(listViewGadget.ident, $.fn.GadgetsEvents);
        return listViewGadget.ident;
    };
    cGadget.MDIGadget = function (Gadget, x, y, Width, Height, SubMenu, FirstMenuItem, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return -1;
    };
    cGadget.OpenGadgetList = function (Gadget, Item) {
        if (Item === void 0) { Item = 0; }
        var functionName = "OpenGadgetList";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Container:
                cCommon.CurrentContainer = selector;
                break;
            case cConstants.PB_GadgetType_Panel:
                cCommon.CurrentContainer = selector.find("div").eq(Item);
                break;
            case cConstants.PB_GadgetType_ScrollArea:
                selector = $("#g_i_" + Gadget);
                cCommon.CurrentContainer = selector;
                break;
            case cConstants.PB_GadgetType_Html:
                cCommon.CurrentContainer = selector;
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.OptionGadget = function (Gadget, x, y, Width, Height, Text) {
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<div class='ui-widget' />");
        selector.attr("id", "g_" + Gadget);
        selector.append($("<input  id='g_" + Gadget + "_radio' type='radio' name ='" + cCommon.CurrentContainer.attr("id") + "' style='vertical-align:middle' />"));
        selector.append($("<label for='g_" + Gadget + "_radio' id='g_" + Gadget + "_label'>" + Text + "</label>"));
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        cCommon.CurrentContainer.append(selector);
        selector.data("GadgetType", cConstants.PB_GadgetType_Option);
        cGadget.GetDefaultColors(selector);
        $("#g_" + Gadget + "_radio").click(function (event) {
            cEvent.HandleEvent($("#g_" + Gadget + "_radio"), event, Gadget, cConstants.PB_EventType_LeftClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.PanelGadget = function (Gadget, x, y, Width, Height, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<div><ul /></div>");
        selector.attr("id", "g_" + Gadget);
        selector.tabs({
            activate: function (event, ui) {
                var h1 = ui.newTab.parent().position().top + ui.newTab.parent().height();
                var h2 = $(this).height();
                ui.newPanel.css("height", h2 - h1);
                selector.find('*').each(function () {
                    if ($(this).data("GadgetType") === cConstants.PB_GadgetType_ListIcon) {
                        var id = $(this).attr("id");
                        w2ui["w2ui_" + id].refresh();
                    }
                });
            }
        });
        if (cCommon.CheckFlag(Flags, cConstants.PB_PanelGadget_Sortable)) {
            selector.find(".ui-tabs-nav").sortable({
                axis: "x",
                stop: function () {
                    selector.tabs("refresh");
                }
            });
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_PanelGadget_Closable)) {
            selector.data("Closable", true);
        }
        else {
            selector.data("Closable", false);
        }
        selector.delegate("span.ui-icon-close", "click", function () {
            var panelId = $(this).closest("li").remove().attr("aria-controls");
            $("#" + panelId).remove();
            selector.tabs("refresh");
        });
        cCommon.CurrentContainer.append(selector);
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        selector.data("GadgetType", cConstants.PB_GadgetType_Panel);
        cGadget.GetDefaultColors(selector);
        var cb;
        selector.on("tabsactivate", function (event, ui) {
            if (this !== event.target) {
                return false;
            }
            cb = selector.data("onChange");
            if (cb) {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_Change;
                cb();
            }
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.ProgressBarGadget = function (Gadget, x, y, Width, Height, Minimum, Maximum, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var progressBarGadget = $("<div />").progressbar({
            value: 0,
            max: Maximum
        });
        progressBarGadget.attr("id", "g_" + Gadget);
        progressBarGadget.css({ "position": "absolute", "top": y, "left": x, "width": Width, "height": Height });
        if (Flags) {
            
        }
        progressBarGadget.data("pbmin", Minimum);
        progressBarGadget.data("pbmax", Maximum);
        progressBarGadget.data("GadgetType", cConstants.PB_GadgetType_ProgressBar);
        cCommon.CurrentContainer.append(progressBarGadget);
        cGadget.GetDefaultColors(progressBarGadget);
        return Gadget;
    };
    cGadget.RemoveGadgetAttr = function (Gadget, propertyName) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("RemoveGadgetAttr()");
        return selector.removeAttr(propertyName);
    };
    cGadget.RemoveGadgetClass = function (Gadget, className) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("RemoveGadgetClass()");
        return selector.removeClass(className);
    };
    cGadget.AddGadgetClass = function (Gadget, className) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("AddGadgetClass()");
        selector.addClass(className);
    };
    cGadget.GetGadgetClass = function (Gadget, className) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("GetGadgetClass()");
        return selector.hasClass(className);
    };
    cGadget.SwitchGadgetClass = function (Gadget, removeClassName, addClassName) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("SwitchGadgetClass()");
        selector.switchClass(removeClassName, addClassName);
    };
    cGadget.RemoveGadgetColumn = function (Gadget, Column) {
        var functionName = "RemoveGadgetColumn";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ListIcon:
                w2ui["w2ui_g_" + Gadget].columns.splice(Column, 1);
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_GadgetType_ExplorerList:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.RemoveGadgetItem_ComboBox = function (selector, Position) {
        var liArray = selector.children().toArray();
        if (liArray === null || liArray.length === 0)
            return;
        liArray.splice(Position, 1);
        selector.empty();
        selector.append(liArray);
        if (selector.data("cbtype") === "selectmenu") {
            selector.selectmenu("refresh");
        }
    };
    cGadget.RemoveGadgetItem_ListIcon = function (Gadget, Position) {
        var Records = w2ui["w2ui_g_" + Gadget].records;
        if (Position < -1) {
            Position = 0;
        }
        if (Position >= Records.length) {
            Position = Records.length;
        }
        if (Position === -1) {
            Position = Records.length;
        }
        Records.splice(Position, 1);
        for (var i = 0; i <= Records.length - 1; i++) {
            Records[i].recid = i;
        }
        w2ui["w2ui_g_" + Gadget].records = Records;
        w2ui["w2ui_g_" + Gadget].refresh();
    };
    cGadget.RemoveGadgetItem_ListView = function (Gadget, Position) {
        $("#g_" + Gadget + " option:eq(" + Position + ")").remove();
    };
    cGadget.RemoveGadgetItem_Panel = function (Gadget, Position) {
        var selector = $("#g_" + Gadget);
        var id = $("#g_" + Gadget + " li:eq(" + Position + ") a");
        $("#g_" + Gadget + " li:eq(" + Position + ")").remove();
        $(id).remove();
        selector.tabs("refresh");
    };
    cGadget.RemoveGadgetItem_Tree = function (Gadget, Position) {
        var selector = $("#g_" + Gadget);
        var tree = selector.fancytree("getTree");
        var match = null;
        var pos = 0;
        tree.visit(function (node) {
            if (pos === Position) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (match !== null) {
            match.remove();
        }
    };
    cGadget.RemoveGadgetItem = function (Gadget, Position) {
        var functionName = "RemoveGadgetItem";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Position);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Position);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.RemoveGadgetItem_ComboBox(selector, Position);
                break;
            case cConstants.PB_GadgetType_Panel:
                cGadget.RemoveGadgetItem_Panel(Gadget, Position);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.RemoveGadgetItem_ListIcon(Gadget, Position);
                break;
            case cConstants.PB_GadgetType_ListView:
                cGadget.RemoveGadgetItem_ListView(Gadget, Position);
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadget.RemoveGadgetItem_Tree(Gadget, Position);
                break;
            case cConstants.PB_GadgetType_Editor:
            case cConstants.PB_GadgetType_MDI:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.ResizeGadget = function (Gadget, x, y, Width, Height) {
        var functionName = "ResizeGadget";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, x, y, Width, Height);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, x, y, Width, Height);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Spin:
                selector = selector.spinner("widget");
                break;
            case cConstants.PB_GadgetType_ComboBox:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        selector = $("#g_" + Gadget + "_customcombobox");
                        break;
                    case "selectmenu":
                        selector = $("#g_" + Gadget + "-button");
                        break;
                }
                break;
        }
        if (x !== cConstants.PB_Ignore)
            selector.css("left", x);
        if (y !== cConstants.PB_Ignore)
            selector.css("top", y);
        if (Width !== cConstants.PB_Ignore) {
            switch (cGadget.GadgetType(Gadget)) {
                case cConstants.PB_GadgetType_Frame:
                    selector.css("width", Width - cPixelPerfect.FrameGadgetWidthOffset);
                    break;
                case cConstants.PB_GadgetType_ComboBox:
                    switch ($("#g_" + Gadget).data("cbtype")) {
                        case "combobox":
                            $("#g_" + Gadget + "_uiautocompleteinput").css("width", Width - cPixelPerfect.ComboBoxEditableGadgetWidth);
                            break;
                        case "selectmenu":
                            $("#g_" + Gadget + "-button").css("width", Width - cPixelPerfect.ComboBoxGadgetWidth);
                            break;
                        case "simple":
                            selector.css("width", Width - cPixelPerfect.ComboBoxGadgetSimpleWidth);
                            break;
                    }
                    break;
                case cConstants.PB_GadgetType_Spin:
                    selector.css("width", Width - cPixelPerfect.SpinGadgetWidthOffset);
                    break;
                case cConstants.PB_GadgetType_String:
                    selector.css("width", Width - cPixelPerfect.StringGadgetWidthOffset);
                    break;
                case cConstants.PB_GadgetType_Tree:
                    selector.css("width", Width - cPixelPerfect.TreeGadgetWidthOffset);
                    break;
                case cConstants.PB_GadgetType_Editor:
                    selector.css("width", Width - cPixelPerfect.EditorGadgetWidthOffset);
                    break;
                default:
                    selector.css("width", Width);
                    break;
            }
        }
        if (Height !== cConstants.PB_Ignore) {
            switch (cGadget.GadgetType(Gadget)) {
                case cConstants.PB_GadgetType_Frame:
                    selector.css("height", Height - cPixelPerfect.FrameGadgetHeightOffset);
                    break;
                case cConstants.PB_GadgetType_ComboBox:
                    switch ($("#g_" + Gadget).data("cbtype")) {
                        case "combobox":
                            $("#g_" + Gadget + "_uiautocompleteinput").css("height", Height - cPixelPerfect.ComboBoxEditableGadgetHeight);
                            break;
                        case "selectmenu":
                            $("#g_" + Gadget + "-button").css("height", Height - cPixelPerfect.ComboBoxGadgetHeight);
                            break;
                        case "simple":
                            selector.css("height", Height - cPixelPerfect.ComboBoxGadgetSimpleHeight);
                            break;
                    }
                    break;
                case cConstants.PB_GadgetType_Spin:
                    selector.css("height", Height - cPixelPerfect.SpinGadgetHeightOffset);
                    break;
                case cConstants.PB_GadgetType_String:
                    selector.css("height", Height - cPixelPerfect.StringGadgetHeightOffset);
                    break;
                case cConstants.PB_GadgetType_Tree:
                    selector.css("height", Height - cPixelPerfect.TreeGadgetHeightOffset);
                    break;
                case cConstants.PB_GadgetType_Editor:
                    selector.css("height", Height - cPixelPerfect.EditorGadgetHeightOffset);
                    break;
                default:
                    selector.css("height", Height);
                    break;
            }
        }
        switch (cGadget.GadgetType(Gadget)) {
            case cConstants.PB_GadgetType_ListIcon:
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
        }
    };
    cGadget.ResizeGadget_Button = function (Gadget, x, y, Width, Height) {
        var selector = $("#g_" + Gadget);
        if (selector.is("input"))
            selector = $("#g_" + Gadget + "_label");
        if (x !== cConstants.PB_Ignore)
            selector.css("left", x);
        if (y !== cConstants.PB_Ignore)
            selector.css("top", y);
        if (Width !== cConstants.PB_Ignore)
            selector.css("width", Width);
        if (Height !== cConstants.PB_Ignore)
            selector.css("height", Height);
    };
    cGadget.ScrollAreaGadget = function (Gadget, x, y, Width, Height, ScrollAreaWidth, ScrollAreaHeight, ScrollStep, Flags) {
        if (ScrollStep === void 0) { ScrollStep = 0; }
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var outerContainer = $("<div id='g_" + Gadget + "' />");
        cCommon.SetGadgetPosition(outerContainer, x, y, Width, Height);
        outerContainer.css("overflow", "auto");
        if (!cCommon.CheckFlag(Flags, cConstants.PB_ScrollArea_BorderLess)) {
            outerContainer.addClass("ui-widget-content");
            outerContainer.addClass("ui-corner-all");
        }
        var innerContainer = $("<div id='g_i_" + Gadget + "' />");
        cCommon.SetGadgetPosition(outerContainer, x, y, Width, Height);
        innerContainer.css("overflow", "none");
        innerContainer.css("width", ScrollAreaWidth);
        innerContainer.css("height", ScrollAreaHeight);
        outerContainer.append(innerContainer);
        cCommon.CurrentContainer.append(outerContainer);
        innerContainer.data("currentContainerParent", cCommon.CurrentContainer);
        cCommon.CurrentContainer = innerContainer;
        innerContainer.data("GadgetType", cConstants.PB_GadgetType_ScrollArea);
        outerContainer.data("GadgetType", cConstants.PB_GadgetType_ScrollArea);
        outerContainer.bind("scroll", function (event) {
            var cb = outerContainer.data("onScroll");
            if (typeof cb === "function") {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_Scroll;
                cb();
            }
        });
        return Gadget;
    };
    cGadget.ScrollBarGadget = function (Gadget, x, y, Width, Height, Min, Max, PageLength, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return -1;
    };
    cGadget.SetActiveGadget = function (Gadget) {
        var functionName = "SetActiveGadget";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget);
        }
        selector.focus();
    };
    cGadget.SetGadgetAttr = function (Gadget, attrName, attrValue) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("SetGadgetAttr()");
        selector.attr(attrName, attrValue);
    };
    cGadget.SetGadgetAttribute = function (Gadget, Attribute, Value) {
        var functionName = "SetGadgetAttribute";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Attribute, Value);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Attribute, Value);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ButtonImage:
                cGadget.SetGadgetAttribute_ButtonImage(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_Calendar:
                cGadget.SetGadgetAttribute_Calendar(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_Canvas:
                cGadget.SetGadgetAttribute_Canvas(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.SetGadgetAttribute_ComboBox(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_Date:
                cGadget.SetGadgetAttribute_Date(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_Editor:
                cGadget.SetGadgetAttribute_Editor(Gadget, Attribute, Value);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.SetGadgetAttribute_ListIcon(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_ProgressBar:
                cGadget.SetGadgetAttribute_ProgressBar(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_ScrollArea:
                cGadget.SetGadgetAttribute_ScrollArea(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_Spin:
                cGadget.SetGadgetAttribute_Spin(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_String:
                cGadget.SetGadgetAttribute_String(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_TrackBar:
                cGadget.SetGadgetAttribute_TrackBar(Gadget, Attribute, Value, functionName, gadgetType);
                break;
            case cConstants.PB_GadgetType_Date:
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_MDI:
            case cConstants.PB_GadgetType_ScrollBar:
            case cConstants.PB_GadgetType_Splitter:
            case cConstants.PB_GadgetType_Web:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetAttribute_ButtonImage = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Button_Image:
                var img = cCommon.P2W_ImageList[Value];
                if (img != null) {
                    selector.css("background-image", "url(" + img.src + ")");
                }
                break;
            case cConstants.PB_Button_PressedImage:
                
                break;
        }
    };
    cGadget.SetGadgetAttribute_Calendar = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        if (Attribute === cConstants.PB_Date_Minimum) {
            selector.datepicker("option", "minDate", moment.unix(Value).toDate());
        }
        else if (Attribute === cConstants.PB_Date_Maximum) {
            selector.datepicker("option", "maxDate", moment.unix(Value).toDate());
        }
    };
    cGadget.SetGadgetAttribute_Canvas = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Canvas_Image:
                
                break;
            case cConstants.PB_Canvas_Clip:
                
                break;
            case cConstants.PB_Canvas_Cursor:
                cGadget.SetGadgetCursor(Gadget, Value);
                break;
            case cConstants.PB_Canvas_CustomCursor:
                
                break;
            default:
                
                break;
        }
    };
    cGadget.SetGadgetAttribute_ComboBox = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_ComboBox_MaxHeight:
                switch (selector.data("cbtype")) {
                    case "combobox":
                        $("#g_" + Gadget + "_uiautocomplete").css({ "max-height": Value });
                        break;
                    case "selectmenu":
                        selector.selectmenu("menuWidget").css({ "max-height": Value });
                        break;
                    case "simple":
                        break;
                }
                break;
            default:
                
                break;
        }
    };
    cGadget.SetGadgetAttribute_Date = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        if (Attribute === cConstants.PB_Date_Minimum) {
            selector.datepicker("option", "minDate", moment.unix(Value).toDate());
        }
        else if (Attribute === cConstants.PB_Date_Maximum) {
            selector.datepicker("option", "maxDate", moment.unix(Value).toDate());
        }
    };
    cGadget.SetGadgetAttribute_Editor = function (Gadget, Attribute, Value) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Editor_ReadOnly:
                if (Value === 0) {
                    selector.prop("readonly", false);
                }
                else {
                    selector.prop("readonly", true);
                }
                break;
            case cConstants.PB_Editor_WordWrap:
                if (Value === 0) {
                    selector.attr("wrap", "off");
                }
                else {
                    selector.removeAttr("wrap");
                }
                break;
        }
    };
    cGadget.SetGadgetAttribute_ListIcon = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_ListIcon_ColumnDelimiter:
                selector.data("ColumnDelimiter", Value);
                break;
            case cConstants.PB_ListIcon_RecordDelimiter:
                selector.data("RecordDelimiter", Value);
                break;
            case cConstants.PB_ListIcon_HeaderText:
                w2ui["w2ui_g_" + Gadget].header = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_Header:
                w2ui["w2ui_g_" + Gadget].show.header = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_Toolbar:
                w2ui["w2ui_g_" + Gadget].show.toolbar = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_Footer:
                w2ui["w2ui_g_" + Gadget].show.footer = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ColumnHeaders:
                w2ui["w2ui_g_" + Gadget].show.columnHeaders = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_LineNumbers:
                w2ui["w2ui_g_" + Gadget].show.lineNumbers = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ExpandColumn:
                w2ui["w2ui_g_" + Gadget].show.expandColumn = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_SelectColumn:
                w2ui["w2ui_g_" + Gadget].show.selectColumn = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_EmptyRecords:
                w2ui["w2ui_g_" + Gadget].show.emptyRecords = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarReload:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-reload");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-reload");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarColumns:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-column-on-off");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-column-on-off");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarSearch:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-search");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-search");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarAdd:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-add");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-add");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarEdit:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-edit");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-edit");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarDelete:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-delete");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-delete");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_ToolbarSave:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].toolbar.show("w2ui-save");
                }
                else {
                    w2ui["w2ui_g_" + Gadget].toolbar.hide("w2ui-save");
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_SelectionBorder:
                w2ui["w2ui_g_" + Gadget].show.selectionBorder = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_RecordTitles:
                w2ui["w2ui_g_" + Gadget].show.recordTitles = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_SkipRecords:
                w2ui["w2ui_g_" + Gadget].show.skipRecords = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_MultiSelect:
                w2ui["w2ui_g_" + Gadget].multiSelect = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_HeaderDragDrop:
                w2ui["w2ui_g_" + Gadget].reorderColumns = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_SelectTypeCell:
                if (Value === 1) {
                    w2ui["w2ui_g_" + Gadget].selectType = 'cell';
                }
                else {
                    w2ui["w2ui_g_" + Gadget].selectType = 'row';
                }
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_Columns:
                var colArr = [];
                for (var colCounter = 0; colCounter <= Value.length - 1; colCounter++) {
                    var newColumn = {
                        caption: '',
                        field: '',
                        size: null,
                        min: 15,
                        max: null,
                        gridMinWidth: null,
                        hidden: false,
                        sortable: false,
                        searchable: false,
                        resizable: false,
                        attr: '',
                        style: '',
                        render: null,
                        editable: {}
                    };
                    Object.keys(Value[colCounter]).forEach(function (key) {
                        if (Value[colCounter][key] !== null) {
                            newColumn[key] = Value[colCounter][key];
                        }
                        else {
                            delete newColumn[key];
                        }
                    });
                    colArr.push(newColumn);
                }
                Value = colArr;
                w2ui["w2ui_g_" + Gadget].columns = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_Records:
                w2ui["w2ui_g_" + Gadget].records = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_SearchFields:
                w2ui["w2ui_g_" + Gadget].searches = Value;
                w2ui["w2ui_g_" + Gadget].refresh();
                break;
            case cConstants.PB_ListIcon_URL:
                w2ui["w2ui_g_" + Gadget].url = Value;
                w2ui["w2ui_g_" + Gadget].reload();
                break;
            default:
                
                break;
        }
    };
    cGadget.SetGadgetAttribute_ProgressBar = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_ProgressBar_Minimum:
                
                break;
            case cConstants.PB_ProgressBar_Maximum:
                selector.progressbar("option", "max", Value);
                break;
            default:
                cCommon.UnsupportedGadgetAttribute(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetAttribute_ScrollArea = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        selector = $("#g_i_" + Gadget);
        if (selector.length === 1) {
            if (Attribute === cConstants.PB_ScrollArea_InnerWidth) {
                selector.css("width", Value);
            }
            else if (Attribute === cConstants.PB_ScrollArea_InnerHeight) {
                selector.css("height", Value);
            }
            else if (Attribute === cConstants.PB_ScrollArea_X) {
                selector.css("left", Value);
            }
            else if (Attribute === cConstants.PB_ScrollArea_Y) {
                selector.css("top", Value);
            }
            else if (Attribute === cConstants.PB_ScrollArea_ScrollStep) {
                
            }
            else {
                cCommon.UnsupportedGadgetAttribute(functionName, Gadget);
            }
        }
        else {
            
        }
    };
    cGadget.SetGadgetAttribute_Spin = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_Spin_Minimum:
                selector.spinner("option", "min", Value);
                break;
            case cConstants.PB_Spin_Maximum:
                selector.spinner("option", "max", Value);
                break;
            case cConstants.PB_Spin_Step:
                selector.spinner("option", "step", Value);
                break;
            default:
                cCommon.UnsupportedGadgetAttribute(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetAttribute_String = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_String_Autocomplete_Datasource:
                selector.autocomplete({ source: Value });
                break;
            case cConstants.PB_String_Autocomplete_MinLength:
                selector.autocomplete({ minLength: Value });
                break;
            case cConstants.PB_String_MaximumLength:
                selector.attr("maxlength", Value);
                break;
            case cConstants.PB_String_Type:
                switch (Value) {
                    case cConstants.PB_String_Color:
                        selector.attr("type", "color");
                        break;
                    case cConstants.PB_String_Date:
                        selector.attr("type", "date");
                        break;
                    case cConstants.PB_String_DateTime:
                        selector.attr("type", "datetime");
                        break;
                    case cConstants.PB_String_DateTimeLocal:
                        selector.attr("type", "datetime-local");
                        break;
                    case cConstants.PB_String_Email:
                        selector.attr("type", "email");
                        break;
                    case cConstants.PB_String_Month:
                        selector.attr("type", "month");
                        break;
                    case cConstants.PB_String_Range:
                        selector.attr("type", "range");
                        break;
                    case cConstants.PB_String_Search:
                        selector.attr("type", "search");
                        break;
                    case cConstants.PB_String_Tel:
                        selector.attr("type", "tel");
                        break;
                    case cConstants.PB_String_Time:
                        selector.attr("type", "time");
                        break;
                    case cConstants.PB_String_Url:
                        selector.attr("type", "url");
                        break;
                    case cConstants.PB_String_Week:
                        selector.attr("type", "week");
                        break;
                }
                break;
            case cConstants.PB_String_Pattern:
                selector.attr("pattern", Value);
                break;
            case cConstants.PB_String_AllowedChars:
                selector.data("allowedchars", new RegExp(Value));
                break;
            case cConstants.PB_String_Placeholder:
                selector.attr("placeholder", Value);
                break;
            case cConstants.PB_String_Required:
                selector.prop("required", Value);
                break;
            default:
                cCommon.UnsupportedGadgetAttribute(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetAttribute_TrackBar = function (Gadget, Attribute, Value, functionName, gadgetType) {
        var selector = $("#g_" + Gadget);
        switch (Attribute) {
            case cConstants.PB_TrackBar_Minimum:
                selector.slider("option", "min", Value);
                if (selector.hasClass("ui-slider-pips"))
                    selector.slider().slider('pips').slider('float');
                break;
            case cConstants.PB_TrackBar_Maximum:
                selector.slider("option", "max", Value);
                if (selector.hasClass("ui-slider-pips"))
                    selector.slider().slider('pips').slider('float');
                break;
            default:
                cCommon.UnsupportedGadgetAttribute(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetColor = function (Gadget, ColorType, Color) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("SetGadgetColor()");
        switch (ColorType) {
            case cConstants.PB_Gadget_FrontColor:
                if (Color === -1) {
                    Color = selector.data("defaultFrontColor");
                }
                selector.css("color", Color);
                break;
            case cConstants.PB_Gadget_BackColor:
                if (Color === -1) {
                    Color = selector.data("defaultBackColor");
                }
                if (cGadget.GadgetType(Gadget) === cConstants.PB_GadgetType_Spin) {
                    selector = selector.parent();
                }
                selector.css("background", Color);
                break;
            case cConstants.PB_Gadget_LineColor:
                
                break;
            case cConstants.PB_Gadget_TitleFrontColor:
                
                break;
            case cConstants.PB_Gadget_TitleBackColor:
                
                break;
            case cConstants.PB_Gadget_GrayTextColor:
                
                break;
            default:
                
                break;
        }
    };
    cGadget.SetGadgetCss = function (Gadget, propertyName, propertyValue) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("SetGadgetCss()");
        selector.css(propertyName, propertyValue);
    };
    cGadget.SetGadgetCursor = function (Gadget, Cursor) {
        var functionName = "SetGadgetCursor";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var CssCursor = "";
        switch (Cursor) {
            case cConstants.PB_Cursor_Arrows:
                CssCursor = "all-scroll";
                break;
            case cConstants.PB_Cursor_Busy:
                CssCursor = "wait";
                break;
            case cConstants.PB_Cursor_Cross:
                CssCursor = "crosshair";
                break;
            case cConstants.PB_Cursor_Default:
                CssCursor = "default";
                break;
            case cConstants.PB_Cursor_Denied:
                CssCursor = "not-allowed";
                break;
            case cConstants.PB_Cursor_Hand:
                CssCursor = "pointer";
                break;
            case cConstants.PB_Cursor_IBeam:
                CssCursor = "text";
                break;
            case cConstants.PB_Cursor_Invisible:
                CssCursor = "none";
                break;
            case cConstants.PB_Cursor_LeftDownRightUp:
                CssCursor = "nesw-resize";
                break;
            case cConstants.PB_Cursor_LeftRight:
                CssCursor = "ew-resize";
                break;
            case cConstants.PB_Cursor_LeftUpRightDown:
                CssCursor = "nwse-resize";
                break;
            case cConstants.PB_Cursor_UpDown:
                CssCursor = "ns-resize";
                break;
            default:
                CssCursor = Cursor;
                break;
        }
        selector.css('cursor', CssCursor);
    };
    cGadget.SetGadgetData = function (Gadget, Value, Key) {
        if (Key === void 0) { Key = "data"; }
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized("SetGadgetData()");
        selector.data(Key, Value);
    };
    cGadget.SetGadgetFont = function (Gadget, FontID) {
        var functionName = "SetGadgetFont";
        var font = cCommon.P2W_FontList[FontID];
        var gadgetSelector = $("#g_" + Gadget);
        if (Gadget !== cConstants.PB_Default) {
            if (cGadget.GadgetType(Gadget) === cConstants.PB_GadgetType_Frame) {
                gadgetSelector = gadgetSelector.find("legend");
            }
        }
        if ((Gadget !== cConstants.PB_Default) && (FontID !== cConstants.PB_Default)) {
            if (gadgetSelector.length === 0)
                return cCommon.GadgetIsNotInitialized(functionName);
            if (font === null)
                return cCommon.FontIsNotInitialized(functionName);
            gadgetSelector.css("font-size", font.Size);
            gadgetSelector.css("font-family", font.Family);
            gadgetSelector.css("font-weight", font.Weight);
            gadgetSelector.css("font-style", font.Style);
            gadgetSelector.css("text-decoration", font.Decoration);
        }
        else if ((Gadget === cConstants.PB_Default) && (FontID !== cConstants.PB_Default)) {
            if (font === null)
                return cCommon.FontIsNotInitialized(functionName);
            cCommon.DefaultGadgetFont = font;
        }
        else if ((Gadget !== cConstants.PB_Default) && (FontID === cConstants.PB_Default)) {
            if (gadgetSelector.length === 0)
                return cCommon.GadgetIsNotInitialized(functionName);
            gadgetSelector.css("font-size", "");
            gadgetSelector.css("font-family", "");
            gadgetSelector.css("font-weight", "");
            gadgetSelector.css("font-style", "");
            gadgetSelector.css("text-decoration", "");
        }
        else if ((Gadget === cConstants.PB_Default) && (FontID === cConstants.PB_Default)) {
            cCommon.DefaultGadgetFont = null;
        }
    };
    cGadget.SetGadgetHtml = function (Gadget, Html) {
        var functionName = "SetGadgetHtml";
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Html);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Html);
        }
    };
    cGadget.SetGadgetItemAttribute = function (Gadget, Item, Attribute, Value, Column) {
        if (Column === void 0) { Column = 0; }
        var functionName = "SetGadgetItemAttribute";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, Attribute, Value, Column);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, Attribute, Value, Column);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ExplorerList:
                cCommon.NotSupported(functionName + " / " + gadgetType);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                if (w2ui["w2ui_g_" + Gadget].columns[Column]) {
                    switch (Attribute) {
                        case cConstants.PB_ListIcon_ColumnWidth:
                            w2ui["w2ui_g_" + Gadget].columns[Column].size = Value;
                            w2ui["w2ui_g_" + Gadget].refresh();
                            break;
                        case cConstants.PB_ListIcon_Sortable:
                            w2ui["w2ui_g_" + Gadget].columns[Column].sortable = (Value === 1 ? true : false);
                            w2ui["w2ui_g_" + Gadget].refresh();
                            break;
                        case cConstants.PB_ListIcon_Resizable:
                            w2ui["w2ui_g_" + Gadget].columns[Column].resizable = (Value === 1 ? true : false);
                            w2ui["w2ui_g_" + Gadget].refresh();
                            break;
                        case cConstants.PB_ListIcon_Editable:
                            w2ui["w2ui_g_" + Gadget].columns[Column].editable = Value;
                            w2ui["w2ui_g_" + Gadget].refresh();
                            break;
                        case cConstants.PB_ListIcon_CustomRenderer:
                            w2ui["w2ui_g_" + Gadget].columns[Column].render = Value;
                            w2ui["w2ui_g_" + Gadget].refresh();
                            break;
                        case cConstants.PB_ListIcon_Alignment:
                            switch (Value) {
                                case cConstants.PB_ListIcon_Align_Left:
                                    w2ui["w2ui_g_" + Gadget].columns[Column].attr = "align=left";
                                    w2ui["w2ui_g_" + Gadget].refresh();
                                    break;
                                case cConstants.PB_ListIcon_Align_Right:
                                    w2ui["w2ui_g_" + Gadget].columns[Column].attr = "align=right";
                                    w2ui["w2ui_g_" + Gadget].refresh();
                                    break;
                                case cConstants.PB_ListIcon_Align_Center:
                                    w2ui["w2ui_g_" + Gadget].columns[Column].attr = "align=center";
                                    w2ui["w2ui_g_" + Gadget].refresh();
                                    break;
                            }
                            break;
                    }
                }
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetItemColor = function (Gadget, Item, ColorType, Color, Column) {
        if (Column === void 0) { Column = 0; }
        var functionName = "SetGadgetItemColor";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, ColorType, Color, Column);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, ColorType, Color, Column);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ListIcon:
            case cConstants.PB_GadgetType_Tree:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetItemData = function (Gadget, Item, Value, Key) {
        if (Key === void 0) { Key = "data"; }
        var functionName = "SetGadgetItemData";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0)
            return cCommon.GadgetIsNotInitialized(functionName);
        if (Item == -1)
            Item = cGadget.CountGadgetItems(Gadget) - 1;
        selector.data(Key + "|" + Item, Value);
    };
    cGadget.SetGadgetItemImage = function (Gadget, Item, ImageID) {
        var functionName = "SetGadgetItemImage";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, ImageID);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, ImageID);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.SetGadgetItemImage_ComboBox(Gadget, Item, ImageID);
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadget.SetGadgetItemImage_Tree(Gadget, Item, ImageID);
                break;
            case cConstants.PB_GadgetType_ListIcon:
            case cConstants.PB_GadgetType_Panel:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetItemImage_ComboBox = function (Gadget, Item, ImageID) {
        var selector = $("#g_" + Gadget);
        var oItem = selector.children().eq(Item);
        if (!oItem)
            return;
        var img = cCommon.P2W_ImageList[ImageID];
        if (img != null) {
            oItem.attr("imgs", img.src);
            oItem.attr("imgw", img.width);
            oItem.attr("imgh", img.height);
        }
        if (selector.data("cbtype") === "selectmenu") {
            selector.selectmenu("refresh");
        }
    };
    cGadget.SetGadgetItemImage_Tree = function (Gadget, Item, ImageID) {
        var selector = $("#g_" + Gadget);
        var tree = selector.fancytree("getTree");
        var match = null;
        var pos = 0;
        tree.visit(function (node) {
            if (pos === Item) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (match === null)
            return;
        var img = cCommon.P2W_ImageList[ImageID];
        if (img != null) {
            match.data.icon = img.src;
        }
        match.renderTitle();
    };
    cGadget.SetGadgetItemState = function (Gadget, Position, State) {
        var functionName = "SetGadgetItemState";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Calendar:
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_ListIcon:
                
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadget.SetGadgetItemState_Tree(Gadget, Position, State);
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetItemState_Tree = function (Gadget, Position, State) {
        var selector = $("#g_" + Gadget);
        var tree = selector.fancytree("getTree");
        if (Position === -1)
            Position = cGadget.CountGadgetItems(Gadget);
        if (Position < 0)
            Position = 0;
        var pos = 0;
        var match = null;
        selector.fancytree("getRootNode").visit(function (node) {
            if (pos === Position) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (cCommon.CheckFlag(State, cConstants.PB_Tree_Selected)) {
            if (match)
                match.setSelected(true);
        }
        if (cCommon.CheckFlag(State, cConstants.PB_Tree_Expanded)) {
            if (match)
                match.setExpanded(true);
        }
        else if (cCommon.CheckFlag(State, cConstants.PB_Tree_Collapsed)) {
            if (match)
                match.setExpanded(false);
        }
        if (cCommon.CheckFlag(State, cConstants.PB_Tree_Checked)) {
            if (match)
                match.setSelected(true);
        }
        if (cCommon.CheckFlag(State, cConstants.PB_Tree_Inbetween)) {
            
        }
    };
    cGadget.SetGadgetItemText_ComboBox = function (selector, Item, Text) {
        var liArray = selector.children().toArray();
        if (liArray === null || liArray.length === 0)
            return;
        if (Item < 0)
            Item = 0;
        if (Item > liArray.length - 1)
            Item = liArray.length - 1;
        $(liArray[Item]).text(Text);
        selector.empty();
        selector.append(liArray);
        if (selector.data("cbtype") === "selectmenu") {
            selector.selectmenu("refresh");
        }
    };
    cGadget.SetGadgetItemText_Editor = function (Gadget, Item, Text) {
        var selector = $("#g_" + Gadget);
        var editorContent = selector.val();
        var textArray = editorContent.split("\n");
        if (Item < 0)
            Item = 0;
        if (Item > textArray.length - 1)
            Item = textArray.length - 1;
        textArray[Item] = Text;
        selector.val(textArray.join("\n"));
        ;
    };
    cGadget.SetGadgetItemText_ListIcon = function (Gadget, Item, Text, Column) {
        if (Column === void 0) { Column = 0; }
        var Columns = w2ui["w2ui_g_" + Gadget].columns;
        if (Item === -1) {
            try {
                Columns[Column].caption = Text;
            }
            catch (e) { }
        }
        else {
            try {
                w2ui["w2ui_g_" + Gadget].records[Item][Columns[Column].field] = Text;
            }
            catch (e) { }
        }
        w2ui["w2ui_g_" + Gadget].refresh();
    };
    cGadget.SetGadgetItemText_ListView = function (Gadget, Item, Text, Column) {
        if (Column === void 0) { Column = 0; }
        var selector = $("#g_" + Gadget);
        selector.children("option").eq(Item).text(Text);
    };
    cGadget.SetGadgetItemText_Tree = function (Gadget, Item, Text, Column) {
        if (Column === void 0) { Column = 0; }
        var selector = $("#g_" + Gadget);
        var tree = selector.fancytree("getTree");
        var match = null;
        var pos = 0;
        tree.visit(function (node) {
            if (pos === Item) {
                match = node;
                return false;
            }
            pos += 1;
        });
        if (match === null)
            return;
        match.setTitle(Text);
    };
    cGadget.SetGadgetItemText_Web = function (Gadget, Item, Text, Column) {
        if (Column === void 0) { Column = 0; }
        var selector = $("#g_" + Gadget);
        if (Item === cConstants.PB_Web_HtmlCode) {
            var myIFrameElement = selector[0];
            if (myIFrameElement) {
                var myDocument = myIFrameElement.contentWindow.document;
                if (myDocument) {
                    myDocument.open();
                    myDocument.write(Text);
                    myDocument.close();
                }
            }
        }
    };
    cGadget.SetGadgetItemText = function (Gadget, Item, Text, Column) {
        if (Column === void 0) { Column = cConstants.PB_Ignore; }
        var functionName = "SetGadgetItemText";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Item, Text, Column);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Item, Text, Column);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.SetGadgetItemText_ComboBox(selector, Item, Text);
                break;
            case cConstants.PB_GadgetType_Editor:
                cGadget.SetGadgetItemText_Editor(Gadget, Item, Text);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.SetGadgetItemText_ListIcon(Gadget, Item, Text, Column);
                break;
            case cConstants.PB_GadgetType_ListView:
                cGadget.SetGadgetItemText_ListView(Gadget, Item, Text, Column);
                break;
            case cConstants.PB_GadgetType_Panel:
                selector.find("li:eq(" + Item + ") a").text(Text);
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadget.SetGadgetItemText_Tree(Gadget, Item, Text, Column);
                break;
            case cConstants.PB_GadgetType_Web:
                cGadget.SetGadgetItemText_Web(Gadget, Item, Text, Column);
                break;
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_MDI:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetState_Button = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        if (selector.is("input")) {
            if (State === 1) {
                selector.prop('checked', true);
            }
            else {
                selector.prop('checked', false);
            }
            selector.button("refresh");
        }
    };
    cGadget.SetGadgetState_Calendar = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        selector.datepicker("setDate", moment.unix(State).toDate());
        selector.data("xDate", State);
    };
    cGadget.SetGadgetState_CheckBox = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        if (selector.data("isTriState")) {
            if (State === cConstants.PB_Checkbox_Checked || State === true) {
                selector.find("input").tristate('state', true);
            }
            else if (State === cConstants.PB_Checkbox_Unchecked || State === false) {
                selector.find("input").tristate('state', false);
            }
            else if (State === cConstants.PB_Checkbox_Inbetween || State === null) {
                selector.find("input").tristate('state', null);
            }
        }
        else {
            if (State === cConstants.PB_Checkbox_Checked || State === true) {
                selector.find("input").prop('checked', true);
            }
            else if (State === cConstants.PB_Checkbox_Unchecked || State === false) {
                selector.find("input").prop('checked', false);
            }
        }
    };
    cGadget.SetGadgetState_ComboBox = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        selector.find("option").removeAttr("selected");
        if (State === -1) {
            cGadget.SetGadgetText(Gadget, "");
            return;
        }
        selector.find("option").eq(State).attr("selected", "selected");
        switch (selector.data("cbtype")) {
            case "combobox":
                selector.combobox("refresh");
                break;
            case "selectmenu":
                selector.selectmenu("refresh");
                selector.selectmenu("open");
                selector.selectmenu("close");
                break;
            case "simple":
                break;
        }
    };
    cGadget.SetGadgetState_Date = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        switch (selector.data("type")) {
            case "datetimepicker":
                if (State === -1) {
                    selector.val("");
                }
                else {
                    selector.datetimepicker("setDate", moment.unix(State).toDate());
                }
                break;
            case "datepicker":
                selector.datepicker("setDate", moment.unix(State).toDate());
                break;
            case "timepicker":
                selector.datetimepicker("setDate", moment.unix(State).toDate());
                break;
        }
    };
    cGadget.SetGadgetState_Image = function (Gadget, State, Callback) {
        if (Callback === void 0) { Callback = null; }
        var selector = $("#g_" + Gadget);
        if (cString.isString(State)) {
            State = State.replace(/\\/g, "/");
            selector.attr("src", State);
            var img = new Image();
            $(img).on("load", function () {
                selector.css("width", img.width);
                selector.css("height", img.height);
            });
            $(img).on("error", function () {
                
            });
            img.src = State;
        }
        else {
            var img = cCommon.P2W_ImageList[State];
            if (img === null) {
                selector.attr("src", cCommon.EmptyImage);
                if (Callback) {
                    selector.load(function () { Callback(); });
                }
            }
            else {
                if (cString.StartsWith(State, "data:image")) {
                    selector.attr("src", State);
                }
                else {
                    selector.attr("src", img.src);
                    selector.css("width", img.width);
                    selector.css("height", img.height);
                }
                if (Callback) {
                    selector.load(function () { Callback(); });
                }
            }
        }
    };
    cGadget.SetGadgetState_ListIcon = function (Gadget, State) {
        if (State === -1) {
            w2ui["w2ui_g_" + Gadget].selectNone();
        }
        else {
            try {
                var recId = w2ui["w2ui_g_" + Gadget].records[State].recid;
                w2ui["w2ui_g_" + Gadget].select(recId);
                w2ui["w2ui_g_" + Gadget].scrollIntoView(recId);
            }
            catch (e) { }
        }
    };
    cGadget.SetGadgetState_ListView = function (Gadget, State) {
        $("#g_" + Gadget + " option").removeAttr("selected");
        $("#g_" + Gadget + " option:eq(" + State + ")").attr("selected", "selected");
        $("#g_" + Gadget).get(0).scrollIntoView;
    };
    cGadget.SetGadgetState_Option = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        if (State === 1) {
            selector.find("input").attr("checked", "true");
        }
        else {
            selector.find("input").attr("checked", "false");
        }
    };
    cGadget.SetGadgetState_Panel = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        var cb = $("#g_" + Gadget).data("onChange");
        $("#g_" + Gadget).data("onChange", null);
        selector.tabs("option", "active", State);
        $("#g_" + Gadget).data("onChange", cb);
    };
    cGadget.SetGadgetState_Tree = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
    };
    cGadget.SetGadgetState_Splitter = function (Gadget, State) {
        var selector = $("#g_" + Gadget);
        var splitterGadget = selector.split({});
        splitterGadget.position(State, false);
    };
    cGadget.SetGadgetState = function (Gadget, State, Callback) {
        if (Callback === void 0) { Callback = null; }
        var functionName = "SetGadgetState";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, State, Callback);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, State, Callback);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_Calendar:
                cGadget.SetGadgetState_Calendar(Gadget, State);
                break;
            case cConstants.PB_GadgetType_CheckBox:
                cGadget.SetGadgetState_CheckBox(Gadget, State);
                break;
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.SetGadgetState_ComboBox(Gadget, State);
                break;
            case cConstants.PB_GadgetType_Date:
                cGadget.SetGadgetState_Date(Gadget, State);
                break;
            case cConstants.PB_GadgetType_Image:
                cGadget.SetGadgetState_Image(Gadget, State, Callback);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.SetGadgetState_ListIcon(Gadget, State);
                break;
            case cConstants.PB_GadgetType_ListView:
                cGadget.SetGadgetState_ListView(Gadget, State);
                break;
            case cConstants.PB_GadgetType_Option:
                cGadget.SetGadgetState_Option(Gadget, State);
                break;
            case cConstants.PB_GadgetType_Panel:
                cGadget.SetGadgetState_Panel(Gadget, State);
                break;
            case cConstants.PB_GadgetType_ProgressBar:
                selector.progressbar("option", "value", State);
                break;
            case cConstants.PB_GadgetType_Spin:
                selector.spinner("value", State);
                break;
            case cConstants.PB_GadgetType_Splitter:
                cGadget.SetGadgetState_Splitter(Gadget, State);
                break;
            case cConstants.PB_GadgetType_TrackBar:
                var min = selector.slider("option", "min");
                var max = selector.slider("option", "max");
                if (State < min)
                    State = min;
                if (State > max)
                    State = max;
                selector.slider("option", "value", State);
                break;
            case cConstants.PB_GadgetType_Tree:
                cGadget.SetGadgetState_Tree(Gadget, State);
                break;
            case cConstants.PB_GadgetType_ButtonImage:
            case cConstants.PB_GadgetType_IPAddress:
            case cConstants.PB_GadgetType_MDI:
            case cConstants.PB_GadgetType_ScrollBar:
            case cConstants.PB_GadgetType_Shortcut:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.SetGadgetText_Button = function (Gadget, Text) {
        var selector = $("#g_" + Gadget);
        if (selector.is("input")) {
            $("#g_" + Gadget + "_label").text(Text);
        }
        else {
            selector.button().text(Text);
        }
    };
    cGadget.SetGadgetText_ComboBox = function (Gadget, Text) {
        switch ($("#g_" + Gadget).data("cbtype")) {
            case "combobox":
                $("#g_" + Gadget + "_uiautocompleteinput").val(Text);
                break;
            case "selectmenu":
                $("#g_" + Gadget + "-button").find(".ui-selectmenu-text").html(Text);
                break;
            case "simple":
                $("#g_" + Gadget).val(Text);
                break;
        }
    };
    cGadget.SetGadgetText_Date = function (Gadget, Text) {
        var selector = $("#g_" + Gadget);
        var oldPPh = cPixelPerfect.DateGadgetHeight;
        cPixelPerfect.DateGadgetHeight = 0;
        cGadget.DateGadget(Gadget, cGadget.GadgetX(Gadget), cGadget.GadgetY(Gadget), cGadget.GadgetWidth(Gadget), cGadget.GadgetHeight(Gadget), Text, selector.data("xDate"), selector.data("Flags"), selector.data("onChange"));
        cPixelPerfect.DateGadgetHeight = oldPPh;
    };
    cGadget.SetGadgetText_ListIcon = function (Gadget, Text) {
        var selectedItem = cGadget.GetGadgetState(Gadget);
        if (selectedItem > -1) {
            w2ui["w2ui_g_" + Gadget].records[selectedItem][w2ui["w2ui_g_" + Gadget].columns[0].field] = Text;
            w2ui["w2ui_g_" + Gadget].refresh();
        }
    };
    cGadget.SetGadgetText = function (Gadget, Text) {
        var functionName = "SetGadgetText";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        var gadgetType = cGadget.GadgetType(Gadget);
        if (cCommon.isUserGadgetProcedure(gadgetType, functionName)) {
            return p2w_UserGadget[gadgetType][functionName](Gadget, Text);
        }
        if (cCommon.isPbGadgetProcedure(gadgetType, functionName)) {
            return p2w_PbGadget[gadgetType][functionName](Gadget, Text);
        }
        switch (gadgetType) {
            case cConstants.PB_GadgetType_CheckBox:
                selector.find("label").html(Text);
                break;
            case cConstants.PB_GadgetType_ComboBox:
                cGadget.SetGadgetText_ComboBox(Gadget, Text);
                break;
            case cConstants.PB_GadgetType_Date:
                cGadget.SetGadgetText_Date(Gadget, Text);
                break;
            case cConstants.PB_GadgetType_Editor:
                selector.val(Text);
                break;
            case cConstants.PB_GadgetType_Html:
                selector.html(Text);
                break;
            case cConstants.PB_GadgetType_ListIcon:
                cGadget.SetGadgetText_ListIcon(Gadget, Text);
                break;
            case cConstants.PB_GadgetType_Option:
                selector.find("label").html(Text);
                break;
            case cConstants.PB_GadgetType_Spin:
                selector.spinner("value", Text);
                break;
            case cConstants.PB_GadgetType_String:
                selector.val(Text);
                break;
            case cConstants.PB_GadgetType_Text:
                selector.html(Text);
                break;
            case cConstants.PB_GadgetType_HyperLink:
                selector.html(Text);
                break;
            case cConstants.PB_GadgetType_Tree:
                var node = selector.fancytree("getActiveNode");
                if (node)
                    node.setTitle(Text);
                break;
            case cConstants.PB_GadgetType_Web:
                selector.attr("src", Text);
                break;
            case cConstants.PB_GadgetType_ExplorerCombo:
            case cConstants.PB_GadgetType_ExplorerList:
            case cConstants.PB_GadgetType_ExplorerTree:
            case cConstants.PB_GadgetType_Frame:
                
                break;
            default:
                cCommon.UnsupportedGadgetType(functionName, Gadget);
                break;
        }
    };
    cGadget.ShortcutGadget = function (Gadget, x, y, Width, Height, Shortcut) {
        
        return -1;
    };
    cGadget.SpinGadget = function (Gadget, x, y, Width, Height, Minimum, Maximum, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector;
        if (cCommon.CheckFlag(Flags, cConstants.PB_Spin_ReadOnly)) {
            selector = $("<input readonly />");
        }
        else {
            selector = $("<input />");
        }
        Height -= cPixelPerfect.SpinGadgetHeightOffset;
        Width -= cPixelPerfect.SpinGadgetWidthOffset;
        selector.attr("id", "g_" + Gadget);
        selector.css("text-align", "right");
        cCommon.CurrentContainer.append(selector);
        var spinOptions = {
            min: Minimum,
            max: Maximum,
            culture: cSystem.GetBrowserLanguage()
        };
        selector.data("GadgetType", cConstants.PB_GadgetType_Spin);
        selector.spinner(spinOptions);
        selector.parent().css("position", "absolute");
        selector.parent().css("left", x);
        selector.parent().css("top", y);
        selector.css("width", Width);
        selector.css("height", Height);
        selector.addClass("p2w-gadget");
        selector.on("spinchange", function (event, ui) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_Change);
        });
        selector.parent().find(".ui-spinner-up").on("click", function (event, ui) {
            if (selector.data("onUp")) {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_Up;
                selector.data("onUp")();
            }
        });
        selector.parent().find(".ui-spinner-down").on("click", function (event, ui) {
            if (selector.data("onDown")) {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_Down;
                selector.data("onDown")();
            }
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.SplitterGadget = function (Gadget, x, y, Width, Height, Gadget1, Gadget2, Flags) {
        if (Flags === void 0) { Flags = 0; }
        if (!cGadget.IsGadget(Gadget1)) {
            
            return -1;
        }
        if (!cGadget.IsGadget(Gadget2)) {
            
            return -1;
        }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<div />");
        selector.attr("id", "g_" + Gadget);
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        var firstGadget = $("#g_" + Gadget1);
        firstGadget.css("position", "");
        firstGadget.css("width", "100%");
        firstGadget.css("height", "100%");
        firstGadget.css("top", "");
        firstGadget.css("left", "");
        selector.append(firstGadget);
        var secondGadget = $("#g_" + Gadget2);
        secondGadget.css("position", "");
        secondGadget.css("width", "100%");
        secondGadget.css("height", "100%");
        secondGadget.css("top", "");
        secondGadget.css("left", "");
        selector.append(secondGadget);
        var Orientation = "horizontal";
        if (cCommon.CheckFlag(Flags, cConstants.PB_Splitter_Vertical))
            Orientation = "vertical";
        cCommon.CurrentContainer.append(selector);
        selector.split({
            orientation: Orientation,
            limit: 10,
            position: '50%',
            onDragEnd: function (e) {
                if (firstGadget.data("GadgetType") == cConstants.PB_GadgetType_ListIcon)
                    w2ui["w2ui_g_" + Gadget1].refresh();
                if (secondGadget.data("GadgetType") == cConstants.PB_GadgetType_ListIcon)
                    w2ui["w2ui_g_" + Gadget2].refresh();
            }
        });
        selector.data("GadgetType", cConstants.PB_GadgetType_Splitter);
        return Gadget;
    };
    cGadget.GetDefaultColors = function (selector) {
        if (typeof selector.css("color") === "string") {
        }
        selector.data("defaultFrontColor", selector.css("color"));
        selector.data("defaultBackColor", selector.css("background-color"));
    };
    cGadget.StringGadget = function (Gadget, x, y, Width, Height, Content, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<input />");
        selector.attr("id", "g_" + Gadget);
        if (Content !== "") {
            selector.attr("value", Content);
        }
        selector.attr("type", "text");
        selector.addClass("ui-widget ui-widget-content ui-corner-all");
        Height -= cPixelPerfect.StringGadgetHeightOffset;
        Width -= cPixelPerfect.StringGadgetWidthOffset;
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Numeric))
            selector.attr("type", "number");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Password))
            selector.attr("type", "password");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Color))
            selector.attr("type", "color");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Date))
            selector.attr("type", "date");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_DateTime))
            selector.attr("type", "datetime");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_DateTimeLocal))
            selector.attr("type", "datetime-local");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Email))
            selector.attr("type", "email");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Month))
            selector.attr("type", "month");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Range))
            selector.attr("type", "range");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Search))
            selector.attr("type", "search");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Tel))
            selector.attr("type", "tel");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Time))
            selector.attr("type", "time");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Url))
            selector.attr("type", "url");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Week))
            selector.attr("type", "week");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_ReadOnly))
            selector.attr("readonly", "true");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_LowerCase))
            selector.css("text-transform", "lowercase");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_UpperCase))
            selector.css("text-transform", "uppercase");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_BorderLess))
            selector.css("border", "0 none");
        if (cCommon.CheckFlag(Flags, cConstants.PB_String_Left)) {
            selector.css("text-align", "left");
        }
        else if (cCommon.CheckFlag(Flags, cConstants.PB_String_Right)) {
            selector.css("text-align", "right");
        }
        else if (cCommon.CheckFlag(Flags, cConstants.PB_String_Center)) {
            selector.css("text-align", "center");
        }
        selector.data("GadgetType", cConstants.PB_GadgetType_String);
        cCommon.CurrentContainer.append(selector);
        cGadget.GetDefaultColors(selector);
        cFont.SetDefaultFont(selector);
        selector.bind("keypress", function (event) {
            if (selector.data("allowedchars")) {
                var win = window;
                var key = window.event ? win.event.keyCode : (event.keyCode || (event.charCode || undefined));
                var keyChar = String.fromCharCode(key);
                if (!selector.data("allowedchars").test(keyChar)) {
                    event.preventDefault();
                }
            }
        });
        selector.data("oldContent", Content);
        selector.bind("keyup autocompleteselect", function (event) {
            if (selector.data("oldContent") !== cGadget.GetGadgetText(Gadget)) {
                selector.data("oldContent", cGadget.GetGadgetText(Gadget));
                cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_Change);
            }
        });
        selector.bind("focus", function (event) { cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_Focus); });
        selector.bind("touchstart", function (event) { this.focus(); cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_Focus); });
        selector.bind("focusout", function (event) { cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_LostFocus); });
        selector.bind("keypress", function (event) { cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_ReturnKey); });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.TextGadget = function (Gadget, x, y, Width, Height, Text, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<label />");
        selector.attr("id", "g_" + Gadget);
        selector.html(Text);
        selector.css("overflow", "hidden");
        selector.css("white-space", "pre-wrap");
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        if (Height === cConstants.PB_Ignore || Height === -1) {
            selector.css("height", "auto");
        }
        else {
            selector.css("height", Height);
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Text_Center)) {
            selector.css("text-align", "center");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Text_Middle)) {
            selector.css("vertical-align", "middle");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Text_Right)) {
            selector.css("text-align", "right");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Text_Border)) {
            selector.addClass("ui-widget-content");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Text_Rounded_Corners)) {
            selector.addClass("ui-corner-all");
        }
        cFont.SetDefaultFont(selector);
        selector.addClass("ui-widget");
        selector.data("GadgetType", cConstants.PB_GadgetType_Text);
        cCommon.CurrentContainer.append(selector);
        cGadget.GetDefaultColors(selector);
        selector.bind("click", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_LeftClick);
        });
        selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_LeftDoubleClick);
        });
        selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_RightClick);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.TrackBarGadget = function (Gadget, x, y, Width, Height, Minimum, Maximum, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var selector = $("<div />");
        selector.attr("id", "g_" + Gadget);
        selector.css("position", "absolute");
        selector.css("left", x);
        selector.css("top", y);
        var sliderOptions = {
            min: Minimum,
            max: Maximum,
            orientation: ''
        };
        if (cCommon.CheckFlag(Flags, cConstants.PB_TrackBar_Vertical)) {
            selector.css("height", Height);
            sliderOptions.orientation = "vertical";
        }
        else {
            selector.css("width", Width);
            sliderOptions.orientation = "horizontal";
        }
        selector.data("GadgetType", cConstants.PB_GadgetType_TrackBar);
        selector.slider(sliderOptions);
        if (cCommon.CheckFlag(Flags, cConstants.PB_TrackBar_Ticks)) {
            selector.slider('pips', {
                prefix: "",
                suffix: ""
            });
            selector.slider('float', {
                handle: true,
                pips: true,
                prefix: "",
                suffix: ""
            });
        }
        cCommon.CurrentContainer.append(selector);
        selector.on("slidechange", function (event, ui) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_Change);
        });
        selector.on("slide", function (event, ui) {
            $(this).slider('value', ui.value);
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_Change);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return Gadget;
    };
    cGadget.TreeGadget = function (Gadget, x, y, Width, Height, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var treeGadget = new cControl(Gadget, x, y, Width, Height, "<div />");
        var ShowLine = true;
        var CheckBox = false;
        if (cCommon.CheckFlag(Flags, cConstants.PB_Tree_AlwaysShowSelection)) {
            
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Tree_NoLines)) {
            ShowLine = false;
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Tree_NoButtons)) {
            
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Tree_CheckBoxes)) {
            CheckBox = true;
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Tree_ThreeState)) {
            
        }
        treeGadget.selector.fancytree({
            extensions: ["themeroller"],
            source: [],
            checkbox: CheckBox
        });
        Width -= cPixelPerfect.TreeGadgetWidthOffset;
        Height -= cPixelPerfect.TreeGadgetHeightOffset;
        treeGadget.selector.find(".fancytree-container").css("width", "100%");
        treeGadget.selector.find(".fancytree-container").css("height", "100%");
        treeGadget.selector.find(".fancytree-container").css("margin", "0");
        treeGadget.selector.find(".fancytree-container").css("padding", "0");
        treeGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Tree);
        cCommon.CurrentContainer.append(treeGadget.selector);
        cGadget.GetDefaultColors(treeGadget.selector);
        treeGadget.selector.bind("click", function (event) {
            cEvent.HandleEvent(treeGadget.selector, event, treeGadget.ident, cConstants.PB_EventType_LeftClick);
        });
        treeGadget.selector.bind("dblclick", function (event) {
            cEvent.HandleEvent(treeGadget.selector, event, treeGadget.ident, cConstants.PB_EventType_LeftDoubleClick);
        });
        treeGadget.selector.bind("contextmenu", function (event) {
            cEvent.HandleEvent(treeGadget.selector, event, treeGadget.ident, cConstants.PB_EventType_RightClick);
        });
        treeGadget.selector.bind("change", function (event) {
            cEvent.HandleEvent(treeGadget.selector, event, treeGadget.ident, cConstants.PB_EventType_Change);
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return treeGadget.ident;
    };
    cGadget.UnbindGadgetEvent = function (Gadget, Callback, EventType) {
        if (EventType === void 0) { EventType = cConstants.PB_All; }
        var functionName = "UnbindGadgetEvent";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            return cCommon.GadgetIsNotInitialized(functionName);
        }
        cGadgetEvent.BindGadgetEvent(Gadget, Callback, EventType, false);
    };
    cGadget.UseGadgetList = function (WindowID) {
        var selector = $("#g_" + WindowID);
        if (selector.length === 0) {
            selector = $("#w_" + WindowID);
            if (selector.length === 0) {
                return cCommon.GadgetIsNotInitialized("UseGadgetList()");
            }
        }
        if (cCommon.CurrentContainer == null)
            cCommon.CurrentContainer = $("body");
        var OldCurrentContainer = cCommon.CurrentContainer;
        cCommon.CurrentContainer = selector;
        return cString.Mid(OldCurrentContainer.attr("id"), 3);
    };
    cGadget.WebGadget = function (Gadget, x, y, Width, Height, URL) {
        var webGadget = new cControl(Gadget, x, y, Width, Height, "<iframe />");
        webGadget.selector.attr("src", URL);
        webGadget.selector.data("GadgetType", cConstants.PB_GadgetType_Web);
        webGadget.selector.addClass("ui-widget ui-widget-content ui-corner-all");
        cCommon.CurrentContainer.append(webGadget.selector);
        cGadget.GetDefaultColors(webGadget.selector);
        webGadget.selector.bind('load', function (event) {
            if (webGadget.selector.data("onDownloadStart")) {
                cEvent.eventGadget = Gadget;
                cEvent.eventType = cConstants.PB_EventType_DownloadEnd;
                webGadget.selector.data("onDownloadEnd")();
            }
        });
        if ($.fn.GadgetsEvents)
            cGadget.BindGadgetEvent(Gadget, $.fn.GadgetsEvents);
        return webGadget.ident;
    };
    cGadget.WindowTitleButtonGadget = function (Gadget, Icon, ToolTip) {
        if (ToolTip === void 0) { ToolTip = ""; }
        if (!cCommon.CurrentContainer)
            return 0;
        if (cCommon.CurrentContainer.parent().find(".ui-dialog-titlebar-buttonpane").length == 0)
            return 0;
        if (Gadget == cConstants.PB_Any)
            Gadget = cCommon.guid();
        if ($("#g_" + Gadget).length > 0)
            $("#g_" + Gadget).remove();
        var selector;
        selector = $('<button type="button" id="g_' + Gadget + '" ' +
            ' class="ui-button ui-widget ui-state-default ui-corner-all ui-button-icon-only ui-dialog-titlebar-close" ' +
            ' role="button" title="' + ToolTip + '" style="position: relative; float: right; top: auto; right: auto; margin: 0px;">' +
            '	<span class="ui-button-icon-primary ui-icon ' + Icon + '"></span>' +
            '</button>');
        cCommon.CurrentContainer.parent().find(".ui-dialog-titlebar-buttonpane").append(selector);
        selector.data("GadgetType", cConstants.PB_GadgetType_Button);
        selector.bind("click", function (event) {
            cEvent.HandleEvent(selector, event, Gadget, cConstants.PB_EventType_LeftClick);
        });
        if (Gadget == 0)
            return true;
        return Gadget;
    };
    return cGadget;
}());
var cControl = (function () {
    function cControl(Ident, x, y, w, h, selectorHtml) {
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        this.ident = cCommon.SetGadgetAndStuff(Ident);
        this.selector = $(selectorHtml);
        this.selector.attr("id", "g_" + this.ident);
        cCommon.SetGadgetPosition(this.selector, this.x, this.y, this.w, this.h);
    }
    return cControl;
}());
var cHttp = (function () {
    function cHttp() {
    }
    cHttp.GetHTTPHeader = function (URL) {
        
        return "";
    };
    cHttp.GetURLPart = function (URL, Parameter) {
        
        return "";
    };
    cHttp.HttpRequest = function (Type, URL, Parameters, Callback, UserData) {
        if (UserData === void 0) { UserData = 0; }
        $.ajax({
            url: URL,
            type: (Type == cConstants.PB_HTTP_Post ? "POST" : "GET"),
            data: Parameters,
            cache: false,
            success: function (result) { if (Callback)
                Callback(true, result, UserData); },
            error: function () { if (Callback)
                Callback(false, "", UserData); }
        });
    };
    cHttp.ReceiveHTTPFile = function (URL, Filename) {
        $.ajax({
            url: URL,
            type: "GET",
            async: true,
            success: function (result) {
                var blob = new Blob([result]);
                saveAs(blob, Filename);
            },
            error: function () {
            }
        });
        return 0;
    };
    cHttp.ReceiveHTTPMemory = function (URL, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        var ReturnValue;
        try {
            var jas = {
                url: URL,
                async: false,
                success: null,
                error: null
            };
            if (cCommon.CheckFlag(Flags, cConstants.PB_HTTP_Asynchronous))
                jas.async = true;
            if (cCommon.CheckFlag(Flags, cConstants.PB_HTTP_NoRedirect)) {
            }
            if (jas.async) {
                jas.success = function (result) {
                    if (typeof Callback === "function") {
                        ReturnValue = true;
                        Callback(true, result);
                    }
                };
                jas.error = function (jqXHR, textStatus, errorThrown) {
                    if (typeof Callback === "function") {
                        ReturnValue = false;
                        Callback(false, "error: textStatus: " + textStatus + " errorThrown: " + errorThrown);
                    }
                };
            }
            else {
                jas.success = function (result) {
                    ReturnValue = result;
                };
                jas.error = function (jqXHR, textStatus, errorThrown) {
                    ReturnValue = "error: textStatus: " + textStatus + " errorThrown: " + errorThrown;
                };
            }
            $.ajax(jas);
        }
        catch (err) {
            if (typeof Callback === "function") {
                ReturnValue = false;
                Callback(false, "error (catch): " + err);
            }
            else {
                ReturnValue = "error (catch): " + err;
            }
        }
        return ReturnValue;
    };
    cHttp.SetURLPart = function (URL, Parameter, Value) {
        
        return "";
    };
    cHttp.URLDecoder = function (URL) {
        return decodeURIComponent(URL);
    };
    cHttp.URLEncoder = function (URL) {
        return encodeURIComponent(URL);
    };
    return cHttp;
}());
var cImage = (function () {
    function cImage() {
    }
    cImage.CatchImage = function (I, MemoryAddress, Size) {
        if (Size === void 0) { Size = 0; }
        if (I === cConstants.PB_Any)
            I = cCommon.guid();
        var img = new Image();
        img.src = MemoryAddress;
        cCommon.P2W_ImageList[I] = img;
        if (I === 0)
            return true;
        return I;
    };
    cImage.CopyImage = function (I1, I2) {
        var img1 = cCommon.P2W_ImageList[I1];
        if (img1 === null) {
            cCommon.ImageIsNotInitialized("CopyImage()");
            return 0;
        }
        if (I2 === cConstants.PB_Any)
            I2 = cCommon.guid();
        var img2 = new Image();
        img2.src = img1.src;
        cCommon.P2W_ImageList[I2] = img2;
        if (I2 === 0)
            return true;
        return I2;
    };
    cImage.CreateImage = function (I, Width, Height, Depth, BackColor) {
        if (Depth === void 0) { Depth = 0; }
        if (BackColor === void 0) { BackColor = "black"; }
        if (I === cConstants.PB_Any)
            I = cCommon.guid();
        var img = new Image();
        var canvas = document.createElement("canvas");
        canvas.width = Width;
        canvas.height = Height;
        var ctx = canvas.getContext("2d");
        ctx.fillStyle = BackColor;
        ctx.fillRect(0, 0, Width, Height);
        img.src = canvas.toDataURL("image/png");
        cCommon.P2W_ImageList[I] = img;
        if (I === 0)
            return true;
        return I;
    };
    cImage.EncodeImage = function (I, ImagePlugin, Flags, Depth) {
        if (ImagePlugin === void 0) { ImagePlugin = 0; }
        if (Flags === void 0) { Flags = 0; }
        if (Depth === void 0) { Depth = 0; }
        
        return -1;
    };
    cImage.FreeImage = function (I) {
        cCommon.P2W_ImageList[I] = null;
        delete cCommon.P2W_ImageList[I];
    };
    cImage.GrabImage = function (I1, I2, x, y, Width, Height) {
        
        return -1;
    };
    cImage.ImageDepth = function (I, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return -1;
    };
    cImage.ImageFormat = function (I) {
        
        return -1;
    };
    cImage.ImageHeight = function (I) {
        var img = cCommon.P2W_ImageList[I];
        if (img === null) {
            cCommon.ImageIsNotInitialized("ImageHeight()");
            return 0;
        }
        return img.height;
    };
    cImage.ImageID = function (I) {
        return I;
    };
    cImage.ImageOutput = function (I) {
        return "i_" + I;
    };
    cImage.ImageWidth = function (I) {
        var img = cCommon.P2W_ImageList[I];
        if (img === null) {
            cCommon.ImageIsNotInitialized("ImageWidth()");
            return 0;
        }
        return img.width;
    };
    cImage.IsImage = function (I) {
        return (cCommon.P2W_ImageList[I] != null);
    };
    cImage.LoadImage = function (I, Filename, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        if (I === cConstants.PB_Any)
            I = cCommon.guid();
        Filename = Filename.replace(/\\/g, "/");
        var img = new Image();
        cCommon.P2W_ImageList[I] = img;
        $(img).on("load", function () {
            $(img).css("width", img.width);
            $(img).css("height", img.height);
            if (typeof Callback === "function")
                Callback(I);
        });
        $(img).on("error", function () {
            
        });
        img.src = Filename;
        return I;
    };
    cImage.ResizeImage = function (I, Width, Height, Mode) {
        if (Mode === void 0) { Mode = 0; }
        var img = cCommon.P2W_ImageList[I];
        if (img === null) {
            cCommon.ImageIsNotInitialized("ResizeImage()");
            return 0;
        }
        if (Width != cConstants.PB_Ignore)
            img.width = Width;
        if (Height != cConstants.PB_Ignore)
            img.height = Height;
        return 1;
    };
    cImage.SaveImage = function (I, FileName, ImagePlugin, Flags, Depth) {
        if (ImagePlugin === void 0) { ImagePlugin = 0; }
        if (Flags === void 0) { Flags = 0; }
        if (Depth === void 0) { Depth = 0; }
        if (!cCommon.checkBlob())
            return 0;
        var img = cCommon.P2W_ImageList[I];
        if (img === null) {
            cCommon.ImageIsNotInitialized("SaveImage()");
            return 0;
        }
        FileName = FileName.replace(/\\/g, "/");
        var drawingCanvas = document.createElement("canvas");
        var drawingContext = drawingCanvas.getContext("2d");
        drawingCanvas.width = img.width;
        drawingCanvas.height = img.height;
        drawingContext.drawImage(img, 0, 0);
        drawingCanvas.toBlobX(function (blob) {
            saveAs(blob, FileName);
        }, "image/png");
        return 1;
    };
    return cImage;
}());
var cImagePlugin = (function () {
    function cImagePlugin() {
    }
    cImagePlugin.UseJPEG2000ImageDecoder = function () {
    };
    cImagePlugin.UseJPEG2000ImageEncoder = function () {
    };
    cImagePlugin.UseJPEGImageDecoder = function () {
    };
    cImagePlugin.UseJPEGImageEncoder = function () {
    };
    cImagePlugin.UsePNGImageDecoder = function () {
    };
    cImagePlugin.UsePNGImageEncoder = function () {
    };
    cImagePlugin.UseTGAImageDecoder = function () {
    };
    cImagePlugin.UseTIFFImageDecoder = function () {
    };
    return cImagePlugin;
}());
var cJson = (function () {
    function cJson() {
    }
    cJson.JsonStringToObject = function (Text) {
        return JSON.parse(Text);
    };
    cJson.JsonObjectToString = function (Object) {
        return JSON.stringify(Object);
    };
    cJson.AddJSONElement = function (JSONValue, Index) {
        if (Index === void 0) { Index = null; }
        
    };
    cJson.AddJSONMember = function (JSONValue, Key) {
        var newElement = new Object();
        newElement[Key] = null;
        for (var ListItem in this.JsonArray) {
            if (this.JsonArray[ListItem] === JSONValue) {
                if (this.JSONType(JSONValue) == cConstants.PB_JSON_Array) {
                    this.JsonArray[ListItem].push(newElement);
                }
                else if (this.JSONType(JSONValue) == cConstants.PB_JSON_Object) {
                    this.JsonArray[ListItem] = $.extend(this.JsonArray[ListItem], newElement);
                }
                return JSONValue;
            }
        }
    };
    cJson.CatchJSON = function (JSON, Buffer, Size, Flags) {
        if (Flags === void 0) { Flags = null; }
        if (JSON == cConstants.PB_Any)
            JSON = cCommon.guid();
        this.JsonArray[JSON] = Buffer;
        if (JSON == 0)
            return true;
        return JSON;
    };
    cJson.ClearJSONElements = function (JSONValue) {
        
    };
    cJson.ClearJSONMembers = function (JSONValue) {
        
    };
    cJson.ComposeJSON = function (xJSON, Flags) {
        if (Flags === void 0) { Flags = null; }
        var json = this.JsonArray[xJSON];
        if (Flags == cConstants.PB_JSON_PrettyPrint)
            return JSON.stringify(json, null, "\t");
        return JSON.stringify(json);
    };
    cJson.CreateJSON = function (JSON, Flags) {
        if (Flags === void 0) { Flags = null; }
        if (JSON == cConstants.PB_Any)
            JSON = cCommon.guid();
        this.JsonArray[JSON] = null;
        if (JSON == 0)
            return true;
        return JSON;
    };
    cJson.ExamineJSONMembers = function (JSONValue) {
        
        return 0;
    };
    cJson.ExportJSON = function (JSON, Buffer, Size, Flags) {
        if (Flags === void 0) { Flags = null; }
        
        return 0;
    };
    cJson.ExportJSONSize = function (JSON, Flags) {
        if (Flags === void 0) { Flags = null; }
        
        return 0;
    };
    cJson.ExtractJSONArray = function (JSONValue, Array) {
        $.extend(true, Array, JSONValue);
    };
    cJson.ExtractJSONList = function (JSONValue, List) {
        List.ClearList();
        $.each(JSONValue, function (key, value) {
            List.AddElement();
            List.SetContent(value);
        });
    };
    cJson.ExtractJSONMap = function (JSONValue, Map) {
        $.extend(true, Map.data, JSONValue);
    };
    cJson.ExtractJSONStructure = function (JSONValue, Buffer, Structure) {
        $.extend(true, Buffer, JSONValue);
    };
    cJson.FreeJSON = function (JSON) {
        delete this.JsonArray[JSON];
    };
    cJson.GetJSONBoolean = function (JSONValue) {
        return Boolean(JSONValue);
    };
    cJson.GetJSONDouble = function (JSONValue) {
        return parseFloat(JSONValue);
    };
    cJson.GetJSONElement = function (JSONValue, Index) {
        if (this.JSONType(JSONValue) == cConstants.PB_JSON_Array) {
            return JSONValue[Index];
        }
        else if (this.JSONType(JSONValue) == cConstants.PB_JSON_Object) {
            return JSONValue[Object.getOwnPropertyNames(JSONValue)[Index]];
        }
    };
    cJson.GetJSONFloat = function (JSONValue) {
        return parseFloat(JSONValue);
    };
    cJson.GetJSONInteger = function (JSONValue) {
        return parseInt(JSONValue);
    };
    cJson.GetJSONMember = function (JSONValue, Key) {
        return JSONValue[Key];
    };
    cJson.GetJSONQuad = function (JSONValue) {
        return JSONValue;
    };
    cJson.GetJSONString = function (JSONValue) {
        return JSONValue;
    };
    cJson.InsertJSONArray = function (JSONValue, Array) {
        for (var ArrayItem in this.JsonArray) {
            if (this.JsonArray[ArrayItem] == JSONValue) {
                if (this.JsonArray[ArrayItem] === null) {
                    this.JsonArray[ArrayItem] = Array;
                    JSONValue = this.JsonArray[ArrayItem];
                }
                else {
                    JSONValue = $.extend(JSONValue, Array);
                }
                return;
            }
        }
    };
    cJson.InsertJSONList = function (JSONValue, List) {
        for (var ArrayItem in this.JsonArray) {
            if (this.JsonArray[ArrayItem] == JSONValue) {
                var dummyArray = [];
                List.ForEach_Start();
                while (List.ForEach()) {
                    dummyArray.push(List.GetContent());
                }
                List.ForEach_End();
                if (this.JsonArray[ArrayItem] === null) {
                    this.JsonArray[ArrayItem] = dummyArray;
                    JSONValue = this.JsonArray[ArrayItem];
                }
                else {
                    JSONValue = $.extend(JSONValue, dummyArray);
                }
            }
        }
    };
    cJson.InsertJSONMap = function (JSONValue, Map) {
        for (var ArrayItem in this.JsonArray) {
            if (this.JsonArray[ArrayItem] == JSONValue) {
                if (this.JsonArray[ArrayItem] === null) {
                    this.JsonArray[ArrayItem] = $.extend({}, Map.data);
                    JSONValue = this.JsonArray[ArrayItem];
                }
                else {
                    JSONValue = $.extend(JSONValue, Map.data);
                }
                return;
            }
        }
    };
    cJson.InsertJSONStructure = function (JSONValue, Buffer, Structure) {
        for (var ArrayItem in this.JsonArray) {
            if (this.JsonArray[ArrayItem] == JSONValue) {
                if (this.JsonArray[ArrayItem] === null) {
                    this.JsonArray[ArrayItem] = $.extend({}, Buffer);
                    JSONValue = this.JsonArray[ArrayItem];
                }
                else {
                    JSONValue = $.extend(JSONValue, Buffer);
                }
                return;
            }
        }
    };
    cJson.IsJSON = function (JSON) {
        return !(this.JsonArray[JSON] === undefined);
    };
    cJson.JSONArraySize = function (JSONValue) {
        if (this.JSONType(JSONValue) == cConstants.PB_JSON_Array)
            return JSONValue.length;
        return -1;
    };
    cJson.JSONErrorLine = function () {
        
        return 0;
    };
    cJson.JSONErrorMessage = function () {
        return cCommon.JSONErrorMessage;
    };
    cJson.JSONErrorPosition = function () {
        
        return 0;
    };
    cJson.JSONMemberKey = function (JSONValue) {
        
        return "";
    };
    cJson.JSONMemberValue = function (JSONValue) {
        
        return 0;
    };
    cJson.JSONObjectSize = function (JSONValue) {
        if (this.JSONType(JSONValue) == cConstants.PB_JSON_Object)
            return Object.getOwnPropertyNames(JSONValue).length;
        return -1;
    };
    cJson.JSONType = function (JSONValue) {
        var jsonType = ({}).toString.call(JSONValue).match(/\s([a-z|A-Z]+)/)[1].toLowerCase();
        switch (jsonType) {
            case "array": return cConstants.PB_JSON_Array;
            case "string": return cConstants.PB_JSON_String;
            case "number": return cConstants.PB_JSON_Number;
            case "null": return cConstants.PB_JSON_Null;
            case "object": return cConstants.PB_JSON_Object;
            case "boolean": return cConstants.PB_JSON_Boolean;
            default: return 0;
        }
        ;
    };
    cJson.JSONValue = function (JSON) {
        return this.JsonArray[JSON];
    };
    cJson.LoadJSON = function (JSON, FileName, Flags, Callback) {
        if (Flags === void 0) { Flags = null; }
        if (Callback === void 0) { Callback = null; }
        if (JSON == cConstants.PB_Any)
            JSON = cCommon.guid();
        var async = false;
        if (typeof Callback === "function")
            async = true;
        $.ajax({
            type: "get",
            dataType: "json",
            url: FileName,
            cache: false,
            async: async,
            success: function (data) {
                this.JsonArray[JSON] = data;
                if (typeof Callback === "function")
                    Callback(true, data);
            },
            error: function (jqXHR, textStatus, errorThrown) {
                if (typeof Callback === "function")
                    Callback(false, jqXHR);
            }
        });
        if (JSON == 0)
            return true;
        return JSON;
    };
    cJson.NextJSONMember = function (JSONValue) {
        
        return 0;
    };
    cJson.ParseJSON = function (JSON, Input, Flags) {
        if (Flags === void 0) { Flags = null; }
        if (JSON == cConstants.PB_Any)
            JSON = cCommon.guid();
        try {
            this.JsonArray[JSON] = jQuery.parseJSON(Input);
            cCommon.JSONErrorMessage = "";
        }
        catch (e) {
            cCommon.JSONErrorMessage = e.message;
            return 0;
        }
        if (JSON == 0)
            return true;
        return JSON;
    };
    cJson.RemoveJSONElement = function (JSONValue, Index) {
        
    };
    cJson.RemoveJSONMember = function (JSONValue, Key) {
        
    };
    cJson.ResizeJSONElements = function (JSONValue, Size) {
        
    };
    cJson.SaveJSON = function (JSON, FileName, Flags) {
        if (Flags === void 0) { Flags = null; }
        
        return 0;
    };
    cJson.SetJSONArray = function (JSONValue) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = new Array();
    };
    cJson.SetJSONBoolean = function (JSONValue, Value) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = Value;
    };
    cJson.SetJSONDouble = function (JSONValue, Value) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = Value;
    };
    cJson.SetJSONFloat = function (JSONValue, Value) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = Value;
    };
    cJson.SetJSONInteger = function (JSONValue, Value) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = Value;
    };
    cJson.SetJSONNull = function (JSONValue) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = null;
    };
    cJson.SetJSONObject = function (JSONValue) {
        for (var ArrayItem in this.JsonArray) {
            if (this.JsonArray[ArrayItem] == JSONValue) {
                this.JsonArray[ArrayItem] = new Object();
                return this.JsonArray[ArrayItem];
            }
        }
    };
    cJson.SetJSONQuad = function (JSONValue, Value) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = Value;
    };
    cJson.SetJSONString = function (JSONValue, String) {
        JSONValue[Object.getOwnPropertyNames(JSONValue)[Object.getOwnPropertyNames(JSONValue).length - 1]] = String;
    };
    cJson.JsonArray = [];
    return cJson;
}());
var cKeyboard = (function () {
    function cKeyboard() {
    }
    cKeyboard.ExamineKeyboard = function () {  };
    cKeyboard.InitKeyboard = function () {  };
    cKeyboard.KeyboardInkey = function () {  };
    cKeyboard.KeyboardMode = function () {  };
    cKeyboard.KeyboardPushed = function () {  };
    cKeyboard.KeyboardReleased = function () {  };
    return cKeyboard;
}());
var cLibrary = (function () {
    function cLibrary() {
    }
    cLibrary.CallCFunction = function () {
        
    };
    cLibrary.CallCFunctionFast = function () {
        
    };
    cLibrary.CallFunction = function () {
        
    };
    cLibrary.CallFunctionFast = function () {
        
    };
    cLibrary.CloseLibrary = function (Library) {
        $("#p2wl_" + Library).remove();
    };
    cLibrary.CountLibraryFunctions = function () {
        
    };
    cLibrary.ExamineLibraryFunctions = function (Library) {
        
    };
    cLibrary.GetFunction = function () {
        
    };
    cLibrary.GetFunctionEntry = function () {
        
    };
    cLibrary.IsLibrary = function (Library) {
        if ($("#p2wl_" + Library).length === 0)
            return false;
        return true;
    };
    cLibrary.LibraryFunctionAddress = function () {
        
    };
    cLibrary.LibraryFunctionName = function () {
        
    };
    cLibrary.LibraryID = function () {
        
    };
    cLibrary.NextLibraryFunction = function () {
        
    };
    cLibrary.OpenLibrary = function (Library, Filename, Callback) {
        if (Callback === void 0) { Callback = null; }
        if (Library === cConstants.PB_Any)
            Library = cCommon.guid();
        if ($("#p2wl_" + Library).length > 0)
            cLibrary.CloseLibrary(Library);
        if (cString.EndsWith(Filename.toLowerCase(), ".css") === true) {
            var request = $.ajax({
                url: Filename,
                async: false,
                timeout: 5000
            });
            request.done(function (data) {
                var style = $("<style />");
                style.attr("id", "p2wl_" + Library);
                style.text(data);
                $("head").append(style);
                if (Callback) {
                    Callback(true, data, Filename);
                }
            });
            request.fail(function (jqXHR, textStatus) {
                if (Callback) {
                    Callback(false, jqXHR, textStatus, Filename);
                }
            });
        }
        else {
            var request = $.ajax({
                url: Filename,
                async: false,
                dataType: 'script',
                timeout: 5000
            });
            request.done(function (data) {
                var script = $("<script />");
                script.attr("id", "p2wl_" + Library);
                script.attr("type", "text/javascript");
                script.text(data);
                $("head").append(script);
                if (Callback) {
                    Callback(true, data, Filename);
                }
            });
            request.fail(function (jqXHR, textStatus) {
                if (Callback) {
                    Callback(false, jqXHR, textStatus, Filename);
                }
            });
        }
        if (Library === 0)
            return true;
        return Library;
    };
    return cLibrary;
}());
var cNode = (function () {
    function cNode(Structure) {
        this.Next = null;
        this.Prev = null;
        this.Content = null;
        if (Structure) {
            this.Content = Structure;
        }
        else {
            this.Content = {};
        }
    }
    return cNode;
}());
var cLinkedList = (function () {
    function cLinkedList() {
        this.FirstNode = null;
        this.LastNode = null;
        this.CurrentNode = null;
        this.Stack = [];
    }
    cLinkedList.prototype.AddElement = function (Structure) {
        var Node = new cNode(Structure);
        if (this.FirstNode != null) {
            if (this.CurrentNode.Next != null) {
                Node.Next = this.CurrentNode.Next;
            }
            Node.Prev = this.CurrentNode;
            this.CurrentNode.Next = Node;
            this.CurrentNode = Node;
        }
        else {
            this.CurrentNode = Node;
            this.FirstNode = Node;
        }
        if (Node.Next == null)
            this.LastNode = Node;
        return this.CurrentNode;
    };
    cLinkedList.prototype.ChangeCurrentElement = function (Node) {
        this.CurrentNode = Node;
    };
    cLinkedList.prototype.PopListPosition = function () {
        this.CurrentNode = this.Stack.pop();
    };
    cLinkedList.prototype.GetCurrentElement = function () {
        return this.CurrentNode;
    };
    cLinkedList.prototype.ListSize = function () {
        var Index = 0;
        if (this.FirstNode == null)
            return 0;
        var Node = this.FirstNode;
        while (Node) {
            Index++;
            if (Node.Next == null)
                break;
            Node = Node.Next;
        }
        return Index;
    };
    cLinkedList.prototype.NextElement = function () {
        if (this.CurrentNode == null) {
            this.CurrentNode = this.FirstNode;
            return this.CurrentNode;
        }
        else {
            if (this.CurrentNode.Next) {
                this.CurrentNode = this.CurrentNode.Next;
                return this.CurrentNode;
            }
            else {
                return 0;
            }
        }
    };
    cLinkedList.prototype.PreviousElement = function () {
        if (this.CurrentNode == null) {
            this.CurrentNode = this.LastNode;
            return this.CurrentNode;
        }
        else {
            if (this.CurrentNode.Prev) {
                this.CurrentNode = this.CurrentNode.Prev;
                return this.CurrentNode;
            }
            else {
                return 0;
            }
        }
    };
    cLinkedList.prototype.PushListPosition = function () {
        this.Stack.push(this.CurrentNode);
    };
    cLinkedList.prototype.ClearList = function () {
        this.FirstNode = null;
        this.CurrentNode = null;
    };
    cLinkedList.prototype.CopyList = function (List) {
        List.ClearList();
        var Node = this.FirstNode;
        while (Node) {
            List.AddElement(null).Content = Node.Content;
            Node = Node.Next;
        }
    };
    cLinkedList.prototype.CountList = function () {
        return this.ListSize();
    };
    cLinkedList.prototype.FirstElement = function () {
        this.CurrentNode = this.FirstNode;
        if (this.CurrentNode)
            return this.CurrentNode;
        return 0;
    };
    cLinkedList.prototype.LastElement = function () {
        var Node = this.FirstNode;
        while (Node) {
            if (Node.Next == null) {
                this.CurrentNode = Node;
                return Node;
            }
            Node = Node.Next;
        }
        return 0;
    };
    cLinkedList.prototype.SplitList = function (List, KeepCurrent) {
        if (KeepCurrent === void 0) { KeepCurrent = false; }
        var Node = null;
        if (KeepCurrent)
            Node = this.CurrentNode.Next;
        else
            Node = this.CurrentNode;
        if (Node) {
            if (Node.Prev)
                Node.Prev.Next = null;
            Node.Prev = null;
            List.FirstNode = Node;
        }
    };
    cLinkedList.prototype.DeleteElement = function (Flag) {
        if (Flag === void 0) { Flag = false; }
        var Node = this.CurrentNode;
        var Prev = Node.Prev;
        var Next = Node.Next;
        if (Next && Prev == null) {
            this.FirstNode = Node.Next;
            this.FirstNode.Prev = null;
        }
        if (Next == null && Prev == null) {
            this.LastNode = null;
            this.FirstNode = null;
            this.CurrentNode = null;
            return null;
        }
        if (Next == null && Prev) {
            Node.Prev.Next = null;
            this.LastNode = Node.Prev;
        }
        if (Next && Prev) {
            Node.Prev.Next = Next;
            Node.Next.Prev = Prev;
        }
        this.CurrentNode = Prev;
        if (Flag) {
            if (Node.Prev == null && Next)
                this.CurrentNode = Next;
        }
        if (this.CurrentNode)
            Node = this.CurrentNode;
        return Node;
    };
    cLinkedList.prototype.SelectElement = function (Index) {
        var Node = this.FirstNode;
        var i = 0;
        while (Node) {
            if (Index == i) {
                this.CurrentNode = Node;
                break;
            }
            i++;
            Node = Node.Next;
        }
        return Node;
    };
    cLinkedList.prototype.ListIndex = function () {
        var Index = 0;
        if (this.CurrentNode == null)
            return -1;
        var Node = this.FirstNode;
        while (Node) {
            if (Node == this.CurrentNode) {
                break;
            }
            Index++;
            Node = Node.Next;
        }
        return Index;
    };
    cLinkedList.prototype.InsertElement = function (Structure) {
        var Node = new cNode(Structure);
        if (this.FirstNode == null) {
            this.FirstNode = Node;
            this.CurrentNode = Node;
        }
        else {
            if (this.CurrentNode.Prev == null) {
                this.FirstNode = Node;
            }
            else {
                this.CurrentNode.Prev.Next = Node;
                Node.Prev = this.CurrentNode.Prev;
            }
            this.CurrentNode.Prev = Node;
            Node.Next = this.CurrentNode;
            this.CurrentNode = Node;
        }
        return this.CurrentNode;
    };
    cLinkedList.prototype.SetContent = function (v) {
        this.CurrentNode.Content = v;
    };
    cLinkedList.prototype.GetContent = function () {
        return this.CurrentNode.Content;
    };
    cLinkedList.prototype.ResetList = function () {
        return this.CurrentNode = null;
    };
    cLinkedList.prototype.MergeLists = function (List, Location) {
        if (Location === void 0) { Location = cConstants.PB_List_Last; }
        var Node = null;
        if (Location == cConstants.PB_List_First) {
            Node = List.FirstElement();
            Node.Prev = this.LastElement();
            Node.Prev.Next = Node;
            List.FirstNode = this.FirstNode;
            this.FirstNode = null;
        }
        else if (Location == cConstants.PB_List_Last) {
            Node = List.LastElement();
            Node.Next = this.FirstNode;
            this.FirstNode.Prev = Node;
            this.FirstNode = null;
        }
        else if (Location == cConstants.PB_List_Before) {
            var Node = List.CurrentNode.Prev;
            if (!Node) {
                this.MergeLists(List, 1);
                return;
            }
            Node.Next.Prev = this.LastNode;
            this.FirstNode.Prev = Node;
            this.LastNode.Next = Node.Next;
            Node.Next = this.FirstNode;
        }
        else if (Location == cConstants.PB_List_After) {
            var Node = List.CurrentNode;
            if (!Node.Next) {
                this.MergeLists(List, 2);
                return;
            }
            Node.Next.Prev = this.LastNode;
            this.FirstNode.Prev = Node;
            this.LastNode.Next = Node.Next;
            Node.Next = this.FirstNode;
        }
    };
    cLinkedList.prototype.MoveElement = function (Location, RelativeNode) {
        if (RelativeNode === void 0) { RelativeNode = null; }
        if (this.FirstNode == null)
            return;
        if (this.FirstNode.Next == null)
            return;
        if (Location == cConstants.PB_List_First) {
            if (this.FirstNode == this.CurrentNode)
                return;
            var Node = this.CurrentNode;
            if (Node.Next) {
                Node.Next.Prev = Node.Prev;
                Node.Prev.Next = Node.Next;
            }
            else {
                Node.Prev.Next = null;
                this.LastNode = Node;
            }
            Node.Prev = null;
            this.FirstNode.Prev = Node;
            Node.Next = this.FirstNode;
            this.FirstNode = Node;
        }
        if (Location == cConstants.PB_List_Last) {
            if (this.CurrentNode.Next == null)
                return;
            var Node = this.CurrentNode;
            if (Node.Prev) {
                Node.Prev.Next = Node.Next;
                Node.Next.Prev = Node.Prev;
            }
            else {
                Node.Next.Prev = null;
                this.FirstNode = Node.Next;
            }
            Node.Next = null;
            this.LastNode.Next = Node;
            Node.Prev = this.LastNode;
            this.LastNode = Node;
        }
        if (Location == cConstants.PB_List_Before) {
            if (this.CurrentNode == RelativeNode)
                return;
            if (RelativeNode == this.FirstNode) {
                this.MoveElement(1);
                return;
            }
            var Node = this.CurrentNode;
            if (Node.Next) {
                Node.Next.Prev = Node.Prev;
            }
            else {
                this.LastNode = Node.Prev;
            }
            if (Node.Prev) {
                Node.Prev.Next = Node.Next;
            }
            else {
                this.FirstNode = Node.Next;
            }
            RelativeNode.Prev.Next = this.CurrentNode;
            this.CurrentNode.Next = RelativeNode;
            RelativeNode.Next.Prev = this.CurrentNode;
        }
        if (Location == cConstants.PB_List_After) {
            if (this.CurrentNode == RelativeNode)
                return;
            if (RelativeNode == this.LastNode) {
                this.MoveElement(2);
                return;
            }
            var Node = this.CurrentNode;
            if (Node.Next) {
                Node.Next.Prev = Node.Prev;
            }
            else {
                this.LastNode = Node.Prev;
            }
            if (Node.Prev) {
                Node.Prev.Next = Node.Next;
            }
            else {
                this.FirstNode = Node.Next;
            }
            RelativeNode.Next.Prev = this.CurrentNode;
            this.CurrentNode.Next = RelativeNode.Next;
            RelativeNode.Next = this.CurrentNode;
        }
    };
    cLinkedList.prototype.SwapElements = function (Node1, Node2) {
        var swap = new Array(4);
        swap[0] = Node1.Prev;
        swap[1] = Node2.Prev;
        swap[2] = Node1.Next;
        swap[3] = Node2.Next;
        if ((Node1.Next == Node2 && Node2.Prev == Node1) || (Node1.Prev == Node2 && Node2.Next == Node1)) {
            Node1.Prev = swap[2];
            Node2.Prev = swap[0];
            Node1.Next = swap[3];
            Node2.Next = swap[1];
        }
        else {
            Node1.Prev = swap[1];
            Node2.Prev = swap[0];
            Node1.Next = swap[3];
            Node2.Next = swap[2];
        }
        if (Node1.Prev)
            Node1.Prev.Next = Node1;
        if (Node1.Next)
            Node1.Next.Prev = Node1;
        if (Node2.Prev)
            Node2.Prev.Next = Node2;
        if (Node2.Next)
            Node2.Next.Prev = Node2;
    };
    cLinkedList.prototype.ForEach_Start = function () {
        this.PushListPosition();
        this.ResetList();
    };
    cLinkedList.prototype.ForEach_End = function () {
        this.PopListPosition();
    };
    cLinkedList.prototype.ForEach = function () {
        var Node;
        if (this.CurrentNode == null) {
            this.CurrentNode = this.FirstNode;
            Node = this.CurrentNode;
        }
        else {
            this.CurrentNode = this.CurrentNode.Next;
            Node = this.CurrentNode;
        }
        return Node;
    };
    return cLinkedList;
}());
var cMapObject = (function () {
    function cMapObject() {
    }
    return cMapObject;
}());
var cMap_oll = (function () {
    function cMap_oll(o) {
        if (o === void 0) { o = null; }
        this.hashTable = new Hashtable;
        this.currentKey = null;
        this.currentIndex = -1;
        this.currentObject = o;
    }
    cMap_oll.prototype.AddMapElement = function (Key, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var mapObject = new cMapObject;
        mapObject.mapObject = this.currentObject;
        this.hashTable.Add(Key, mapObject);
        this.currentKey = Key;
    };
    cMap_oll.prototype.ClearMap = function () {
        this.hashTable = new Hashtable;
        this.currentKey = null;
        this.currentIndex = -1;
        this.currentObject = null;
    };
    cMap_oll.prototype.CopyMap = function (SourceMap, DestinationMap) {
        
    };
    cMap_oll.prototype.DeleteMapElement = function (Key) {
        if (Key === void 0) { Key = null; }
        if (Key == null) {
            this.hashTable.Remove(this.currentKey);
        }
        else {
            this.hashTable.Remove(Key);
        }
    };
    cMap_oll.prototype.FindMapElement = function (Key) {
        var keys = this.hashTable.GetKeys();
        for (var Counter = 0; Counter <= keys.length; Counter++) {
            if (keys[Counter] == Key) {
                this.currentKey = Key;
                return true;
            }
        }
        return false;
    };
    cMap_oll.prototype.FreeMap = function () {
        this.hashTable = new Hashtable;
        this.currentKey = null;
        this.currentIndex = -1;
        this.currentObject = null;
    };
    cMap_oll.prototype.MapKey = function () {
        return this.currentKey;
    };
    cMap_oll.prototype.MapSize = function () {
        return this.hashTable.GetKeys().length;
    };
    cMap_oll.prototype.NextMapElement = function () {
        if (this.currentIndex < this.MapSize() - 1) {
            this.currentIndex += 1;
            var keys = this.hashTable.GetKeys();
            this.currentKey = keys[this.currentIndex];
            return true;
        }
        else {
            return false;
        }
    };
    cMap_oll.prototype.PopMapPosition = function () {
        
    };
    cMap_oll.prototype.PushMapPosition = function () {
        
    };
    cMap_oll.prototype.ResetMap = function () {
        this.currentKey = null;
        this.currentIndex = -1;
    };
    cMap_oll.prototype.ForEach_Init = function () {
        this.currentIndex = -1;
    };
    cMap_oll.prototype.ForEach = function () {
        return this.NextMapElement();
    };
    cMap_oll.prototype.setData = function (data) {
        this.hashTable.Add(this.currentKey, data);
    };
    cMap_oll.prototype.setData2 = function (key, data) {
        this.currentKey = key;
        this.hashTable.Add(key, data);
    };
    cMap_oll.prototype.getData = function () {
        if (!this.hashTable.GetValue(this.currentKey)) {
            var mapObject = new cMapObject;
            mapObject.mapObject = this.currentObject;
            this.hashTable.Add(this.currentKey, mapObject);
        }
        var value = this.hashTable.GetValue(this.currentKey);
        return value.mapObject;
    };
    cMap_oll.prototype.getData2 = function (key) {
        if (!this.hashTable.GetValue(key)) {
            var mapObject = new cMapObject;
            mapObject.mapObject = this.currentObject;
            this.hashTable.Add(key, mapObject);
        }
        this.currentKey = key;
        return this.hashTable.GetValue(key);
    };
    return cMap_oll;
}());
var Hashtable = (function () {
    function Hashtable() {
        this.Items = {};
        this.Count = 0;
    }
    Hashtable.prototype.GetKeys = function () {
        var keys = [];
        for (var property in this.Items) {
            keys.push(property);
        }
        return keys;
    };
    Hashtable.prototype.GetValues = function (value) {
        var values = [];
        for (var property in this.Items) {
            values.push(this.Items[property]);
        }
        return values;
    };
    Hashtable.prototype.GetValue = function (key) {
        return this.Items[key];
    };
    Hashtable.prototype.GetKey = function (value) {
        var key;
        for (var property in this.Items) {
            if (this.Items[property] == value) {
                key = property;
                break;
            }
        }
        return key;
    };
    Hashtable.prototype.Add = function (key, value) {
        var containsKey = this.ContainsKey(key);
        if (!containsKey)
            this.Count++;
        this.Items[key] = value;
        return !containsKey;
    };
    Hashtable.prototype.Remove = function (key) {
        var containsKey = this.ContainsKey(key);
        if (containsKey) {
            this.Count--;
            delete this.Items[key];
        }
        return !containsKey;
    };
    Hashtable.prototype.Clear = function () {
        this.Items = {};
    };
    Hashtable.prototype.ContainsKey = function (key) {
        return (typeof (this.Items[key]) != "undefined");
    };
    Hashtable.prototype.ContainsValue = function (value) {
        return (typeof (this.GetKey(value)) != "undefined");
    };
    return Hashtable;
}());
var cMap = (function () {
    function cMap(Structure) {
        if (Structure === void 0) { Structure = {}; }
        this.currentIndex = 0;
        this.structure = Structure;
        this.data = {};
    }
    cMap.prototype.getIndexOfKey = function (Key) {
        for (var i = 0; i < Object.keys(this.data).length; i++) {
            if (Object.keys(this.data)[i] == Key) {
                return i;
            }
        }
        return -1;
    };
    cMap.prototype.getData = function (Key) {
        if (Key === void 0) { Key = this.MapKey(); }
        if (Key == "") {
            
            return;
        }
        if (!this.data[Key])
            this.AddMapElement(Key);
        this.currentIndex = this.getIndexOfKey(Key);
        return this.data[Key];
    };
    cMap.prototype.setData = function (Value, Key) {
        if (Value === void 0) { Value = null; }
        if (Key === void 0) { Key = this.MapKey(); }
        if (Key == "") {
            
            return;
        }
        if (!this.data[Key])
            this.AddMapElement(Key);
        this.currentIndex = this.getIndexOfKey(Key);
        this.data[Key] = Value;
    };
    cMap.prototype.AddMapElement = function (Key, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var json = JSON.parse(" { \"" + Key + "\" : " + JSON.stringify(this.structure) + " } ");
        $.extend(true, this.data, json);
        this.currentIndex = this.getIndexOfKey(Key);
        return json;
    };
    cMap.prototype.ClearMap = function () {
        this.currentIndex = -1;
        this.data = {};
    };
    cMap.CopyMap = function (SourceMap, DestinationMap) {
        if (JSON.stringify(SourceMap.structure) != JSON.stringify(DestinationMap.structure))
            return false;
        $.extend(true, DestinationMap.data, SourceMap.data);
        return true;
    };
    cMap.prototype.DeleteMapElement = function (Key) {
        if (Key === void 0) { Key = this.MapKey(); }
        delete this.data[Key];
    };
    cMap.prototype.FindMapElement = function (Key) {
        if (this.data[Key])
            return true;
        return false;
    };
    cMap.prototype.FreeMap = function () {
        this.currentIndex = -1;
        this.structure = {};
        this.data = {};
    };
    cMap.prototype.MapKey = function () {
        return Object.keys(this.data)[this.currentIndex];
    };
    cMap.prototype.MapSize = function () {
        return Object.keys(this.data).length;
    };
    cMap.prototype.NextMapElement = function () {
        if (this.currentIndex < this.MapSize() - 1) {
            this.currentIndex += 1;
            return true;
        }
        return false;
    };
    cMap.prototype.PopMapPosition = function () {
        
    };
    cMap.prototype.PushMapPosition = function () {
        
    };
    cMap.prototype.ResetMap = function () {
        this.currentIndex = -1;
    };
    cMap.prototype.ForEach_Init = function () {
        this.currentIndex = -1;
    };
    cMap.prototype.ForEach = function () {
        return this.NextMapElement();
    };
    return cMap;
}());
var cMap2 = (function () {
    function cMap2() {
    }
    return cMap2;
}());
var cMath = (function () {
    function cMath() {
    }
    cMath.ACos = function (Value) {
        return Math.acos(Value);
    };
    cMath.ACosH = function (Value) {
        return Math.log(Value + Math.sqrt(Value * Value - 1));
    };
    cMath.ASin = function (Value) {
        return Math.asin(Value);
    };
    cMath.ASinH = function (Value) {
        return Math.log(Value + Math.sqrt(Value * Value + 1));
    };
    cMath.ATan = function (Value) {
        return Math.atan(Value);
    };
    cMath.ATan2 = function (x, y) {
        return Math.atan2(y, x);
    };
    cMath.ATanH = function (Value) {
        return 0.5 * Math.log((1 + Value) / (1 - Value));
    };
    cMath.Abs = function (Number) {
        return Math.abs(Number) || 0;
    };
    cMath.Cos = function (Angle) {
        return Math.cos(Angle);
    };
    cMath.CosH = function (Angle) {
        return (Math.exp(Angle) + Math.exp(-Angle)) / 2;
    };
    cMath.Degree = function (Angle) {
        return Angle * 180 / Math.PI;
    };
    cMath.Exp = function (Number) {
        return Math.exp(Number);
    };
    cMath.Infinity = function () {
        return -1;
    };
    cMath.Int = function (Number) {
        return Math.floor(Number);
    };
    cMath.IntQ = function (Number) {
        return Math.floor(Number);
    };
    cMath.IsInfinity = function (Value) {
        return -1;
    };
    cMath.IsNaN = function (Value) {
        return -1;
    };
    cMath.Log = function (Number) {
        return Math.log(Number);
    };
    cMath.Log10 = function (Number) {
        return Math.log(Number) / 2.302585092994046;
    };
    cMath.Max = function (Num1, Num2) {
        return Math.max(Num1, Num2);
    };
    cMath.Min = function (Num1, Num2) {
        return Math.min(Num1, Num2);
    };
    cMath.Mod = function (Number, Divisor) {
        return Number % Divisor;
    };
    cMath.NaN = function () {
        return -1;
    };
    cMath.Pow = function (Number, Power) {
        return Math.pow(Number, Power);
    };
    cMath.Radian = function (Angle) {
        return Angle * Math.PI / 180;
    };
    cMath.Random = function (Maximum, Minimum) {
        if (Minimum === void 0) { Minimum = 0; }
        return Math.floor(Math.random() * (Maximum - Minimum + 1) + Minimum);
    };
    cMath.RandomData = function (Buffer, Length) {
    };
    cMath.RandomSeed = function (Value) {
    };
    cMath.Round = function (Number, Mode) {
        switch (Mode) {
            case cConstants.PB_Round_Down:
                return Math.floor(Number);
            case cConstants.PB_Round_Up:
                return Math.ceil(Number);
            case cConstants.PB_Round_Nearest:
                return Math.round(Number);
        }
        return 0;
    };
    cMath.Sign = function (Number) {
        return -1;
    };
    cMath.Sin = function (Angle) {
        return Math.sin(Angle);
    };
    cMath.SinH = function (Angle) {
        return (Math.exp(Angle) - Math.exp(-Angle)) / 2;
    };
    cMath.Sqr = function (Number) {
        return Math.sqrt(Number);
    };
    cMath.Tan = function (Angle) {
        return Math.tan(Angle);
    };
    cMath.TanH = function (Angle) {
        return (Math.exp(Angle) - Math.exp(-Angle)) / (Math.exp(Angle) + Math.exp(-Angle));
    };
    return cMath;
}());
var cMemory = (function () {
    function cMemory() {
    }
    cMemory.AllocateMemory = function () { };
    cMemory.AllocateStructure = function () { };
    cMemory.CompareMemory = function () { };
    cMemory.CompareMemoryString = function () { };
    cMemory.CopyMemory = function () { };
    cMemory.CopyMemoryString = function () { };
    cMemory.FillMemory = function () { };
    cMemory.FreeMemory = function () { };
    cMemory.FreeStructure = function () { };
    cMemory.MemorySize = function () { };
    cMemory.MemoryStringLength = function () { };
    cMemory.MoveMemory = function () { };
    cMemory.PeekA = function () { };
    cMemory.PeekB = function () { };
    cMemory.PeekC = function () { };
    cMemory.PeekD = function () { };
    cMemory.PeekF = function () { };
    cMemory.PeekI = function () { };
    cMemory.PeekL = function () { };
    cMemory.PeekQ = function () { };
    cMemory.PeekS = function () { };
    cMemory.PeekU = function () { };
    cMemory.PeekW = function () { };
    cMemory.PokeA = function () { };
    cMemory.PokeB = function () { };
    cMemory.PokeC = function () { };
    cMemory.PokeD = function () { };
    cMemory.PokeF = function () { };
    cMemory.PokeI = function () { };
    cMemory.PokeL = function () { };
    cMemory.PokeQ = function () { };
    cMemory.PokeS = function () { };
    cMemory.PokeU = function () { };
    cMemory.PokeW = function () { };
    cMemory.ReAllocateMemory = function () { };
    return cMemory;
}());
var cMenu = (function () {
    function cMenu() {
    }
    cMenu.BindMenuEvent = function (Menu, MenuItem, Callback) {
        var functionName = "BindMenuEvent";
        var selector = $("#m_" + Menu).find("a#mi_" + MenuItem);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        selector.data("clickcallback", Callback);
        selector.bind('click', function (event) {
            cEvent.eventMenu = MenuItem;
            cEvent.eventType = cConstants.PB_EventType_LeftClick;
            Callback();
        });
    };
    cMenu.CloseSubMenu = function () {
        cCommon.CurrentSubMenu = cCommon.CurrentSubMenuParent;
    };
    cMenu.CreateImageMenu = function (Menu, WindowID, Flags) {
        if (Flags === void 0) { Flags = 0; }
        return cMenu.CreateMenu(Menu, WindowID);
    };
    cMenu.CreateMenu = function (Menu, WindowID) {
        var Menu = cCommon.SetGadgetAndStuff(Menu);
        var selector = $("<ul />");
        selector.attr("id", "m_" + Menu);
        cCommon.CurrentContainer.append(selector);
        cCommon.CurrentMenu = selector;
        selector.menubar();
        selector.data("MenuType", "NormalMenu");
        return Menu;
    };
    cMenu.CreatePopupImageMenu = function (Menu, Flags) {
        return cMenu.CreatePopupMenu(Menu);
    };
    cMenu.CreatePopupMenu = function (Menu) {
        var Menu = cCommon.SetGadgetAndStuff(Menu);
        var selector = $("<ul />");
        selector.attr("id", "m_" + Menu);
        selector.css("position", "absolute");
        if (cCommon.CurrentContainer == null) {
            cCommon.CurrentContainer = $("body");
        }
        cCommon.CurrentContainer.append(selector);
        cCommon.CurrentMenu = selector;
        cCommon.CurrentSubMenu = cCommon.CurrentMenu;
        selector.menu();
        selector.hide();
        selector.data("MenuType", "PopupMenu");
        return Menu;
    };
    cMenu.DisableMenuItem = function (Menu, MenuItem, State) {
        var functionName = "DisableMenuItem()";
        var selector = $("#m_" + Menu).find("a#mi_" + MenuItem);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        if (State == 1) {
            selector.addClass('ui-state-disabled');
            selector.off("click");
        }
        else if (State == 0) {
            selector.removeClass('ui-state-disabled');
            if (selector.data("clickcallback")) {
                selector.bind('click', function (event) {
                    cEvent.eventMenu = MenuItem;
                    cEvent.eventType = cConstants.PB_EventType_LeftClick;
                    selector.data("clickcallback")();
                });
            }
        }
    };
    cMenu.DisplayPopupMenu = function (Menu, WindowID, x, y) {
        if (x === void 0) { x = -1; }
        if (y === void 0) { y = -1; }
        var functionName = "DisplayPopupMenu()";
        var selector = $("#m_" + Menu);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        if (x == -1) {
            x = cCommon.CurrentMouseX;
        }
        if (y == -1) {
            y = cCommon.CurrentMouseY;
        }
        selector.css("top", y);
        selector.css("left", x);
        selector.css('zIndex', '9999');
        selector.show();
        $(document).bind("keydown", function (event) {
            if (event.which === $.ui.keyCode.ESCAPE) {
                selector.hide();
            }
        }).bind("mousedown", function (event) {
            if (!$(event.target).closest(".ui-menu-item").length) {
                selector.hide();
            }
        });
        selector.bind("click", function (event) {
            selector.hide();
        });
    };
    cMenu.FreeMenu = function (Menu) {
        var functionName = "FreeMenu()";
        var selector = $("#m_" + Menu);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        selector.remove();
        cCommon.CurrentMenu = null;
    };
    cMenu.GetMenuItemState = function () {
        
    };
    cMenu.GetMenuItemText = function (Menu, Item) {
        var functionName = "GetMenuItemText()";
        var selector = $("#m_" + Menu).find("a#mi_" + Item);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        return selector.text();
    };
    cMenu.GetMenuTitleText = function (Menu, Title) {
        var functionName = "GetMenuTitleText()";
        var selector = $("#m_" + Menu).find("li").eq(Title).find("a").find("span").eq(0);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        return selector.text();
    };
    cMenu.HideMenu = function (Menu, State) {
        var functionName = "HideMenu";
        var selector = $("#m_" + Menu);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        if (State == 1) {
            selector.hide();
        }
        else {
            selector.show();
        }
    };
    cMenu.IsMenu = function (Menu) {
        return $("#m_" + Menu).length > 0;
    };
    cMenu.MenuBar = function () {
        cCommon.CurrentSubMenu.append("<li><hr /></li>");
        if (cCommon.CurrentMenu.data("MenuType") == "NormalMenu") {
            cCommon.CurrentMenu.menubar('destroy');
            cCommon.CurrentMenu.menubar();
        }
        else {
        }
    };
    cMenu.MenuHeight = function () {
        return cCommon.CurrentMenu.height();
    };
    cMenu.MenuID = function (Menu) {
        return Menu;
    };
    cMenu.MenuItem = function (MenuItemID, Text, ImageID) {
        if (ImageID === void 0) { ImageID = null; }
        var img;
        if (ImageID) {
            if (typeof (ImageID) === 'string') {
                img = $('<span class="ui-icon ' + ImageID + '"></span>');
            }
            else {
                img = $('<span class="ui-icon"></span>');
                var myImg = cCommon.P2W_ImageList[ImageID];
                if (myImg != null) {
                    img.css("background-image", "url(" + myImg.src + ")");
                }
            }
        }
        var li = $("<li></li>");
        var ar = $("<a href='#' id='mi_" + MenuItemID + "'>" + Text + "</a>");
        ar.prepend(img);
        li.append(ar);
        cCommon.CurrentSubMenu.append(li);
        if (cCommon.CurrentMenu.data("MenuType") == "NormalMenu") {
            cCommon.CurrentMenu.menubar('destroy');
            cCommon.CurrentMenu.menubar();
        }
        else {
            cCommon.CurrentMenu.menu('refresh');
        }
    };
    cMenu.MenuTitle = function (Title) {
        var li = $("<li></li>");
        var ar = $("<a href='#'>" + Title + "</a>");
        var ul = $("<ul />");
        li.append(ar);
        li.append(ul);
        cCommon.CurrentSubMenu = cCommon.CurrentMenu;
        cCommon.CurrentSubMenu.append(li);
        cCommon.CurrentSubMenu = ul;
        if (cCommon.CurrentMenu.data("MenuType") == "NormalMenu") {
            cCommon.CurrentMenu.menubar('destroy');
            cCommon.CurrentMenu.menubar();
        }
        else {
            cCommon.CurrentMenu.menu('refresh');
        }
    };
    cMenu.OpenSubMenu = function (Text, ImageID) {
        if (ImageID === void 0) { ImageID = 0; }
        var img;
        if (ImageID) {
            if (typeof (ImageID) === 'string') {
                img = $('<span class="ui-icon ' + ImageID + '"></span>');
            }
            else {
                img = $('<span class="ui-icon"></span>');
                var myImg = cCommon.P2W_ImageList[ImageID];
                if (myImg != null) {
                    img.css("background-image", "url(" + myImg.src + ")");
                }
            }
        }
        var li = $("<li></li>");
        var ar = $("<a href='#'>" + Text + "</a>");
        ar.prepend(img);
        var ul = $("<ul />");
        li.append(ar);
        li.append(ul);
        cCommon.CurrentSubMenu.append(li);
        cCommon.CurrentSubMenuParent = cCommon.CurrentSubMenu;
        cCommon.CurrentSubMenu = ul;
        if (cCommon.CurrentMenu.data("MenuType") == "NormalMenu") {
            cCommon.CurrentMenu.menubar('destroy');
            cCommon.CurrentMenu.menubar();
        }
        else {
            cCommon.CurrentMenu.menu('refresh');
        }
    };
    cMenu.SetMenuItemState = function () {
        
    };
    cMenu.SetMenuItemText = function (Menu, Item, Text) {
        var functionName = "SetMenuItemText()";
        var selector = $("#m_" + Menu).find("a#mi_" + Item);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        selector.text(Text);
    };
    cMenu.SetMenuTitleText = function (Menu, Title, Text) {
        var functionName = "SetMenuTitleText()";
        var selector = $("#m_" + Menu).find("li").eq(Title).find("a").find("span").eq(0);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        selector.text(Text);
    };
    cMenu.UnbindMenuEvent = function (Menu, MenuItem, Callback) {
        var functionName = "UnbindMenuEvent";
        var selector = $("#m_" + Menu).find("a#mi_" + MenuItem);
        if (selector.length == 0) {
            cCommon.MenuIsNotInitialized(functionName);
            return;
        }
        selector.data("clickcallback", null);
        selector.unbind("click", Callback);
    };
    return cMenu;
}());
var cMisc = (function () {
    function cMisc() {
    }
    cMisc.End = function () {
        
    };
    return cMisc;
}());
var cMoment = (function () {
    function cMoment() {
    }
    cMoment.Moment = function (m) {
        if (m === void 0) { m = new Date(); }
        return moment(m);
    };
    cMoment.AddMoment = function (Date, Type, Value) {
        return moment(Date).add(Value, Type);
    };
    cMoment.FormatMoment = function (Mask, Moment) {
        return moment(Moment).format(Mask);
    };
    cMoment.ParseMoment = function (Mask, String) {
        return moment(String, Mask);
    };
    cMoment.MomentFromDate = function (Date) {
        return moment.unix(Date);
    };
    cMoment.DateFromMoment = function (Moment) {
        return Moment.format("X");
    };
    return cMoment;
}());
var cMovie_jPlayer = (function () {
    function cMovie_jPlayer() {
    }
    cMovie_jPlayer.FreeMovie = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("FreeMovie()");
            return;
        }
        var movie = selector[0];
        try {
            movie.pause();
        }
        catch (ex) { }
        selector.empty();
        selector.remove();
    };
    cMovie_jPlayer.InitMovie = function () {
        return true;
    };
    cMovie_jPlayer.IsMovie = function (Movie) {
        return $("#m_" + Movie).length > 0;
    };
    cMovie_jPlayer.LoadMovie = function (Movie, Filename, Callback) {
        if (Callback === void 0) { Callback = null; }
        var Movie = cCommon.SetMovieAndStuff(Movie);
        var selector = $('<div />');
        selector.hide();
        selector.attr("id", "m_" + Movie);
        $("body").append(selector);
        $("body").append('<div id="m_' + Movie + '_container"><a href="#" class="jp-play">Play</a><a href="#" class="jp-pause">Pause</a></div>');
        selector.jPlayer({
            cssSelectorAncestor: "#m_" + Movie + "_container",
            ready: function (event) {
                if (cFileSystem.GetExtensionPart(Filename).toLowerCase() == "mp4") {
                    $(this).jPlayer("setMedia", {
                        m4v: Filename
                    });
                }
            },
            error: function (event) {
                
                
            },
            warning: function (event) {
                
                
            },
            volumechange: function (event) {
                selector.jPlayer().data("jPlayer").status.volume = event.jPlayer.options.volume;
            },
            solution: "html, flash",
            supplied: "webmv, ogv, m4v",
            wmode: "window",
            swfPath: "/libraries/jquery.jplayer"
        });
        selector.data("GadgetType", cConstants.PB_GadgetType_Movie);
        return Movie;
    };
    cMovie_jPlayer.MovieAudio = function (Movie, Volume, Balance) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieAudio()");
            return;
        }
        if (Volume < 0)
            Volume = 0;
        if (Volume > 100)
            Volume = 100;
        selector.jPlayer("volume", Volume / 100);
        if (Balance != 0) {
            
        }
    };
    cMovie_jPlayer.MovieHeight = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieHeight()");
            return -1;
        }
        return selector.height();
    };
    cMovie_jPlayer.MovieInfo = function (Movie, Flags) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieInfo()");
            return -1;
        }
        var movie = selector[0];
        if (Flags == 0) {
            
            return -1;
        }
    };
    cMovie_jPlayer.MovieLength = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieLength()");
            return -1;
        }
        var movie = selector[0];
        return movie.duration;
    };
    cMovie_jPlayer.MovieSeek = function (Movie, Frame) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieSeek()");
            return;
        }
        var movie = selector[0];
        movie.currentTime = Frame;
    };
    cMovie_jPlayer.MovieStatus = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieLength()");
            return -2;
        }
        var movie = selector[0];
        if (movie.paused && movie.currentTime == 0) {
            return 0;
        }
        else if (movie.paused) {
            return -1;
        }
        else {
            return movie.currentTime;
        }
    };
    cMovie_jPlayer.MovieWidth = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieWidth()");
            return -1;
        }
        return selector.width();
    };
    cMovie_jPlayer.PauseMovie = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("PauseMovie()");
            return;
        }
        var movie = selector[0];
        movie.pause();
    };
    cMovie_jPlayer.PlayMovie = function (Movie, WindowID) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("PlayMovie()");
            return;
        }
        var window = $("#w_" + WindowID);
        if (selector.length == 0) {
            cCommon.WindowIsNotInitialized("PlayMovie()");
            return;
        }
        selector.prependTo(window);
        selector = $("#m_" + Movie);
        selector.show();
        selector.jPlayer("play");
    };
    cMovie_jPlayer.ResizeMovie = function (Movie, x, y, Width, Height) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("ResizeMovie()");
            return;
        }
        if (x != cConstants.PB_Ignore)
            selector.css("left", x);
        if (y != cConstants.PB_Ignore)
            selector.css("top", y);
        if (Width != cConstants.PB_Ignore)
            selector.css("width", Width);
        if (Height != cConstants.PB_Ignore)
            selector.css("height", Height);
    };
    cMovie_jPlayer.ResumeMovie = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("ResumeMovie()");
            return;
        }
        var movie = selector[0];
        movie.play();
    };
    cMovie_jPlayer.StopMovie = function (Movie) {
        var selector = $("#m_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("PlayMovie()");
            return;
        }
        var movie = selector[0];
        movie.pause();
        movie.currentTime = 0;
    };
    return cMovie_jPlayer;
}());
var cMovie = (function () {
    function cMovie() {
    }
    cMovie.FreeMovie = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("FreeMovie()");
            return;
        }
        var movie = selector[0];
        try {
            movie.pause();
        }
        catch (ex) { }
        selector.empty();
        selector.remove();
    };
    cMovie.InitMovie = function () {
        return true;
    };
    cMovie.IsMovie = function (Movie) {
        return $("#v_" + Movie).length > 0;
    };
    cMovie.LoadMovie = function (Movie, Filename, Callback) {
        if (Callback === void 0) { Callback = null; }
        var Movie = cCommon.SetMovieAndStuff(Movie);
        var type = '';
        switch (cFileSystem.GetExtensionPart(Filename).toLowerCase()) {
            case "mp4":
            case "m4v":
                type = 'video/mp4';
                break;
            case "webm":
                type = 'video/webm';
                break;
            case "ogv":
                type = 'video/ogv';
                break;
            default:
                
                return 0;
        }
        var selector = $('<video />');
        selector.append($("<source src='" + Filename + "' type='" + type + "' />"));
        selector.css("width", 0);
        selector.css("height", 0);
        selector.hide();
        selector.attr("id", "v_" + Movie);
        selector.data("GadgetType", cConstants.PB_GadgetType_Movie);
        $("body").append(selector);
        var myVideo = selector[0];
        if (Callback) {
            cP2W.P2W_BindMovieEvent(Movie, Callback, cConstants.PB_All);
        }
        try {
            myVideo.controls = false;
            myVideo.autoplay = false;
            myVideo.preload = 'metadata';
            myVideo.load();
            return Movie;
        }
        catch (ex) {
            cMovie.FreeMovie(Movie);
            return 0;
        }
    };
    cMovie.MovieAudio = function (Movie, Volume, Balance) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieAudio()");
            return;
        }
        var movie = selector[0];
        if (Volume < 0)
            Volume = 0;
        if (Volume > 100)
            Volume = 100;
        movie.volume = Volume / 100;
        if (Balance != 0) {
            
        }
    };
    cMovie.MovieHeight = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieHeight()");
            return -1;
        }
        var movie = selector[0];
        return movie.videoHeight;
    };
    cMovie.MovieInfo = function (Movie, Flags) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieInfo()");
            return -1;
        }
        var movie = selector[0];
        if (Flags == 0) {
            
            return -1;
        }
    };
    cMovie.MovieLength = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieLength()");
            return -1;
        }
        var movie = selector[0];
        return movie.duration;
    };
    cMovie.MovieSeek = function (Movie, Frame) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieSeek()");
            return;
        }
        var movie = selector[0];
        movie.currentTime = Frame;
    };
    cMovie.MovieStatus = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieLength()");
            return -2;
        }
        var movie = selector[0];
        if (movie.paused && movie.currentTime == 0) {
            return 0;
        }
        else if (movie.paused) {
            return -1;
        }
        else {
            return movie.currentTime;
        }
    };
    cMovie.MovieWidth = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("MovieWidth()");
            return -1;
        }
        var movie = selector[0];
        return movie.videoWidth;
    };
    cMovie.PauseMovie = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("PauseMovie()");
            return;
        }
        var movie = selector[0];
        movie.pause();
    };
    cMovie.PlayMovie = function (Movie, WindowID) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("PlayMovie()");
            return;
        }
        var window = $("#w_" + WindowID);
        if (selector.length == 0) {
            cCommon.WindowIsNotInitialized("PlayMovie()");
            return;
        }
        selector.prependTo(window);
        selector = $("#v_" + Movie);
        selector.show();
        var movie = selector[0];
        try {
            movie.play();
            return true;
        }
        catch (ex) {
            return false;
        }
    };
    cMovie.ResizeMovie = function (Movie, x, y, Width, Height) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("ResizeMovie()");
            return;
        }
        if (x != cConstants.PB_Ignore)
            selector.css("left", x);
        if (y != cConstants.PB_Ignore)
            selector.css("top", y);
        if (Width != cConstants.PB_Ignore)
            selector.css("width", Width);
        if (Height != cConstants.PB_Ignore)
            selector.css("height", Height);
    };
    cMovie.ResumeMovie = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("ResumeMovie()");
            return;
        }
        var movie = selector[0];
        movie.play();
    };
    cMovie.StopMovie = function (Movie) {
        var selector = $("#v_" + Movie);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("PlayMovie()");
            return;
        }
        var movie = selector[0];
        movie.pause();
        movie.currentTime = 0;
    };
    return cMovie;
}());
var cMusic = (function () {
    function cMusic() {
    }
    cMusic.CatchMusic = function (Music, MemoryAddress, Size) {
        
        return -1;
    };
    cMusic.FreeMusic = function (Music) {
        var selector = $("#a_" + Music);
        if (selector.length == 0) {
            cCommon.MovieIsNotInitialized("FreeMusic()");
            return;
        }
        var audio = selector[0];
        try {
            audio.pause();
        }
        catch (ex) { }
        selector.empty();
        selector.remove();
    };
    cMusic.GetMusicPosition = function (Music) {
        var selector = $("#a_" + Music);
        if (selector.length == 0) {
            cCommon.MusicIsNotInitialized("GetMusicPosition()");
            return;
        }
        var myAudioElement = selector[0];
        try {
            return myAudioElement.currentTime;
        }
        catch (ex) {
            return -1;
        }
    };
    cMusic.GetMusicRow = function (Music) {
        
        return -1;
    };
    cMusic.IsMusic = function (Music) {
        return $("#a_" + Music).length > 0;
    };
    cMusic.LoadMusic = function (Music, Filename, Callback) {
        if (Callback === void 0) { Callback = null; }
        var Music = cCommon.SetMusicAndStuff(Music);
        var type = '';
        switch (cFileSystem.GetExtensionPart(Filename).toLowerCase()) {
            case "mp3":
                type = 'audio/mpeg';
                break;
            case "ogg":
                type = 'audio/ogg';
                break;
            case "wav":
                type = 'audio/wav';
                break;
            default:
                
                return 0;
        }
        var selector = $('<audio />');
        selector.append($("<source src='" + Filename + "' type='" + type + "' />"));
        selector.css("width", 0);
        selector.css("height", 0);
        selector.hide();
        selector.attr("id", "a_" + Music);
        selector.data("GadgetType", cConstants.PB_GadgetType_Music);
        $("body").append(selector);
        var myAudio = selector[0];
        if (Callback) {
            cP2W.P2W_BindMusicEvent(Music, Callback, cConstants.PB_All);
        }
        try {
            myAudio.controls = false;
            myAudio.autoplay = false;
            myAudio.preload = 'metadata';
            myAudio.load();
            return Music;
        }
        catch (ex) {
            cMusic.FreeMusic(Music);
            return 0;
        }
    };
    cMusic.MusicVolume = function (Music, Volume) {
        var selector = $("#a_" + Music);
        if (selector.length == 0) {
            cCommon.MusicIsNotInitialized("MusicVolume()");
            return;
        }
        var myAudioElement = selector[0];
        try {
            myAudioElement.volume = Volume * 100;
        }
        catch (ex) {
        }
    };
    cMusic.PlayMusic = function (Music, Loop) {
        if (Loop === void 0) { Loop = false; }
        var selector = $("#a_" + Music);
        if (selector.length == 0) {
            cCommon.MusicIsNotInitialized("PlayMusic()");
            return;
        }
        var myAudioElement = selector[0];
        try {
            myAudioElement.loop = Loop;
            myAudioElement.play();
        }
        catch (ex) {
        }
    };
    cMusic.SetMusicPosition = function (Music, Position) {
        var selector = $("#a_" + Music);
        if (selector.length == 0) {
            cCommon.MusicIsNotInitialized("SetMusicPosition()");
            return;
        }
        var myAudioElement = selector[0];
        try {
            myAudioElement.currentTime = Position;
        }
        catch (ex) {
        }
    };
    cMusic.StopMusic = function (Music) {
        var selector = $("#a_" + Music);
        if (selector.length == 0) {
            cCommon.MusicIsNotInitialized("StopMusic()");
            return;
        }
        var myAudioElement = selector[0];
        try {
            myAudioElement.pause();
            myAudioElement.currentTime = 0;
        }
        catch (ex) {
        }
    };
    return cMusic;
}());
var cNetwork = (function () {
    function cNetwork() {
    }
    cNetwork.CloseNetworkConnection = function () { };
    cNetwork.CloseNetworkServer = function () { };
    cNetwork.ConnectionID = function () { };
    cNetwork.CreateNetworkServer = function () { };
    cNetwork.EventClient = function () { };
    cNetwork.EventServer = function () { };
    cNetwork.ExamineIPAddresses = function () { };
    cNetwork.FreeIP = function () { };
    cNetwork.GetClientIP = function () { };
    cNetwork.GetClientPort = function () { };
    cNetwork.HostName = function () { };
    cNetwork.IPAddressField = function () { };
    cNetwork.IPString = function () { };
    cNetwork.InitNetwork = function () { };
    cNetwork.MakeIPAddress = function () { };
    cNetwork.NetworkClientEvent = function () { };
    cNetwork.NetworkServerEvent = function () { };
    cNetwork.NextIPAddress = function () { };
    cNetwork.OpenNetworkConnection = function () { };
    cNetwork.ReceiveNetworkData = function () { };
    cNetwork.SendNetworkData = function () { };
    cNetwork.SendNetworkString = function () { };
    cNetwork.ServerID = function () { };
    return cNetwork;
}());
var cSimpleObject = (function () {
    function cSimpleObject() {
    }
    return cSimpleObject;
}());
var cObject = (function () {
    function cObject(FreeFunc) {
        this.MAXOBJECTSIZE = 5000;
        this.Objects = [];
        this.freeDynID = this.MAXOBJECTSIZE + 1;
        this.FreeFunc = FreeFunc;
    }
    cObject.prototype.Free = function (id) {
        var num;
        if (typeof (id) === 'number')
            num = id;
        if (typeof (id) === 'object')
            num = id.value;
        if (num > this.MAXOBJECTSIZE) {
            for (var i = this.MAXOBJECTSIZE; i < this.Objects.length; i++) {
                if (this.Objects[i].id == num) {
                    try {
                        this.Objects[i].FreeFunc(id);
                        delete this.Objects[i];
                    }
                    catch (e) {
                        throw new Error("ID " + id + " not found!");
                    }
                }
            }
        }
        else {
            try {
                this.Objects[num].FreeFunc(id);
                delete this.Objects[num];
            }
            catch (e) {
                throw new Error("ID " + id + " not found!");
            }
        }
    };
    cObject.prototype.addDynamicObject = function () {
        this.freeDynID++;
        var obj = new cSimpleObject();
        obj.id = this.freeDynID;
        obj.FreeFunc = this.FreeFunc;
        this.Objects.push(obj);
        return obj;
    };
    cObject.prototype.addStaticObject = function (id) {
        if (this.GetObject(id))
            this.Free(id);
        this.Objects[id] = new cSimpleObject();
        this.Objects[id].value = id;
        this.Objects[id].FreeFunc = this.FreeFunc;
        return this.Objects[id];
    };
    cObject.prototype.GetObject = function (id) {
        var result;
        var num;
        if (typeof (id) === 'number')
            num = id;
        if (typeof (id) === 'object')
            num = id.value;
        if (num > this.MAXOBJECTSIZE) {
            for (var i = this.MAXOBJECTSIZE; i < this.Objects.length; i++) {
                if (this.Objects[i].id == num) {
                    try {
                        result = this.Objects[i];
                    }
                    catch (e) {
                        throw new Error("ID " + id + " not found!");
                    }
                }
            }
        }
        else {
            try {
                result = this.Objects[num];
            }
            catch (e) {
                throw new Error("ID " + id + " not found!");
            }
        }
        return result;
    };
    cObject.prototype.GetOrAllocateID = function (id) {
        var result;
        if (id == cConstants.PB_Any)
            result = this.addDynamicObject();
        else {
            if (id <= this.MAXOBJECTSIZE)
                result = this.addStaticObject(id);
            else
                throw "Static ID (" + id + ") is to big, please use PB_Any.";
        }
        return result;
    };
    return cObject;
}());
var cP2W = (function () {
    function cP2W() {
    }
    cP2W.bla = function () {
    };
    cP2W.RegisterUserGadgetProcedure = function (Gadget, Procedurename, Procedure) {
        if (typeof p2w_UserGadget[Gadget] === "undefined")
            p2w_UserGadget[Gadget] = [];
        p2w_UserGadget[Gadget][Procedurename] = Procedure;
    };
    cP2W.RegisterPbGadgetProcedure = function (Gadget, Procedurename, Procedure) {
        if (typeof p2w_PbGadget[Gadget] === "undefined")
            p2w_PbGadget[Gadget] = [];
        p2w_PbGadget[Gadget][Procedurename] = Procedure;
    };
    cP2W.assign = function (obj, prop, value) {
        if (typeof prop === "string")
            prop = prop.split(".");
        if (prop.length > 1) {
            var e = prop.shift();
            this.assign(obj[e] = Object.prototype.toString.call(obj[e]) === "[object Object]" ? obj[e] : {}, prop, value);
        }
        else
            obj[prop[0]] = value;
    };
    cP2W.GetAjaxSetup = function (Key) {
        return $.ajaxSetup()[Key];
    };
    cP2W.SetAjaxSetup = function (Key, Value) {
        var options = {};
        this.assign(options, Key, Value);
        $.ajaxSetup(options);
    };
    cP2W.SetTheme = function (Theme) {
        $('#jquery_ui_stylesheet').attr({ href: 'libraries/jquery.ui/themes/' + Theme + '/jquery-ui.min.css' });
        cPixelPerfect.SetValues(Theme);
    };
    cP2W.ExternalRaiseEvent = function (EventName, Params) {
        try {
            window.external.raiseEvent(EventName, Params);
        }
        catch (e) {
            
        }
    };
    cP2W.P2W_w2ui_ToolBar = function (ToolBar) {
        if (ToolBar === cConstants.PB_Any) {
            ToolBar = cCommon.guid();
        }
        if ($("#tb_" + ToolBar).length > 0) {
            cToolBar.FreeToolBar(ToolBar);
        }
        if (cCommon.CurrentContainer === null) {
            cCommon.CurrentContainer = $("body");
        }
        var selector = $("<div />");
        selector.attr("id", "tb_" + ToolBar);
        selector.w2toolbar({
            name: "tb_" + ToolBar
        });
        cCommon.CurrentContainer.append(selector);
        cCommon.CurrentToolbar = selector;
        return ToolBar;
    };
    cP2W.P2W_w2ui_ToolBar_AddItems = function (ToolBar, Items) {
        w2ui["tb_" + ToolBar].add(Items);
        w2ui["tb_" + ToolBar].refresh();
    };
    cP2W.P2W_Image2DataURL = function (url, success, error) {
        var data, canvas, ctx;
        var img = new Image();
        img.onload = function () {
            canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            ctx = canvas.getContext("2d");
            ctx.drawImage(img, 0, 0);
            try {
                data = canvas.toDataURL();
                success(data);
            }
            catch (e) {
                error(e);
            }
        };
        try {
            img.src = url;
        }
        catch (e) {
            error(e);
        }
    };
    cP2W.P2W_SetWindowPosition = function (Window, PosMy, PosAt, PosOf) {
        if (PosMy === void 0) { PosMy = "center"; }
        if (PosAt === void 0) { PosAt = "center"; }
        if (PosOf === void 0) { PosOf = window; }
        var functionName = "P2W_SetWindowPosition()";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (selector.prop("tagName").toLowerCase() === "body") {
            
            return;
        }
        selector.dialog("option", "position", {
            my: PosMy,
            at: PosAt,
            of: PosOf
        });
    };
    cP2W.SetCookie = function (Name, Value, Expires) {
        Cookies.set(Name, Value, Expires);
        return (Cookies.get(Name) === Value);
    };
    cP2W.GetCookie = function (Name, DefaultValue) {
        if (DefaultValue === void 0) { DefaultValue = ""; }
        if (typeof Cookies.get(Name) != 'undefined')
            return Cookies.get(Name);
        return DefaultValue;
    };
    cP2W.RemoveCookie = function (Name) {
        return Cookies.remove(Name);
    };
    cP2W.CookieExists = function (Name) {
        return (typeof Cookies.get(Name) != 'undefined');
    };
    cP2W.LoadTextfileFromServer = function (Filename) {
        jQuery.support.cors = true;
        var returnValue = "";
        $.ajax({
            url: Filename,
            type: "GET",
            dataType: "Text",
            async: false,
            success: function (result) { returnValue = result; },
            error: function (a, b, c) { }
        });
        return returnValue;
    };
    cP2W.LoadTextfileFromClient = function (Callback) {
        $('<div style="width:0px;height:0px;overflow:hidden"><input name="upload" type="file" id="fileinput"/></div>').appendTo($('body'));
        document.getElementById('fileinput').addEventListener('change', readTextFile, false);
        function readTextFile(e) {
            var file = e.target.files[0];
            if (!file)
                return;
            var reader = new FileReader();
            reader.onload = function (e) {
            };
            reader.readAsText(file);
        }
    };
    cP2W.BlockWindow = function (Window, State, Message, Title, Callback) {
        if (Message === void 0) { Message = null; }
        if (Title === void 0) { Title = null; }
        if (Callback === void 0) { Callback = null; }
        var functionName = "BlockWindow";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (State) {
            if (selector.prop("tagName") === "BODY") {
                $.blockUI({
                    theme: true,
                    message: Message,
                    title: Title,
                    onBlock: Callback
                });
            }
            else {
                selector.block({
                    theme: true,
                    message: Message,
                    title: Title,
                    onBlock: Callback
                });
            }
        }
        else {
            if (selector.prop("tagName") === "BODY") {
                $.unblockUI({
                    onUnblock: Callback
                });
            }
            else {
                selector.unblock({
                    onUnblock: Callback
                });
            }
        }
    };
    cP2W.BlockGadget = function (Gadget, State, Message, Title, Callback) {
        if (Message === void 0) { Message = null; }
        if (Title === void 0) { Title = null; }
        if (Callback === void 0) { Callback = null; }
        var functionName = "BlockGadget";
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            cCommon.GadgetIsNotInitialized(functionName);
            return;
        }
        if (State) {
            selector.block({
                theme: true,
                message: Message,
                title: Title,
                onBlock: Callback
            });
        }
        else {
            selector.unblock({
                onUnblock: Callback
            });
        }
    };
    cP2W.P2W_LocalStorage_Available = function () {
        return $.jStorage.storageAvailable();
    };
    cP2W.P2W_LocalStorage_GetItem = function (Key, Default) {
        if (Default === void 0) { Default = ""; }
        if (cP2W.P2W_LocalStorage_Available())
            return $.jStorage.get(Key, Default);
        return Default;
    };
    cP2W.P2W_LocalStorage_SetItem = function (Key, Value) {
        if (cP2W.P2W_LocalStorage_Available())
            return $.jStorage.set(Key, Value);
        return null;
    };
    cP2W.P2W_LocalStorage_RemoveItem = function (Key) {
        if (cP2W.P2W_LocalStorage_Available())
            return $.jStorage.deleteKey(Key);
        return false;
    };
    cP2W.P2W_LocalStorage_GetTTL = function (Key) {
        if (cP2W.P2W_LocalStorage_Available())
            return $.jStorage.getTTL(Key);
        return -1;
    };
    cP2W.P2W_LocalStorage_SetTTL = function (Key, TTL) {
        if (cP2W.P2W_LocalStorage_Available())
            return $.jStorage.setTTL(Key, TTL);
        return false;
    };
    cP2W.P2W_LocalStorage_ListenKeyChange = function (Key, Callback) {
        $.jStorage.listenKeyChange(Key, Callback);
    };
    cP2W.P2W_LocalStorage_StopListening = function (Key) {
        $.jStorage.stopListening(Key);
    };
    cP2W.P2W_LocalStorage_Clear = function () {
        if (cP2W.P2W_LocalStorage_Available())
            $.jStorage.flush();
    };
    cP2W.IsMobile = function () {
        return isMobile.any;
    };
    cP2W.IsMobilePhone = function () {
        return isMobile.phone;
    };
    cP2W.IsMobileTablet = function () {
        return isMobile.tablet;
    };
    cP2W.NewStringBuilder = function () {
        return new Array();
    };
    cP2W.StringBuilderAppendLine = function (SB, String) {
        SB.push(String + "\n");
    };
    cP2W.StringBuilderAppend = function (SB, String) {
        SB.push(String);
    };
    cP2W.StringBuilderToString = function (SB, Separator) {
        if (Separator === void 0) { Separator = ""; }
        return SB.join(Separator);
    };
    cP2W.StringBuilderClear = function (SB) {
        SB = [];
        return SB;
    };
    cP2W.SaveText = function (Text, Filename) {
        if (!cCommon.checkBlob())
            return 0;
        var blob = new Blob([Text], { type: "text/plain;charset=" + document.characterSet });
        saveAs(blob, Filename);
    };
    cP2W.SaveCsv = function (Text, Filename) {
        if (!cCommon.checkBlob())
            return 0;
        var blob = new Blob([Text], { type: "text/csv;charset=" + document.characterSet });
        saveAs(blob, Filename);
    };
    cP2W.SaveCanvas = function (Canvas, FileName) {
        if (!cCommon.checkBlob())
            return;
        var selector = $("#g_" + Canvas);
        if (selector.length === 0) {
            cCommon.ImageIsNotInitialized("P2W_SaveCanvas()");
            return;
        }
        FileName = FileName.replace(/\\/g, "/");
        var myCanvas = selector[0];
        myCanvas.toBlobX(function (blob) {
            saveAs(blob, FileName);
        }, "image/png");
    };
    cP2W.P2W_PauseMusic = function (Music) {
        var selector = $("#a_" + Music);
        if (selector.length === 0) {
            cCommon.MusicIsNotInitialized("P2W_PauseMusic()");
            return;
        }
        var myAudioElement = selector[0];
        try {
            myAudioElement.pause();
        }
        catch (ex) {
        }
    };
    cP2W.P2W_SetMusicAttribute = function (Music, Attribute, Value) {
        var selector = $("#a_" + Music);
        if (selector.length === 0) {
            cCommon.MusicIsNotInitialized("P2W_SetMusicAttribute()");
            return;
        }
        var myAudioElement = selector[0];
        switch (Attribute) {
            case cConstants.PB_Music_ShowControls:
                if (Value === 0) {
                    myAudioElement.controls = false;
                }
                else {
                    myAudioElement.controls = true;
                }
                break;
            case cConstants.PB_Music_Position:
                if (Value < 0)
                    Value = 0;
                if (Value > myAudioElement.duration)
                    Value = myAudioElement.duration;
                myAudioElement.currentTime = Value;
                break;
            case cConstants.PB_Music_Volume:
                if (Value < 0)
                    Value = 0;
                if (Value > 100)
                    Value = 100;
                myAudioElement.volume = Value / 100;
                break;
        }
    };
    cP2W.P2W_GetMusicAttribute = function (Music, Attribute) {
        var selector = $("#a_" + Music);
        if (selector.length === 0) {
            cCommon.MusicIsNotInitialized("P2W_GetMusicAttribute()");
            return;
        }
        var myAudioElement = selector[0];
        switch (Attribute) {
            case cConstants.PB_Music_ShowControls:
                return myAudioElement.controls;
            case cConstants.PB_Music_Position:
                return myAudioElement.currentTime;
            case cConstants.PB_Music_Length:
                return myAudioElement.duration;
            case cConstants.PB_Music_Volume:
                return myAudioElement.volume * 100;
        }
    };
    cP2W.P2W_BindMusicEvent = function (Music, Callback, EventType) {
        if (EventType === void 0) { EventType = cConstants.PB_All; }
        var functionName = "P2W_BindMusicEvent";
        var selector = $("#a_" + Music);
        if (selector.length === 0) {
            cCommon.MusicIsNotInitialized(functionName);
            return;
        }
        var myAudioElement = selector[0];
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_Event_Music_Abort |
                cConstants.PB_Event_Music_CanPlay |
                cConstants.PB_Event_Music_CanPlayThrough |
                cConstants.PB_Event_Music_DurationChange |
                cConstants.PB_Event_Music_Emptied |
                cConstants.PB_Event_Music_Ended |
                cConstants.PB_Event_Music_Error |
                cConstants.PB_Event_Music_LoadedData |
                cConstants.PB_Event_Music_LoadedMetaData |
                cConstants.PB_Event_Music_LoadStart |
                cConstants.PB_Event_Music_Pause |
                cConstants.PB_Event_Music_Play |
                cConstants.PB_Event_Music_Playing |
                cConstants.PB_Event_Music_Progress |
                cConstants.PB_Event_Music_RateChange |
                cConstants.PB_Event_Music_Seeked |
                cConstants.PB_Event_Music_Seeking |
                cConstants.PB_Event_Music_Stalled |
                cConstants.PB_Event_Music_Suspend |
                cConstants.PB_Event_Music_TimeUpdate |
                cConstants.PB_Event_Music_VolumeChange |
                cConstants.PB_Event_Music_Waiting;
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Abort)) {
            myAudioElement.addEventListener("abort", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Abort;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_CanPlay)) {
            myAudioElement.addEventListener("canplay", function () {
                cEvent.eventType = cConstants.PB_Event_Music_CanPlay;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_CanPlayThrough)) {
            myAudioElement.addEventListener("canplaythrough", function () {
                cEvent.eventType = cConstants.PB_Event_Music_CanPlayThrough;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_DurationChange)) {
            myAudioElement.addEventListener("durationchange", function () {
                cEvent.eventType = cConstants.PB_Event_Music_DurationChange;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Emptied)) {
            myAudioElement.addEventListener("emptied", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Emptied;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Ended)) {
            myAudioElement.addEventListener("ended", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Ended;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Error)) {
            myAudioElement.addEventListener("error", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Error;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_LoadedData)) {
            myAudioElement.addEventListener("loadeddata", function () {
                cEvent.eventType = cConstants.PB_Event_Music_LoadedData;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_LoadedMetaData)) {
            myAudioElement.addEventListener("loadedmetadata", function () {
                cEvent.eventType = cConstants.PB_Event_Music_LoadedMetaData;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_LoadStart)) {
            myAudioElement.addEventListener("loadstart", function () {
                cEvent.eventType = cConstants.PB_Event_Music_LoadStart;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Pause)) {
            myAudioElement.addEventListener("pause", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Pause;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Play)) {
            myAudioElement.addEventListener("play", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Play;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Playing)) {
            myAudioElement.addEventListener("playing", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Playing;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Progress)) {
            myAudioElement.addEventListener("progress", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Progress;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_RateChange)) {
            myAudioElement.addEventListener("ratechange", function () {
                cEvent.eventType = cConstants.PB_Event_Music_RateChange;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Seeked)) {
            myAudioElement.addEventListener("seeked", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Seeked;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Seeking)) {
            myAudioElement.addEventListener("seeking", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Seeking;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Stalled)) {
            myAudioElement.addEventListener("stalled", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Stalled;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Suspend)) {
            myAudioElement.addEventListener("suspend", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Suspend;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_TimeUpdate)) {
            myAudioElement.addEventListener("timeupdate", function () {
                cEvent.eventType = cConstants.PB_Event_Music_TimeUpdate;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_VolumeChange)) {
            myAudioElement.addEventListener("volumechange", function () {
                cEvent.eventType = cConstants.PB_Event_Music_VolumeChange;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Music_Waiting)) {
            myAudioElement.addEventListener("waiting", function () {
                cEvent.eventType = cConstants.PB_Event_Music_Waiting;
                Callback();
            }, false);
        }
    };
    cP2W.P2W_SetMovieAttribute = function (Movie, Attribute, Value) {
        var selector = $("#v_" + Movie);
        if (selector.length === 0) {
            cCommon.MovieIsNotInitialized("P2W_SetMovieAttribute()");
            return;
        }
        var movie = selector[0];
        switch (Attribute) {
            case cConstants.PB_Movie_ShowControls:
                if (Value === 0) {
                    movie.controls = false;
                }
                else {
                    movie.controls = true;
                }
                break;
            case cConstants.PB_Movie_Position:
                if (Value < 0)
                    Value = 0;
                if (Value > movie.duration)
                    Value = movie.duration;
                movie.currentTime = Value;
                break;
            case cConstants.PB_Movie_Volume:
                if (Value < 0)
                    Value = 0;
                if (Value > 100)
                    Value = 100;
                movie.volume = Value / 100;
                break;
        }
    };
    cP2W.P2W_GetMovieAttribute = function (Movie, Attribute) {
        var selector = $("#v_" + Movie);
        if (selector.length === 0) {
            cCommon.MovieIsNotInitialized("P2W_GetMovieAttribute()");
            return;
        }
        var movie = selector[0];
        switch (Attribute) {
            case cConstants.PB_Movie_ShowControls:
                return movie.controls;
            case cConstants.PB_Movie_Position:
                return movie.currentTime;
            case cConstants.PB_Movie_Length:
                return movie.duration;
            case cConstants.PB_Movie_Volume:
                return movie.volume * 100;
        }
    };
    cP2W.P2W_BindMovieEventY = function (Movie, Callback, EventType) {
        if (EventType === void 0) { EventType = cConstants.PB_All; }
    };
    cP2W.P2W_BindMovieEvent = function (Movie, Callback, EventType) {
        if (EventType === void 0) { EventType = cConstants.PB_All; }
        var functionName = "P2W_BindMovieEvent";
        var selector = $("#v_" + Movie);
        if (selector.length === 0) {
            cCommon.MovieIsNotInitialized(functionName);
            return;
        }
        var myMovie = selector[0];
        if (EventType === cConstants.PB_All) {
            EventType = cConstants.PB_Event_Movie_Abort |
                cConstants.PB_Event_Movie_CanPlay |
                cConstants.PB_Event_Movie_CanPlayThrough |
                cConstants.PB_Event_Movie_DurationChange |
                cConstants.PB_Event_Movie_Emptied |
                cConstants.PB_Event_Movie_Ended |
                cConstants.PB_Event_Movie_Error |
                cConstants.PB_Event_Movie_LoadedData |
                cConstants.PB_Event_Movie_LoadedMetaData |
                cConstants.PB_Event_Movie_LoadStart |
                cConstants.PB_Event_Movie_Pause |
                cConstants.PB_Event_Movie_Play |
                cConstants.PB_Event_Movie_Playing |
                cConstants.PB_Event_Movie_Progress |
                cConstants.PB_Event_Movie_RateChange |
                cConstants.PB_Event_Movie_Seeked |
                cConstants.PB_Event_Movie_Seeking |
                cConstants.PB_Event_Movie_Stalled |
                cConstants.PB_Event_Movie_Suspend |
                cConstants.PB_Event_Movie_TimeUpdate |
                cConstants.PB_Event_Movie_VolumeChange |
                cConstants.PB_Event_Movie_Waiting;
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Abort)) {
            myMovie.addEventListener("abort", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Abort;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_CanPlay)) {
            myMovie.addEventListener("canplay", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_CanPlay;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_CanPlayThrough)) {
            myMovie.addEventListener("canplaythrough", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_CanPlayThrough;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_DurationChange)) {
            myMovie.addEventListener("durationchange", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_DurationChange;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Emptied)) {
            myMovie.addEventListener("emptied", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Emptied;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Ended)) {
            myMovie.addEventListener("ended", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Ended;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Error)) {
            myMovie.addEventListener("error", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Error;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_LoadedData)) {
            myMovie.addEventListener("loadeddata", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_LoadedData;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_LoadedMetaData)) {
            myMovie.addEventListener("loadedmetadata", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_LoadedMetaData;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_LoadStart)) {
            myMovie.addEventListener("loadstart", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_LoadStart;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Pause)) {
            myMovie.addEventListener("pause", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Pause;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Play)) {
            myMovie.addEventListener("play", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Play;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Playing)) {
            myMovie.addEventListener("playing", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Playing;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Progress)) {
            myMovie.addEventListener("progress", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Progress;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_RateChange)) {
            myMovie.addEventListener("ratechange", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_RateChange;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Seeked)) {
            myMovie.addEventListener("seeked", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Seeked;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Seeking)) {
            myMovie.addEventListener("seeking", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Seeking;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Stalled)) {
            myMovie.addEventListener("stalled", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Stalled;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Suspend)) {
            myMovie.addEventListener("suspend", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Suspend;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_TimeUpdate)) {
            myMovie.addEventListener("timeupdate", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_TimeUpdate;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_VolumeChange)) {
            myMovie.addEventListener("volumechange", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_VolumeChange;
                Callback();
            }, false);
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_Event_Movie_Waiting)) {
            myMovie.addEventListener("waiting", function () {
                cEvent.eventType = cConstants.PB_Event_Movie_Waiting;
                Callback();
            }, false);
        }
    };
    cP2W.GetCurrentGeolocationPosition = function (Callback) {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function (position) {
                Callback(true, position.coords.latitude + ";" +
                    position.coords.longitude + ";" +
                    position.coords.accuracy + ";" +
                    position.coords.altitude + ";" +
                    position.coords.altitudeAccuracy + ";" +
                    position.coords.heading + ";" +
                    position.coords.speed + ";" +
                    position.timestamp);
            }, function (error) {
                var ErrorCode = '';
                switch (error.code) {
                    case error.PERMISSION_DENIED:
                        ErrorCode = "User denied the request for Geolocation.";
                        break;
                    case error.POSITION_UNAVAILABLE:
                        ErrorCode = "Location information is unavailable.";
                        break;
                    case error.TIMEOUT:
                        ErrorCode = "The request to get user location timed out.";
                        break;
                    default:
                        ErrorCode = "An unknown error occurred.";
                        break;
                }
                Callback(false, ErrorCode);
            });
        }
        else {
            Callback(false, "Geolocation is not supported by this browser.");
        }
    };
    cP2W.P2W_SetWindowOption = function (Window, Optionname, OptionValue) {
        $("#w_" + Window).dialog("option", Optionname, OptionValue);
    };
    cP2W.P2W_Alert = function (Message) {
        alert(Message);
    };
    cP2W.P2W_IsValidMailAddress = function (mailAddress) {
        var reg = /^\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*$/;
        if (reg.test(mailAddress)) {
            return true;
        }
        else {
            return false;
        }
    };
    cP2W.P2W_ParseJSON = function (String) {
        return $.parseJSON(String);
    };
    cP2W.P2W_JSONstringify = function (String) {
        return $.parseJSON(String);
    };
    cP2W.P2W_GetJSONValue = function (JSON, Attribute) {
        return JSON[Attribute];
    };
    cP2W.P2W_JQO_FromWindow = function (Window) {
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            
            return null;
        }
        else {
            return selector;
        }
    };
    cP2W.P2W_JQO_FromGadget = function (Gadget) {
        var selector = $("#g_" + Gadget);
        if (selector.length === 0) {
            
            return null;
        }
        else {
            return selector;
        }
    };
    cP2W.P2W_JQO_FromImage = function (Image) {
        var myImg = cCommon.P2W_ImageList[Image];
        if (myImg != null)
            return $(myImg);
        cCommon.ImageIsNotInitialized("P2W_JQO_FromImage()");
        return null;
    };
    cP2W.P2W_JQO_AddClass = function (JQueryObject, ClassName) {
        JQueryObject.addClass(ClassName);
    };
    cP2W.P2W_JQO_HasClass = function (JQueryObject, ClassName) {
        return JQueryObject.hasClass(ClassName);
    };
    cP2W.P2W_JQO_RemoveClass = function (JQueryObject, ClassName) {
        JQueryObject.removeClass(ClassName);
    };
    cP2W.P2W_JQO_ToggleClass = function (JQueryObject, ClassName) {
        JQueryObject.toggleClass(ClassName);
    };
    cP2W.P2W_JQO_CSS = function (JQueryObject, PropertyName, PropertyValue) {
        JQueryObject.css(PropertyName, PropertyValue);
    };
    cP2W.P2W_JQO_SetAttribute = function (JQueryObject, AttributeName, AttributeValue) {
        JQueryObject.attr(AttributeName, AttributeValue);
    };
    cP2W.P2W_JQO_GetAttribute = function (JQueryObject, AttributeName, AttributeValue) {
        return JQueryObject.attr(AttributeName);
    };
    cP2W.P2W_JQO_RemoveAttribute = function (JQueryObject, AttributeName, AttributeValue) {
        JQueryObject.removeAttr(AttributeName);
    };
    cP2W.P2W_EvalS = function (JavaScriptString) {
        return eval(JavaScriptString);
    };
    cP2W.P2W_EvalN = function (JavaScriptString) {
        return eval(JavaScriptString);
    };
    cP2W.P2W_EvalFunction = function (functionName, functionParams) {
        var f = new Function(functionName);
        return f.apply(null, functionParams);
    };
    cP2W.P2W_RunFunction = function (functionName, functionParams) {
        var winFunc = window[functionName];
        return winFunc.apply(null, functionParams);
    };
    cP2W.P2W_SetDesktopID = function (DesktopID) {
        if (DesktopID === cConstants.PB_Any) {
            DesktopID = cCommon.guid();
        }
        $('body').attr("id", "w_" + DesktopID);
        return DesktopID;
    };
    cP2W.P2W_GetDesktopID = function () {
        return $('body').attr("id");
    };
    return cP2W;
}());
var cPDF = (function () {
    function cPDF() {
    }
    cPDF.UsePDF = function () {
    };
    cPDF.NewPDF = function (orientation) {
        if (orientation === void 0) { orientation = "portrait"; }
        return new jsPDF(orientation);
    };
    cPDF.PdfSetFont = function (doc, font) {
        doc.setFont(font);
    };
    cPDF.PdfSetFontType = function (doc, fonttype) {
        doc.setFontType(fonttype);
    };
    cPDF.PdfSetFontSize = function (doc, fontsize) {
        doc.setFontSize(fontsize);
    };
    cPDF.PdfAddEllipse = function (doc, x, y, rx, ry, style) {
        if (style === void 0) { style = ""; }
        doc.ellipse(x, y, rx, ry, style);
    };
    cPDF.PdfAddCircle = function (doc, x, y, r, style) {
        if (style === void 0) { style = ""; }
        doc.circle(x, y, r, style);
    };
    cPDF.PdfSetFillColor = function (doc, r, g, b) {
        doc.setFillColor(r, g, b);
    };
    cPDF.PdfSetLineWidth = function (doc, w) {
        doc.setLineWidth(w);
    };
    cPDF.PdfSetDrawColor = function (doc, r, g, b) {
        doc.setDrawColor(r, g, b);
    };
    cPDF.PdfSetTextColor = function (doc, r, g, b) {
        doc.setTextColor(r, g, b);
    };
    cPDF.PdfAddLine = function (doc, x1, y1, x2, y2) {
        doc.line(x1, y1, x2, y2);
    };
    cPDF.PdfAddRect = function (doc, x, y, w, h, style) {
        if (style === void 0) { style = ""; }
        doc.rect(x, y, w, h, style);
    };
    cPDF.PdfAddTriangle = function (doc, x1, y1, x2, y2, x3, y3, style) {
        if (style === void 0) { style = ""; }
        doc.triangle(x1, y1, x2, y2, x3, y3, style);
    };
    cPDF.PdfAddRoundedRect = function (doc, x, y, w, h, rx, ry, style) {
        if (style === void 0) { style = ""; }
        doc.roundedRect(x, y, w, h, rx, ry, style);
    };
    cPDF.PdfAddImage = function (doc, imgData, imgType, x, y, w, h) {
        doc.addImage(imgData, imgType, x, y, w, h);
    };
    cPDF.PdfAddText = function (doc, x, y, text) {
        doc.text(x, y, text);
    };
    cPDF.PdfAddPage = function (doc) {
        doc.addPage();
    };
    cPDF.PdfOutput = function (doc) {
        return doc.output('datauristring');
    };
    return cPDF;
}());
var cPhaser = (function () {
    function cPhaser() {
    }
    return cPhaser;
}());
var cPixelPerfect = (function () {
    function cPixelPerfect() {
    }
    cPixelPerfect.SetValues = function (Theme) {
    };
    cPixelPerfect.DateGadgetHeight = 8;
    cPixelPerfect.ComboBoxGadgetHeight = 1;
    cPixelPerfect.ComboBoxGadgetWidth = 1;
    cPixelPerfect.ComboBoxGadgetSimpleWidth = -1;
    cPixelPerfect.ComboBoxGadgetSimpleHeight = -1;
    cPixelPerfect.ComboBoxEditableGadgetWidth = 46;
    cPixelPerfect.ComboBoxEditableGadgetHeight = 11;
    cPixelPerfect.SpinGadgetHeightOffset = 5;
    cPixelPerfect.SpinGadgetWidthOffset = 27;
    cPixelPerfect.StringGadgetHeightOffset = 3;
    cPixelPerfect.StringGadgetWidthOffset = 1;
    cPixelPerfect.FrameGadgetHeightOffset = 7;
    cPixelPerfect.FrameGadgetWidthOffset = 17;
    cPixelPerfect.TreeGadgetHeightOffset = 8;
    cPixelPerfect.TreeGadgetWidthOffset = 8;
    cPixelPerfect.EditorGadgetHeightOffset = 5;
    cPixelPerfect.EditorGadgetWidthOffset = 5;
    return cPixelPerfect;
}());
var cPreference = (function () {
    function cPreference() {
    }
    cPreference.ClosePreferences = function () {
        cPreference.CurrentPreferenceFilename = "";
        cPreference.CurrentPreferenceGroupname = "";
        cPreference.GroupArray = [];
        cPreference.GroupCounter = -1;
        cPreference.KeyArray = [];
        cPreference.KeyCounter = -1;
    };
    cPreference.CreatePreferences = function (Filename, Flags) {
        if (Flags === void 0) { Flags = 0; }
        cPreference.ClosePreferences();
        if (cP2W.P2W_LocalStorage_Available()) {
            cPreference.CurrentPreferenceFilename = Filename;
            cPreference.GroupArray = [];
            cPreference.GroupCounter = -1;
            cPreference.KeyArray = [];
            cPreference.KeyCounter = -1;
            var myKeyArray = $.jStorage.index();
            for (var counter = 0; counter < myKeyArray.length; counter++) {
                var Filename_Group_Key_Array = myKeyArray[counter].split(cPreference.Separator);
                var myFilename = Filename_Group_Key_Array[0];
                var myGroup = Filename_Group_Key_Array[1];
                var myKey = Filename_Group_Key_Array[2];
                if (myFilename == Filename) {
                    $.jStorage.deleteKey(myKeyArray[counter]);
                }
            }
            return true;
        }
        else {
            return false;
        }
    };
    cPreference.ExaminePreferenceGroups = function () {
        cPreference.GroupArray = [];
        cPreference.GroupCounter = -1;
        var myKeyArray = $.jStorage.index();
        for (var counter = 0; counter < myKeyArray.length; counter++) {
            var Filename_Group_Key_Array = myKeyArray[counter].split(cPreference.Separator);
            var myFilename = Filename_Group_Key_Array[0];
            var myGroup = Filename_Group_Key_Array[1];
            var myKey = Filename_Group_Key_Array[2];
            if (myFilename == cPreference.CurrentPreferenceFilename) {
                cPreference.GroupArray.push(myGroup);
            }
        }
        return cPreference.GroupArray.length > 0;
    };
    cPreference.ExaminePreferenceKeys = function () {
        cPreference.KeyArray = [];
        cPreference.KeyCounter = -1;
        var myKeyArray = $.jStorage.index();
        for (var counter = 0; counter < myKeyArray.length; counter++) {
            var Filename_Group_Key_Array = myKeyArray[counter].split(cPreference.Separator);
            var myFilename = Filename_Group_Key_Array[0];
            var myGroup = Filename_Group_Key_Array[1];
            var myKey = Filename_Group_Key_Array[2];
            if (myFilename == cPreference.CurrentPreferenceFilename && myGroup == cPreference.CurrentPreferenceGroupname) {
                cPreference.KeyArray.push(myKey);
            }
        }
        return cPreference.KeyArray.length > 0;
    };
    cPreference.NextPreferenceGroup = function () {
        if (cPreference.GroupArray.length - 1 > cPreference.GroupCounter) {
            cPreference.GroupCounter += 1;
            return true;
        }
        else {
            return false;
        }
    };
    cPreference.NextPreferenceKey = function () {
        if (cPreference.KeyArray.length - 1 > cPreference.KeyCounter) {
            cPreference.KeyCounter += 1;
            return true;
        }
        else {
            return false;
        }
    };
    cPreference.OpenPreferences = function (Filename, Flags) {
        if (Flags === void 0) { Flags = 0; }
        cPreference.ClosePreferences();
        if (!cP2W.P2W_LocalStorage_Available()) {
            return false;
        }
        cPreference.CurrentPreferenceFilename = Filename;
        cPreference.GroupArray = [];
        cPreference.GroupCounter = -1;
        cPreference.KeyArray = [];
        cPreference.KeyCounter = -1;
        return true;
    };
    cPreference.PreferenceComment = function () {
    };
    cPreference.PreferenceGroup = function (Name) {
        cPreference.CurrentPreferenceGroupname = Name;
    };
    cPreference.PreferenceGroupName = function () {
        return cPreference.GroupArray[cPreference.GroupCounter];
    };
    cPreference.PreferenceKeyName = function () {
        return cPreference.KeyArray[cPreference.KeyCounter];
    };
    cPreference.PreferenceKeyValue = function () {
        var Key = cPreference.CurrentPreferenceFilename +
            cPreference.Separator +
            cPreference.PreferenceGroupName() +
            cPreference.Separator +
            cPreference.PreferenceKeyName();
        return cP2W.P2W_LocalStorage_GetItem(Key, "");
    };
    cPreference.ReadPreferenceDouble = function (Keyword, DefaultValue) {
        return cPreference.ReadPreferenceString(Keyword, DefaultValue);
    };
    cPreference.ReadPreferenceFloat = function (Keyword, DefaultValue) {
        return cPreference.ReadPreferenceString(Keyword, DefaultValue);
    };
    cPreference.ReadPreferenceInteger = function (Keyword, DefaultValue) {
        return cPreference.ReadPreferenceString(Keyword, DefaultValue);
    };
    cPreference.ReadPreferenceLong = function (Keyword, DefaultValue) {
        return cPreference.ReadPreferenceString(Keyword, DefaultValue);
    };
    cPreference.ReadPreferenceQuad = function (Keyword, DefaultValue) {
        return cPreference.ReadPreferenceString(Keyword, DefaultValue);
    };
    cPreference.ReadPreferenceString = function (Keyword, DefaultValue) {
        Keyword = cPreference.CurrentPreferenceFilename +
            cPreference.Separator +
            cPreference.CurrentPreferenceGroupname +
            cPreference.Separator +
            Keyword;
        return cP2W.P2W_LocalStorage_GetItem(Keyword, DefaultValue);
    };
    cPreference.RemovePreferenceGroup = function (Group) {
        var myKeyArray = $.jStorage.index();
        for (var counter = 0; counter < myKeyArray.length; counter++) {
            var Filename_Group_Key_Array = myKeyArray[counter].split(cPreference.Separator);
            var myFilename = Filename_Group_Key_Array[0];
            var myGroup = Filename_Group_Key_Array[1];
            var myKey = Filename_Group_Key_Array[2];
            if (myFilename == cPreference.CurrentPreferenceFilename) {
                if (myGroup == Group) {
                    $.jStorage.deleteKey(myKeyArray[counter]);
                }
            }
        }
    };
    cPreference.RemovePreferenceKey = function (Key) {
        var myKeyArray = $.jStorage.index();
        for (var counter = 0; counter < myKeyArray.length; counter++) {
            var Filename_Group_Key_Array = myKeyArray[counter].split(cPreference.Separator);
            var myFilename = Filename_Group_Key_Array[0];
            var myGroup = Filename_Group_Key_Array[1];
            var myKey = Filename_Group_Key_Array[2];
            if (myFilename == cPreference.CurrentPreferenceFilename) {
                if (myGroup == cPreference.CurrentPreferenceGroupname) {
                    if (myKey == Key) {
                        $.jStorage.deleteKey(myKeyArray[counter]);
                    }
                }
            }
        }
    };
    cPreference.WritePreferenceDouble = function (Keyword, Value) {
        cPreference.WritePreferenceString(Keyword, Value);
    };
    cPreference.WritePreferenceFloat = function (Keyword, Value) {
        cPreference.WritePreferenceString(Keyword, Value);
    };
    cPreference.WritePreferenceInteger = function (Keyword, Value) {
        cPreference.WritePreferenceString(Keyword, Value);
    };
    cPreference.WritePreferenceLong = function (Keyword, Value) {
        cPreference.WritePreferenceString(Keyword, Value);
    };
    cPreference.WritePreferenceQuad = function (Keyword, Value) {
        cPreference.WritePreferenceString(Keyword, Value);
    };
    cPreference.WritePreferenceString = function (Keyword, Value) {
        Keyword = cPreference.CurrentPreferenceFilename +
            cPreference.Separator +
            cPreference.CurrentPreferenceGroupname +
            cPreference.Separator +
            Keyword;
        cP2W.P2W_LocalStorage_SetItem(Keyword, Value);
    };
    cPreference.CurrentPreferenceFilename = "";
    cPreference.CurrentPreferenceGroupname = "";
    cPreference.Separator = String.fromCharCode(1);
    cPreference.GroupArray = [];
    cPreference.GroupCounter = -1;
    cPreference.KeyArray = [];
    cPreference.KeyCounter = -1;
    return cPreference;
}());
var cProcess = (function () {
    function cProcess() {
    }
    cProcess.AvailableProgramOutput = function () {
        
    };
    cProcess.CloseProgram = function () {
        
    };
    cProcess.CountProgramParameters = function () {
        if (window.location.href.indexOf('?') == -1) {
            return 0;
        }
        else {
            return window.location.href.slice(window.location.href.indexOf('?') + 1).split('&').length;
        }
    };
    cProcess.EnvironmentVariableName = function () {
        
    };
    cProcess.EnvironmentVariableValue = function () {
        
    };
    cProcess.ExamineEnvironmentVariables = function () {
        
    };
    cProcess.GetEnvironmentVariable = function () {
        
    };
    cProcess.IsProgram = function () {
        
    };
    cProcess.KillProgram = function () {
        
    };
    cProcess.NextEnvironmentVariable = function () {
        
    };
    cProcess.ProgramExitCode = function () {
        
    };
    cProcess.ProgramFilename = function () {
        return window.location.href;
    };
    cProcess.ProgramID = function () {
        
    };
    cProcess.ProgramParameter = function (Index) {
        if (Index === void 0) { Index = -1; }
        if (Index == -1) {
            Index = cCommon.P2W_Global_ProgramParameter_Counter;
        }
        else {
            cCommon.P2W_Global_ProgramParameter_Counter = Index;
        }
        cCommon.P2W_Global_ProgramParameter_Counter += 1;
        if (Index < 0)
            return "";
        if (window.location.href.indexOf('?') == -1)
            return "";
        var myArray = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
        if (Index > myArray.length - 1) {
            return "";
        }
        ;
        return myArray[Index];
    };
    cProcess.ProgramRunning = function () {
        
    };
    cProcess.ReadProgramData = function () {
        
    };
    cProcess.ReadProgramError = function () {
        
    };
    cProcess.ReadProgramString = function () {
        
    };
    cProcess.RemoveEnvironmentVariable = function () {
        
    };
    cProcess.RunProgram = function (Filename, Parameter, WorkingDirectory, Flags, SenderProgram) {
        if (Parameter === void 0) { Parameter = ""; }
        if (WorkingDirectory === void 0) { WorkingDirectory = ""; }
        if (Flags === void 0) { Flags = 0; }
        if (SenderProgram === void 0) { SenderProgram = 0; }
        var win;
        if (Parameter != "") {
            win = window.open(Filename, Parameter);
            win.focus();
        }
        else {
            window.open(Filename);
        }
    };
    cProcess.SetEnvironmentVariable = function () {
        
    };
    cProcess.WaitProgram = function () {
        
    };
    cProcess.WriteProgramData = function () {
        
    };
    cProcess.WriteProgramString = function () {
        
    };
    cProcess.WriteProgramStringN = function () {
        
    };
    return cProcess;
}());
var cRegularExpression = (function () {
    function cRegularExpression() {
    }
    cRegularExpression.CountRegularExpressionGroups = function () {  };
    cRegularExpression.CreateRegularExpression = function () {  };
    cRegularExpression.ExamineRegularExpression = function () {  };
    cRegularExpression.ExtractRegularExpression = function () {  };
    cRegularExpression.FreeRegularExpression = function () {  };
    cRegularExpression.IsRegularExpression = function () {  };
    cRegularExpression.MatchRegularExpression = function () {  };
    cRegularExpression.NextRegularExpressionMatch = function () {  };
    cRegularExpression.RegularExpressionError = function () {  };
    cRegularExpression.RegularExpressionGroup = function () {  };
    cRegularExpression.RegularExpressionGroupLength = function () {  };
    cRegularExpression.RegularExpressionGroupPosition = function () {  };
    cRegularExpression.RegularExpressionMatchLength = function () {  };
    cRegularExpression.RegularExpressionMatchPosition = function () {  };
    cRegularExpression.RegularExpressionMatchString = function () {  };
    cRegularExpression.RegularExpressionNamedGroup = function () {  };
    cRegularExpression.RegularExpressionNamedGroupLength = function () {  };
    cRegularExpression.RegularExpressionNamedGroupPosition = function () {  };
    cRegularExpression.ReplaceRegularExpression = function () {  };
    return cRegularExpression;
}());
var cRequester = (function () {
    function cRequester() {
    }
    cRequester.CameraRequester = function (Title, Callback) {
        if (Callback === void 0) { Callback = null; }
        var ok = 'OK';
        var cancel = 'Cancel';
        switch (cString.LCase(cString.Left(cSystem.GetBrowserLanguage(), 2))) {
            case "fr":
                cancel = 'Annuler';
                break;
            case "de":
                cancel = "Abbrechen";
                break;
        }
        var myButtons = [
            {
                text: ok,
                click: function () {
                    if (Callback)
                        Callback(cConstants.PB_MessageRequester_Ok, myImage.attr("src"));
                    $(this).dialog("close");
                    $(this).remove();
                }
            },
            {
                text: cancel,
                click: function () {
                    if (Callback)
                        Callback(cConstants.PB_MessageRequester_Cancel, myImage.attr("src"));
                    $(this).dialog("close");
                    $(this).remove();
                }
            }
        ];
        var myDiv = $("<div />");
        var myInput = $('<input type="file" accept="image/*;capture=camera">');
        myDiv.append(myInput);
        myDiv.append($("<hr />"));
        var myImage = $("<img />");
        myDiv.append(myImage);
        myInput.change(function (event) {
            var filename = myInput.val().replace(/C:\\fakepath\\/i, '');
            myImage.attr("src", filename);
        });
        myDiv.dialog({
            buttons: myButtons,
            resizable: false,
            title: Title,
            modal: true
        });
    };
    cRequester.ColorRequester = function (CurrentColor, Callback) {
        if (CurrentColor === void 0) { CurrentColor = null; }
        if (Callback === void 0) { Callback = 0; }
        if (CurrentColor) {
            CurrentColor = cCommon.rgb2hex(CurrentColor);
        }
        var ok = 'OK';
        var cancel = 'Cancel';
        switch (cString.LCase(cString.Left(cSystem.GetBrowserLanguage(), 2))) {
            case "fr":
                cancel = 'Annuler';
                break;
            case "de":
                cancel = "Abbrechen";
                break;
        }
        var myButtons;
        myButtons = [
            {
                text: ok,
                click: function () {
                    if (Callback)
                        Callback(cString.Val($("#" + guid).colorpicker("val")));
                    $(this).dialog("close");
                    $(this).remove();
                }
            },
            {
                text: cancel,
                click: function () {
                    if (Callback)
                        Callback(-1);
                    $(this).dialog("close");
                    $(this).remove();
                }
            }
        ];
        var guid = cCommon.guid();
        $("<div id='" + guid + "' />").dialog({
            buttons: myButtons,
            resizable: false,
            width: 240,
            title: "",
            modal: true,
            open: function (event, ui) {
                $(this).colorpicker({
                    color: CurrentColor
                });
            }
        });
        $("#" + guid).dialog({ position: 'center' });
    };
    cRequester.FontRequester = function (FontName, FontSize, Flags, Color, Style) {
        
        return -1;
    };
    cRequester.InputRequester = function (Title, Message, DefaultText, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        var guid = cCommon.guid();
        var myDiv = $("<div id='ir" + guid + "' />");
        Message = cString.ReplaceString(Message, cString.Chr(13) + cString.Chr(10), "<br />");
        Message = cString.ReplaceString(Message, cString.Chr(13), "<br />");
        Message = cString.ReplaceString(Message, cString.Chr(10), "<br />");
        myDiv.append("<p>" + Message + "</p>");
        var myType = "text";
        if (cCommon.CheckFlag(Flags, cConstants.PB_InputRequester_Password))
            myType = "password";
        myDiv.append("<input type='" + myType + "' id='txt" + guid + "' value='" + DefaultText + "' style='width:100%' />");
        var myButton = [
            {
                text: "OK",
                click: function () {
                    if (Callback)
                        Callback($("#txt" + guid).val());
                    $(this).dialog("close");
                    $(this).remove();
                }
            }
        ];
        myDiv.dialog({
            buttons: myButton,
            resizable: false,
            title: Title,
            modal: true
        });
        $("#ir" + guid).dialog({ position: 'center' });
        return "";
    };
    cRequester.MessageRequester = function (Title, Text, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = 0; }
        Text = cString.ReplaceString(Text, cString.Chr(13) + cString.Chr(10), "<br />");
        Text = cString.ReplaceString(Text, cString.Chr(13), "<br />");
        Text = cString.ReplaceString(Text, cString.Chr(10), "<br />");
        var yes = 'Yes';
        var no = 'No';
        var cancel = 'Cancel';
        switch (cString.LCase(cString.Left(cSystem.GetBrowserLanguage(), 2))) {
            case "fr":
                yes = 'Oui';
                no = 'Non';
                cancel = 'Annuler';
                break;
            case "de":
                yes = "Ja";
                no = "Nein";
                cancel = "Abbrechen";
                break;
        }
        var myButtons;
        if (cCommon.CheckFlag(Flags, cConstants.PB_MessageRequester_YesNo)) {
            myButtons = [
                {
                    text: yes,
                    click: function () {
                        $(this).dialog("close");
                        if (Callback)
                            Callback(cConstants.PB_MessageRequester_Yes);
                    }
                },
                {
                    text: no,
                    click: function () {
                        $(this).dialog("close");
                        if (Callback)
                            Callback(cConstants.PB_MessageRequester_No);
                    }
                }
            ];
        }
        else if (cCommon.CheckFlag(Flags, cConstants.PB_MessageRequester_YesNoCancel)) {
            myButtons = [
                {
                    text: yes,
                    click: function () {
                        $(this).dialog("close");
                        if (Callback)
                            Callback(cConstants.PB_MessageRequester_Yes);
                    }
                },
                {
                    text: no,
                    click: function () {
                        $(this).dialog("close");
                        if (Callback)
                            Callback(cConstants.PB_MessageRequester_No);
                    }
                },
                {
                    text: cancel,
                    click: function () {
                        $(this).dialog("close");
                        if (Callback)
                            Callback(cConstants.PB_MessageRequester_Cancel);
                    }
                }
            ];
        }
        else if (cCommon.CheckFlag(Flags, cConstants.PB_MessageRequester_Ok)) {
            myButtons = [
                {
                    text: "OK",
                    click: function () {
                        $(this).dialog("close");
                        if (Callback)
                            Callback(cConstants.PB_MessageRequester_Ok);
                    }
                }
            ];
        }
        var guid = cCommon.guid();
        $("<div id='w_" + guid + "' />").dialog({
            buttons: myButtons,
            resizable: false,
            title: Title,
            modal: true,
            close: function (event, ui) {
                if ($(event.currentTarget).hasClass("ui-dialog-titlebar-close")) {
                    if (Callback)
                        Callback(cConstants.PB_MessageRequester_Cancel);
                }
                $(this).remove();
            }
        }).html(Text);
        $("#w_" + guid).dialog({ position: 'center' });
        return guid;
    };
    cRequester.NextSelectedFilename = function () {
        
        return "";
    };
    cRequester.zzzGetFileSize = function () {
    };
    cRequester.OpenFileRequester = function (Title, DefaultFile, Pattern, PatternPosition, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        $("#OpenFileRequester").remove();
        var selector = $("<input />");
        selector.attr("id", "OpenFileRequester");
        selector.attr("name", "P2W_Upload[]");
        selector.attr("type", "file");
        selector.css("visibility", "hidden");
        if (Pattern != "")
            selector.attr("accept", Pattern);
        if (PatternPosition >= 0)
            selector.attr("maxsize", PatternPosition);
        if (cCommon.CheckFlag(Flags, cConstants.PB_Requester_MultiSelection))
            selector.attr("multiple", "multiple");
        $("body").append(selector);
        if (Callback) {
            selector.change(function () {
                Callback(this, this.value);
            });
        }
        selector.trigger('click');
    };
    cRequester.OpenFileRequester2 = function (Title, DefaultFile, Pattern, PatternPosition, Flags, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Callback === void 0) { Callback = null; }
        $("#OpenFileRequester").remove();
        $("#UploadForm").remove();
        if (DefaultFile == "") {
            try {
            }
            catch (ex) {
                
                return "";
            }
        }
        var html = "";
        var accept = "";
        var maxsize = "";
        var multiple = "";
        if (DefaultFile != "") {
            html += "<form id='UploadForm' action='" + DefaultFile + "' method='post' enctype='multipart/form-data'>";
            if (Pattern != "")
                accept = "accept='" + Pattern + "'";
            if (PatternPosition >= 0)
                maxsize = "maxsize='" + PatternPosition + "'";
            if (cCommon.CheckFlag(Flags, cConstants.PB_Requester_MultiSelection))
                multiple = "multiple";
            html += "<div style='width: 0px; height: 0px; overflow: hidden;'>";
            html += "<input id='OpenFileRequester' name='P2W_Upload[]' type='file' " + accept + " " + maxsize + " style='visibility:hidden' " + multiple + " />";
            html += "</div>";
            html += "</form>";
            $("body").append(html);
            $("#UploadForm").ajaxForm({
                beforeSend: function () {
                    Callback(cConstants.PB_Event_Upload_BeforeSend, "1" + cString.Chr(10) +
                        "1" + cString.Chr(10) +
                        "unknown" + cString.Chr(10) +
                        "unknown" + cString.Chr(10) +
                        "0");
                },
                uploadProgress: function (event, position, total, percentComplete) {
                    Callback(cConstants.PB_Event_Upload_UploadProgress, "1" + cString.Chr(10) +
                        "1" + cString.Chr(10) +
                        position + cString.Chr(10) +
                        total + cString.Chr(10) +
                        percentComplete);
                },
                success: function () {
                    Callback(cConstants.PB_Event_Upload_Success, "");
                },
                complete: function (xhr) {
                    Callback(cConstants.PB_Event_Upload_Complete, "1" + cString.Chr(10) + "1" + cString.Chr(10) + xhr.responseText);
                },
                error: function () {
                    Callback(cConstants.PB_Event_Upload_Error, "1" + cString.Chr(10) + "1" + cString.Chr(10) + "unable to upload file");
                }
            });
            $('#OpenFileRequester').on("change", function () {
                $("#UploadForm").submit();
            });
            $("#OpenFileRequester").trigger('click');
            return "";
        }
        else {
            if (Pattern != "")
                accept = "accept='" + Pattern + "'";
            if (PatternPosition >= 0)
                maxsize = "maxsize='" + PatternPosition + "'";
            if (cCommon.CheckFlag(Flags, cConstants.PB_Requester_MultiSelection))
                multiple = "multiple";
            html += "<input id='OpenFileRequester' name='P2W_Upload[]' type='file' " + accept + " " + maxsize + " style='visibility:hidden' " + multiple + " />";
            $("body").append(html);
            var myInputElement = document.getElementById('OpenFileRequester');
            myInputElement.addEventListener('change', function (evt) {
                function LoadFile(currentFileNumber, totalFileNumber, currentFile) {
                    var reader = new FileReader();
                    if (cString.FindString(Pattern, "text")) {
                        reader.readAsText(currentFile);
                    }
                    else {
                        reader.readAsDataURL(currentFile);
                    }
                    reader.onloadstart = function (event) {
                        if (Callback(cConstants.PB_Event_Upload_BeforeSend, currentFileNumber + cString.Chr(10) +
                            totalFileNumber + cString.Chr(10) +
                            currentFile.name + cString.Chr(10) +
                            currentFile.type + cString.Chr(10) +
                            currentFile.size) == true) {
                            reader.abort();
                        }
                    };
                    reader.onprogress = function (event) {
                        if (event.lengthComputable) {
                            var position = event.loaded;
                            var total = event.total;
                            var percentComplete = Math.round((position / total) * 100);
                            Callback(cConstants.PB_Event_Upload_UploadProgress, currentFileNumber + cString.Chr(10) +
                                totalFileNumber + cString.Chr(10) +
                                position + cString.Chr(10) +
                                total + cString.Chr(10) +
                                percentComplete);
                        }
                    };
                    reader.onload = function (event) {
                        Callback(cConstants.PB_Event_Upload_Complete, currentFileNumber + cString.Chr(10) +
                            totalFileNumber + cString.Chr(10) +
                            reader.result);
                    };
                    reader.onerror = function (event) {
                        Callback(cConstants.PB_Event_Upload_Error, currentFileNumber + cString.Chr(10) + totalFileNumber);
                    };
                }
                var files = evt.target.files;
                for (var i = 0, len = files.length; i < len; i++) {
                    LoadFile(i + 1, files.length, files[i]);
                }
            });
            $("#OpenFileRequester").trigger('click');
        }
    };
    cRequester.PathRequester = function (Title, InitialPath) {
        
        return "";
    };
    cRequester.SaveFileRequester = function (Title, DefaultFile, Pattern, PatternPosition, Callback) {
        if (Callback === void 0) { Callback = null; }
        $("#SaveFileRequester").remove();
        var nwsaveas = 'nwsaveas';
        if (DefaultFile != "") {
            nwsaveas += '="' + DefaultFile + '"';
        }
        var selector = $("<input " + nwsaveas + " />");
        selector.attr("id", "SaveFileRequester");
        selector.attr("name", "P2W_Download[]");
        selector.attr("type", "file");
        selector.css("visibility", "hidden");
        if (Pattern != "")
            selector.attr("accept", Pattern);
        if (PatternPosition >= 0)
            selector.attr("maxsize", PatternPosition);
        $("body").append(selector);
        if (Callback) {
            selector.change(function () {
                Callback(this, this.value);
            });
        }
        selector.trigger('click');
    };
    cRequester.SelectedFilePattern = function () {
        
        return -1;
    };
    cRequester.SelectedFontColor = function () {
        
        return -1;
    };
    cRequester.SelectedFontName = function () {
        
        return "";
    };
    cRequester.SelectedFontSize = function () {
        
        return -1;
    };
    cRequester.SelectedFontStyle = function () {
        
        return -1;
    };
    return cRequester;
}());
var cScreen = (function () {
    function cScreen() {
    }
    cScreen.AvailableScreenMemory = function () {  };
    cScreen.ChangeGamma = function () {  };
    cScreen.ClearScreen = function () {  };
    cScreen.CloseScreen = function () {  };
    cScreen.ExamineScreenModes = function () {  };
    cScreen.FlipBuffers = function () {  };
    cScreen.IsScreenActive = function () {  };
    cScreen.NextScreenMode = function () {  };
    cScreen.OpenScreen = function () {  };
    cScreen.OpenWindowedScreen = function () {  };
    cScreen.ScreenDepth = function () {  };
    cScreen.ScreenHeight = function () {  };
    cScreen.ScreenID = function () {  };
    cScreen.ScreenModeDepth = function () {  };
    cScreen.ScreenModeHeight = function () {  };
    cScreen.ScreenModeRefreshRate = function () {  };
    cScreen.ScreenModeWidth = function () {  };
    cScreen.ScreenOutput = function () {  };
    cScreen.ScreenWidth = function () {  };
    cScreen.SetFrameRate = function () {  };
    return cScreen;
}());
var cSort = (function () {
    function cSort() {
    }
    cSort.RandomizeArray = function (ArrayName, Start, End) {
        if (Start === void 0) { Start = 0; }
        if (End === void 0) { End = ArrayName.length; }
        if (Start < 0) {
            Start = 0;
        }
        if (End > ArrayName.length) {
            End = ArrayName.length;
        }
        var tmp, rand;
        for (var i = Start; i < End; i++) {
            rand = Math.floor(Math.random() * End);
            tmp = ArrayName[i];
            ArrayName[i] = ArrayName[rand];
            ArrayName[rand] = tmp;
        }
    };
    cSort.RandomizeListOld = function (LinkedList, Start, End) {
        if (Start === void 0) { Start = 0; }
        if (End === void 0) { End = LinkedList.ListSize(); }
        if (Start < 0) {
            Start = 0;
        }
        if (End > LinkedList.ListSize()) {
            End = LinkedList.ListSize();
        }
        for (var i = End - 1; i > Start; i--) {
            var rand = Math.floor(Math.random() * (i + 1));
            LinkedList.SelectElement(i);
            var tmp1 = LinkedList.getData();
            LinkedList.SelectElement(rand);
            var tmp2 = LinkedList.getData();
            LinkedList.SelectElement(i);
            LinkedList.setData(tmp2);
            LinkedList.SelectElement(rand);
            LinkedList.setData(tmp1);
        }
    };
    cSort.RandomizeList = function (LinkedList, Start, End) {
        if (Start === void 0) { Start = 0; }
        if (End === void 0) { End = -1; }
        if (End == -1) {
            End = LinkedList.ListSize();
        }
        if (Start < 0) {
            Start = 0;
        }
        if (End > LinkedList.ListSize()) {
            End = LinkedList.ListSize();
        }
        for (var i = End - 1; i > Start; i--) {
            var rand = Math.floor(Math.random() * (i + 1));
            LinkedList.SelectElement(i);
            var tmp1 = LinkedList.GetContent();
            LinkedList.SelectElement(rand);
            var tmp2 = LinkedList.GetContent();
            LinkedList.SelectElement(i);
            LinkedList.SetContent(tmp2);
            LinkedList.SelectElement(rand);
            LinkedList.SetContent(tmp1);
        }
    };
    cSort.SortArray = function (ArrayName, Options, Start, End) {
        if (Start === void 0) { Start = 0; }
        if (End === void 0) { End = ArrayName.length; }
        if (Start < 0) {
            Start = 0;
        }
        if (End > ArrayName.length) {
            End = ArrayName.length;
        }
        if (Start > 0) {
            
            return;
        }
        if (End < ArrayName.length) {
            
            return;
        }
        if (Options == cConstants.PB_Sort_NoCase) {
            
            return;
        }
        if (Options == cConstants.PB_Sort_Ascending) {
            ArrayName.sort();
        }
        else if (Options == cConstants.PB_Sort_Descending) {
            ArrayName.sort();
            ArrayName.reverse();
        }
    };
    cSort.SortList = function (ListName, Options, Start, End) {
        if (Start === void 0) { Start = 0; }
        if (End === void 0) { End = ListName.ListSize(); }
        if (Start < 0) {
            Start = 0;
        }
        if (End > ListName.ListSize()) {
            End = ListName.ListSize();
        }
        
    };
    cSort.SortStructuredArray = function (ArrayName, Options, OffsetOfStructureField, TypeOfStructureField, Start, End) {
        
    };
    cSort.SortStructuredList = function (ListName, Options, OffsetOfStructureField, TypeOfStructureField, Start, End) {
        
    };
    return cSort;
}());
var cSprite = (function () {
    function cSprite() {
    }
    cSprite.P2W_RenderGadget = function (Gadget, x, y, Width, Height) {
        var functionName = "P2W_RenderGadget";
        var Gadget = cCommon.SetGadgetAndStuff(Gadget);
        var Renderer = PIXI.autoDetectRenderer(Width, Height);
        var RendererView = Renderer.view;
        var selector = $(RendererView);
        cCommon.SetGadgetPosition(selector, x, y, Width, Height);
        selector.attr("id", "g_" + Gadget);
        selector.data("Renderer", Renderer);
        selector.data("GadgetType", cConstants.PB_GadgetType_Button);
        cCommon.CurrentContainer.append(selector);
        return Gadget;
    };
    cSprite.P2W_CreateStage = function (backgroundColor) {
        var myStage = new PIXI.Stage(0xFFFFFF);
        return myStage;
    };
    cSprite.P2W_CreateRenderer = function (width, height) {
        var myRenderer = PIXI.autoDetectRenderer(width, height);
        return myRenderer;
    };
    cSprite.P2W_AddStageChild = function (Stage, Sprite) {
        Stage.addChild(Sprite);
    };
    cSprite.P2W_RenderStage = function (Renderer, Stage) {
        var selector = $("#g_" + Renderer);
        var myRenderer = selector.data("Renderer");
        myRenderer.render(Stage);
    };
    cSprite.P2W_RequestAnimFrame = function (Callback) {
        requestAnimFrame(Callback);
    };
    cSprite.P2W_AnchorSprite = function (Sprite, x, y) {
        Sprite.anchor.x = x;
        Sprite.anchor.y = y;
    };
    cSprite.CatchSprite = function () {
        
    };
    cSprite.ClipSprite = function () {
        
    };
    cSprite.CopySprite = function () {
        
    };
    cSprite.CreateSprite = function (Sprite, Width, Height, Mode) {
        if (Mode === void 0) { Mode = 0; }
        
        return -1;
    };
    cSprite.P2W_CreateSprite = function (imageUrl) {
        var myTexture = PIXI.Texture.fromImage(imageUrl);
        var mySprite = new PIXI.Sprite(myTexture);
        return mySprite;
    };
    cSprite.DisplaySprite = function (Sprite, x, y) {
        Sprite.position.x = x;
        Sprite.position.y = y;
    };
    cSprite.DisplayTransparentSprite = function (Sprite, x, y, Intensity, Color) {
        if (Intensity === void 0) { Intensity = 0; }
        if (Color === void 0) { Color = 0; }
        
    };
    cSprite.FreeSprite = function (Sprite) {
        
    };
    cSprite.GrabSprite = function (Sprite, x, y, Width, Height, Mode) {
        if (Mode === void 0) { Mode = 0; }
        
        return -1;
    };
    cSprite.InitSprite = function () {
        
    };
    cSprite.IsSprite = function (Sprite) {
        
        return -1;
    };
    cSprite.LoadSprite = function (Sprite, Filename, Mode) {
        if (Mode === void 0) { Mode = 0; }
        
        return -1;
    };
    cSprite.RotateSprite = function (Sprite, Angle, Mode) {
        if (Mode == cConstants.PB_Absolute) {
            Sprite.rotation = Angle;
        }
        else {
            Sprite.rotation += Angle;
        }
    };
    cSprite.SaveSprite = function (Sprite, Filename, ImagePlugin, Flags) {
        if (ImagePlugin === void 0) { ImagePlugin = 0; }
        if (Flags === void 0) { Flags = 0; }
        
        return -1;
    };
    cSprite.SpriteBlendingMode = function (SourceMode, DestinationMode) {
        
    };
    cSprite.SpriteCollision = function (Sprite1, x1, y1, Sprite2, x2, y2) {
        
        return -1;
    };
    cSprite.SpriteDepth = function (Sprite) {
        
        return -1;
    };
    cSprite.SpriteHeight = function (Sprite) {
        return Sprite.height;
    };
    cSprite.SpriteID = function () {
        
    };
    cSprite.SpriteOutput = function () {
        
    };
    cSprite.SpritePixelCollision = function () {
        
    };
    cSprite.SpriteQuality = function () {
        
    };
    cSprite.SpriteWidth = function (Sprite) {
        return Sprite.width;
    };
    cSprite.TransformSprite = function () {
        
    };
    cSprite.TransparentSpriteColor = function () {
        
    };
    cSprite.ZoomSprite = function () {
        
    };
    return cSprite;
}());
var cString = (function () {
    function cString() {
    }
    cString.isString = function (String) {
        if (typeof String == 'string')
            return true;
        return false;
    };
    cString.Asc = function (String) {
        if (!cString.isString(String))
            return 0;
        return String.charCodeAt(0);
    };
    cString.Bin = function (Value, Type) {
        if (Type === void 0) { Type = 0; }
        return Value.toString(2);
    };
    cString.Chr = function (CharacterValue) {
        return String.fromCharCode(CharacterValue);
    };
    cString.CountString = function (String, StringToCount) {
        if (!cString.isString(String))
            return 0;
        return String.split(StringToCount).length - 1;
    };
    cString.EndsWith = function (String, Suffix) {
        if (!cString.isString(String))
            return false;
        if (String.match(Suffix + "$")) {
            return (String.match(Suffix + "$")[0] == Suffix);
        }
        else {
            return false;
        }
    };
    cString.FindString = function (String, StringToFind, StartPosition, Mode) {
        if (StartPosition === void 0) { StartPosition = 1; }
        if (Mode === void 0) { Mode = cConstants.PB_String_CaseSensitive; }
        if (StartPosition < 1)
            StartPosition = 1;
        StartPosition -= 1;
        switch (Mode) {
            case cConstants.PB_String_CaseSensitive:
                return String.indexOf(StringToFind, StartPosition) + 1;
            case cConstants.PB_String_NoCase:
                return String.toLowerCase().indexOf(StringToFind.toLowerCase(), StartPosition) + 1;
            default:
                return -1;
        }
    };
    cString.Hex = function (Number, Type) {
        if (Type === void 0) { Type = 0; }
        return Number.toString(16);
    };
    cString.IsNumeric = function (n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    };
    cString.InsertString = function (String, StringToInsert, Position) {
        if (!cString.isString(String))
            return "";
        return String.substring(0, Position - 1) + StringToInsert + String.substr(Position - 1, String.length);
    };
    cString.Join = function (Array, Separator) {
        if (Separator === void 0) { Separator = ""; }
        return Array.join(Separator);
    };
    cString.LCase = function (String) {
        if (!cString.isString(String))
            return "";
        return String.toLowerCase();
    };
    cString.LSet = function (String, Length, Character) {
        if (Character === void 0) { Character = " "; }
        if (!cString.isString(String))
            return "";
        if (String.length === Length)
            return String;
        if (String.length > Length)
            return cString.Left(String, Length);
        var pad = "";
        for (var k = String.length; k < Length; k++) {
            pad += Character;
        }
        return String + pad;
    };
    cString.LTrim = function (String, Character) {
        if (Character === void 0) { Character = ""; }
        if (!cString.isString(String))
            return "";
        var rgxtrim = (!Character) ? new RegExp('^\\s+') : new RegExp('^' + Character + '+');
        return String.replace(rgxtrim, '');
    };
    cString.Left = function (String, Length) {
        if (!cString.isString(String))
            return "";
        return String.substring(0, Length);
    };
    cString.Len = function (String) {
        if (!cString.isString(String))
            return 0;
        return String.length;
    };
    cString.Mid = function (String, StartPosition, Length) {
        if (Length === void 0) { Length = 0; }
        if (!cString.isString(String))
            return "";
        if (Length === 0)
            return String.substring(StartPosition - 1);
        return String.substring(StartPosition - 1, StartPosition + Length - 1);
    };
    cString.RSet = function (String, Length, Character) {
        if (Character === void 0) { Character = " "; }
        if (!cString.isString(String))
            return "";
        if (String.length === Length)
            return String;
        if (String.length > Length)
            return cString.Left(String, Length);
        var pad = "";
        for (var k = String.length; k < Length; k++) {
            pad += Character;
        }
        return pad + String;
    };
    cString.RTrim = function (String, Character) {
        if (Character === void 0) { Character = ""; }
        if (!cString.isString(String))
            return "";
        var rgxtrim = (!Character) ? new RegExp('\\s+$') : new RegExp(Character + '+$');
        return String.replace(rgxtrim, '');
    };
    cString.RemoveString = function (String, StringToRemove, Mode, StartPosition, NbOccurrences) {
        if (Mode === void 0) { Mode = cConstants.PB_String_CaseSensitive; }
        if (StartPosition === void 0) { StartPosition = -1; }
        if (NbOccurrences === void 0) { NbOccurrences = -1; }
        if (!cString.isString(String))
            return "";
        return cString.ReplaceString(String, StringToRemove, "", Mode, StartPosition, NbOccurrences);
    };
    cString.ReplaceString = function (String, StringToFind, StringToReplace, Mode, StartPosition, NbOccurrences) {
        if (Mode === void 0) { Mode = cConstants.PB_String_CaseSensitive; }
        if (StartPosition === void 0) { StartPosition = -1; }
        if (NbOccurrences === void 0) { NbOccurrences = -1; }
        if (!cString.isString(String))
            return "";
        if (!StringToFind)
            return String;
        if (StringToFind === StringToReplace)
            return String;
        if (StartPosition > String.length)
            return String;
        if (StartPosition <= 0)
            StartPosition = 1;
        if (NbOccurrences === -1)
            NbOccurrences = String.length;
        var p1 = cString.Left(String, StartPosition - 1);
        var p2 = cString.Mid(String, StartPosition);
        var StringToReplaceToken = '#PB2WEBTOKEN#';
        if (Mode === cConstants.PB_String_NoCase) {
            while (p2.toLowerCase().indexOf(StringToFind.toLowerCase()) > -1) {
                if (NbOccurrences <= 0)
                    break;
                p2 = p2.replace(new RegExp(StringToFind, 'i'), StringToReplaceToken);
                NbOccurrences -= 1;
            }
        }
        else {
            while (p2.indexOf(StringToFind) > -1) {
                if (NbOccurrences <= 0)
                    break;
                p2 = p2.replace(StringToFind, StringToReplaceToken);
                NbOccurrences -= 1;
            }
        }
        p2 = p2.split(StringToReplaceToken).join(StringToReplace);
        return p1 + p2;
    };
    cString.ReverseString = function (String) {
        if (!cString.isString(String))
            return "";
        return String.split("").reverse().join("");
    };
    cString.Right = function (String, Length) {
        if (!cString.isString(String))
            return "";
        return String.substring(String.length - Length);
    };
    cString.Space = function (Length) {
        return new Array(Length + 1).join(" ").toString();
    };
    cString.StartsWith = function (String, Prefix) {
        if (!cString.isString(String))
            return false;
        return String.indexOf(Prefix) === 0;
    };
    cString.Str = function (Value) {
        if ((typeof Value === "undefined") || (Value === null)) {
            return "";
        }
        else {
            return Value.toString();
        }
    };
    cString.StrD = function (Value, NbDecimals) {
        if (NbDecimals === void 0) { NbDecimals = 0; }
        return Value.toFixed(NbDecimals).toString();
    };
    cString.StrF = function (Value, NbDecimals) {
        if (NbDecimals === void 0) { NbDecimals = 0; }
        return Value.toFixed(NbDecimals).toString();
    };
    cString.StrU = function (Value, Type) {
        return Value.toString();
    };
    cString.StringByteLength = function (String, Format) {
        if (Format === void 0) { Format = 0; }
        if (!cString.isString(String))
            return 0;
        return String.length;
    };
    cString.StringField = function (String, Index, Delimiter) {
        if (Delimiter === void 0) { Delimiter = ""; }
        if (!cString.isString(String))
            return "";
        var myArray = String.split(Delimiter);
        if (myArray[Index - 1])
            return myArray[Index - 1];
        return "";
    };
    cString.Split = function (String, Separator, Count) {
        if (Count === void 0) { Count = -1; }
        if (!cString.isString(String))
            return [];
        if (Count != -1)
            return String.split(Separator, Count);
        return String.split(Separator);
    };
    cString.Trim = function (String, Character) {
        if (Character === void 0) { Character = ""; }
        if (!cString.isString(String))
            return "";
        var rgxtrim = (!Character) ? new RegExp('^\\s+|\\s+$', 'g') : new RegExp('^' + Character + '+|' + Character + '+$', 'g');
        return String.replace(rgxtrim, '');
    };
    cString.UCase = function (String) {
        if (!cString.isString(String))
            return "";
        return String.toUpperCase();
    };
    cString.Val = function (String) {
        if (!cString.isString(String))
            return 0;
        if (cString.Left(String, 1) == "$" || cString.Left(String, 1) == "#") {
            String = cString.Mid(String, 2);
            return parseInt(String, 16);
        }
        else if (isNaN(parseInt(String))) {
            return 0;
        }
        return parseInt(String);
    };
    cString.ValD = function (String) {
        if (!cString.isString(String))
            return 0;
        if (isNaN(parseFloat(String)))
            return 0;
        return parseFloat(String);
    };
    cString.ValF = function (String) {
        if (!cString.isString(String))
            return 0;
        if (isNaN(parseFloat(String)))
            return 0;
        return parseFloat(String);
    };
    return cString;
}());
var cStringBuilder = (function () {
    function cStringBuilder() {
        this.strings = [];
    }
    cStringBuilder.prototype.append = function (value) {
        if (value)
            this.strings.push(value);
    };
    cStringBuilder.prototype.appendLine = function (value) {
        if (value)
            this.strings.push(value + '\r\n');
    };
    cStringBuilder.prototype.clear = function () {
        this.strings.length = 1;
    };
    cStringBuilder.prototype.toString = function () {
        return this.strings.join("");
    };
    return cStringBuilder;
}());
var cSystem = (function () {
    function cSystem() {
    }
    cSystem.SetGuiSize = function (Size) {
        $("body").css("font-size", Size);
    };
    cSystem.GetGuiSize = function () {
        return $("body").css("font-size");
    };
    cSystem.GetBrowserLanguage = function () {
        return cCommon.BrowserLanguage;
    };
    cSystem.SetBrowserLanguage = function (Language) {
        cCommon.BrowserLanguage = Language;
    };
    cSystem.CPUName = function () {
        
    };
    cSystem.CocoaMessage = function () {
        
    };
    cSystem.ComputerName = function () {
        
    };
    cSystem.CountCPUs = function () {
        
    };
    cSystem.Delay = function (milliSeconds) {
        milliSeconds += new Date().getTime();
        while (new Date().getTime() < milliSeconds) { }
    };
    cSystem.DoubleClickTime = function () {
        
    };
    cSystem.ElapsedMilliseconds = function () {
        return new Date().getTime();
    };
    cSystem.MemoryStatus = function () {
        
    };
    cSystem.OSVersion = function () {
        
    };
    cSystem.UserName = function () {
        
    };
    return cSystem;
}());
var cTimer = (function () {
    function cTimer(timerInterval) {
        this.timerInterval = timerInterval;
    }
    cTimer.prototype.start = function (callback) {
        this.timerToken = setInterval(callback, this.timerInterval);
    };
    cTimer.prototype.stop = function () {
        clearTimeout(this.timerToken);
    };
    return cTimer;
}());
var cToolBar = (function () {
    function cToolBar() {
    }
    cToolBar.CreateToolBar = function (ToolBar, WindowID) {
        if (ToolBar == cConstants.PB_Any) {
            ToolBar = cCommon.guid();
        }
        if ($("#tb_" + ToolBar).length > 0) {
            cToolBar.FreeToolBar(ToolBar);
        }
        if (cCommon.CurrentContainer == null) {
            cCommon.CurrentContainer = $("body");
        }
        var html = '';
        html += '<div class="ui-widget-header ui-corner-all">';
        html += '</div>';
        var selector = $(html);
        selector.attr("id", "tb_" + ToolBar);
        cCommon.CurrentContainer.append(selector);
        cCommon.CurrentToolbar = selector;
        return ToolBar;
    };
    cToolBar.DisableToolBarButton = function (ToolBar, ButtonID, State) {
        var selector = $("#tb_" + ToolBar).find("#tbb_" + ButtonID);
        if (selector.length == 0) {
            
            return;
        }
        if (State == 1) {
            selector.attr("disabled", "disabled");
            selector.addClass("ui-state-disabled");
        }
        else {
            selector.removeAttr("disabled");
            selector.removeClass("ui-state-disabled");
        }
    };
    cToolBar.FreeToolBar = function (ToolBar) {
        var selector = $("#tb_" + ToolBar);
        if (selector.length == 0) {
            cCommon.ToolbarIsNotInitialized("FreeToolbar()");
            return;
        }
        selector.empty();
        selector.remove();
    };
    cToolBar.GetToolBarButtonState = function (ToolBar, ButtonID) {
        var selector = $("#tb_" + ToolBar).find("#tbb_" + ButtonID);
        if (selector.length == 0) {
            
            return;
        }
        if (selector.find("input").attr("checked")) {
            return 1;
        }
        else {
            return 0;
        }
    };
    cToolBar.IsToolBar = function (ToolBar) {
        return $("#tb_" + ToolBar).length > 0;
    };
    cToolBar.SetToolBarButtonState = function (ToolBar, ButtonID, State) {
        var selector = $("#tb_" + ToolBar).find("#tbb_" + ButtonID);
        if (selector.length == 0) {
            
            return;
        }
        if (State == 1) {
            selector.find("input").attr("checked", "true");
        }
        else {
            selector.find("input").attr("checked", "false");
        }
    };
    cToolBar.ToolBarHeight = function (ToolBar) {
        var selector = $("#tb_" + ToolBar);
        if (selector.length == 0) {
            cCommon.ToolbarIsNotInitialized("ToolBarHeight()");
            return 0;
        }
        return selector.height();
    };
    cToolBar.ToolBarID = function (ToolBar) {
        return ToolBar;
    };
    cToolBar.ToolBarImageButton = function (ButtonID, ImageID, Mode) {
        if (Mode === void 0) { Mode = cConstants.PB_ToolBar_Normal; }
        if (cCommon.CurrentToolbar == null) {
            cCommon.ToolbarIsNotInitialized("ToolBarImageButton()");
            return;
        }
        var selector = $("<button />").button();
        selector.attr("id", "tbb_" + ButtonID);
        var img = cCommon.P2W_ImageList[ImageID];
        if (img != null) {
            selector.css("background-image", "url(" + img.src + ")");
            selector.css("background-repeat", "no-repeat");
        }
        selector.css("font-size", "0px");
        selector.css("height", 26);
        selector.css("width", 26);
        cCommon.CurrentToolbar.append(selector);
    };
    cToolBar.ToolBarSeparator = function () {
        if (cCommon.CurrentToolbar == null) {
            cCommon.ToolbarIsNotInitialized("ToolBarSeparator()");
            return;
        }
        cCommon.CurrentToolbar.append($('<span style="margin:0.2em" />'));
    };
    cToolBar.ToolBarStandardButton = function (ButtonID, ButtonIcon, Mode) {
        if (Mode === void 0) { Mode = cConstants.PB_ToolBar_Normal; }
        if (cCommon.CurrentToolbar == null) {
            cCommon.ToolbarIsNotInitialized("ToolBarStandardButton()");
            return;
        }
        var icon = '';
        switch (ButtonIcon) {
            case cConstants.PB_ToolBarIcon_New:
                icon = 'ui-icon-document';
                break;
            case cConstants.PB_ToolBarIcon_Open:
                icon = 'ui-icon-folder-open';
                break;
            case cConstants.PB_ToolBarIcon_Save:
                icon = 'ui-icon-disk';
                break;
            case cConstants.PB_ToolBarIcon_Print:
                icon = 'ui-icon-print';
                break;
            case cConstants.PB_ToolBarIcon_PrintPreview:
                icon = 'ui-icon-print';
                break;
            case cConstants.PB_ToolBarIcon_Find:
                icon = 'ui-icon-search';
                break;
            case cConstants.PB_ToolBarIcon_Replace:
                icon = 'ui-icon-shuffle';
                break;
            case cConstants.PB_ToolBarIcon_Cut:
                icon = 'ui-icon-scissors';
                break;
            case cConstants.PB_ToolBarIcon_Copy:
                icon = 'ui-icon-copy';
                break;
            case cConstants.PB_ToolBarIcon_Paste:
                icon = 'ui-icon-clipboard';
                break;
            case cConstants.PB_ToolBarIcon_Undo:
                icon = 'ui-icon-arrowreturnthick-1-w';
                break;
            case cConstants.PB_ToolBarIcon_Redo:
                icon = 'ui-icon-arrowreturnthick-1-e';
                break;
            case cConstants.PB_ToolBarIcon_Delete:
                icon = 'ui-icon-trash';
                break;
            case cConstants.PB_ToolBarIcon_Properties:
                icon = 'ui-icon-wrench';
                break;
            case cConstants.PB_ToolBarIcon_Help:
                icon = 'ui-icon-help';
                break;
            default:
                if (typeof (ButtonIcon) === 'string') {
                    icon = ButtonIcon;
                    break;
                }
                else {
                    icon = 'ui-icon-help';
                    break;
                }
        }
        var selector;
        if (Mode == cConstants.PB_ToolBar_Normal) {
            selector = $('<button />');
        }
        else if (Mode == cConstants.PB_ToolBar_Toggle) {
            selector = $("<input type='checkbox'><label for='tbb_" + ButtonID + "'></label>");
        }
        else {
            
            return;
        }
        selector.attr("id", "tbb_" + ButtonID);
        selector.button({
            text: false,
            icons: { primary: icon }
        });
        selector.css("height", 26);
        selector.css("width", 26);
        cCommon.CurrentToolbar.append(selector);
    };
    cToolBar.ToolBarToolTip = function (ToolBar, ButtonID, Text) {
        var selector = $("#tb_" + ToolBar).find("#tbb_" + ButtonID);
        if (selector.length == 0) {
            
            return;
        }
        selector.attr("title", Text);
    };
    return cToolBar;
}());
var cWebsocket = (function () {
    function cWebsocket() {
    }
    cWebsocket.OpenWebsocket = function (Url) {
        try {
            var WS = new WebSocket(Url);
            WS.onopen = function (event) {
                if ($(WS).data("onOpen")) {
                    $(WS).data("onOpen")(event);
                }
            };
            WS.onclose = function (event) {
                if ($(WS).data("onClose")) {
                    $(WS).data("onClose")(event);
                }
            };
            WS.onmessage = function (event) { if ($(WS).data("onMessage"))
                $(WS).data("onMessage")(event.data); };
            WS.onerror = function (event) {
                if ($(WS).data("onError")) {
                    $(WS).data("onError")(event);
                }
            };
            return WS;
        }
        catch (ex) {
            return null;
        }
    };
    cWebsocket.SendWebsocket = function (Websocket, DataToSend) {
        try {
            Websocket.send(DataToSend);
        }
        catch (ex) {
            var la = 42;
        }
    };
    cWebsocket.CloseWebsocket = function (Websocket, Code, Reason) {
        if (Code === void 0) { Code = 1000; }
        if (Reason === void 0) { Reason = "bye"; }
        try {
            if (Code == 0) {
                Websocket.close();
            }
            else if (Code != 0 && Reason == "") {
                Websocket.close(Code);
            }
            else if (Code != 0 && Reason != "") {
                Websocket.close(Code, Reason);
            }
            Websocket.onopen = null;
            Websocket.onclose = null;
            Websocket.onmessage = null;
            Websocket.onerror = null;
        }
        catch (ex) {
        }
    };
    cWebsocket.BindNetworkEvent = function (WS, Callback, EventType) {
        switch (EventType) {
            case cConstants.PB_Event_Websocket_OnOpen:
                $(WS).data("onOpen", Callback);
                break;
            case cConstants.PB_Event_Websocket_OnClose:
                $(WS).data("onClose", Callback);
                break;
            case cConstants.PB_Event_Websocket_OnMessage:
                $(WS).data("onMessage", Callback);
                break;
            case cConstants.PB_Event_Websocket_OnError:
                $(WS).data("onError", Callback);
                break;
            default:
                
                break;
        }
    };
    return cWebsocket;
}());
var cWindow = (function () {
    function cWindow() {
    }
    cWindow.AddKeyboardShortcut = function (Window, Key, Event) {
        var functionName = "AddKeyboardShortcut";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (selector.prop("tagName") !== "BODY") {
            selector = selector.parent();
        }
        var keyboardshortcuts = selector.data("keyboardshortcuts");
        if (!keyboardshortcuts)
            keyboardshortcuts = [];
        var hotkey = [];
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Alt)) {
            hotkey.push("alt");
            Key = (Key & ~cConstants.PB_Shortcut_Alt);
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Control)) {
            hotkey.push("ctrl");
            Key = Key & ~cConstants.PB_Shortcut_Control;
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Command)) {
            hotkey.push("meta");
            Key = Key & ~cConstants.PB_Shortcut_Command;
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Shift)) {
            hotkey.push("shift");
            Key = Key & ~cConstants.PB_Shortcut_Shift;
        }
        hotkey.push(cWindow.getShortCutAsString(Key).toLowerCase());
        var keyboardshortcut = {
            hotkey: hotkey.join("+"),
            event: Event
        };
        keyboardshortcuts.push(keyboardshortcut);
        selector.data("keyboardshortcuts", keyboardshortcuts);
    };
    cWindow.BindKeyboardShortcut = function (Object, Key, Callback, EventMenu, EventType) {
        if (EventType === void 0) { EventType = 0; }
        var functionName = "AddKeyboardShortcut2";
        var selector;
        selector = $("#w_" + Object);
        if (selector.length === 0) {
            selector = $("#g_" + Object);
            if (selector.length === 0) {
                
                return;
            }
        }
        else {
            if (selector.prop("tagName") !== "BODY") {
                selector = selector.parent();
            }
        }
        var hotkey = [];
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Alt)) {
            hotkey.push("alt");
            Key = (Key & ~cConstants.PB_Shortcut_Alt);
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Control)) {
            hotkey.push("ctrl");
            Key = Key & ~cConstants.PB_Shortcut_Control;
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Command)) {
            hotkey.push("meta");
            Key = Key & ~cConstants.PB_Shortcut_Command;
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Shift)) {
            hotkey.push("shift");
            Key = Key & ~cConstants.PB_Shortcut_Shift;
        }
        hotkey.push(cWindow.getShortCutAsString(Key).toLowerCase());
        var ShortCut = hotkey.join("+");
        if (EventType === 0) {
            EventType = cConstants.PB_All;
        }
        if (EventType === cConstants.PB_All) {
            EventType =
                cConstants.PB_EventType_KeyDown |
                    cConstants.PB_EventType_KeyUp;
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyDown)) {
            selector.bind("keydown." + ShortCut, ShortCut, function (event) {
                cEvent.eventMenu = EventMenu;
                cEvent.eventType = cConstants.PB_EventType_KeyDown;
                Callback();
                event.stopPropagation;
                return false;
            });
        }
        if (cCommon.CheckFlag(EventType, cConstants.PB_EventType_KeyUp)) {
            selector.bind("keyup." + ShortCut, ShortCut, function (event) {
                cEvent.eventMenu = EventMenu;
                cEvent.eventType = cConstants.PB_EventType_KeyUp;
                Callback();
                event.stopPropagation;
                return false;
            });
        }
    };
    cWindow.AddKeyboardShortcut_old = function (Window, Key, Event) {
        var functionName = "AddKeyboardShortcut";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (selector.prop("tagName") !== "BODY") {
            selector = selector.parent();
        }
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Shift) ||
            cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Control) ||
            cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Alt) ||
            cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Command)) {
            
            return;
        }
        var isShift = false;
        var isControl = false;
        var isAlt = false;
        var isCommand = false;
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Shift))
            isShift = true;
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Control))
            isControl = true;
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Alt))
            isAlt = true;
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Command))
            isCommand = true;
        selector.keydown(function (e) {
            if (e.which === Key) {
                cEvent.eventMenu = Key;
                cEvent.eventType = cConstants.PB_EventType_KeyDown;
                Event();
                e.preventDefault();
            }
        });
        selector.keyup(function (e) {
            if (e.which === Key) {
                cEvent.eventMenu = Key;
                cEvent.eventType = cConstants.PB_EventType_KeyUp;
                Event();
                e.preventDefault();
            }
        });
        selector.keypress(function (e) {
            if (e.which === Key) {
                cEvent.eventMenu = Key;
                cEvent.eventType = cConstants.PB_EventType_KeyPress;
                Event();
                e.preventDefault();
            }
        });
    };
    cWindow.AddWindowTimer = function (Window, Timer, Timeout) {
        var functionName = "AddWindowTimer";
        var selector = $("#w_" + Window);
        if (selector.length === 0)
            return cCommon.WindowIsNotInitialized(functionName);
        var myTimer = selector.data("timer_" + Timer);
        if (myTimer)
            cWindow.RemoveWindowTimer(Window, Timer);
        myTimer = new cTimer(Timeout);
        selector.data("timer_" + Timer, myTimer);
    };
    cWindow.IsWindowTimer = function (Window, Timer) {
        var functionName = "IsWindowTimer";
        var selector = $("#w_" + Window);
        if (selector.length === 0)
            return false;
        var myTimer = selector.data("timer_" + Timer);
        if (myTimer)
            return true;
        return false;
    };
    cWindow.BindEvent = function (Event, Callback, Window, Object, EventType) {
        if (Window === void 0) { Window = cConstants.PB_All; }
        if (Object === void 0) { Object = cConstants.PB_All; }
        if (EventType === void 0) { EventType = cConstants.PB_All; }
        cWindowEvent.BindEvent(Event, Callback, Window, Object, EventType, true);
    };
    cWindow.CenterWindow = function (Window, Direction) {
        if (Direction === void 0) { Direction = cConstants.PB_Center_Both; }
        var selector = $("#w_" + Window);
        var parent = selector.parent().parent();
        if (parent.prop("tagName").toLowerCase() === "body")
            parent = $(window);
        var newX = (parent.innerWidth() - selector.outerWidth()) / 2;
        var newY = (parent.innerHeight() - selector.outerHeight()) / 2;
        switch (Direction) {
            case cConstants.PB_Center_Horizontal:
                cWindow.ResizeWindow(Window, newX, cConstants.PB_Ignore, cConstants.PB_Ignore, cConstants.PB_Ignore);
                break;
            case cConstants.PB_Center_Vertical:
                cWindow.ResizeWindow(Window, cConstants.PB_Ignore, newY, cConstants.PB_Ignore, cConstants.PB_Ignore);
                break;
            case cConstants.PB_Center_Both:
                cWindow.ResizeWindow(Window, newX, newY, cConstants.PB_Ignore, cConstants.PB_Ignore);
                break;
        }
    };
    cWindow.CloseWindow = function (Window) {
        var functionName = "CloseWindow";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        selector.find('*').each(function () {
            if ($(this).data("GadgetType")) {
                var id = $(this).attr("id");
                cGadget.FreeGadget(id);
            }
        });
        if (selector.prop("tagName").toLowerCase() === "body") {
            selector.empty();
            return;
        }
        selector.data("canClose", true);
        selector.data("closeCallback", null);
        selector.dialog("close");
    };
    cWindow.DisableWindow = function (Window, State) {
        var functionName = "DisableWindow";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (State === true) {
            selector.attr("disabled", "disabled");
            selector.addClass("ui-state-disabled");
        }
        else {
            selector.removeAttr("disabled");
            selector.removeClass("ui-state-disabled");
        }
    };
    cWindow.EventlParam = function () {
        var functionName = "EventlParam";
        
        return -1;
    };
    cWindow.EventwParam = function () {
        var functionName = "EventwParam";
        
        return -1;
    };
    cWindow.GetActiveWindow = function () {
        var functionName = "GetActiveWindow";
        
        return -1;
    };
    cWindow.GetWindowColor = function (Window) {
        var functionName = "GetWindowColor";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        var color;
        var defaultBackColor;
        color = selector.css("background-color");
        defaultBackColor = selector.data("defaultBackColor");
        if (color === defaultBackColor) {
            color = -1;
        }
        else {
            color = cCommon.bgr2hex(color);
            color = cCommon.hex2decimal(cString.Mid(color, 2));
        }
        return color;
    };
    cWindow.GetWindowData = function (Window, DataKey) {
        if (DataKey === void 0) { DataKey = "data"; }
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized("GetWindowData()");
            return 0;
        }
        if (typeof (selector.data(DataKey)) != 'undefined')
            return selector.data(DataKey);
        return 0;
    };
    cWindow.GetWindowState = function (Window) {
        var functionName = "GetWindowState";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return 0;
        }
        switch (selector.dialogExtend("state")) {
            case "maximized":
                return cConstants.PB_Window_Maximize;
            case "minimized":
                return cConstants.PB_Window_Minimize;
            case "collapsed":
                return cConstants.PB_Window_Collapsed;
            default:
                return cConstants.PB_Window_Normal;
        }
    };
    cWindow.GetWindowTitle = function (Window) {
        var functionName = "GetWindowTitle";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return "";
        }
        if (selector.prop("tagName") === "BODY") {
            return $(document).attr("title");
        }
        else {
            return selector.dialog("option", "title").toString();
        }
    };
    cWindow.HideWindow = function (Window, State, Flags, Duration, Callback) {
        if (Flags === void 0) { Flags = 0; }
        if (Duration === void 0) { Duration = 0; }
        if (Callback === void 0) { Callback = null; }
        var functionName = "HideWindow";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (Flags !== 0) {
            
        }
        if (State === true) {
            if ((Duration > 0) && (Callback !== null)) {
                selector.parent().fadeOut(Duration, function () {
                    Callback();
                });
            }
            else {
                selector.parent().hide();
            }
        }
        else {
            if ((Duration > 0) && (Callback !== null)) {
                selector.parent().fadeIn(Duration, function () {
                    Callback();
                });
            }
            else {
                selector.parent().show();
            }
        }
    };
    cWindow.IsWindow = function (Window) {
        return ($("#w_" + Window).length === 1);
    };
    cWindow.OpenWindow = function (Window, x, y, InnerWidth, InnerHeight, Title, Flags, ParentID) {
        if (Flags === void 0) { Flags = cConstants.PB_Window_SystemMenu; }
        if (ParentID === void 0) { ParentID = -1; }
        InnerWidth += 5;
        InnerHeight += 40;
        if (Window === cConstants.PB_Any)
            Window = cCommon.guid();
        if ($("#w_" + Window).length > 0)
            cWindow.CloseWindow(Window);
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_Maximize) && cCommon.CheckFlag(Flags, cConstants.PB_Window_BorderLess)) {
            $('body').attr("id", "w_" + Window);
            cCommon.CurrentContainer = $("body");
            this.SetWindowTitle(Window, Title);
            if (Window === 0)
                return true;
            return Window;
        }
        if (cCommon.CurrentContainer === null)
            cCommon.CurrentContainer = $("body");
        var selector = $("<div />");
        selector.attr("id", "w_" + Window);
        cCommon.CurrentContainer.append(selector);
        cCommon.CurrentContainer = selector;
        if (x === cConstants.PB_Ignore)
            x = 10;
        if (y === cConstants.PB_Ignore)
            y = 10;
        var dialogOptions = {
            title: Title,
            width: InnerWidth,
            height: InnerHeight,
            close: function () {
                selector.find('*').each(function () {
                    if ($(this).data("GadgetType")) {
                        var id = $(this).attr("id");
                        cGadget.FreeGadget(id);
                    }
                });
                selector.empty();
                selector.remove();
                cCommon.CurrentContainer = null;
            },
            closeOnEscape: false,
            resizable: false,
            modal: ((ParentID !== -1) ? true : false),
            beforeClose: function () {
                if (selector.data("closeCallback")) {
                    cEvent.eventWindow = Window;
                    selector.data("closeCallback")();
                }
                if (selector.data("canClose")) {
                    return true;
                }
                else {
                    return false;
                }
            }
        };
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_SizeGadget))
            dialogOptions.resizable = true;
        var minimizable = false;
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_MinimizeGadget)) {
            minimizable = true;
        }
        var maximizable = false;
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_MaximizeGadget)) {
            maximizable = true;
        }
        var ontitlebardblclick = '';
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_MaximizeGadget)) {
            ontitlebardblclick = 'maximize';
        }
        else {
            ontitlebardblclick = '';
        }
        var closable = true;
        if (!cCommon.CheckFlag(Flags, cConstants.PB_Window_SystemMenu))
            closable = false;
        selector.dialog(dialogOptions).dialogExtend({
            "closable": closable,
            "maximizable": maximizable,
            "minimizable": minimizable,
            "dblclick": ontitlebardblclick,
            "load": function (evt, dlg) { },
            "beforeCollapse": function (evt, dlg) { },
            "beforeMaximize": function (evt, dlg) { },
            "beforeMinimize": function (evt, dlg) { },
            "beforeRestore": function (evt, dlg) { },
            "collapse": function (evt, dlg) { },
            "maximize": function (evt, dlg) {
                if (selector.data("maximizeCallback")) {
                    cEvent.eventWindow = Window;
                    selector.data("maximizeCallback")();
                }
            },
            "minimize": function (evt, dlg) {
                if (selector.data("minimizeCallback")) {
                    cEvent.eventWindow = Window;
                    selector.data("minimizeCallback")();
                }
            },
            "restore": function (evt, dlg) {
                if (selector.data("resizeCallback")) {
                    cEvent.eventWindow = Window;
                    selector.data("resizeCallback")();
                }
            }
        });
        if (!cCommon.CheckFlag(Flags, cConstants.PB_Window_ScreenCentered) && !cCommon.CheckFlag(Flags, cConstants.PB_Window_WindowCentered)) {
            selector.dialog("widget").css("left", x);
            selector.dialog("widget").css("top", y);
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_WindowCentered)) {
            if (cWindow.IsWindow(ParentID)) {
                selector.dialog().parent().position({
                    of: $("#w_" + ParentID).dialog().parent()
                });
            }
        }
        selector.dialog("moveToTop");
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_Invisible)) {
            cWindow.HideWindow(Window, true);
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_BorderLess)) {
            selector.dialog("widget").find(".ui-dialog-titlebar").hide();
        }
        selector.data("defaultBackColor", selector.css("background-color"));
        if (!cCommon.largeWindowFix) {
            if (cP2W.IsMobile) {
                selector.dialog().draggable({ cancel: ".p2w-gadget, .ui-dialog-content" });
            }
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_Maximize)) {
            selector.dialogExtend("maximize");
        }
        if (cCommon.CheckFlag(Flags, cConstants.PB_Window_Minimize)) {
            selector.dialogExtend("minimize");
        }
        selector.dialog("option", "closeText", "");
        if (Window === 0)
            return true;
        return Window;
    };
    cWindow.RemoveKeyboardShortcut = function (Window, Key) {
        var functionName = "RemoveKeyboardShortcut";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (selector.prop("tagName") !== "BODY") {
            selector = selector.parent();
        }
        var keyboardshortcuts = selector.data("keyboardshortcuts");
        if (!keyboardshortcuts)
            return;
        if (keyboardshortcuts.length === 0)
            return;
        var hotkey = [];
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Alt))
            hotkey.push("alt");
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Control))
            hotkey.push("ctrl");
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Command))
            hotkey.push("meta");
        if (cCommon.CheckFlag(Key, cConstants.PB_Shortcut_Shift))
            hotkey.push("shift");
        hotkey.push(cWindow.getShortCutAsString(Key).toLowerCase());
        var result = $.grep(keyboardshortcuts, function (e) { return e.hotkey === hotkey.join("+"); })[0];
        if (!result)
            return;
        keyboardshortcuts.splice($.inArray(result, keyboardshortcuts), 1);
        selector.data("keyboardshortcuts", keyboardshortcuts);
    };
    cWindow.RemoveWindowTimer = function (Window, Timer) {
        var functionName = "RemoveWindowTimer";
        var selector = $("#w_" + Window);
        if (selector.length === 0)
            return cCommon.WindowIsNotInitialized(functionName);
        var myTimer = selector.data("timer_" + Timer);
        if (!myTimer)
            return cCommon.TimerIsNotInitialized(functionName);
        myTimer.stop();
        selector.data("timer_" + Timer, null);
    };
    cWindow.ResizeWindow = function (Window, x, y, Width, Height) {
        var functionName = "ResizeWindow";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (selector.prop("tagName").toLowerCase() === "body") {
            if (Width !== cConstants.PB_Ignore)
                selector.css("width", Width);
            if (Height !== cConstants.PB_Ignore)
                selector.css("height", Height);
            return;
        }
        var pos = selector.dialog("option", "position");
        if (x === cConstants.PB_Ignore)
            x = pos[0];
        if (y === cConstants.PB_Ignore)
            y = pos[1];
        selector.dialog("option", "position", [x, y]);
        selector.dialog("widget").css({ top: y, left: x });
        if (Width !== cConstants.PB_Ignore)
            selector.dialog("option", "width", Width);
        if (Height !== cConstants.PB_Ignore)
            selector.dialog("option", "height", Height);
    };
    cWindow.SetActiveWindow = function (Window) {
        var functionName = "SetActiveWindow";
        var selector = $("#w_" + Window);
        if (selector.length === 0)
            return cCommon.WindowIsNotInitialized(functionName);
        selector.dialog().focus();
    };
    cWindow.SetWindowBackgroundImage = function (Window, Image) {
        var functionName = "SetWindowBackgroundImage";
        var selector = $("#w_" + Window);
        if (selector.length === 0)
            return cCommon.WindowIsNotInitialized(functionName);
        selector.css("background-image", "url(" + Image + ")");
        selector.css("background-position", "left top");
        selector.css("background-repeat", "no-repeat");
        selector.css("background-size", "100%");
    };
    cWindow.SetWindowCallback = function (ProcedureName, Window) {
        if (Window === void 0) { Window = 0; }
        var functionName = "SetWindowCallback";
        
    };
    cWindow.SetWindowColor = function (Window, Color) {
        var functionName = "SetWindowColor";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (Color === -1) {
            Color = selector.data("defaultBackColor");
        }
        selector.css("background-color", Color);
    };
    cWindow.SetWindowData = function (Window, Value, DataKey) {
        if (DataKey === void 0) { DataKey = "data"; }
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized("SetWindowData");
            return;
        }
        selector.data(DataKey, Value);
    };
    cWindow.SetWindowState = function (Window, State) {
        var functionName = "SetWindowState";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        switch (State) {
            case cConstants.PB_Window_Normal:
                selector.dialogExtend("restore");
                break;
            case cConstants.PB_Window_Maximize:
                selector.dialogExtend("maximize");
                break;
            case cConstants.PB_Window_Minimize:
                selector.dialogExtend("minimize");
                break;
            case cConstants.PB_Window_Collapsed:
                selector.dialogExtend("collapse");
                break;
        }
    };
    cWindow.SetWindowTitle = function (Window, Title) {
        var functionName = "SetWindowTitle";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (selector.prop("tagName") === "BODY") {
            $(document).attr("title", Title);
        }
        else {
            selector.dialog("option", "title", Title);
        }
    };
    cWindow.SmartWindowRefresh = function (Window, State) {
        var functionName = "SmartWindowRefresh";
        
    };
    cWindow.StickyWindow = function (Window, State) {
        var functionName = "StickyWindow";
        
    };
    cWindow.UnbindEvent = function (Event, Callback, Window, Object, EventType) {
        if (Window === void 0) { Window = cConstants.PB_All; }
        if (Object === void 0) { Object = cConstants.PB_All; }
        if (EventType === void 0) { EventType = cConstants.PB_All; }
        cWindowEvent.BindEvent(Event, Callback, Window, Object, EventType, false);
    };
    cWindow.WaitWindowEvent = function (Timeout) {
        if (Timeout === void 0) { Timeout = 0; }
        var functionName = "WaitWindowEvent";
        
        return -1;
    };
    cWindow.WindowBounds = function (Window, MinimalWidth, MinimalHeight, MaximalWidth, MaximalHeight) {
        var functionName = "WindowBounds";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return;
        }
        if (MaximalWidth !== cConstants.PB_Ignore)
            selector.dialog("option", "maxWidth", MaximalWidth);
        if (MaximalHeight !== cConstants.PB_Ignore)
            selector.dialog("option", "maxHeight", MaximalHeight);
        if (MinimalWidth !== cConstants.PB_Ignore)
            selector.dialog("option", "minWidth", MinimalWidth);
        if (MinimalHeight !== cConstants.PB_Ignore)
            selector.dialog("option", "minHeight", MinimalHeight);
    };
    cWindow.WindowEvent = function () {
        var functionName = "WindowEvent";
        
        return -1;
    };
    cWindow.WindowHeight = function (Window, Mode) {
        if (Mode === void 0) { Mode = cConstants.PB_Window_InnerCoordinate; }
        var functionName = "WindowHeight";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return -1;
        }
        var height = 0;
        if (Mode === cConstants.PB_Window_InnerCoordinate) {
            if (selector.prop("tagName") === "BODY") {
                height = $(window).height();
            }
            else {
                height = selector.closest(".ui-dialog-content").innerHeight();
            }
        }
        else {
            if (selector.prop("tagName") === "BODY") {
                height = $(window).height();
            }
            else {
                height = selector.closest(".ui-dialog").outerHeight();
            }
        }
        return Math.round(height);
    };
    cWindow.WindowID = function (Window) {
        return Window;
    };
    cWindow.WindowMouseX = function (Window) {
        var functionName = "WindowMouseX";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return -1;
        }
        return Math.round(cCommon.CurrentMouseX - cWindow.WindowX(Window));
    };
    cWindow.WindowMouseY = function (Window) {
        var functionName = "WindowMouseY";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return -1;
        }
        return Math.round(cCommon.CurrentMouseY - cWindow.WindowY(Window));
    };
    cWindow.WindowOutput = function (Window) {
        var functionName = "WindowOutput";
        
        return -1;
    };
    cWindow.WindowWidth = function (Window, Mode) {
        if (Mode === void 0) { Mode = cConstants.PB_Window_InnerCoordinate; }
        var functionName = "WindowWidth";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return -1;
        }
        var width = 0;
        if (Mode === cConstants.PB_Window_InnerCoordinate) {
            if (selector.prop("tagName") === "BODY") {
                width = $(window).width();
            }
            else {
                width = selector.closest(".ui-dialog-content").innerWidth();
            }
        }
        else {
            if (selector.prop("tagName") === "BODY") {
                width = $(window).width();
            }
            else {
                width = selector.closest(".ui-dialog").outerWidth();
            }
        }
        return Math.round(width);
    };
    cWindow.WindowX = function (Window, Mode) {
        if (Mode === void 0) { Mode = 0; }
        var functionName = "WindowX";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return -1;
        }
        var xPos = selector.offset().left;
        return Math.round(xPos);
    };
    cWindow.WindowY = function (Window, Mode) {
        if (Mode === void 0) { Mode = 0; }
        var functionName = "WindowY";
        var selector = $("#w_" + Window);
        if (selector.length === 0) {
            cCommon.WindowIsNotInitialized(functionName);
            return -1;
        }
        var yPos = selector.offset().top;
        return Math.round(yPos);
    };
    cWindow.getShortCutAsString = function (shortcut) {
        switch (shortcut) {
            case cConstants.PB_Shortcut_0:
            case cConstants.PB_Shortcut_1:
            case cConstants.PB_Shortcut_2:
            case cConstants.PB_Shortcut_3:
            case cConstants.PB_Shortcut_4:
            case cConstants.PB_Shortcut_5:
            case cConstants.PB_Shortcut_6:
            case cConstants.PB_Shortcut_7:
            case cConstants.PB_Shortcut_8:
            case cConstants.PB_Shortcut_9:
            case cConstants.PB_Shortcut_A:
            case cConstants.PB_Shortcut_B:
            case cConstants.PB_Shortcut_C:
            case cConstants.PB_Shortcut_D:
            case cConstants.PB_Shortcut_E:
            case cConstants.PB_Shortcut_F:
            case cConstants.PB_Shortcut_G:
            case cConstants.PB_Shortcut_H:
            case cConstants.PB_Shortcut_I:
            case cConstants.PB_Shortcut_J:
            case cConstants.PB_Shortcut_K:
            case cConstants.PB_Shortcut_L:
            case cConstants.PB_Shortcut_M:
            case cConstants.PB_Shortcut_N:
            case cConstants.PB_Shortcut_O:
            case cConstants.PB_Shortcut_P:
            case cConstants.PB_Shortcut_Q:
            case cConstants.PB_Shortcut_R:
            case cConstants.PB_Shortcut_S:
            case cConstants.PB_Shortcut_T:
            case cConstants.PB_Shortcut_U:
            case cConstants.PB_Shortcut_V:
            case cConstants.PB_Shortcut_W:
            case cConstants.PB_Shortcut_X:
            case cConstants.PB_Shortcut_Y:
            case cConstants.PB_Shortcut_Z: return cString.Chr(shortcut);
            case cConstants.PB_Shortcut_F1: return "f1";
            case cConstants.PB_Shortcut_F2: return "f2";
            case cConstants.PB_Shortcut_F3: return "f3";
            case cConstants.PB_Shortcut_F4: return "f4";
            case cConstants.PB_Shortcut_F5: return "f5";
            case cConstants.PB_Shortcut_F6: return "f6";
            case cConstants.PB_Shortcut_F7: return "f7";
            case cConstants.PB_Shortcut_F8: return "f8";
            case cConstants.PB_Shortcut_F9: return "f9";
            case cConstants.PB_Shortcut_F10: return "f10";
            case cConstants.PB_Shortcut_F11: return "f11";
            case cConstants.PB_Shortcut_F12: return "f12";
            case cConstants.PB_Shortcut_F13: return "f13";
            case cConstants.PB_Shortcut_F14: return "f14";
            case cConstants.PB_Shortcut_F15: return "f15";
            case cConstants.PB_Shortcut_F16: return "f16";
            case cConstants.PB_Shortcut_F17: return "f17";
            case cConstants.PB_Shortcut_F18: return "f18";
            case cConstants.PB_Shortcut_F19: return "f19";
            case cConstants.PB_Shortcut_F20: return "f20";
            case cConstants.PB_Shortcut_F21: return "f21";
            case cConstants.PB_Shortcut_F22: return "f22";
            case cConstants.PB_Shortcut_F23: return "f23";
            case cConstants.PB_Shortcut_F24: return "f24";
            case cConstants.PB_Shortcut_Left: return "left";
            case cConstants.PB_Shortcut_Right: return "right";
            case cConstants.PB_Shortcut_Up: return "up";
            case cConstants.PB_Shortcut_Down: return "down";
            case cConstants.PB_Shortcut_Tab: return "tab";
            case cConstants.PB_Shortcut_Escape: return "esc";
            case cConstants.PB_Shortcut_Return: return "return";
            case cConstants.PB_Shortcut_Space: return "space";
            case cConstants.PB_Shortcut_Back: return "backspace";
            case cConstants.PB_Shortcut_Home: return "home";
            case cConstants.PB_Shortcut_Insert: return "insert";
            case cConstants.PB_Shortcut_Pause: return "pause";
            case cConstants.PB_Shortcut_End: return "end";
            case cConstants.PB_Shortcut_Delete: return "del";
            case cConstants.PB_Shortcut_PageUp: return cString.Chr(33);
            case cConstants.PB_Shortcut_PageDown: return cString.Chr(34);
            case cConstants.PB_Shortcut_LeftWindows: return cString.Chr(91);
            case cConstants.PB_Shortcut_RightWindows: return cString.Chr(92);
            case cConstants.PB_Shortcut_Select: return cString.Chr(93);
            case cConstants.PB_Shortcut_Multiply: return cString.Chr(106);
            case cConstants.PB_Shortcut_Add: return cString.Chr(107);
            case cConstants.PB_Shortcut_Subtract: return cString.Chr(109);
            case cConstants.PB_Shortcut_Decimal: return cString.Chr(110);
            case cConstants.PB_Shortcut_Divide: return cString.Chr(111);
            case cConstants.PB_Shortcut_Numlock: return cString.Chr(144);
            case cConstants.PB_Shortcut_Apps: return "!";
            case cConstants.PB_Shortcut_Capital: return "^";
            case cConstants.PB_Shortcut_Clear: return "!";
            case cConstants.PB_Shortcut_Execute: return "!";
            case cConstants.PB_Shortcut_Help: return "!";
            case cConstants.PB_Shortcut_Menu: return "!";
            case cConstants.PB_Shortcut_Print: return "!";
            case cConstants.PB_Shortcut_Scroll: return "!";
            case cConstants.PB_Shortcut_Separator: return "!";
            case cConstants.PB_Shortcut_Snapshot: return "!";
            case cConstants.PB_Shortcut_Pad0:
            case cConstants.PB_Shortcut_Pad1:
            case cConstants.PB_Shortcut_Pad2:
            case cConstants.PB_Shortcut_Pad3:
            case cConstants.PB_Shortcut_Pad4:
            case cConstants.PB_Shortcut_Pad5:
            case cConstants.PB_Shortcut_Pad6:
            case cConstants.PB_Shortcut_Pad7:
            case cConstants.PB_Shortcut_Pad8:
            case cConstants.PB_Shortcut_Pad9: return cString.Chr(shortcut - 48);
            default: return "";
        }
    };
    return cWindow;
}());
var cXML = (function () {
    function cXML() {
    }
    cXML.XSLTransformation = function (xml, xsl) {
        return JSXML.transReady(xml, xsl);
    };
    cXML.CatchXML = function (XML, Address, Length, Flags, Encoding) {
        if (Flags === void 0) { Flags = null; }
        if (Encoding === void 0) { Encoding = null; }
        if (XML === cConstants.PB_Any)
            XML = cCommon.guid();
        try {
            this.XmlArray[XML] = jQuery.parseXML(Address);
            $(this.XmlArray[XML]).removeData("error");
        }
        catch (e) {
            $(this.XmlArray[XML]).data("error", e.message);
            return 0;
        }
        if (XML === 0)
            return true;
        return XML;
    };
    cXML.ChildXMLNode = function (Node, Index) {
        if (Index === void 0) { Index = 0; }
        if (Index > 0)
            Index -= 1;
        if (Node.childNodes[Index])
            return Node.childNodes[Index];
        return 0;
    };
    cXML.ComposeXML = function (XML, Flags) {
        if (Flags === void 0) { Flags = 0; }
        return (new XMLSerializer()).serializeToString(this.XmlArray[XML]);
    };
    cXML.CopyXMLNode = function (Node, ParentNode, PreviousNode) {
        if (PreviousNode === void 0) { PreviousNode = null; }
        return ParentNode.appendChild(Node.cloneNode(true));
    };
    cXML.CreateXML = function (XML, Encoding) {
        if (Encoding === void 0) { Encoding = 0; }
        if (XML === cConstants.PB_Any)
            XML = cCommon.guid();
        this.XmlArray[XML] = document.implementation.createDocument("", "", null);
        if (XML === 0)
            return true;
        return XML;
    };
    cXML.CreateXMLNode = function (ParentNode, Name, PreviousNode, Type) {
        if (PreviousNode === void 0) { PreviousNode = 0; }
        if (Type === void 0) { Type = 0; }
        if (ParentNode.ownerDocument) {
            return ParentNode.appendChild(ParentNode.ownerDocument.createElement(Name));
        }
        else {
            return ParentNode.appendChild(ParentNode.createElement(Name));
        }
    };
    cXML.DeleteXMLNode = function (Node) {
        Node.parentNode.removeChild(Node);
    };
    cXML.ExamineXMLAttributes = function (Node) {
        $(Node).data("currentAttribute", -1);
        return 1;
    };
    cXML.ExportXML = function (XML, Address, Length, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return 0;
    };
    cXML.ExportXMLSize = function (XML, Flags) {
        if (Flags === void 0) { Flags = 0; }
        
        return 0;
    };
    cXML.FormatXML = function (XML, Filename, Encoding) {
        
        return 0;
    };
    cXML.FreeXML = function (XML) {
        delete this.XmlArray[XML];
    };
    cXML.GetXMLAttribute = function (Node, Attribute) {
        if ($(Node).attr(Attribute))
            return $(Node).attr(Attribute);
        return "";
    };
    cXML.GetXMLEncoding = function (XML) {
        return cConstants.PB_UTF8;
    };
    cXML.GetXMLNodeName = function (Node) {
        return $(Node).prop("tagName");
    };
    cXML.GetXMLNodeOffset = function (Node) {
        
        return -1;
    };
    cXML.GetXMLNodeText = function (Node) {
        if (typeof (Node) == 'undefined')
            return "";
        if (typeof (Node.textContent) == 'undefined')
            return "";
        return Node.textContent;
    };
    cXML.GetXMLStandalone = function (XML) {
        var xDoc = this.XmlArray[XML];
        if (xDoc.xmlStandalone)
            return cConstants.PB_XML_StandaloneYes;
        return cConstants.PB_XML_StandaloneNo;
    };
    cXML.IsXML = function (XML) {
        return (this.XmlArray[XML] != null);
    };
    cXML.LoadXML = function (XML, Filename, Encoding, Callback) {
        if (Encoding === void 0) { Encoding = cConstants.PB_UTF8; }
        if (Callback === void 0) { Callback = null; }
        if (XML === cConstants.PB_Any)
            XML = cCommon.guid();
        var that = this;
        try {
            $.ajax({
                type: "GET",
                url: Filename,
                async: (typeof Callback === "function") ? true : false,
                dataType: "xml",
                success: function (xml) {
                    that.XmlArray[XML] = xml;
                    $(that.XmlArray[XML]).removeData("error");
                    if (typeof Callback === "function")
                        Callback(XML);
                },
                error: function (a, b, c) {
                    $(that.XmlArray[XML]).data("error", b + " / " + c);
                }
            });
        }
        catch (e) {
            $(that.XmlArray[XML]).data("error", e.message);
            return 0;
        }
        if (XML === 0)
            return true;
        return XML;
    };
    cXML.MainXMLNode = function (XML) {
        return $(this.XmlArray[XML]).find(":first-child");
    };
    cXML.MoveXMLNode = function (Node, ParentNode, PreviousNode) {
        if (PreviousNode === void 0) { PreviousNode = null; }
        return ParentNode.appendChild(Node.parentNode.removeChild(Node));
    };
    cXML.NextXMLAttribute = function (Node) {
        var currentAttribute = $(Node).data("currentAttribute");
        if (currentAttribute < Node.attributes.length - 1) {
            currentAttribute += 1;
            $(Node).data("currentAttribute", currentAttribute);
            return 1;
        }
        return 0;
    };
    cXML.NextXMLNode = function (Node) {
        if (Node.nextElementSibling)
            return Node.nextElementSibling;
        return 0;
    };
    cXML.ParentXMLNode = function (Node) {
        if (Node.parentNode)
            return Node.parentNode;
        return 0;
    };
    cXML.ParseXML = function (XML, Input) {
        if (cString.Len(Input) == 0)
            return false;
        if (XML === cConstants.PB_Any)
            XML = cCommon.guid();
        $(this.XmlArray[XML]).removeData("error");
        try {
            this.XmlArray[XML] = jQuery.parseXML(Input);
        }
        catch (e) {
            $(this.XmlArray[XML]).data("error", e.message);
            return 0;
        }
        if (XML === 0)
            return true;
        return XML;
    };
    cXML.PreviousXMLNode = function (Node) {
        if (Node.previousElementSibling)
            return Node.previousElementSibling;
        return 0;
    };
    cXML.RemoveXMLAttribute = function (Node, Attribute) {
        Node.attributes.removeNamedItem(Attribute);
    };
    cXML.ResolveXMLAttributeName = function () {  };
    cXML.ResolveXMLNodeName = function () {  };
    cXML.RootXMLNode = function (XML) {
        return this.XmlArray[XML];
    };
    cXML.SaveXML = function (XML, Filename, Flags) {
        if (Flags === void 0) { Flags = 0; }
        var xml = this.ComposeXML(XML);
        var blob = new Blob([xml], { type: "text/plain;charset=utf-8" });
        saveAs(blob, Filename);
        return true;
    };
    cXML.SetXMLAttribute = function (Node, Attribute, Value) {
        Node.setAttribute(Attribute, Value);
    };
    cXML.SetXMLEncoding = function () {
        
    };
    cXML.SetXMLNodeName = function (Node, Name) {
        try {
            var newNode = document.createElement(Name);
            newNode.innerHTML = Node.innerHTML;
            Node.parentNode.replaceChild(newNode, Node);
        }
        catch (e) {
            
        }
    };
    cXML.SetXMLNodeOffset = function () {
        
    };
    cXML.SetXMLNodeText = function (Node, Text) {
        Node.textContent = Text;
    };
    cXML.SetXMLStandalone = function (XML, Standalone) {
        
    };
    cXML.XMLAttributeName = function (Node) {
        var currentAttribute = $(Node).data("currentAttribute");
        var Attr = Node.attributes[currentAttribute];
        return Attr.name;
    };
    cXML.XMLAttributeValue = function (Node) {
        var currentAttribute = $(Node).data("currentAttribute");
        var Attr = Node.attributes[currentAttribute];
        return Attr.value;
    };
    cXML.XMLChildCount = function (Node) {
        if (!Node)
            return 0;
        if (!Node.childNodes)
            return 0;
        return Node.childNodes.length;
    };
    cXML.XMLError = function (XML) {
        if ($(this.XmlArray[XML]).data("error"))
            return $(this.XmlArray[XML]).data("error");
        return "";
    };
    cXML.XMLErrorLine = function (XML) {
        
        return 0;
    };
    cXML.XMLErrorPosition = function (XML) {
        
        return 0;
    };
    cXML.XMLNodeFromID = function () {  };
    cXML.XMLNodeFromPath = function (ParentNode, Path) {
        var result = $(ParentNode).xpath(Path);
        if (result.length > 0)
            return result[0];
        return 0;
    };
    cXML.XMLNodePath = function (Node, ParentNode) {
        if (ParentNode === void 0) { ParentNode = null; }
        return cXML.getXPath(Node, "");
    };
    cXML.XMLNodeType = function (Node) {
        if (!Node)
            return -1;
        switch (Node.nodeType) {
            case 1:
                return cConstants.PB_XML_Normal;
            case 2:
                return Node.nodeType;
            case 3:
                return cConstants.PB_XML_TextDeclaration;
            case 4:
                return cConstants.PB_XML_CData;
            case 5:
                return Node.nodeType;
            case 6:
                return Node.nodeType;
            case 7:
                return cConstants.PB_XML_Instruction;
            case 8:
                return cConstants.PB_XML_Comment;
            case 9:
                return cConstants.PB_XML_Normal;
            case 10:
                return Node.nodeType;
            case 11:
                return Node.nodeType;
            case 12:
                return cConstants.PB_XML_DTD;
        }
    };
    cXML.XMLStatus = function (XML) {
        return 0;
    };
    cXML.XmlToString = function (xmlData) {
        var ReturnValue;
        try {
            ReturnValue = (new XMLSerializer()).serializeToString(xmlData);
        }
        catch (e) {
            ReturnValue = "";
            
        }
        return ReturnValue;
    };
    cXML.getXPath = function (node, path) {
        path = path || [];
        if (node.parentNode)
            path = cXML.getXPath(node.parentNode, path);
        if (node.previousSibling) {
            var count = 1;
            var sibling = node.previousSibling;
            do {
                if (sibling.nodeType === 1 && sibling.nodeName === node.nodeName) {
                    count++;
                }
                sibling = sibling.previousSibling;
            } while (sibling);
            if (count === 1) {
                count = null;
            }
        }
        else if (node.nextSibling) {
            var sibling = node.nextSibling;
            do {
                if (sibling.nodeType === 1 && sibling.nodeName === node.nodeName) {
                    var count = 1;
                    sibling = null;
                }
                else {
                    var count = 0;
                    sibling = sibling.previousSibling;
                }
            } while (sibling);
        }
        if (node.nodeType === 1) {
            path.push(node.nodeName.toLowerCase() + (node.id ? "[@id='" + node.id + "']" : count > 0 ? "[" + count + "]" : ''));
        }
        return path;
    };
    cXML.XmlArray = [];
    return cXML;
}());
var cZip = (function () {
    function cZip() {
    }
    cZip.AddPackFile = function () {  };
    cZip.AddPackMemory = function () {  };
    cZip.ClosePack = function () {  };
    cZip.CompressMemory = function () {  };
    cZip.CreatePack = function () {  };
    cZip.ExaminePack = function () {  };
    cZip.NextPackEntry = function () {  };
    cZip.OpenPack = function () {  };
    cZip.PackEntryName = function () {  };
    cZip.PackEntrySize = function () {  };
    cZip.PackEntryType = function () {  };
    cZip.RemovePackFile = function () {  };
    cZip.UncompressMemory = function () {  };
    cZip.UncompressPackFile = function () {  };
    cZip.UncompressPackMemory = function () {  };
    cZip.UseBriefLZPacker = function () {  };
    cZip.UseJCALG1Packer = function () {  };
    cZip.UseLZMAPacker = function () {  };
    cZip.UseZipPacker = function () {  };
    return cZip;
}());
